/* Photo.c generated by valac 0.16.0, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2009-2012 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

struct _PhotoPrivate {
	GStaticRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GStaticRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GStaticRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GStaticRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR
} ImportResult;

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface* photo_dateable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface* library_photo_flaggable_parent_iface = NULL;
static MonitorableIface* library_photo_monitorable_parent_iface = NULL;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_import_params (GValue* value, gpointer v_object);
void value_take_photo_import_params (GValue* value, gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_row (GValue* value, gpointer v_object);
void value_take_photo_row (GValue* value, gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_IMPORT_PARAMS_DUMMY_PROPERTY
};
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams* obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
enum  {
	PHOTO_TRANSFORMATION_STATE_DUMMY_PROPERTY
};
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject* obj);
GType rating_get_type (void) G_GNUC_CONST;
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_photo_row (GValue* value, gpointer v_object);
void value_take_backing_photo_row (GValue* value, gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value, gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value, gpointer v_object);
void value_take_one_shot_scheduler (GValue* value, gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
enum  {
	PHOTO_DUMMY_PROPERTY
};
gboolean photo_exception_prohibits (PhotoException self, PhotoException exception);
gboolean photo_exception_allows (PhotoException self, PhotoException exception);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
Photo* photo_construct (GType object_type, PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at (const gchar* str, gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) (-1))
static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self, PhotoRow* row, GError** error);
static void photo_internal_remove_all_transformations (Photo* self, gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d);
gchar* data_object_to_string (DataObject* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self, BackingPhotoID* id, GError** error);
void backing_photo_table_remove (BackingPhotoTable* self, BackingPhotoID* backing_id, GError** error);
gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileSnifferOptions options);
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self, GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_detected_photo_information (GValue* value, gpointer v_object);
void value_take_detected_photo_information (GValue* value, gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self, BackingPhotoRow* state, GError** error);
void photo_table_update_raw_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, BackingPhotoID* backing_photo_id, GError** error);
static void photo_develop_photo (Photo* self, RawDeveloper d);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self, const gchar* raw_filepath, GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
void photo_set_default_raw_developer (Photo* self, RawDeveloper d);
void photo_set_raw_developer (Photo* self, RawDeveloper d);
void photo_revert_to_master (Photo* self, gboolean notify);
gboolean photo_set_orientation (Photo* self, Orientation orientation);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
gboolean photo_discard_prefetched (Photo* self, gboolean immed);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, GError** error);
void photo_redevelop_raw (Photo* self, RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row, const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type, BackingPhotoRow* photo_row, const gchar* md5);
static void _vala_array_add227 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add228 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add229 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) (-1))
void photo_id_init (PhotoID *self, gint64 id);
#define EVENT_ID_INVALID ((gint64) (-1))
void event_id_init (EventID *self, gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails, PhotoFileReader* reader, Orientation orientation, Dimensions* original_dim, GError** error);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self, gint width, gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error);
static void _vala_array_add230 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add231 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add232 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add233 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add234 (gchar*** array, int* length, int* size, gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_table_reimport (PhotoTable* self, PhotoRow* row, GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self, BackingPhotoRow* from);
static void _vala_array_add235 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add236 (gchar*** array, int* length, int* size, gchar* value);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_editable_id (Photo* self, BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self, BackingPhotoRow* row, GError** error);
void media_source_set_title (MediaSource* self, const gchar* title);
void media_source_set_rating (MediaSource* self, Rating rating);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error);
gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object);
void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object);
gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value);
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self, PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self, GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self, PhotoID* photo_id, time_t timestamp, GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, GError** error);
void photo_update_many_editable_timestamps (GeeMap* map, GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format, int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self, GFile* file);
void photo_table_set_filepath (PhotoTable* self, PhotoID* photo_id, const gchar* filepath, GError** error);
void media_source_notify_master_replaced (MediaSource* self, GFile* old_file, GFile* new_file);
static void _vala_array_add237 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add238 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add239 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add240 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_editable_file (Photo* self, GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self, BackingPhotoID* id, const gchar* filepath, GError** error);
static void _vala_array_add241 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add242 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add243 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_many_editable_file (GeeMap* map, GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base, EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base, ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self, Alteration* other);
guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self, PhotoID* photo_id, guint64 flags);
gboolean photo_is_flag_set (Photo* self, guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags, guint64 selector);
guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags, guint64 selector);
guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags, guint64 selector);
guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error);
guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self, PhotoID* photo_id, gboolean dirty, GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base, Rating rating);
gboolean photo_table_set_rating (PhotoTable* self, PhotoID* photo_id, Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self, PhotoID* photo_id, const gchar* backlinks, GError** error);
static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self, PhotoID* photo_id, EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base, DataSource* source);
gboolean data_source_equals (DataSource* self, DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self, PhotoID* photoID, gint64 filesize, glong timestamp, const gchar* md5, const gchar* exif_md5, const gchar* thumbnail_md5, PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static void photo_real_set_title (MediaSource* base, const gchar* title);
gboolean photo_table_set_title (PhotoTable* self, PhotoID* photo_id, const gchar* new_title);
void photo_set_import_id (Photo* self, ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self, PhotoID* photo_id, ImportID* import_id, GError** error);
void photo_set_title_persistent (Photo* self, const gchar* title, GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
void library_monitor_unblacklist_file (GFile* file);
static void photo_real_set_exposure_time (Dateable* base, time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self, PhotoID* photo_id, time_t time);
void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error);
void dateable_set_exposure_time (Dateable* self, time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result);
void photo_get_raw_dimensions (Photo* self, Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self, gdouble* theta);
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self, Box* crop);
void box_get_dimensions (Box *self, Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self, KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self, const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self, PixelTransformationType type);
void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self, const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self, const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self, PixelTransformation* old_trans, PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self, PhotoID* photo_id, Orientation orientation, GeeHashMap* transformations);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self, PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self, PhotoID* photo_id, Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self, Rotation rotation);
static void photo_real_rotate (Photo* self, Rotation rotation);
Orientation orientation_perform (Orientation self, Rotation rotation);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self, PhotoID* photo_id, const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self, Box* crop);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
static void photo_set_raw_crop (Photo* self, Box* crop);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle);
gdouble key_value_map_get_double (KeyValueMap* self, const gchar* key, gdouble def);
static void photo_set_raw_straighten (Photo* self, gdouble theta);
void key_value_map_set_double (KeyValueMap* self, const gchar* key, gdouble value);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
void photo_populate_prefetched (Photo* self, GError** error);
GdkPixbuf* photo_get_prefetched_copy (Photo* self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value, gpointer v_object);
void value_take_photo_file_format_properties (GValue* value, gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self, GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error);
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format);
void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self, const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
gchar* configuration_facade_get_external_raw_app (ConfigurationFacade* self);
gchar* configuration_facade_get_external_photo_app (ConfigurationFacade* self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self, GError** error);
void photo_open_with_external_editor (Photo* self, GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error);
static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error);
static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error);
static void photo_update_editable_attributes (Photo* self, GError** error);
void photo_reimport_editable (Photo* self, GError** error);
void photo_table_attach_editable (PhotoTable* self, PhotoRow* row, BackingPhotoID* editable_id, GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, gint64 filesize, GError** error);
static void _vala_array_add244 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add245 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add246 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add247 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add248 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add249 (gchar*** array, int* length, int* size, gchar* value);
void backing_photo_id_init (BackingPhotoID *self, gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name, OneShotCallback callback, void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type, const gchar* name, OneShotCallback callback, void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self, guint msec, gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self, Dimensions* result);
void photo_get_master_dimensions (Photo* self, Dimensions* result);
void photo_set_crop (Photo* self, Box* crop);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void photo_set_straighten (Photo* self, gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y);
void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject* obj);
enum  {
	PHOTO_BACKING_READERS_DUMMY_PROPERTY
};
static void photo_backing_readers_finalize (PhotoBackingReaders* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_DUMMY_PROPERTY
};
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_IMPL_DUMMY_PROPERTY
};
static gchar** _vala_array_dup31 (gchar** self, int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_DUMMY_PROPERTY
};
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_DUMMY_PROPERTY
};
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DUMMY_PROPERTY
};
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_DUMMY_PROPERTY
};
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj);
static void photo_finalize (GObject* obj);
static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_DUMMY_PROPERTY
};
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (void* _file);
static guint _file_hash_ghash_func (gconstpointer key);
gboolean file_equal (void* _a, void* _b);
static gboolean _file_equal_gequal_func (gconstpointer a, gconstpointer b);
gint int64_compare (void* a, void* b);
static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type, Workers* workers, GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self, const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self, const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self, GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self, GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self, gint64 numeric_id);
gint64 parse_int64 (const gchar* str, gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self, EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self, GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize);
gint utf8_ci_compare (void* a, void* b);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self, const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self, GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type, MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection* obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
enum  {
	LIBRARY_PHOTO_DUMMY_PROPERTY
};
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor, void* monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self, GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self, GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo);
void photo_table_add (PhotoTable* self, PhotoRow* photo_row, PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self, PhotoID* photo_id, GError** error);
static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source, gboolean force, GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self, gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
static void library_photo_real_rotate (Photo* base, Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source, Rotation rotation, GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source, gint scale, GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, gboolean blacklist, GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error);
void photo_table_duplicate (PhotoTable* self, PhotoID* photo_id, const gchar* new_filename, BackingPhotoID* editable_id, BackingPhotoID* develop_shotwell, BackingPhotoID* develop_camera_id, BackingPhotoID* develop_embedded_id, PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self, PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source, ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self, DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self, MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
void tag_attach (Tag* self, MediaSource* source);
gboolean spin_event_loop (gint max);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
Rating media_source_get_rating (MediaSource* self);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self, const gchar* name, gboolean treat_htags_as_root);
static void library_photo_finalize (GObject* obj);
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type, MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType backing_fetch_mode_get_type (void) {
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 41 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 2798 "Photo.c"
}


static gpointer _thumbnails_ref0 (gpointer self) {
#line 48 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 2805 "Photo.c"
}


PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	ImportID _tmp4_;
	PhotoFileSnifferOptions _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	Thumbnails* _tmp12_;
	Thumbnails* _tmp13_;
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((final_associated_file == NULL) || G_IS_FILE (final_associated_file), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 41 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 41 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 41 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 41 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->file = _tmp1_;
#line 42 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = final_associated_file;
#line 42 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 42 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 42 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->final_associated_file = _tmp3_;
#line 43 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = *import_id;
#line 43 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->import_id = _tmp4_;
#line 44 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = sniffer_options;
#line 44 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->sniffer_options = _tmp5_;
#line 45 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = exif_md5;
#line 45 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 45 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 45 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->exif_md5 = _tmp7_;
#line 46 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = thumbnail_md5;
#line 46 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 46 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 46 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->thumbnail_md5 = _tmp9_;
#line 47 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = full_md5;
#line 47 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 47 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 47 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->full_md5 = _tmp11_;
#line 48 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = thumbnails;
#line 48 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _thumbnails_ref0 (_tmp12_);
#line 48 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->thumbnails = _tmp13_;
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 2893 "Photo.c"
}


PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
#line 38 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 2900 "Photo.c"
}


PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
#line 52 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 53 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 53 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 53 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 53 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->file = _tmp1_;
#line 54 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = *import_id;
#line 54 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->import_id = _tmp2_;
#line 55 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 56 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 56 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->exif_md5 = NULL;
#line 57 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 57 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 58 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 58 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->full_md5 = NULL;
#line 59 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 59 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->thumbnails = NULL;
#line 52 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 2947 "Photo.c"
}


PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id) {
#line 52 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 2954 "Photo.c"
}


static void value_photo_import_params_init (GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 2961 "Photo.c"
}


static void value_photo_import_params_free_value (GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 2970 "Photo.c"
	}
}


static void value_photo_import_params_copy_value (const GValue* src_value, GValue* dest_value) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 2980 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2984 "Photo.c"
	}
}


static gpointer value_photo_import_params_peek_pointer (const GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 2992 "Photo.c"
}


static gchar* value_photo_import_params_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 2999 "Photo.c"
		PhotoImportParams* object;
		object = collect_values[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3006 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3010 "Photo.c"
		}
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 3014 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3018 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 3022 "Photo.c"
}


static gchar* value_photo_import_params_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoImportParams** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!object_p) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3033 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = NULL;
#line 3039 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 3043 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 3047 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 3051 "Photo.c"
}


GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoImportParams* spec;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 3065 "Photo.c"
}


gpointer value_get_photo_import_params (const GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3074 "Photo.c"
}


void value_set_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 3094 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3098 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_import_params_unref (old);
#line 3104 "Photo.c"
	}
}


void value_take_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 3123 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3127 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_import_params_unref (old);
#line 3133 "Photo.c"
	}
}


static void photo_import_params_class_init (PhotoImportParamsClass * klass) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_IMPORT_PARAMS_CLASS (klass)->finalize = photo_import_params_finalize;
#line 3143 "Photo.c"
}


static void photo_import_params_instance_init (PhotoImportParams * self) {
	PhotoRow* _tmp0_;
#line 24 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->final_associated_file = NULL;
#line 35 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 35 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->row = _tmp0_;
#line 36 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->keywords = NULL;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->ref_count = 1;
#line 3159 "Photo.c"
}


static void photo_import_params_finalize (PhotoImportParams* obj) {
	PhotoImportParams * self;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_IMPORT_PARAMS (obj);
#line 23 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 24 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 27 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 28 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 29 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 32 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 35 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 36 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 3183 "Photo.c"
}


GType photo_import_params_get_type (void) {
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer photo_import_params_ref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return instance;
#line 3208 "Photo.c"
}


void photo_import_params_unref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 21 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3221 "Photo.c"
	}
}


PhotoTransformationState* photo_transformation_state_construct (GType object_type) {
	PhotoTransformationState * self = NULL;
#line 72 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 72 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 3232 "Photo.c"
}


gboolean photo_transformation_state_is_broken (PhotoTransformationState* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 75 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 76 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 76 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 76 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3247 "Photo.c"
}


static void photo_transformation_state_real_broken (PhotoTransformationState* self) {
#line 69 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 3254 "Photo.c"
}


static void photo_transformation_state_class_init (PhotoTransformationStateClass * klass) {
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_TRANSFORMATION_STATE_CLASS (klass)->broken = photo_transformation_state_real_broken;
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3269 "Photo.c"
}


static void photo_transformation_state_instance_init (PhotoTransformationState * self) {
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 64 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 3278 "Photo.c"
}


static void photo_transformation_state_finalize (GObject* obj) {
	PhotoTransformationState * self;
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_TRANSFORMATION_STATE (obj);
#line 63 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 3288 "Photo.c"
}


GType photo_transformation_state_get_type (void) {
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean rating_can_increase (Rating self) {
	gboolean result = FALSE;
#line 90 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = self < RATING_FIVE;
#line 90 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3310 "Photo.c"
}


gboolean rating_can_decrease (Rating self) {
	gboolean result = FALSE;
#line 94 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = self > RATING_REJECTED;
#line 94 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3320 "Photo.c"
}


gboolean rating_is_valid (Rating self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 98 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 98 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 3332 "Photo.c"
	} else {
#line 98 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = FALSE;
#line 3336 "Photo.c"
	}
#line 98 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 98 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 98 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3344 "Photo.c"
}


Rating rating_increase (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Rating _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = rating_can_increase (self);
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self + 1;
#line 3359 "Photo.c"
	} else {
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self;
#line 3363 "Photo.c"
	}
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3371 "Photo.c"
}


Rating rating_decrease (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Rating _tmp2_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = rating_can_decrease (self);
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self - 1;
#line 3386 "Photo.c"
	} else {
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self;
#line 3390 "Photo.c"
	}
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3398 "Photo.c"
}


gint rating_serialize (Rating self) {
	gint result = 0;
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (self) {
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_REJECTED:
#line 3408 "Photo.c"
		{
#line 112 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = -1;
#line 112 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3414 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_UNRATED:
#line 3418 "Photo.c"
		{
#line 114 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 0;
#line 114 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3424 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_ONE:
#line 3428 "Photo.c"
		{
#line 116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 1;
#line 116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3434 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_TWO:
#line 3438 "Photo.c"
		{
#line 118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 2;
#line 118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3444 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_THREE:
#line 3448 "Photo.c"
		{
#line 120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 3;
#line 120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3454 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_FOUR:
#line 3458 "Photo.c"
		{
#line 122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 4;
#line 122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3464 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RATING_FIVE:
#line 3468 "Photo.c"
		{
#line 124 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 5;
#line 124 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3474 "Photo.c"
		}
		default:
		{
#line 126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = 0;
#line 126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3482 "Photo.c"
		}
	}
}


Rating rating_unserialize (gint value) {
	Rating result = 0;
	gint _tmp0_;
	gint _tmp2_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = value;
#line 131 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ > ((gint) RATING_FIVE)) {
#line 132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = RATING_FIVE;
#line 132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 3500 "Photo.c"
	} else {
		gint _tmp1_;
#line 133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = value;
#line 133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp1_ < ((gint) RATING_REJECTED)) {
#line 134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_REJECTED;
#line 134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3511 "Photo.c"
		}
	}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = value;
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp2_) {
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case -1:
#line 3520 "Photo.c"
		{
#line 138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_REJECTED;
#line 138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3526 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case 0:
#line 3530 "Photo.c"
		{
#line 140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_UNRATED;
#line 140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3536 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case 1:
#line 3540 "Photo.c"
		{
#line 142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_ONE;
#line 142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3546 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case 2:
#line 3550 "Photo.c"
		{
#line 144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_TWO;
#line 144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3556 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case 3:
#line 3560 "Photo.c"
		{
#line 146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_THREE;
#line 146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3566 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case 4:
#line 3570 "Photo.c"
		{
#line 148 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_FOUR;
#line 148 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3576 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case 5:
#line 3580 "Photo.c"
		{
#line 150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_FIVE;
#line 150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3586 "Photo.c"
		}
		default:
		{
#line 152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = RATING_UNRATED;
#line 152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 3594 "Photo.c"
		}
	}
}


GType rating_get_type (void) {
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
		GType rating_type_id;
		rating_type_id = g_enum_register_static ("Rating", values);
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}


gboolean photo_exception_prohibits (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_;
#line 214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = exception;
#line 214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = (self & _tmp0_) != 0;
#line 214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3621 "Photo.c"
}


gboolean photo_exception_allows (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_;
#line 218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = exception;
#line 218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = (self & _tmp0_) == 0;
#line 218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 3634 "Photo.c"
}


GType photo_exception_get_type (void) {
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer _photo_row_ref0 (gpointer self) {
#line 374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 3653 "Photo.c"
}


static gpointer _backing_photo_row_ref0 (gpointer self) {
#line 394 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 3660 "Photo.c"
}


Photo* photo_construct (GType object_type, PhotoRow* row) {
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	PhotoBackingReaders* _tmp6_;
	PhotoRow* _tmp7_;
	BackingPhotoRow* _tmp8_;
	PhotoFileFormat _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	const gchar* _tmp12_;
	PhotoFileReader* _tmp13_ = NULL;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_ = NULL;
	gchar* basename;
	const gchar* _tmp18_;
	const gchar* _tmp21_;
	gboolean _tmp22_ = FALSE;
	PhotoRow* _tmp27_;
	BackingPhotoID _tmp28_;
	gint64 _tmp29_;
	PhotoRow* _tmp45_;
	BackingPhotoRow* _tmp46_;
	PhotoFileFormat _tmp47_;
	gboolean _tmp63_ = FALSE;
	PhotoRow* _tmp64_;
	BackingPhotoRow* _tmp65_;
	PhotoFileFormat _tmp66_;
	gboolean _tmp71_;
	PhotoBackingReaders* _tmp82_;
	PhotoFileReader* _tmp83_;
	GError * _inner_error_ = NULL;
#line 373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = row;
#line 374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->row = _tmp1_;
#line 377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = self->row;
#line 377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = self->row;
#line 377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_->title;
#line 377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = media_source_prep_title (_tmp4_);
#line 377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp2_->title);
#line 377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_->title = _tmp5_;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = self->priv->readers;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = row;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_->master;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_->file_format;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = row;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = _tmp11_->filepath;
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = photo_file_format_create_reader (_tmp9_, _tmp12_);
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp6_->master);
#line 381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_->master = _tmp13_;
#line 384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = row;
#line 384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = string_sliced_at_last_char (_tmp16_, (gunichar) G_DIR_SEPARATOR, 0);
#line 384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	basename = _tmp17_;
#line 385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = basename;
#line 385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 3760 "Photo.c"
		const gchar* _tmp19_;
		gchar* _tmp20_ = NULL;
#line 386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = basename;
#line 386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = string_sliced_at (_tmp19_, 1);
#line 386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		self->priv->file_title = _tmp20_;
#line 3771 "Photo.c"
	}
#line 388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = self->priv->file_title;
#line 388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = is_string_empty (_tmp21_);
#line 388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp22_) {
#line 3779 "Photo.c"
		PhotoRow* _tmp23_;
		BackingPhotoRow* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
#line 389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = row;
#line 389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = _tmp23_->master;
#line 389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = _tmp24_->filepath;
#line 389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = g_strdup (_tmp25_);
#line 389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		self->priv->file_title = _tmp26_;
#line 3796 "Photo.c"
	}
#line 391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = row;
#line 391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = _tmp27_->editable_id;
#line 391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = _tmp28_.id;
#line 391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp29_ != BACKING_PHOTO_ID_INVALID) {
#line 3806 "Photo.c"
		PhotoRow* _tmp30_;
		BackingPhotoID _tmp31_;
		BackingPhotoRow* _tmp32_ = NULL;
		BackingPhotoRow* e;
		BackingPhotoRow* _tmp33_;
#line 392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = row;
#line 392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = _tmp30_->editable_id;
#line 392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = photo_get_backing_row (self, &_tmp31_);
#line 392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		e = _tmp32_;
#line 393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp33_ = e;
#line 393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp33_ != NULL) {
#line 3824 "Photo.c"
			BackingPhotoRow* _tmp34_;
			BackingPhotoRow* _tmp35_;
			PhotoBackingReaders* _tmp36_;
			BackingPhotoRow* _tmp37_;
			PhotoFileFormat _tmp38_;
			BackingPhotoRow* _tmp39_;
			const gchar* _tmp40_;
			PhotoFileReader* _tmp41_ = NULL;
#line 394 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp34_ = e;
#line 394 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp35_ = _backing_photo_row_ref0 (_tmp34_);
#line 394 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 394 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			self->priv->editable = _tmp35_;
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_ = self->priv->readers;
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp37_ = self->priv->editable;
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = _tmp37_->file_format;
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp39_ = self->priv->editable;
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp40_ = _tmp39_->filepath;
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp41_ = photo_file_format_create_reader (_tmp38_, _tmp40_);
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp36_->editable);
#line 395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_->editable = _tmp41_;
#line 3857 "Photo.c"
		} else {
			{
				PhotoTable* _tmp42_ = NULL;
				PhotoTable* _tmp43_;
				PhotoRow* _tmp44_;
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp42_ = photo_table_get_instance ();
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = self->row;
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_detach_editable (_tmp43_, _tmp44_, &_inner_error_);
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp43_);
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3877 "Photo.c"
						goto __catch214_database_error;
					}
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (basename);
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return NULL;
#line 3890 "Photo.c"
				}
			}
			goto __finally214;
			__catch214_database_error:
			{
				GError* err = NULL;
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				err = _inner_error_;
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (err);
#line 3903 "Photo.c"
			}
			__finally214:
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (basename);
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return NULL;
#line 3918 "Photo.c"
			}
#line 405 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 3922 "Photo.c"
		}
#line 391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 3926 "Photo.c"
	}
#line 409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = row;
#line 409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = _tmp45_->master;
#line 409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = _tmp46_->file_format;
#line 409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp47_ == PHOTO_FILE_FORMAT_RAW) {
#line 3936 "Photo.c"
		GeeHashMap* _tmp48_;
		gint _tmp49_ = 0;
		RawDeveloper* _tmp50_ = NULL;
#line 411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp48_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, backing_photo_row_unref, NULL, NULL, NULL);
#line 411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		self->priv->developments = _tmp48_;
#line 412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = raw_developer_as_array (&_tmp49_);
#line 3948 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			d_collection = _tmp50_;
#line 412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			d_collection_length1 = _tmp49_;
#line 412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			for (d_it = 0; d_it < _tmp49_; d_it = d_it + 1) {
#line 3960 "Photo.c"
				RawDeveloper d = 0;
#line 412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				d = d_collection[d_it];
#line 3964 "Photo.c"
				{
					PhotoRow* _tmp51_;
					BackingPhotoID* _tmp52_;
					gint _tmp52__length1;
					RawDeveloper _tmp53_;
					BackingPhotoID _tmp54_;
					BackingPhotoID id;
					BackingPhotoID _tmp55_;
					gint64 _tmp56_;
#line 413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp51_ = row;
#line 413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52_ = _tmp51_->development_ids;
#line 413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52__length1 = _tmp51_->development_ids_length1;
#line 413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp53_ = d;
#line 413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp54_ = _tmp52_[_tmp53_];
#line 413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					id = _tmp54_;
#line 414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp55_ = id;
#line 414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp56_ = _tmp55_.id;
#line 414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_tmp56_ != BACKING_PHOTO_ID_INVALID) {
#line 3992 "Photo.c"
						BackingPhotoID _tmp57_;
						BackingPhotoRow* _tmp58_ = NULL;
						BackingPhotoRow* bpr;
						BackingPhotoRow* _tmp59_;
#line 415 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp57_ = id;
#line 415 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp58_ = photo_get_backing_row (self, &_tmp57_);
#line 415 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						bpr = _tmp58_;
#line 416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp59_ = bpr;
#line 416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp59_ != NULL) {
#line 4007 "Photo.c"
							GeeHashMap* _tmp60_;
							RawDeveloper _tmp61_;
							BackingPhotoRow* _tmp62_;
#line 417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp60_ = self->priv->developments;
#line 417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp61_ = d;
#line 417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp62_ = bpr;
#line 417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp60_), GINT_TO_POINTER (_tmp61_), _tmp62_);
#line 4019 "Photo.c"
						}
#line 414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 4023 "Photo.c"
					}
				}
			}
#line 412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4029 "Photo.c"
		}
	}
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp64_ = row;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp65_ = _tmp64_->master;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp66_ = _tmp65_->file_format;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp66_ == PHOTO_FILE_FORMAT_RAW) {
#line 4040 "Photo.c"
		GeeHashMap* _tmp67_;
		PhotoRow* _tmp68_;
		RawDeveloper _tmp69_;
		gboolean _tmp70_ = FALSE;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp67_ = self->priv->developments;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp68_ = row;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp69_ = _tmp68_->developer;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp70_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp67_), GINT_TO_POINTER (_tmp69_));
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp63_ = _tmp70_;
#line 4055 "Photo.c"
	} else {
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp63_ = FALSE;
#line 4059 "Photo.c"
	}
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp71_ = _tmp63_;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp71_) {
#line 4065 "Photo.c"
		GeeHashMap* _tmp72_;
		PhotoRow* _tmp73_;
		RawDeveloper _tmp74_;
		gpointer _tmp75_ = NULL;
		BackingPhotoRow* r;
		PhotoBackingReaders* _tmp76_;
		BackingPhotoRow* _tmp77_;
		PhotoFileFormat _tmp78_;
		BackingPhotoRow* _tmp79_;
		const gchar* _tmp80_;
		PhotoFileReader* _tmp81_ = NULL;
#line 424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp72_ = self->priv->developments;
#line 424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp73_ = row;
#line 424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp74_ = _tmp73_->developer;
#line 424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp75_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp72_), GINT_TO_POINTER (_tmp74_));
#line 424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		r = (BackingPhotoRow*) _tmp75_;
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp76_ = self->priv->readers;
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp77_ = r;
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp78_ = _tmp77_->file_format;
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp79_ = r;
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp80_ = _tmp79_->filepath;
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp81_ = photo_file_format_create_reader (_tmp78_, _tmp80_);
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp76_->developer);
#line 425 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp76_->developer = _tmp81_;
#line 423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 4105 "Photo.c"
	}
#line 429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp82_ = self->priv->readers;
#line 429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp83_ = _tmp82_->editable;
#line 429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp83_ != NULL) {
#line 4113 "Photo.c"
		BackingPhotoRow* _tmp84_;
		BackingPhotoRow* _tmp85_;
#line 430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp84_ = self->priv->editable;
#line 430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp85_ = _backing_photo_row_ref0 (_tmp84_);
#line 430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		self->backing_photo_row = _tmp85_;
#line 4124 "Photo.c"
	} else {
		PhotoRow* _tmp86_;
		BackingPhotoRow* _tmp87_;
		PhotoFileFormat _tmp88_;
#line 431 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp86_ = row;
#line 431 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp87_ = _tmp86_->master;
#line 431 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp88_ = _tmp87_->file_format;
#line 431 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp88_ != PHOTO_FILE_FORMAT_RAW) {
#line 4137 "Photo.c"
			PhotoRow* _tmp89_;
			BackingPhotoRow* _tmp90_;
			BackingPhotoRow* _tmp91_;
#line 432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp89_ = self->row;
#line 432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp90_ = _tmp89_->master;
#line 432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp91_ = _backing_photo_row_ref0 (_tmp90_);
#line 432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			self->backing_photo_row = _tmp91_;
#line 4151 "Photo.c"
		} else {
			GeeHashMap* _tmp92_;
			PhotoRow* _tmp93_;
			RawDeveloper _tmp94_;
			gboolean _tmp95_ = FALSE;
#line 436 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp92_ = self->priv->developments;
#line 436 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp93_ = row;
#line 436 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp94_ = _tmp93_->developer;
#line 436 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp95_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp92_), GINT_TO_POINTER (_tmp94_));
#line 436 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp95_) {
#line 4167 "Photo.c"
				GeeHashMap* _tmp96_;
				PhotoRow* _tmp97_;
				RawDeveloper _tmp98_;
				gpointer _tmp99_ = NULL;
#line 437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp96_ = self->priv->developments;
#line 437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp97_ = row;
#line 437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp98_ = _tmp97_->developer;
#line 437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp99_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp96_), GINT_TO_POINTER (_tmp98_));
#line 437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp99_;
#line 4184 "Photo.c"
			} else {
				PhotoRow* _tmp100_;
				BackingPhotoRow* _tmp101_;
				BackingPhotoRow* _tmp102_;
#line 440 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp100_ = self->row;
#line 440 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp101_ = _tmp100_->master;
#line 440 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp102_ = _backing_photo_row_ref0 (_tmp101_);
#line 440 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 440 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->backing_photo_row = _tmp102_;
#line 4199 "Photo.c"
			}
		}
	}
#line 373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (basename);
#line 373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 4207 "Photo.c"
}


static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 445 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 445 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = old_file;
#line 446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = new_file;
#line 446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-replaced", _tmp0_, _tmp1_);
#line 4224 "Photo.c"
}


void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 445 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 445 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 4233 "Photo.c"
}


static void photo_real_notify_raw_development_modified (Photo* self) {
#line 450 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "raw-development-modified");
#line 4240 "Photo.c"
}


void photo_notify_raw_development_modified (Photo* self) {
#line 449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 4249 "Photo.c"
}


static void photo_real_notify_baseline_replaced (Photo* self) {
#line 454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-replaced");
#line 4256 "Photo.c"
}


void photo_notify_baseline_replaced (Photo* self) {
#line 453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 4265 "Photo.c"
}


static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_);
#line 4277 "Photo.c"
}


void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 4286 "Photo.c"
}


static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_);
#line 4298 "Photo.c"
}


void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 4307 "Photo.c"
}


static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_);
#line 4319 "Photo.c"
}


void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 4328 "Photo.c"
}


static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 470 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 470 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_);
#line 4340 "Photo.c"
}


void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 4349 "Photo.c"
}


static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error) {
	Photo * self;
	gboolean result = FALSE;
	gboolean ret;
	GFile* file;
	PhotoFileFormat _tmp7_ = 0;
	GFile* _tmp11_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_;
	gboolean _tmp26_;
	GError * _inner_error_ = NULL;
#line 473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ret = TRUE;
#line 475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = NULL;
#line 4371 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4378 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 4388 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp4_));
#line 478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				file = _tmp5_;
#line 4402 "Photo.c"
			}
		}
		__finally215:
		{
			PhotoBackingReaders* _tmp6_;
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4412 "Photo.c"
		}
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 4422 "Photo.c"
		}
	}
#line 481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 483 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = photo_get_master_file_format (self);
#line 483 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp7_ == PHOTO_FILE_FORMAT_RAW) {
#line 4431 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_ = NULL;
#line 484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 4436 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			d_collection = _tmp9_;
#line 484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			for (d_it = 0; d_it < _tmp8_; d_it = d_it + 1) {
#line 4448 "Photo.c"
				RawDeveloper d = 0;
#line 484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				d = d_collection[d_it];
#line 4452 "Photo.c"
				{
					RawDeveloper _tmp10_;
#line 485 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp10_ = d;
#line 485 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 4459 "Photo.c"
				}
			}
#line 484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4464 "Photo.c"
		}
	}
#line 489 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = file;
#line 489 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4471 "Photo.c"
		{
			GFile* _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_;
#line 491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = file;
#line 491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = g_file_trash (_tmp12_, NULL, &_inner_error_);
#line 491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 4484 "Photo.c"
				goto __catch216_g_error;
			}
#line 491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			ret = _tmp14_;
#line 4489 "Photo.c"
		}
		goto __finally216;
		__catch216_g_error:
		{
			GError* err = NULL;
			GFile* _tmp15_;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			ret = FALSE;
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = file;
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = g_file_get_path (_tmp15_);
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = data_object_to_string (DATA_OBJECT (self));
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = err;
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = _tmp20_->message;
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_message ("Photo.vala:494: Unable to move editable %s for %s to trash: %s", _tmp17_, _tmp19_, _tmp21_);
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp19_);
#line 494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp17_);
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 4530 "Photo.c"
		}
		__finally216:
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 4541 "Photo.c"
		}
	}
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (DATA_SOURCE (PHOTO_SOURCE (self)), &_inner_error_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = _tmp23_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 4556 "Photo.c"
	}
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp24_) {
#line 4560 "Photo.c"
		gboolean _tmp25_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = ret;
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = _tmp25_;
#line 4566 "Photo.c"
	} else {
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = FALSE;
#line 4570 "Photo.c"
	}
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = _tmp22_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp26_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 4580 "Photo.c"
}


static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id) {
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	BackingPhotoRow* backing_row;
	BackingPhotoRow* _tmp12_;
	GError * _inner_error_ = NULL;
#line 505 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 505 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *id;
#line 506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 4605 "Photo.c"
	}
#line 509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing_row = NULL;
#line 4609 "Photo.c"
	{
		BackingPhotoTable* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_;
		BackingPhotoID _tmp4_;
		BackingPhotoRow* _tmp5_ = NULL;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = backing_photo_table_get_instance ();
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = *id;
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = backing_photo_table_fetch (_tmp3_, &_tmp4_, &_inner_error_);
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_database_table_unref0 (_tmp3_);
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 4635 "Photo.c"
				goto __catch217_database_error;
			}
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 4646 "Photo.c"
		}
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		backing_row = _tmp7_;
#line 4652 "Photo.c"
	}
	goto __finally217;
	__catch217_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = data_object_to_string (DATA_OBJECT (self));
#line 513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = err;
#line 513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:513: Unable to fetch backing state for %s: %s", _tmp9_, _tmp11_);
#line 513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp9_);
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 4680 "Photo.c"
	}
	__finally217:
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 4693 "Photo.c"
	}
#line 516 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = backing_row;
#line 516 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 4699 "Photo.c"
		{
			BackingPhotoTable* _tmp13_ = NULL;
			BackingPhotoTable* _tmp14_;
			BackingPhotoID _tmp15_;
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = backing_photo_table_get_instance ();
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = *id;
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing_photo_table_remove (_tmp14_, &_tmp15_, &_inner_error_);
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 4718 "Photo.c"
					goto __catch218_database_error;
				}
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return NULL;
#line 4729 "Photo.c"
			}
		}
		goto __finally218;
		__catch218_database_error:
		{
			GError* err = NULL;
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 4742 "Photo.c"
		}
		__finally218:
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 4755 "Photo.c"
		}
#line 522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 4763 "Photo.c"
	}
#line 525 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = backing_row;
#line 525 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 4769 "Photo.c"
}


gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4778 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 4785 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			RawDeveloper _tmp2_;
			gboolean _tmp3_ = FALSE;
#line 531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = d;
#line 531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp1_), GINT_TO_POINTER (_tmp2_));
#line 531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 4798 "Photo.c"
			{
				GeeHashMap* _tmp4_;
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->developments;
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4805 "Photo.c"
			}
#line 531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 4809 "Photo.c"
		}
		__finally219:
		{
			GeeHashMap* _tmp5_;
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4818 "Photo.c"
		}
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 4826 "Photo.c"
	}
}


gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	RawDeveloper _tmp6_;
	GError * _inner_error_ = NULL;
#line 536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4837 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 4844 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			RawDeveloper _tmp2_;
			gboolean _tmp3_ = FALSE;
#line 538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = d;
#line 538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp1_), GINT_TO_POINTER (_tmp2_));
#line 538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_) {
#line 539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = TRUE;
#line 4859 "Photo.c"
				{
					GeeHashMap* _tmp4_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4866 "Photo.c"
				}
#line 539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 4870 "Photo.c"
			}
		}
		__finally220:
		{
			GeeHashMap* _tmp5_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4880 "Photo.c"
		}
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 4890 "Photo.c"
		}
	}
#line 542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = d;
#line 542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp6_) {
#line 542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 4899 "Photo.c"
		{
#line 544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = TRUE;
#line 544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 4905 "Photo.c"
		}
#line 542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 4909 "Photo.c"
		{
#line 547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = FALSE;
#line 547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 4915 "Photo.c"
		}
#line 542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 4919 "Photo.c"
		{
			{
				PhotoMetadata* _tmp7_ = NULL;
				PhotoMetadata* meta;
				PhotoMetadata* _tmp8_;
				guint _tmp9_ = 0U;
#line 551 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = photo_get_master_metadata (self, &_inner_error_);
#line 551 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				meta = _tmp7_;
#line 551 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 4932 "Photo.c"
					goto __catch221_g_error;
				}
#line 552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = meta;
#line 552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = photo_metadata_get_preview_count (_tmp8_);
#line 552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp9_ > ((guint) 0)) {
#line 553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					result = TRUE;
#line 553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return result;
#line 4947 "Photo.c"
				}
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 4951 "Photo.c"
			}
			goto __finally221;
			__catch221_g_error:
			{
				GError* e = NULL;
				GError* _tmp10_;
				const gchar* _tmp11_;
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				e = _inner_error_;
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 555 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = e;
#line 555 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tmp10_->message;
#line 555 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_debug ("Photo.vala:555: Error accessing embedded preview. Message: %s", _tmp11_);
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (e);
#line 4971 "Photo.c"
			}
			__finally221:
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return FALSE;
#line 4982 "Photo.c"
			}
#line 557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = FALSE;
#line 557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 4988 "Photo.c"
		}
		default:
		{
#line 560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_assert_not_reached ();
#line 4994 "Photo.c"
		}
	}
}


void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
	BackingPhotoRow* _tmp2_;
	GError * _inner_error_ = NULL;
#line 567 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 567 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->row;
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = d;
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = bpr;
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 5023 "Photo.c"
	}
	{
		GeeHashMap* _tmp3_;
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = self->priv->developments;
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 5031 "Photo.c"
		{
			GeeHashMap* _tmp4_;
			RawDeveloper _tmp5_;
			BackingPhotoRow* _tmp6_;
#line 570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = d;
#line 570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = bpr;
#line 570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp4_), GINT_TO_POINTER (_tmp5_), _tmp6_);
#line 5044 "Photo.c"
		}
		__finally222:
		{
			GeeHashMap* _tmp7_;
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5053 "Photo.c"
		}
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 5061 "Photo.c"
		}
	}
}


void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	BackingPhotoRow* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* file;
	GFile* _tmp3_;
	GFileInfo* _tmp4_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp5_;
	GTimeVal _tmp6_ = {0};
	GTimeVal timestamp;
	GFile* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	DetectedPhotoInformation* detected;
	BackingPhotoRow* _tmp12_;
	DetectedPhotoInformation* _tmp13_;
	Dimensions _tmp14_;
	BackingPhotoRow* _tmp15_;
	GFileInfo* _tmp16_;
	gint64 _tmp17_ = 0LL;
	BackingPhotoRow* _tmp18_;
	GTimeVal _tmp19_;
	glong _tmp20_;
	Orientation _tmp21_ = 0;
	DetectedPhotoInformation* _tmp22_;
	PhotoMetadata* _tmp23_;
	BackingPhotoRow* _tmp27_;
	Orientation _tmp28_;
	BackingPhotoTable* _tmp29_ = NULL;
	BackingPhotoTable* _tmp30_;
	BackingPhotoRow* _tmp31_;
	PhotoTable* _tmp32_ = NULL;
	PhotoTable* _tmp33_;
	PhotoRow* _tmp34_;
	RawDeveloper _tmp35_;
	BackingPhotoRow* _tmp36_;
	BackingPhotoID _tmp37_;
	GError * _inner_error_ = NULL;
#line 574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 576 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = bpr;
#line 576 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->filepath;
#line 576 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 576 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp2_;
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = file;
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	info = _tmp4_;
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 5135 "Photo.c"
	}
#line 579 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = info;
#line 579 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_info_get_modification_time (_tmp5_, &_tmp6_);
#line 579 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	timestamp = _tmp6_;
#line 581 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = file;
#line 581 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (_tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 581 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	interrogator = _tmp8_;
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = interrogator;
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error_);
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 5165 "Photo.c"
	}
#line 585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = interrogator;
#line 585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	detected = _tmp11_;
#line 586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = bpr;
#line 586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = detected;
#line 586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp13_->image_dim;
#line 586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_->dim = _tmp14_;
#line 587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = bpr;
#line 587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = info;
#line 587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = g_file_info_get_size (_tmp16_);
#line 587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_->filesize = _tmp17_;
#line 588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = bpr;
#line 588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = timestamp;
#line 588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = _tmp19_.tv_sec;
#line 588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_->timestamp = (time_t) _tmp20_;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = detected;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = _tmp22_->metadata;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 5203 "Photo.c"
		DetectedPhotoInformation* _tmp24_;
		PhotoMetadata* _tmp25_;
		Orientation _tmp26_ = 0;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = detected;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = _tmp24_->metadata;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = photo_metadata_get_orientation (_tmp25_);
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp26_;
#line 5215 "Photo.c"
	} else {
#line 590 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = ORIENTATION_TOP_LEFT;
#line 5219 "Photo.c"
	}
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = bpr;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = _tmp21_;
#line 589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_->original_orientation = _tmp28_;
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = backing_photo_table_get_instance ();
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = _tmp29_;
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = bpr;
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing_photo_table_add (_tmp30_, _tmp31_, &_inner_error_);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp30_);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 5251 "Photo.c"
	}
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = row;
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = d;
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = bpr;
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = _tmp36_->id;
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_table_update_raw_development (_tmp33_, _tmp34_, _tmp35_, &_tmp37_, &_inner_error_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 5283 "Photo.c"
	}
#line 574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (info);
#line 574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 5293 "Photo.c"
}


static void photo_develop_photo (Photo* self, RawDeveloper d) {
	RawDeveloper _tmp0_;
	GError * _inner_error_ = NULL;
#line 599 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = d;
#line 600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp0_) {
#line 600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5308 "Photo.c"
		{
			{
				RawDeveloper _tmp1_;
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				const gchar* _tmp4_;
				BackingPhotoRow* _tmp5_ = NULL;
				BackingPhotoRow* bps;
				GdkPixbuf* pix;
				GdkPixbuf* _tmp11_;
				BackingPhotoRow* _tmp12_;
				const gchar* _tmp13_;
				PhotoFileWriter* _tmp14_ = NULL;
				PhotoFileWriter* writer;
				PhotoFileWriter* _tmp15_;
				GdkPixbuf* _tmp16_;
				RawDeveloper _tmp17_;
				BackingPhotoRow* _tmp18_;
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = d;
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp2_ = self->row;
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->filepath;
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = raw_developer_create_backing_row_for_development (_tmp1_, _tmp4_, &_inner_error_);
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				bps = _tmp5_;
#line 604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 5341 "Photo.c"
					goto __catch223_g_error;
				}
#line 605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				pix = NULL;
#line 5346 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 5353 "Photo.c"
					{
						Scaling _tmp7_ = {0};
						GdkPixbuf* _tmp8_ = NULL;
						GdkPixbuf* _tmp9_;
#line 607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						scaling_for_original (&_tmp7_);
#line 607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp8_ = photo_get_master_pixbuf (self, &_tmp7_, TRUE, &_inner_error_);
#line 607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp9_ = _tmp8_;
#line 607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 5366 "Photo.c"
							goto __finally224;
						}
#line 607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (pix);
#line 607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						pix = _tmp9_;
#line 5373 "Photo.c"
					}
					__finally224:
					{
						PhotoBackingReaders* _tmp10_;
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp10_ = self->priv->readers;
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5382 "Photo.c"
					}
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (pix);
#line 606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 5390 "Photo.c"
						goto __catch223_g_error;
					}
				}
#line 610 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = pix;
#line 610 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp11_ == NULL) {
#line 611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_debug ("Photo.vala:611: Could not get preview pixbuf");
#line 612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 5406 "Photo.c"
				}
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = bps;
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = _tmp12_->filepath;
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp13_, &_inner_error_);
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				writer = _tmp14_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 616 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 5422 "Photo.c"
					goto __catch223_g_error;
				}
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = writer;
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = pix;
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_file_writer_write (_tmp15_, _tmp16_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 5439 "Photo.c"
					goto __catch223_g_error;
				}
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = d;
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = bps;
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_add_backing_photo_for_development (self, _tmp17_, _tmp18_, &_inner_error_);
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 5456 "Photo.c"
					goto __catch223_g_error;
				}
#line 622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_notify_raw_development_modified (self);
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (pix);
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 5467 "Photo.c"
			}
			goto __finally223;
			__catch223_g_error:
			{
				GError* err = NULL;
				GError* _tmp19_;
				const gchar* _tmp20_;
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				err = _inner_error_;
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = err;
#line 624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = _tmp19_->message;
#line 624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_debug ("Photo.vala:624: Error developing photo: %s", _tmp20_);
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (err);
#line 5487 "Photo.c"
			}
			__finally223:
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 5498 "Photo.c"
			}
#line 627 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 5502 "Photo.c"
		}
#line 600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5506 "Photo.c"
		{
#line 631 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 5510 "Photo.c"
		}
#line 600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5514 "Photo.c"
		{
			{
				PhotoMetadata* _tmp21_ = NULL;
				PhotoMetadata* meta;
				PhotoMetadata* _tmp22_;
				guint _tmp23_ = 0U;
				guint c;
				guint _tmp24_;
				PhotoMetadata* _tmp25_;
				guint _tmp26_;
				PhotoPreview* _tmp27_ = NULL;
				PhotoPreview* prev;
				PhotoPreview* _tmp28_;
				PhotoPreview* _tmp29_;
				GdkPixbuf* _tmp30_ = NULL;
				GdkPixbuf* pix;
				GdkPixbuf* _tmp31_;
				RawDeveloper _tmp32_;
				PhotoRow* _tmp33_;
				BackingPhotoRow* _tmp34_;
				const gchar* _tmp35_;
				BackingPhotoRow* _tmp36_ = NULL;
				BackingPhotoRow* bps;
				BackingPhotoRow* _tmp37_;
				const gchar* _tmp38_;
				PhotoFileWriter* _tmp39_ = NULL;
				PhotoFileWriter* writer;
				PhotoFileWriter* _tmp40_;
				GdkPixbuf* _tmp41_;
				RawDeveloper _tmp42_;
				BackingPhotoRow* _tmp43_;
#line 636 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = photo_get_master_metadata (self, &_inner_error_);
#line 636 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				meta = _tmp21_;
#line 636 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 5552 "Photo.c"
					goto __catch225_g_error;
				}
#line 637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = meta;
#line 637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = photo_metadata_get_preview_count (_tmp22_);
#line 637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				c = _tmp23_;
#line 638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = c;
#line 638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp24_ <= ((guint) 0)) {
#line 639 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 639 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 5569 "Photo.c"
				}
#line 640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = meta;
#line 640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = c;
#line 640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = photo_metadata_get_preview (_tmp25_, _tmp26_ - 1);
#line 640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				prev = _tmp27_;
#line 641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = prev;
#line 641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp28_ == NULL) {
#line 642 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_debug ("Photo.vala:642: Could not get preview from metadata");
#line 643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 5591 "Photo.c"
				}
#line 646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = prev;
#line 646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp30_ = photo_preview_get_pixbuf (_tmp29_, &_inner_error_);
#line 646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				pix = _tmp30_;
#line 646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5605 "Photo.c"
					goto __catch225_g_error;
				}
#line 647 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = pix;
#line 647 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp31_ == NULL) {
#line 648 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_debug ("Photo.vala:648: Could not get preview pixbuf");
#line 649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 5622 "Photo.c"
				}
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = d;
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = self->row;
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp34_ = _tmp33_->master;
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = _tmp34_->filepath;
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = raw_developer_create_backing_row_for_development (_tmp32_, _tmp35_, &_inner_error_);
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				bps = _tmp36_;
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5644 "Photo.c"
					goto __catch225_g_error;
				}
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = bps;
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = _tmp37_->filepath;
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp38_, &_inner_error_);
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				writer = _tmp39_;
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5665 "Photo.c"
					goto __catch225_g_error;
				}
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp40_ = writer;
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp41_ = pix;
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_file_writer_write (_tmp40_, _tmp41_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5686 "Photo.c"
					goto __catch225_g_error;
				}
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp42_ = d;
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = bps;
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_add_backing_photo_for_development (self, _tmp42_, _tmp43_, &_inner_error_);
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pix);
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5707 "Photo.c"
					goto __catch225_g_error;
				}
#line 660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_notify_raw_development_modified (self);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (pix);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 5722 "Photo.c"
			}
			goto __finally225;
			__catch225_g_error:
			{
				GError* e = NULL;
				GError* _tmp44_;
				const gchar* _tmp45_;
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				e = _inner_error_;
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = e;
#line 662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp45_ = _tmp44_->message;
#line 662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_debug ("Photo.vala:662: Error accessing embedded preview. Message: %s", _tmp45_);
#line 663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (e);
#line 663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 5744 "Photo.c"
			}
			__finally225:
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 5755 "Photo.c"
			}
#line 665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 5759 "Photo.c"
		}
		default:
		{
#line 668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_assert_not_reached ();
#line 5765 "Photo.c"
		}
	}
}


void photo_set_default_raw_developer (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 5775 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 5782 "Photo.c"
		{
			PhotoRow* _tmp1_;
			RawDeveloper _tmp2_;
#line 675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = d;
#line 675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_->developer = _tmp2_;
#line 5792 "Photo.c"
		}
		__finally226:
		{
			PhotoRow* _tmp3_;
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 5801 "Photo.c"
		}
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 5811 "Photo.c"
		}
	}
}


void photo_set_raw_developer (Photo* self, RawDeveloper d) {
	PhotoFileFormat _tmp0_ = 0;
	Alteration* _tmp32_;
	Alteration* _tmp33_;
	GError * _inner_error_ = NULL;
#line 680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 5830 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 5838 "Photo.c"
		{
			RawDeveloper _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeHashMap* _tmp5_;
			RawDeveloper _tmp6_;
			gboolean _tmp7_ = FALSE;
			PhotoRow* _tmp9_;
			RawDeveloper _tmp10_;
			GeeHashMap* _tmp11_;
			RawDeveloper _tmp12_;
			gpointer _tmp13_ = NULL;
			PhotoBackingReaders* _tmp14_;
			BackingPhotoRow* _tmp15_;
			PhotoFileFormat _tmp16_;
			BackingPhotoRow* _tmp17_;
			const gchar* _tmp18_;
			PhotoFileReader* _tmp19_ = NULL;
			BackingPhotoRow* _tmp20_;
			Orientation _tmp21_;
#line 686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = d;
#line 686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = photo_is_raw_developer_complete (self, _tmp2_);
#line 686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp3_) {
#line 5864 "Photo.c"
				RawDeveloper _tmp4_;
#line 687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = d;
#line 687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_develop_photo (self, _tmp4_);
#line 5870 "Photo.c"
			}
#line 688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = d;
#line 688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp5_), GINT_TO_POINTER (_tmp6_));
#line 688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp7_) {
#line 5880 "Photo.c"
				{
					GeeHashMap* _tmp8_;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp8_ = self->priv->developments;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5887 "Photo.c"
				}
#line 689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 5891 "Photo.c"
			}
#line 692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->row;
#line 695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = d;
#line 695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_->developer = _tmp10_;
#line 696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = self->priv->developments;
#line 696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = d;
#line 696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp11_), GINT_TO_POINTER (_tmp12_));
#line 696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp13_;
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = self->priv->readers;
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = self->backing_photo_row;
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = _tmp15_->file_format;
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = self->backing_photo_row;
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = _tmp17_->filepath;
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = photo_file_format_create_reader (_tmp16_, _tmp18_);
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp14_->developer);
#line 697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_->developer = _tmp19_;
#line 699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = self->backing_photo_row;
#line 699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = _tmp20_->original_orientation;
#line 699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_set_orientation (self, _tmp21_);
#line 5933 "Photo.c"
			{
				PhotoTable* _tmp22_ = NULL;
				PhotoTable* _tmp23_;
				PhotoRow* _tmp24_;
				RawDeveloper _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoID _tmp27_;
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = photo_table_get_instance ();
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = _tmp22_;
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = self->row;
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = d;
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = self->backing_photo_row;
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = _tmp26_->id;
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_update_raw_development (_tmp23_, _tmp24_, _tmp25_, &_tmp27_, &_inner_error_);
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp23_);
#line 702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 5959 "Photo.c"
					goto __catch228_g_error;
				}
			}
			goto __finally228;
			__catch228_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				e = _inner_error_;
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = e;
#line 704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_warning ("Photo.vala:704: Error updating database: %s", _tmp29_);
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (e);
#line 5981 "Photo.c"
			}
			__finally228:
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 5986 "Photo.c"
				{
					GeeHashMap* _tmp30_;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp30_ = self->priv->developments;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5993 "Photo.c"
				}
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 6001 "Photo.c"
			}
		}
		__finally227:
		{
			GeeHashMap* _tmp31_;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp31_ = self->priv->developments;
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6011 "Photo.c"
		}
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 6021 "Photo.c"
		}
	}
#line 708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = alteration_new ("image", "developer");
#line 708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	data_object_notify_altered (DATA_OBJECT (self), _tmp33_);
#line 708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_unref0 (_tmp33_);
#line 709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 6034 "Photo.c"
}


RawDeveloper photo_get_raw_developer (Photo* self) {
	RawDeveloper result = 0;
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
#line 712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->row;
#line 713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 6052 "Photo.c"
}


static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	gboolean ret;
	GError * _inner_error_ = NULL;
#line 718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 719 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ret = FALSE;
#line 6064 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 6071 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			RawDeveloper _tmp2_;
			gboolean _tmp3_ = FALSE;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			RawDeveloper _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			GeeHashMap* _tmp10_;
			RawDeveloper _tmp11_;
			gpointer _tmp12_ = NULL;
			BackingPhotoRow* bpr;
			BackingPhotoRow* _tmp13_;
			const gchar* _tmp14_;
			GeeHashMap* _tmp35_;
			RawDeveloper _tmp36_;
			gboolean _tmp37_ = FALSE;
#line 722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = d;
#line 722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp1_), GINT_TO_POINTER (_tmp2_));
#line 722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp3_) {
#line 723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = FALSE;
#line 6100 "Photo.c"
				{
					GeeHashMap* _tmp4_;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6107 "Photo.c"
				}
#line 723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 6111 "Photo.c"
			}
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = data_object_to_string (DATA_OBJECT (self));
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = d;
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = raw_developer_to_string (_tmp7_);
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_debug ("Photo.vala:726: Delete raw development: %s %s", _tmp6_, _tmp9_);
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp6_);
#line 727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = self->priv->developments;
#line 727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = d;
#line 727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp10_), GINT_TO_POINTER (_tmp11_));
#line 727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp12_;
#line 728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = bpr;
#line 728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_->filepath;
#line 728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp14_ != NULL) {
#line 6143 "Photo.c"
				BackingPhotoRow* _tmp15_;
				const gchar* _tmp16_;
				GFile* _tmp17_ = NULL;
				GFile* f;
#line 729 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = bpr;
#line 729 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp15_->filepath;
#line 729 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = g_file_new_for_path (_tmp16_);
#line 729 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				f = _tmp17_;
#line 6156 "Photo.c"
				{
					GFile* _tmp18_;
#line 731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp18_ = f;
#line 731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_file_delete (_tmp18_, NULL, &_inner_error_);
#line 731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 6165 "Photo.c"
						goto __catch230_g_error;
					}
				}
				goto __finally230;
				__catch230_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp19_;
					const gchar* _tmp20_;
					GError* _tmp21_;
					const gchar* _tmp22_;
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					e = _inner_error_;
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_inner_error_ = NULL;
#line 733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp19_ = bpr;
#line 733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp20_ = _tmp19_->filepath;
#line 733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp21_ = e;
#line 733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp22_ = _tmp21_->message;
#line 733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_warning ("Photo.vala:733: Unable to delete RAW development: %s error: %s", _tmp20_, _tmp22_);
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_error_free0 (e);
#line 6193 "Photo.c"
				}
				__finally230:
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (f);
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (f);
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 6206 "Photo.c"
					{
						GeeHashMap* _tmp23_;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp23_ = self->priv->developments;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6213 "Photo.c"
					}
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return FALSE;
#line 6221 "Photo.c"
				}
#line 728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (f);
#line 6225 "Photo.c"
			}
			{
				PhotoTable* _tmp24_ = NULL;
				PhotoTable* _tmp25_;
				PhotoRow* _tmp26_;
				RawDeveloper _tmp27_;
				BackingPhotoTable* _tmp28_ = NULL;
				BackingPhotoTable* _tmp29_;
				BackingPhotoRow* _tmp30_;
				BackingPhotoID _tmp31_;
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = photo_table_get_instance ();
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = _tmp24_;
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = self->row;
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = d;
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_remove_development (_tmp25_, _tmp26_, _tmp27_, &_inner_error_);
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp25_);
#line 739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 6250 "Photo.c"
					goto __catch231_g_error;
				}
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = backing_photo_table_get_instance ();
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp30_ = bpr;
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = _tmp30_->id;
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				backing_photo_table_remove (_tmp29_, &_tmp31_, &_inner_error_);
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp29_);
#line 740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 6267 "Photo.c"
					goto __catch231_g_error;
				}
			}
			goto __finally231;
			__catch231_g_error:
			{
				GError* e = NULL;
				GError* _tmp32_;
				const gchar* _tmp33_;
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				e = _inner_error_;
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = e;
#line 742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = _tmp32_->message;
#line 742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_warning ("Photo.vala:742: Database error while deleting RAW development: %s", _tmp33_);
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (e);
#line 6289 "Photo.c"
			}
			__finally231:
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 6298 "Photo.c"
				{
					GeeHashMap* _tmp34_;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = self->priv->developments;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6305 "Photo.c"
				}
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 738 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return FALSE;
#line 6313 "Photo.c"
			}
#line 745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp35_ = self->priv->developments;
#line 745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_ = d;
#line 745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp37_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp35_), GINT_TO_POINTER (_tmp36_), NULL);
#line 745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			ret = _tmp37_;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 6325 "Photo.c"
		}
		__finally229:
		{
			GeeHashMap* _tmp38_;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = self->priv->developments;
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6334 "Photo.c"
		}
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 6344 "Photo.c"
		}
	}
#line 748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 749 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = ret;
#line 749 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 6353 "Photo.c"
}


void photo_redevelop_raw (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 753 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 6361 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 6368 "Photo.c"
		{
			RawDeveloper _tmp1_;
			RawDeveloper _tmp2_;
			RawDeveloper dev;
			RawDeveloper _tmp3_;
			RawDeveloper _tmp4_;
#line 755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = d;
#line 755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_delete_raw_development (self, _tmp1_);
#line 756 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = d;
#line 756 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			dev = _tmp2_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = dev;
#line 757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_ == RAW_DEVELOPER_CAMERA) {
#line 758 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 6389 "Photo.c"
			}
#line 760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = dev;
#line 760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_set_raw_developer (self, _tmp4_);
#line 6395 "Photo.c"
		}
		__finally232:
		{
			GeeHashMap* _tmp5_;
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6404 "Photo.c"
		}
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 6414 "Photo.c"
		}
	}
}


static void _vala_array_add227 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6427 "Photo.c"
	}
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6433 "Photo.c"
}


static void _vala_array_add228 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6444 "Photo.c"
	}
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6450 "Photo.c"
}


static void _vala_array_add229 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6461 "Photo.c"
	}
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6467 "Photo.c"
}


static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1) {
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** _tmp0_ = NULL;
	BackingFileState** backing;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp27_;
	gint _tmp27__length1;
	GError * _inner_error_ = NULL;
#line 764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 765 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 765 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing = _tmp0_;
#line 765 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing_length1 = 0;
#line 765 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 6491 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = self->row;
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 6498 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow* _tmp3_;
			BackingPhotoRow* _tmp4_;
			PhotoRow* _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp12_ = FALSE;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = backing;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add227 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = photo_has_editable (self);
#line 768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_) {
#line 6529 "Photo.c"
				BackingFileState** _tmp9_;
				gint _tmp9__length1;
				BackingPhotoRow* _tmp10_;
				BackingFileState* _tmp11_;
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = backing;
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9__length1 = backing_length1;
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = self->priv->editable;
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = backing_file_state_new_from_photo_row (_tmp10_, NULL);
#line 769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_vala_array_add228 (&backing, &backing_length1, &_backing_size_, _tmp11_);
#line 6544 "Photo.c"
			}
#line 771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo_is_developed (self);
#line 771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp12_) {
#line 6550 "Photo.c"
				GeeCollection* _tmp13_ = NULL;
				GeeCollection* dev_rows;
				GeeCollection* _tmp14_;
#line 772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = photo_get_raw_development_photo_rows (self);
#line 772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				dev_rows = _tmp13_;
#line 773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = dev_rows;
#line 773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp14_ != NULL) {
#line 6562 "Photo.c"
					{
						GeeCollection* _tmp15_;
						GeeIterator* _tmp16_ = NULL;
						GeeIterator* _r_it;
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp15_ = dev_rows;
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp16_ = gee_iterable_iterator (GEE_ITERABLE (_tmp15_));
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_r_it = _tmp16_;
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 6575 "Photo.c"
							GeeIterator* _tmp17_;
							gboolean _tmp18_ = FALSE;
							GeeIterator* _tmp19_;
							gpointer _tmp20_ = NULL;
							BackingPhotoRow* r;
							BackingPhotoRow* _tmp21_;
							const gchar* _tmp22_;
							BackingFileState** _tmp23_;
							gint _tmp23__length1;
							BackingPhotoRow* _tmp24_;
							BackingFileState* _tmp25_;
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp17_ = _r_it;
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp18_ = gee_iterator_next (_tmp17_);
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp18_) {
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 6595 "Photo.c"
							}
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp19_ = _r_it;
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							r = (BackingPhotoRow*) _tmp20_;
#line 775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp21_ = r;
#line 775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp22_ = _tmp21_->filepath;
#line 775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							g_debug ("Photo.vala:775: adding: %s", _tmp22_);
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp23_ = backing;
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp23__length1 = backing_length1;
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp24_ = r;
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp25_ = backing_file_state_new_from_photo_row (_tmp24_, NULL);
#line 776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_vala_array_add229 (&backing, &backing_length1, &_backing_size_, _tmp25_);
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 6621 "Photo.c"
						}
#line 774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 6625 "Photo.c"
					}
				}
#line 771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 6630 "Photo.c"
			}
		}
		__finally233:
		{
			PhotoRow* _tmp26_;
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = self->row;
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 6640 "Photo.c"
		}
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 6652 "Photo.c"
		}
	}
#line 782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = backing;
#line 782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27__length1 = backing_length1;
#line 782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (result_length1) {
#line 782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*result_length1 = _tmp27__length1;
#line 6663 "Photo.c"
	}
#line 782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp27_;
#line 782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 6669 "Photo.c"
}


static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode) {
	PhotoFileReader* result = NULL;
	BackingFetchMode _tmp0_;
#line 785 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = mode;
#line 786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp0_) {
#line 786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 6684 "Photo.c"
		{
			PhotoFileReader* _tmp1_ = NULL;
#line 788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_get_master_reader (self);
#line 788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp1_;
#line 788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 6693 "Photo.c"
		}
#line 786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 6697 "Photo.c"
		{
			PhotoFileReader* _tmp2_ = NULL;
#line 791 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = photo_get_baseline_reader (self);
#line 791 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 791 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 6706 "Photo.c"
		}
#line 786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 6710 "Photo.c"
		{
			PhotoFileReader* _tmp3_ = NULL;
#line 794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = photo_get_source_reader (self);
#line 794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 6719 "Photo.c"
		}
#line 786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 6723 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = photo_get_master_file_format (self);
#line 797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp4_ == PHOTO_FILE_FORMAT_RAW) {
#line 6730 "Photo.c"
				PhotoFileReader* _tmp5_ = NULL;
#line 798 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = photo_get_raw_developer_reader (self);
#line 798 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp5_;
#line 798 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 6738 "Photo.c"
			} else {
				PhotoFileReader* _tmp6_ = NULL;
#line 800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = photo_get_master_reader (self);
#line 800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp6_;
#line 800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 6747 "Photo.c"
			}
		}
		default:
		{
			BackingFetchMode _tmp7_;
			GEnumValue* _tmp8_;
#line 803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = mode;
#line 803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), _tmp7_);
#line 803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_error ("Photo.vala:803: Unknown backing fetch mode %s", (_tmp8_ != NULL) ? _tmp8_->value_name : NULL);
#line 6760 "Photo.c"
		}
	}
}


static gpointer _photo_file_adapter_ref0 (gpointer self) {
#line 809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 6769 "Photo.c"
}


static PhotoFileReader* photo_get_master_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 807 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 6778 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 6785 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 6798 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6805 "Photo.c"
			}
#line 809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 6809 "Photo.c"
		}
		__finally234:
		{
			PhotoBackingReaders* _tmp5_;
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6818 "Photo.c"
		}
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 6826 "Photo.c"
	}
}


PhotoFileReader* photo_get_editable_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 813 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 6836 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 6843 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 6856 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6863 "Photo.c"
			}
#line 815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 6867 "Photo.c"
		}
		__finally235:
		{
			PhotoBackingReaders* _tmp5_;
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6876 "Photo.c"
		}
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 6884 "Photo.c"
	}
}


static PhotoFileReader* photo_get_baseline_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 6894 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 6901 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 822 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 822 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 822 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 6916 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp5_;
#line 6928 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6935 "Photo.c"
				}
#line 823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 6939 "Photo.c"
			}
#line 825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 6947 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp11_;
#line 6959 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6966 "Photo.c"
				}
#line 826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 6970 "Photo.c"
			}
#line 828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp15_;
#line 6980 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6987 "Photo.c"
			}
#line 828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 6991 "Photo.c"
		}
		__finally236:
		{
			PhotoBackingReaders* _tmp17_;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7000 "Photo.c"
		}
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7008 "Photo.c"
	}
}


static PhotoFileReader* photo_get_source_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 833 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7018 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7025 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7040 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp5_;
#line 7052 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7059 "Photo.c"
				}
#line 836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 7063 "Photo.c"
			}
#line 838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7071 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp11_;
#line 7083 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7090 "Photo.c"
				}
#line 839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 7094 "Photo.c"
			}
#line 841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp15_;
#line 7104 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7111 "Photo.c"
			}
#line 841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7115 "Photo.c"
		}
		__finally237:
		{
			PhotoBackingReaders* _tmp17_;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7124 "Photo.c"
		}
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7132 "Photo.c"
	}
}


static PhotoFileReader* photo_get_raw_developer_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 846 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7142 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7149 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 7162 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7169 "Photo.c"
			}
#line 848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7173 "Photo.c"
		}
		__finally238:
		{
			PhotoBackingReaders* _tmp5_;
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7182 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7190 "Photo.c"
	}
}


gboolean photo_is_developed (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 852 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 7200 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7207 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7217 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7224 "Photo.c"
			}
#line 854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7228 "Photo.c"
		}
		__finally239:
		{
			PhotoBackingReaders* _tmp4_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7237 "Photo.c"
		}
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 7245 "Photo.c"
	}
}


gboolean photo_has_editable (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 858 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 7255 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7262 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7272 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7279 "Photo.c"
			}
#line 860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7283 "Photo.c"
		}
		__finally240:
		{
			PhotoBackingReaders* _tmp4_;
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7292 "Photo.c"
		}
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 7300 "Photo.c"
	}
}


gboolean photo_does_master_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 7310 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7317 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			gboolean _tmp3_ = FALSE;
#line 866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = photo_file_adapter_file_exists (PHOTO_FILE_ADAPTER (_tmp2_));
#line 866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 7330 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7337 "Photo.c"
			}
#line 866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7341 "Photo.c"
		}
		__finally241:
		{
			PhotoBackingReaders* _tmp5_;
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7350 "Photo.c"
		}
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 7358 "Photo.c"
	}
}


gboolean photo_does_editable_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 7368 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7375 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 7386 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = photo_file_adapter_file_exists (PHOTO_FILE_ADAPTER (_tmp5_));
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 7398 "Photo.c"
			} else {
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = FALSE;
#line 7402 "Photo.c"
			}
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp1_;
#line 7406 "Photo.c"
			{
				PhotoBackingReaders* _tmp7_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7413 "Photo.c"
			}
#line 873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7417 "Photo.c"
		}
		__finally242:
		{
			PhotoBackingReaders* _tmp8_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7426 "Photo.c"
		}
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 7434 "Photo.c"
	}
}


gboolean photo_is_master_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 877 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 7444 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7451 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 879 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 879 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 879 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_ == NULL;
#line 7461 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7468 "Photo.c"
			}
#line 879 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7472 "Photo.c"
		}
		__finally243:
		{
			PhotoBackingReaders* _tmp4_;
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7481 "Photo.c"
		}
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 7489 "Photo.c"
	}
}


gboolean photo_is_master_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 883 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = !_tmp0_;
#line 884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 7505 "Photo.c"
}


gboolean photo_is_editable_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 887 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 7514 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7521 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7531 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7538 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7542 "Photo.c"
		}
		__finally244:
		{
			PhotoBackingReaders* _tmp4_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7551 "Photo.c"
		}
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 7559 "Photo.c"
	}
}


gboolean photo_is_editable_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 7575 "Photo.c"
}


BackingPhotoRow* photo_get_master_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7584 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7591 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 7604 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7611 "Photo.c"
			}
#line 899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7615 "Photo.c"
		}
		__finally245:
		{
			PhotoRow* _tmp5_;
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7624 "Photo.c"
		}
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7632 "Photo.c"
	}
}


BackingPhotoRow* photo_get_editable_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7642 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7649 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 906 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 906 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = backing_photo_id_is_valid (&_tmp1_->editable_id);
#line 906 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_) {
#line 7659 "Photo.c"
				BackingPhotoRow* _tmp3_;
				BackingPhotoRow* _tmp4_;
#line 907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->editable;
#line 907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _backing_photo_row_ref0 (_tmp3_);
#line 907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = _tmp4_;
#line 7668 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp5_ = self->row;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7675 "Photo.c"
				}
#line 907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 7679 "Photo.c"
			} else {
#line 909 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = NULL;
#line 7683 "Photo.c"
				{
					PhotoRow* _tmp6_;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp6_ = self->row;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7690 "Photo.c"
				}
#line 909 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 7694 "Photo.c"
			}
		}
		__finally246:
		{
			PhotoRow* _tmp7_;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->row;
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7704 "Photo.c"
		}
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 904 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7712 "Photo.c"
	}
}


GeeCollection* photo_get_raw_development_photo_rows (Photo* self) {
	GeeCollection* result = NULL;
	GError * _inner_error_ = NULL;
#line 913 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7722 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7729 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7737 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (GEE_MAP (_tmp3_));
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 7751 "Photo.c"
			} else {
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = NULL;
#line 7757 "Photo.c"
			}
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp1_;
#line 7761 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->row;
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7768 "Photo.c"
			}
#line 915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7772 "Photo.c"
		}
		__finally247:
		{
			PhotoRow* _tmp7_;
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->row;
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7781 "Photo.c"
		}
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7789 "Photo.c"
	}
}


BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7799 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7806 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7814 "Photo.c"
				GeeHashMap* _tmp3_;
				RawDeveloper _tmp4_;
				gpointer _tmp5_ = NULL;
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = d;
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp3_), GINT_TO_POINTER (_tmp4_));
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp5_;
#line 7828 "Photo.c"
			} else {
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = NULL;
#line 7834 "Photo.c"
			}
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp1_;
#line 7838 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->row;
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7845 "Photo.c"
			}
#line 921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 7849 "Photo.c"
		}
		__finally248:
		{
			PhotoRow* _tmp7_;
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->row;
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7858 "Photo.c"
		}
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 7866 "Photo.c"
	}
}


static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self) {
	PhotoFileFormat* dup;
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return dup;
#line 7879 "Photo.c"
}


static gpointer __photo_file_format_dup0 (gpointer self) {
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 7886 "Photo.c"
}


PhotoFileFormat* photo_get_editable_file_format (Photo* self) {
	PhotoFileFormat* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_ = 0;
	PhotoFileFormat* _tmp4_;
#line 925 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 926 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 926 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reader = _tmp0_;
#line 927 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = reader;
#line 927 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 928 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 928 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 928 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 7914 "Photo.c"
	}
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = reader;
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 7928 "Photo.c"
}


PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _result_;
	ExportFormatParameters _tmp1_;
	ExportFormatMode _tmp2_;
#line 934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_file_format_get_system_default_format ();
#line 935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_result_ = _tmp0_;
#line 937 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = *params;
#line 937 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_.mode;
#line 937 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp2_) {
#line 937 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 7954 "Photo.c"
		{
			PhotoFileFormat _tmp3_ = 0;
#line 939 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = photo_get_master_file_format (self);
#line 939 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_result_ = _tmp3_;
#line 940 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 7963 "Photo.c"
		}
#line 937 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 7967 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = photo_get_best_export_file_format (self);
#line 943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_result_ = _tmp4_;
#line 944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 7976 "Photo.c"
		}
#line 937 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 7980 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
#line 947 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = *params;
#line 947 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp5_.specified_format;
#line 947 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_result_ = _tmp6_;
#line 948 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 7992 "Photo.c"
		}
		default:
		{
#line 951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_error ("Photo.vala:951: get_export_format_for_parameters: unsupported export f" \
"ormat mode");
#line 7998 "Photo.c"
		}
	}
#line 954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _result_;
#line 954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 8005 "Photo.c"
}


gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params) {
	gchar* result = NULL;
	gchar* _result_;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_result_ = NULL;
#line 960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *params;
#line 960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp1_) {
#line 960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8029 "Photo.c"
		{
			GFile* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_ = NULL;
#line 962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_result_);
#line 962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_result_ = _tmp4_;
#line 962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 963 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 8048 "Photo.c"
		}
#line 960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8054 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_ = 0;
			gchar* _tmp7_ = NULL;
#line 967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = *params;
#line 967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp7_;
#line 967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_result_);
#line 967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 8071 "Photo.c"
		}
		default:
		{
#line 970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_error ("Photo.vala:970: get_export_basename_for_parameters: unsupported export" \
" format mode");
#line 8077 "Photo.c"
		}
	}
#line 973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _result_;
#line 973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp8_ != NULL);
#line 974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _result_;
#line 974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 8088 "Photo.c"
}


ImportResult photo_prepare_for_import (PhotoImportParams* params) {
	ImportResult result = 0;
	PhotoImportParams* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp6_;
	GFileType _tmp7_ = 0;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GFile* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GFileInfo* _tmp18_;
	GTimeVal _tmp19_ = {0};
	GTimeVal timestamp;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	PhotoImportParams* _tmp22_;
	const gchar* _tmp23_;
	gboolean _tmp26_;
	gboolean _tmp29_;
	GFile* _tmp33_;
	PhotoImportParams* _tmp34_;
	PhotoFileSnifferOptions _tmp35_;
	PhotoFileInterrogator* _tmp36_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp43_;
	DetectedPhotoInformation* _tmp44_ = NULL;
	DetectedPhotoInformation* detected;
	DetectedPhotoInformation* _tmp45_;
	PhotoImportParams* _tmp46_;
	PhotoFileSnifferOptions _tmp47_;
	Orientation orientation;
	time_t exposure_time;
	gchar* _tmp60_;
	gchar* title;
	Rating rating;
	DetectedPhotoInformation* _tmp61_;
	PhotoMetadata* _tmp62_;
	gboolean _tmp82_ = FALSE;
	gboolean _tmp83_ = FALSE;
	DetectedPhotoInformation* _tmp84_;
	GdkColorspace _tmp85_;
	gboolean _tmp88_;
	gboolean _tmp91_;
	PhotoImportParams* _tmp95_;
	PhotoRow* _tmp96_;
	PhotoImportParams* _tmp97_;
	PhotoRow* _tmp98_;
	BackingPhotoRow* _tmp99_;
	GFile* _tmp100_;
	gchar* _tmp101_ = NULL;
	PhotoImportParams* _tmp102_;
	PhotoRow* _tmp103_;
	BackingPhotoRow* _tmp104_;
	DetectedPhotoInformation* _tmp105_;
	Dimensions _tmp106_;
	PhotoImportParams* _tmp107_;
	PhotoRow* _tmp108_;
	BackingPhotoRow* _tmp109_;
	GFileInfo* _tmp110_;
	gint64 _tmp111_ = 0LL;
	PhotoImportParams* _tmp112_;
	PhotoRow* _tmp113_;
	BackingPhotoRow* _tmp114_;
	GTimeVal _tmp115_;
	glong _tmp116_;
	PhotoImportParams* _tmp117_;
	PhotoRow* _tmp118_;
	time_t _tmp119_;
	PhotoImportParams* _tmp120_;
	PhotoRow* _tmp121_;
	Orientation _tmp122_;
	PhotoImportParams* _tmp123_;
	PhotoRow* _tmp124_;
	BackingPhotoRow* _tmp125_;
	Orientation _tmp126_;
	PhotoImportParams* _tmp127_;
	PhotoRow* _tmp128_;
	PhotoImportParams* _tmp129_;
	ImportID _tmp130_;
	PhotoImportParams* _tmp131_;
	PhotoRow* _tmp132_;
	PhotoImportParams* _tmp133_;
	PhotoRow* _tmp134_;
	PhotoImportParams* _tmp135_;
	PhotoRow* _tmp136_;
	DetectedPhotoInformation* _tmp137_;
	const gchar* _tmp138_;
	gchar* _tmp139_;
	PhotoImportParams* _tmp140_;
	PhotoRow* _tmp141_;
	DetectedPhotoInformation* _tmp142_;
	const gchar* _tmp143_;
	gchar* _tmp144_;
	PhotoImportParams* _tmp145_;
	PhotoRow* _tmp146_;
	DetectedPhotoInformation* _tmp147_;
	const gchar* _tmp148_;
	gchar* _tmp149_;
	PhotoImportParams* _tmp150_;
	PhotoRow* _tmp151_;
	PhotoImportParams* _tmp152_;
	PhotoRow* _tmp153_;
	PhotoImportParams* _tmp154_;
	PhotoRow* _tmp155_;
	BackingPhotoRow* _tmp156_;
	DetectedPhotoInformation* _tmp157_;
	PhotoFileFormat _tmp158_;
	PhotoImportParams* _tmp159_;
	PhotoRow* _tmp160_;
	const gchar* _tmp161_;
	gchar* _tmp162_;
	PhotoImportParams* _tmp163_;
	PhotoRow* _tmp164_;
	Rating _tmp165_;
	PhotoImportParams* _tmp166_;
	Thumbnails* _tmp167_;
	GError * _inner_error_ = NULL;
#line 989 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = params;
#line 993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp2_;
#line 995 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	info = NULL;
#line 8224 "Photo.c"
	{
		GFile* _tmp3_;
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_;
#line 997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = file;
#line 997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 8237 "Photo.c"
			goto __catch249_g_error;
		}
#line 997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		info = _tmp5_;
#line 8244 "Photo.c"
	}
	goto __finally249;
	__catch249_g_error:
	{
		GError* err = NULL;
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 1000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8264 "Photo.c"
	}
	__finally249:
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 8279 "Photo.c"
	}
#line 1003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = info;
#line 1003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = g_file_info_get_file_type (_tmp6_);
#line 1003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp7_ != G_FILE_TYPE_REGULAR) {
#line 1004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8295 "Photo.c"
	}
#line 1006 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = file;
#line 1006 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = photo_is_file_image (_tmp8_);
#line 1006 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp9_) {
#line 8303 "Photo.c"
		GFile* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
#line 1007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = file;
#line 1007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = g_file_get_path (_tmp10_);
#line 1007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_message ("Photo.vala:1007: Not importing %s: Not an image file", _tmp12_);
#line 1007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp12_);
#line 1009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8325 "Photo.c"
	}
#line 1012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = file;
#line 1012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = photo_file_format_is_file_supported (_tmp13_);
#line 1012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp14_) {
#line 8333 "Photo.c"
		GFile* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = file;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 1013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_message ("Photo.vala:1013: Not importing %s: Unsupported extension", _tmp17_);
#line 1013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8355 "Photo.c"
	}
#line 1018 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = info;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_info_get_modification_time (_tmp18_, &_tmp19_);
#line 1018 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	timestamp = _tmp19_;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = params;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = _tmp22_->exif_md5;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 8369 "Photo.c"
		PhotoImportParams* _tmp24_;
		const gchar* _tmp25_;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = params;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = _tmp24_->thumbnail_md5;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp25_ != NULL;
#line 8378 "Photo.c"
	} else {
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = FALSE;
#line 8382 "Photo.c"
	}
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = _tmp21_;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp26_) {
#line 8388 "Photo.c"
		PhotoImportParams* _tmp27_;
		const gchar* _tmp28_;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27_ = params;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp28_ = _tmp27_->full_md5;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = _tmp28_ != NULL;
#line 8397 "Photo.c"
	} else {
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = FALSE;
#line 8401 "Photo.c"
	}
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = _tmp20_;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp29_) {
#line 8407 "Photo.c"
		PhotoImportParams* _tmp30_;
		PhotoImportParams* _tmp31_;
		PhotoFileSnifferOptions _tmp32_;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = params;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = params;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = _tmp31_->sniffer_options;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_->sniffer_options = _tmp32_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 8419 "Photo.c"
	}
#line 1025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = file;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = params;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = _tmp34_->sniffer_options;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = photo_file_interrogator_new (_tmp33_, _tmp35_);
#line 1025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	interrogator = _tmp36_;
#line 8431 "Photo.c"
	{
		PhotoFileInterrogator* _tmp37_;
#line 1027 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp37_ = interrogator;
#line 1027 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp37_, &_inner_error_);
#line 1027 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 8440 "Photo.c"
			goto __catch250_g_error;
		}
	}
	goto __finally250;
	__catch250_g_error:
	{
		GError* err = NULL;
		GFile* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp38_ = file;
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp39_ = g_file_get_path (_tmp38_);
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41_ = err;
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp42_ = _tmp41_->message;
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:1029: Unable to interrogate photo file %s: %s", _tmp40_, _tmp42_);
#line 1029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp40_);
#line 1031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 1031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8483 "Photo.c"
	}
	__finally250:
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 8500 "Photo.c"
	}
#line 1035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = interrogator;
#line 1035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = photo_file_interrogator_get_detected_photo_information (_tmp43_);
#line 1035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	detected = _tmp44_;
#line 1036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = detected;
#line 1036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp45_ == NULL) {
#line 1037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8524 "Photo.c"
	}
#line 1040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = params;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = _tmp46_->sniffer_options;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp47_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 8532 "Photo.c"
		DetectedPhotoInformation* _tmp48_;
		PhotoImportParams* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		DetectedPhotoInformation* _tmp52_;
		PhotoImportParams* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		DetectedPhotoInformation* _tmp56_;
		PhotoImportParams* _tmp57_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 1041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp48_ = detected;
#line 1041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49_ = params;
#line 1041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = _tmp49_->exif_md5;
#line 1041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = g_strdup (_tmp50_);
#line 1041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp48_->exif_md5);
#line 1041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp48_->exif_md5 = _tmp51_;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp52_ = detected;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp53_ = params;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = _tmp53_->thumbnail_md5;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = g_strdup (_tmp54_);
#line 1042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp52_->thumbnail_md5);
#line 1042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp52_->thumbnail_md5 = _tmp55_;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp56_ = detected;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp57_ = params;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp58_ = _tmp57_->full_md5;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp59_ = g_strdup (_tmp58_);
#line 1043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp56_->md5);
#line 1043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp56_->md5 = _tmp59_;
#line 8581 "Photo.c"
	}
#line 1046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1047 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp60_ = g_strdup ("");
#line 1048 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	title = _tmp60_;
#line 1049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	rating = RATING_UNRATED;
#line 1056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp61_ = detected;
#line 1056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp62_ = _tmp61_->metadata;
#line 1056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp62_ != NULL) {
#line 8599 "Photo.c"
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		MetadataDateTime* _tmp65_ = NULL;
		MetadataDateTime* date_time;
		MetadataDateTime* _tmp66_;
		DetectedPhotoInformation* _tmp69_;
		PhotoMetadata* _tmp70_;
		Orientation _tmp71_ = 0;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
		gchar* _tmp74_ = NULL;
		PhotoImportParams* _tmp75_;
		DetectedPhotoInformation* _tmp76_;
		PhotoMetadata* _tmp77_;
		GeeSet* _tmp78_ = NULL;
		DetectedPhotoInformation* _tmp79_;
		PhotoMetadata* _tmp80_;
		Rating _tmp81_ = 0;
#line 1057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp63_ = detected;
#line 1057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp65_ = photo_metadata_get_exposure_date_time (_tmp64_);
#line 1057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		date_time = _tmp65_;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp66_ = date_time;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp66_ != NULL) {
#line 8630 "Photo.c"
			MetadataDateTime* _tmp67_;
			time_t _tmp68_ = 0;
#line 1059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp67_ = date_time;
#line 1059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp68_ = metadata_date_time_get_timestamp (_tmp67_);
#line 1059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			exposure_time = _tmp68_;
#line 8639 "Photo.c"
		}
#line 1061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp69_ = detected;
#line 1061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp71_ = photo_metadata_get_orientation (_tmp70_);
#line 1061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		orientation = _tmp71_;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp72_ = detected;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp74_ = media_metadata_get_title (MEDIA_METADATA (_tmp73_));
#line 1062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (title);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		title = _tmp74_;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp75_ = params;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp76_ = detected;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp77_ = _tmp76_->metadata;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp78_ = photo_metadata_get_keywords (_tmp77_, NULL);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp75_->keywords);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp75_->keywords = GEE_COLLECTION (_tmp78_);
#line 1064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp79_ = detected;
#line 1064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp80_ = _tmp79_->metadata;
#line 1064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp81_ = photo_metadata_get_rating (_tmp80_);
#line 1064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		rating = _tmp81_;
#line 1056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 8681 "Photo.c"
	}
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp84_ = detected;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp85_ = _tmp84_->colorspace;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp85_ != GDK_COLORSPACE_RGB) {
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp83_ = TRUE;
#line 8691 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp86_;
		gint _tmp87_;
#line 1069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp86_ = detected;
#line 1069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp87_ = _tmp86_->channels;
#line 1069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp83_ = _tmp87_ < 3;
#line 8701 "Photo.c"
	}
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp88_ = _tmp83_;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp88_) {
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp82_ = TRUE;
#line 8709 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp89_;
		gint _tmp90_;
#line 1070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp89_ = detected;
#line 1070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp90_ = _tmp89_->bits_per_channel;
#line 1070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp82_ = _tmp90_ != 8;
#line 8719 "Photo.c"
	}
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp91_ = _tmp82_;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp91_) {
#line 8725 "Photo.c"
		GFile* _tmp92_;
		gchar* _tmp93_ = NULL;
		gchar* _tmp94_;
#line 1071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp92_ = file;
#line 1071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp93_ = g_file_get_path (_tmp92_);
#line 1071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp94_ = _tmp93_;
#line 1071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_message ("Photo.vala:1071: Not importing %s: Unsupported color format", _tmp94_);
#line 1071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp94_);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (title);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 8753 "Photo.c"
	}
#line 1079 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp95_ = params;
#line 1079 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp96_ = _tmp95_->row;
#line 1079 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_id_init (&_tmp96_->photo_id, PHOTO_ID_INVALID);
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp97_ = params;
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp98_ = _tmp97_->row;
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp99_ = _tmp98_->master;
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp100_ = file;
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp101_ = g_file_get_path (_tmp100_);
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp99_->filepath);
#line 1080 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp99_->filepath = _tmp101_;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp102_ = params;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp103_ = _tmp102_->row;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp104_ = _tmp103_->master;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp105_ = detected;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp106_ = _tmp105_->image_dim;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp104_->dim = _tmp106_;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp107_ = params;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp108_ = _tmp107_->row;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp109_ = _tmp108_->master;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp110_ = info;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp111_ = g_file_info_get_size (_tmp110_);
#line 1082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp109_->filesize = _tmp111_;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp112_ = params;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp113_ = _tmp112_->row;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp114_ = _tmp113_->master;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp115_ = timestamp;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp116_ = _tmp115_.tv_sec;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp114_->timestamp = (time_t) _tmp116_;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp117_ = params;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp118_ = _tmp117_->row;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp119_ = exposure_time;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp118_->exposure_time = _tmp119_;
#line 1085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp120_ = params;
#line 1085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp121_ = _tmp120_->row;
#line 1085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp122_ = orientation;
#line 1085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp121_->orientation = _tmp122_;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp123_ = params;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp124_ = _tmp123_->row;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp125_ = _tmp124_->master;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp126_ = orientation;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp125_->original_orientation = _tmp126_;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp127_ = params;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp128_ = _tmp127_->row;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp129_ = params;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp130_ = _tmp129_->import_id;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp128_->import_id = _tmp130_;
#line 1088 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp131_ = params;
#line 1088 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp132_ = _tmp131_->row;
#line 1088 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	event_id_init (&_tmp132_->event_id, EVENT_ID_INVALID);
#line 1089 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp133_ = params;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp134_ = _tmp133_->row;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp134_->transformations);
#line 1089 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp134_->transformations = NULL;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp135_ = params;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp136_ = _tmp135_->row;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp137_ = detected;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp138_ = _tmp137_->md5;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp139_ = g_strdup (_tmp138_);
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp136_->md5);
#line 1090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp136_->md5 = _tmp139_;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp140_ = params;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp141_ = _tmp140_->row;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp142_ = detected;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp143_ = _tmp142_->thumbnail_md5;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp144_ = g_strdup (_tmp143_);
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp141_->thumbnail_md5);
#line 1091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp141_->thumbnail_md5 = _tmp144_;
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp145_ = params;
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp146_ = _tmp145_->row;
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp147_ = detected;
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp148_ = _tmp147_->exif_md5;
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp149_ = g_strdup (_tmp148_);
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp146_->exif_md5);
#line 1092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp146_->exif_md5 = _tmp149_;
#line 1093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp150_ = params;
#line 1093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp151_ = _tmp150_->row;
#line 1093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp151_->time_created = (time_t) 0;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp152_ = params;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp153_ = _tmp152_->row;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp153_->flags = (guint64) 0;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp154_ = params;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp155_ = _tmp154_->row;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp156_ = _tmp155_->master;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp157_ = detected;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp158_ = _tmp157_->file_format;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp156_->file_format = _tmp158_;
#line 1096 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp159_ = params;
#line 1096 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp160_ = _tmp159_->row;
#line 1096 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp161_ = title;
#line 1096 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp162_ = g_strdup (_tmp161_);
#line 1096 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp160_->title);
#line 1096 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp160_->title = _tmp162_;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp163_ = params;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp164_ = _tmp163_->row;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp165_ = rating;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp164_->rating = _tmp165_;
#line 1099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp166_ = params;
#line 1099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp167_ = _tmp166_->thumbnails;
#line 1099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp167_ != NULL) {
#line 8953 "Photo.c"
		PhotoImportParams* _tmp168_;
		PhotoRow* _tmp169_;
		BackingPhotoRow* _tmp170_;
		PhotoFileFormat _tmp171_;
		PhotoImportParams* _tmp172_;
		PhotoRow* _tmp173_;
		BackingPhotoRow* _tmp174_;
		const gchar* _tmp175_;
		PhotoFileReader* _tmp176_ = NULL;
		PhotoFileReader* reader;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp168_ = params;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp169_ = _tmp168_->row;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp170_ = _tmp169_->master;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp171_ = _tmp170_->file_format;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp172_ = params;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp173_ = _tmp172_->row;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp174_ = _tmp173_->master;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp175_ = _tmp174_->filepath;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp176_ = photo_file_format_create_reader (_tmp171_, _tmp175_);
#line 1100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		reader = _tmp176_;
#line 8984 "Photo.c"
		{
			PhotoImportParams* _tmp177_;
			Thumbnails* _tmp178_;
			PhotoFileReader* _tmp179_;
			PhotoImportParams* _tmp180_;
			PhotoRow* _tmp181_;
			Orientation _tmp182_;
			PhotoImportParams* _tmp183_;
			PhotoRow* _tmp184_;
			BackingPhotoRow* _tmp185_;
			Dimensions _tmp186_;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp177_ = params;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp178_ = _tmp177_->thumbnails;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp179_ = reader;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp180_ = params;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp181_ = _tmp180_->row;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp182_ = _tmp181_->orientation;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp183_ = params;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp184_ = _tmp183_->row;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp185_ = _tmp184_->master;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp186_ = _tmp185_->dim;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp178_, _tmp179_, _tmp182_, &_tmp186_, &_inner_error_);
#line 1103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 9020 "Photo.c"
				goto __catch251_g_error;
			}
		}
		goto __finally251;
		__catch251_g_error:
		{
			GError* err = NULL;
			GError* _tmp187_;
			ImportResult _tmp188_ = 0;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp187_ = err;
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp188_ = import_result_convert_error (_tmp187_, IMPORT_RESULT_FILE_ERROR);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp188_;
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (title);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 9056 "Photo.c"
		}
		__finally251:
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (title);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return 0;
#line 9079 "Photo.c"
		}
#line 1099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 9083 "Photo.c"
	}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (title);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (info);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 9099 "Photo.c"
}


void photo_create_pre_import (PhotoImportParams* params) {
	PhotoImportParams* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file;
	PhotoImportParams* _tmp3_;
	PhotoRow* _tmp4_;
	PhotoImportParams* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	gchar* _tmp8_ = NULL;
	PhotoImportParams* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoImportParams* _tmp12_;
	PhotoRow* _tmp13_;
	BackingPhotoRow* _tmp14_;
	PhotoImportParams* _tmp15_;
	PhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	PhotoImportParams* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoImportParams* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoImportParams* _tmp22_;
	PhotoRow* _tmp23_;
	BackingPhotoRow* _tmp24_;
	PhotoImportParams* _tmp25_;
	PhotoRow* _tmp26_;
	PhotoImportParams* _tmp27_;
	ImportID _tmp28_;
	PhotoImportParams* _tmp29_;
	PhotoRow* _tmp30_;
	PhotoImportParams* _tmp31_;
	PhotoRow* _tmp32_;
	PhotoImportParams* _tmp33_;
	PhotoRow* _tmp34_;
	PhotoImportParams* _tmp35_;
	PhotoRow* _tmp36_;
	PhotoImportParams* _tmp37_;
	PhotoRow* _tmp38_;
	PhotoImportParams* _tmp39_;
	PhotoRow* _tmp40_;
	PhotoImportParams* _tmp41_;
	PhotoRow* _tmp42_;
	PhotoImportParams* _tmp43_;
	PhotoRow* _tmp44_;
	BackingPhotoRow* _tmp45_;
	PhotoImportParams* _tmp46_;
	PhotoRow* _tmp47_;
	PhotoImportParams* _tmp48_;
	PhotoRow* _tmp49_;
	PhotoImportParams* _tmp50_;
	GFile* _tmp51_;
	PhotoImportParams* _tmp52_;
	PhotoFileSnifferOptions _tmp53_;
	PhotoFileInterrogator* _tmp54_;
	PhotoFileInterrogator* interrogator;
	GError * _inner_error_ = NULL;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 1117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = params;
#line 1117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp2_;
#line 1118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = params;
#line 1118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_->row;
#line 1118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_id_init (&_tmp4_->photo_id, PHOTO_ID_INVALID);
#line 1119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = params;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_->row;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = g_file_get_path (file);
#line 1119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp7_->filepath);
#line 1119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_->filepath = _tmp8_;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = params;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = _tmp9_->row;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dimensions_init (&_tmp11_->dim, 0, 0);
#line 1121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = params;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_->row;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp13_->master;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_->filesize = (gint64) 0;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = params;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = _tmp15_->row;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp16_->master;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_->timestamp = (time_t) 0;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = params;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = _tmp18_->row;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_->exposure_time = (time_t) 0;
#line 1124 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = params;
#line 1124 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = _tmp20_->row;
#line 1124 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_->orientation = ORIENTATION_TOP_LEFT;
#line 1125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = params;
#line 1125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = _tmp22_->row;
#line 1125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = _tmp23_->master;
#line 1125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = params;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = _tmp25_->row;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = params;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = _tmp27_->import_id;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_->import_id = _tmp28_;
#line 1127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = params;
#line 1127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = _tmp29_->row;
#line 1127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	event_id_init (&_tmp30_->event_id, EVENT_ID_INVALID);
#line 1128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = params;
#line 1128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = _tmp31_->row;
#line 1128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp32_->transformations);
#line 1128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_->transformations = NULL;
#line 1129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = params;
#line 1129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_->row;
#line 1129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp34_->md5);
#line 1129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_->md5 = NULL;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = params;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = _tmp35_->row;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp36_->thumbnail_md5);
#line 1130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_->thumbnail_md5 = NULL;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = params;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = _tmp37_->row;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp38_->exif_md5);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_->exif_md5 = NULL;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = params;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = _tmp39_->row;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_->time_created = (time_t) 0;
#line 1133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = params;
#line 1133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = _tmp41_->row;
#line 1133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_->flags = (guint64) 0;
#line 1134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = params;
#line 1134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = _tmp43_->row;
#line 1134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = _tmp44_->master;
#line 1134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1135 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = params;
#line 1135 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = _tmp46_->row;
#line 1135 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp47_->title);
#line 1135 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_->title = NULL;
#line 1136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = params;
#line 1136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_ = _tmp48_->row;
#line 1136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_->rating = RATING_UNRATED;
#line 1138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp50_ = params;
#line 1138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp51_ = _tmp50_->file;
#line 1138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp52_ = params;
#line 1138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp53_ = _tmp52_->sniffer_options;
#line 1138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp54_ = photo_file_interrogator_new (_tmp51_, _tmp53_);
#line 1138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	interrogator = _tmp54_;
#line 9328 "Photo.c"
	{
		DetectedPhotoInformation* _tmp55_ = NULL;
		DetectedPhotoInformation* detected;
		DetectedPhotoInformation* _tmp56_;
#line 1140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 1140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 9337 "Photo.c"
			goto __catch252_g_error;
		}
#line 1141 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1141 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		detected = _tmp55_;
#line 1142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp56_ = detected;
#line 1142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp56_ != NULL) {
#line 9348 "Photo.c"
			PhotoImportParams* _tmp57_;
			PhotoRow* _tmp58_;
			BackingPhotoRow* _tmp59_;
			DetectedPhotoInformation* _tmp60_;
			PhotoFileFormat _tmp61_;
#line 1143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp57_ = params;
#line 1143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp58_ = _tmp57_->row;
#line 1143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp59_ = _tmp58_->master;
#line 1143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp60_ = detected;
#line 1143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp61_ = _tmp60_->file_format;
#line 1143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp59_->file_format = _tmp61_;
#line 9366 "Photo.c"
		}
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 9370 "Photo.c"
	}
	goto __finally252;
	__catch252_g_error:
	{
		GError* err = NULL;
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_;
		GError* _tmp64_;
		const gchar* _tmp65_;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp62_ = g_file_get_path (file);
#line 1145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp63_ = _tmp62_;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp64_ = err;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp65_ = _tmp64_->message;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_debug ("Photo.vala:1145: Unable to interrogate photo file %s: %s", _tmp63_, _tmp65_);
#line 1145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp63_);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 9398 "Photo.c"
	}
	__finally252:
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 9413 "Photo.c"
	}
#line 1116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 9419 "Photo.c"
}


BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error) {
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* backing;
	GFileInfo* info;
	GFile* _tmp9_;
	PhotoFileSnifferOptions _tmp10_;
	PhotoFileInterrogator* _tmp11_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp12_;
	PhotoFileInterrogator* _tmp13_;
	DetectedPhotoInformation* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_;
	GFileInfo* _tmp18_;
	GTimeVal _tmp19_ = {0};
	GTimeVal modification_time;
	BackingPhotoRow* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_ = NULL;
	BackingPhotoRow* _tmp23_;
	GTimeVal _tmp24_;
	glong _tmp25_;
	BackingPhotoRow* _tmp26_;
	GFileInfo* _tmp27_;
	gint64 _tmp28_ = 0LL;
	BackingPhotoRow* _tmp29_;
	DetectedPhotoInformation* _tmp30_;
	PhotoFileFormat _tmp31_;
	BackingPhotoRow* _tmp32_;
	DetectedPhotoInformation* _tmp33_;
	Dimensions _tmp34_;
	Orientation _tmp35_ = 0;
	DetectedPhotoInformation* _tmp36_;
	PhotoMetadata* _tmp37_;
	BackingPhotoRow* _tmp41_;
	Orientation _tmp42_;
	GError * _inner_error_ = NULL;
#line 1149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_detected = NULL;
#line 1153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing = _tmp0_;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	info = NULL;
#line 9475 "Photo.c"
	{
		GFile* _tmp1_;
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_;
#line 1157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = file;
#line 1157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = g_file_query_info (_tmp1_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 9488 "Photo.c"
			goto __catch253_g_error;
		}
#line 1157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		info = _tmp3_;
#line 9495 "Photo.c"
	}
	goto __finally253;
	__catch253_g_error:
	{
		GError* err = NULL;
		GFile* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = file;
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = err;
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = _tmp7_->message;
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("Photo.vala:1160: Unable to read file information for %s: %s", _tmp6_, _tmp8_);
#line 1160 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (detected) {
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*detected = _vala_detected;
#line 9536 "Photo.c"
		} else {
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 9540 "Photo.c"
		}
#line 1162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 9544 "Photo.c"
	}
	__finally253:
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 9557 "Photo.c"
	}
#line 1166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = file;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = options;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_new (_tmp9_, _tmp10_);
#line 1166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	interrogator = _tmp11_;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = interrogator;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp12_, &_inner_error_);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 9583 "Photo.c"
	}
#line 1168 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = interrogator;
#line 1168 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (_tmp13_);
#line 1168 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1168 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_detected = _tmp14_;
#line 1169 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _vala_detected;
#line 1169 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 9597 "Photo.c"
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 1170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = data_object_to_string (DATA_OBJECT (self));
#line 1170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("Photo.vala:1170: Photo update: %s no longer a recognized image", _tmp17_);
#line 1170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (detected) {
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*detected = _vala_detected;
#line 9620 "Photo.c"
		} else {
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 9624 "Photo.c"
		}
#line 1172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 9628 "Photo.c"
	}
#line 1175 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = info;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_info_get_modification_time (_tmp18_, &_tmp19_);
#line 1175 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	modification_time = _tmp19_;
#line 1177 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = backing;
#line 1177 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = file;
#line 1177 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = g_file_get_path (_tmp21_);
#line 1177 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp20_->filepath);
#line 1177 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_->filepath = _tmp22_;
#line 1178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = backing;
#line 1178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = modification_time;
#line 1178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = _tmp24_.tv_sec;
#line 1178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_->timestamp = (time_t) _tmp25_;
#line 1179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = backing;
#line 1179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = info;
#line 1179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = g_file_info_get_size (_tmp27_);
#line 1179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_->filesize = _tmp28_;
#line 1180 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = backing;
#line 1180 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1180 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = _tmp30_->file_format;
#line 1180 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_->file_format = _tmp31_;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = backing;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = _vala_detected;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_->image_dim;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_->dim = _tmp34_;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = _vala_detected;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = _tmp36_->metadata;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp37_ != NULL) {
#line 9684 "Photo.c"
		DetectedPhotoInformation* _tmp38_;
		PhotoMetadata* _tmp39_;
		Orientation _tmp40_ = 0;
#line 1183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp38_ = _vala_detected;
#line 1183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp39_ = _tmp38_->metadata;
#line 1183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp40_ = photo_metadata_get_orientation (_tmp39_);
#line 1183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = _tmp40_;
#line 9696 "Photo.c"
	} else {
#line 1183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = ORIENTATION_TOP_LEFT;
#line 9700 "Photo.c"
	}
#line 1182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = backing;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = _tmp35_;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_->original_orientation = _tmp42_;
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = backing;
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (info);
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (detected) {
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*detected = _vala_detected;
#line 9718 "Photo.c"
	} else {
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 9722 "Photo.c"
	}
#line 1185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 9726 "Photo.c"
}


static void _vala_array_add230 (gchar*** array, int* length, int* size, gchar* value) {
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9737 "Photo.c"
	}
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9743 "Photo.c"
}


static void _vala_array_add231 (gchar*** array, int* length, int* size, gchar* value) {
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9754 "Photo.c"
	}
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9760 "Photo.c"
}


static void _vala_array_add232 (gchar*** array, int* length, int* size, gchar* value) {
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9771 "Photo.c"
	}
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9777 "Photo.c"
}


static void _vala_array_add233 (gchar*** array, int* length, int* size, gchar* value) {
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9788 "Photo.c"
	}
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9794 "Photo.c"
}


static void _vala_array_add234 (gchar*** array, int* length, int* size, gchar* value) {
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9805 "Photo.c"
	}
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9811 "Photo.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 1307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 9818 "Photo.c"
}


gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error) {
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* file;
	DetectedPhotoInformation* detected = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_ = NULL;
	BackingPhotoRow* backing;
	BackingPhotoRow* _tmp7_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_;
	GdkColorspace _tmp14_;
	gboolean _tmp17_;
	gboolean _tmp20_;
	PhotoRow* _tmp24_;
	PhotoRow* updated_row;
	gchar** _tmp29_ = NULL;
	gchar** list;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp30_;
	const gchar* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	const gchar* _tmp33_;
	PhotoRow* _tmp36_;
	BackingPhotoRow* _tmp37_;
	Orientation _tmp38_;
	BackingPhotoRow* _tmp39_;
	Orientation _tmp40_;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	PhotoRow* _tmp77_;
	BackingPhotoRow* _tmp78_;
	BackingPhotoRow* _tmp79_;
	PhotoRow* _tmp80_;
	DetectedPhotoInformation* _tmp81_;
	const gchar* _tmp82_;
	gchar* _tmp83_;
	PhotoRow* _tmp84_;
	DetectedPhotoInformation* _tmp85_;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	PhotoRow* _tmp88_;
	DetectedPhotoInformation* _tmp89_;
	const gchar* _tmp90_;
	gchar* _tmp91_;
	PhotoMetadata* metadata;
	DetectedPhotoInformation* _tmp92_;
	PhotoMetadata* _tmp93_;
	PhotoRow* _tmp112_;
	PhotoMetadata* _tmp113_;
	gchar** _tmp114_;
	gint _tmp114__length1;
	PhotoReimportMasterStateImpl* _tmp115_;
	GError * _inner_error_ = NULL;
#line 1249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1250 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1250 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp3_;
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = file;
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error_);
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	detected = _tmp5_;
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing = _tmp6_;
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 9921 "Photo.c"
	}
#line 1257 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = backing;
#line 1257 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 9927 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
#line 1258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = file;
#line 1258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:1258: Unable to retrieve photo state from %s for reimport", _tmp10_);
#line 1258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (reimport_state) {
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 9953 "Photo.c"
		} else {
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 9957 "Photo.c"
		}
#line 1259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 9961 "Photo.c"
	}
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = detected;
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp13_->colorspace;
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_ != GDK_COLORSPACE_RGB) {
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = TRUE;
#line 9971 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp15_;
		gint _tmp16_;
#line 1264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = detected;
#line 1264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = _tmp15_->channels;
#line 1264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp16_ < 3;
#line 9981 "Photo.c"
	}
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp12_;
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = TRUE;
#line 9989 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp18_;
		gint _tmp19_;
#line 1265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = detected;
#line 1265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = _tmp18_->bits_per_channel;
#line 1265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = _tmp19_ != 8;
#line 9999 "Photo.c"
	}
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = _tmp11_;
#line 1263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp20_) {
#line 10005 "Photo.c"
		GFile* _tmp21_;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_;
#line 1266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = file;
#line 1266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = g_file_get_path (_tmp21_);
#line 1266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:1266: Not re-importing %s: Unsupported color format", _tmp23_);
#line 1266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp23_);
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (reimport_state) {
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10031 "Photo.c"
		} else {
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10035 "Photo.c"
		}
#line 1268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 10039 "Photo.c"
	}
#line 1272 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = photo_row_new ();
#line 1272 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	updated_row = _tmp24_;
#line 10045 "Photo.c"
	{
		PhotoRow* _tmp25_;
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = self->row;
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10052 "Photo.c"
		{
			PhotoRow* _tmp26_;
			PhotoRow* _tmp27_;
#line 1274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = self->row;
#line 1274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = _photo_row_ref0 (_tmp26_);
#line 1274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			updated_row = _tmp27_;
#line 10064 "Photo.c"
		}
		__finally254:
		{
			PhotoRow* _tmp28_;
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp28_ = self->row;
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10073 "Photo.c"
		}
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 1273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 10089 "Photo.c"
		}
	}
#line 1278 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1278 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	list = _tmp29_;
#line 1278 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	list_length1 = 0;
#line 1278 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_list_size_ = list_length1;
#line 1280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = updated_row;
#line 1280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = detected;
#line 1280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 1280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 10110 "Photo.c"
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp34_ = list;
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 1281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add230 (&list, &list_length1, &_list_size_, _tmp35_);
#line 10122 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = updated_row;
#line 1283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = _tmp36_->master;
#line 1283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = backing;
#line 1283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = _tmp39_->original_orientation;
#line 1283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 10136 "Photo.c"
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		PhotoRow* _tmp43_;
		BackingPhotoRow* _tmp44_;
		BackingPhotoRow* _tmp45_;
		Orientation _tmp46_;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41_ = list;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 1284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add231 (&list, &list_length1, &_list_size_, _tmp42_);
#line 1285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = updated_row;
#line 1285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_ = _tmp43_->master;
#line 1285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45_ = backing;
#line 1285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = _tmp45_->original_orientation;
#line 1285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_->original_orientation = _tmp46_;
#line 10162 "Photo.c"
	}
#line 1288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = detected;
#line 1288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 10170 "Photo.c"
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_ = NULL;
		MetadataDateTime* date_time;
		gboolean _tmp52_ = FALSE;
		MetadataDateTime* _tmp53_;
		gboolean _tmp58_;
		PhotoRow* _tmp61_;
		const gchar* _tmp62_;
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		gchar* _tmp65_ = NULL;
		gchar* _tmp66_;
		gboolean _tmp67_;
		PhotoRow* _tmp70_;
		Rating _tmp71_;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
		Rating _tmp74_ = 0;
#line 1289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49_ = detected;
#line 1289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		date_time = _tmp51_;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp53_ = date_time;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp53_ != NULL) {
#line 10202 "Photo.c"
			PhotoRow* _tmp54_;
			time_t _tmp55_;
			MetadataDateTime* _tmp56_;
			time_t _tmp57_ = 0;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp54_ = updated_row;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp55_ = _tmp54_->exposure_time;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp56_ = date_time;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp57_ = metadata_date_time_get_timestamp (_tmp56_);
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp52_ = _tmp55_ != _tmp57_;
#line 10217 "Photo.c"
		} else {
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp52_ = FALSE;
#line 10221 "Photo.c"
		}
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp58_ = _tmp52_;
#line 1290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp58_) {
#line 10227 "Photo.c"
			gchar** _tmp59_;
			gint _tmp59__length1;
			gchar* _tmp60_;
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp59_ = list;
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp59__length1 = list_length1;
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp60_ = g_strdup ("metadata:exposure-time");
#line 1291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add232 (&list, &list_length1, &_list_size_, _tmp60_);
#line 10239 "Photo.c"
		}
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp61_ = updated_row;
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp62_ = _tmp61_->title;
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp63_ = detected;
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp65_ = media_metadata_get_title (MEDIA_METADATA (_tmp64_));
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp66_ = _tmp65_;
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp67_ = g_strcmp0 (_tmp62_, _tmp66_) != 0;
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp66_);
#line 1293 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp67_) {
#line 10259 "Photo.c"
			gchar** _tmp68_;
			gint _tmp68__length1;
			gchar* _tmp69_;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp68_ = list;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp68__length1 = list_length1;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp69_ = g_strdup ("metadata:name");
#line 1294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add233 (&list, &list_length1, &_list_size_, _tmp69_);
#line 10271 "Photo.c"
		}
#line 1296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp70_ = updated_row;
#line 1296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp71_ = _tmp70_->rating;
#line 1296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp72_ = detected;
#line 1296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp74_ = photo_metadata_get_rating (_tmp73_);
#line 1296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp71_ != _tmp74_) {
#line 10285 "Photo.c"
			gchar** _tmp75_;
			gint _tmp75__length1;
			gchar* _tmp76_;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp75_ = list;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp75__length1 = list_length1;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp76_ = g_strdup ("metadata:rating");
#line 1297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add234 (&list, &list_length1, &_list_size_, _tmp76_);
#line 10297 "Photo.c"
		}
#line 1288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10301 "Photo.c"
	}
#line 1300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp77_ = updated_row;
#line 1300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp78_ = backing;
#line 1300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 1300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp77_->master);
#line 1300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp77_->master = _tmp79_;
#line 1301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp80_ = updated_row;
#line 1301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp81_ = detected;
#line 1301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp82_ = _tmp81_->md5;
#line 1301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp83_ = g_strdup (_tmp82_);
#line 1301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp80_->md5);
#line 1301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp80_->md5 = _tmp83_;
#line 1302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp84_ = updated_row;
#line 1302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp85_ = detected;
#line 1302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp86_ = _tmp85_->exif_md5;
#line 1302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp87_ = g_strdup (_tmp86_);
#line 1302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp84_->exif_md5);
#line 1302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp84_->exif_md5 = _tmp87_;
#line 1303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp88_ = updated_row;
#line 1303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp89_ = detected;
#line 1303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp90_ = _tmp89_->thumbnail_md5;
#line 1303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp91_ = g_strdup (_tmp90_);
#line 1303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp88_->thumbnail_md5);
#line 1303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp88_->thumbnail_md5 = _tmp91_;
#line 1305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = NULL;
#line 1306 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp92_ = detected;
#line 1306 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp93_ = _tmp92_->metadata;
#line 1306 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp93_ != NULL) {
#line 10357 "Photo.c"
		DetectedPhotoInformation* _tmp94_;
		PhotoMetadata* _tmp95_;
		PhotoMetadata* _tmp96_;
		DetectedPhotoInformation* _tmp97_;
		PhotoMetadata* _tmp98_;
		MetadataDateTime* _tmp99_ = NULL;
		MetadataDateTime* date_time;
		MetadataDateTime* _tmp100_;
		PhotoRow* _tmp104_;
		DetectedPhotoInformation* _tmp105_;
		PhotoMetadata* _tmp106_;
		gchar* _tmp107_ = NULL;
		PhotoRow* _tmp108_;
		DetectedPhotoInformation* _tmp109_;
		PhotoMetadata* _tmp110_;
		Rating _tmp111_ = 0;
#line 1307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp94_ = detected;
#line 1307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp95_ = _tmp94_->metadata;
#line 1307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp96_ = _media_metadata_ref0 (_tmp95_);
#line 1307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		metadata = _tmp96_;
#line 1309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp97_ = detected;
#line 1309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp98_ = _tmp97_->metadata;
#line 1309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp99_ = photo_metadata_get_exposure_date_time (_tmp98_);
#line 1309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		date_time = _tmp99_;
#line 1310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp100_ = date_time;
#line 1310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp100_ != NULL) {
#line 10396 "Photo.c"
			PhotoRow* _tmp101_;
			MetadataDateTime* _tmp102_;
			time_t _tmp103_ = 0;
#line 1311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp101_ = updated_row;
#line 1311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp102_ = date_time;
#line 1311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp103_ = metadata_date_time_get_timestamp (_tmp102_);
#line 1311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp101_->exposure_time = _tmp103_;
#line 10408 "Photo.c"
		}
#line 1313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp104_ = updated_row;
#line 1313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp105_ = detected;
#line 1313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp106_ = _tmp105_->metadata;
#line 1313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp107_ = media_metadata_get_title (MEDIA_METADATA (_tmp106_));
#line 1313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp104_->title);
#line 1313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp104_->title = _tmp107_;
#line 1314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp108_ = updated_row;
#line 1314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp109_ = detected;
#line 1314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp110_ = _tmp109_->metadata;
#line 1314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp111_ = photo_metadata_get_rating (_tmp110_);
#line 1314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp108_->rating = _tmp111_;
#line 1306 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10434 "Photo.c"
	}
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp112_ = updated_row;
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp113_ = metadata;
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp114_ = list;
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp114__length1 = list_length1;
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp115_ = photo_reimport_master_state_impl_new (_tmp112_, _tmp113_, _tmp114_, _tmp114__length1);
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_reimport_state = PHOTO_REIMPORT_MASTER_STATE (_tmp115_);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (reimport_state) {
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 10468 "Photo.c"
	} else {
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10472 "Photo.c"
	}
#line 1319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 10476 "Photo.c"
}


static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1322 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1322 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 10485 "Photo.c"
}


void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1322 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1322 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 10494 "Photo.c"
}


static gpointer _photo_reimport_master_state_ref0 (gpointer self) {
#line 1326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 10501 "Photo.c"
}


static void _vala_array_add235 (gchar*** array, int* length, int* size, gchar* value) {
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10512 "Photo.c"
	}
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10518 "Photo.c"
}


static void _vala_array_add236 (gchar*** array, int* length, int* size, gchar* value) {
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10529 "Photo.c"
	}
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10535 "Photo.c"
}


void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_;
	PhotoReimportMasterStateImpl* _tmp1_;
	PhotoReimportMasterStateImpl* reimport_state;
	PhotoTable* _tmp2_ = NULL;
	PhotoTable* _tmp3_;
	PhotoRow* _tmp4_;
	PhotoMetadata* _tmp20_;
	gboolean _tmp22_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	PhotoMetadata* _tmp32_;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = state;
#line 1326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _photo_reimport_master_state_ref0 (PHOTO_REIMPORT_MASTER_STATE_IMPL (_tmp0_));
#line 1326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reimport_state = _tmp1_;
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_table_get_instance ();
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = reimport_state->row;
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_table_reimport (_tmp3_, _tmp4_, &_inner_error_);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp3_);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 10584 "Photo.c"
		} else {
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 10594 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp5_;
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = self->row;
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10603 "Photo.c"
		{
			PhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			BackingPhotoRow* _tmp8_;
			BackingPhotoRow* original_master;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			PhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			BackingPhotoRow* _tmp13_;
			PhotoRow* _tmp14_;
			BackingPhotoRow* _tmp15_;
			PhotoRow* _tmp16_;
			BackingPhotoRow* _tmp17_;
			gboolean _tmp18_;
#line 1332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->row;
#line 1332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _tmp6_->master;
#line 1332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _backing_photo_row_ref0 (_tmp7_);
#line 1332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			original_master = _tmp8_;
#line 1333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = reimport_state->row;
#line 1333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _photo_row_ref0 (_tmp9_);
#line 1333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			self->row = _tmp10_;
#line 1334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = self->row;
#line 1334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = original_master;
#line 1334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (_tmp11_->master);
#line 1334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_->master = _tmp13_;
#line 1335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = self->row;
#line 1335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = _tmp14_->master;
#line 1335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = reimport_state->row;
#line 1335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = _tmp16_->master;
#line 1335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing_photo_row_copy_from (_tmp15_, _tmp17_);
#line 1336 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = reimport_state->metadata_only;
#line 1336 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp18_) {
#line 1337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 10661 "Photo.c"
			}
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 10665 "Photo.c"
		}
		__finally255:
		{
			PhotoRow* _tmp19_;
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = self->row;
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10674 "Photo.c"
		}
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 10686 "Photo.c"
			} else {
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 10696 "Photo.c"
			}
		}
	}
#line 1340 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = reimport_state->metadata;
#line 1340 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 10704 "Photo.c"
		PhotoMetadata* _tmp21_;
#line 1341 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = reimport_state->metadata;
#line 1341 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp21_);
#line 10710 "Photo.c"
	}
#line 1343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = reimport_state->metadata_only;
#line 1343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp22_) {
#line 10716 "Photo.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		gchar* _tmp24_;
		gboolean _tmp25_ = FALSE;
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = g_strdup ("image:master");
#line 1344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add235 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp24_);
#line 1345 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = photo_is_master_baseline (self);
#line 1345 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp25_) {
#line 10733 "Photo.c"
			gchar** _tmp26_;
			gint _tmp26__length1;
			gchar* _tmp27_;
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = reimport_state->alterations;
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26__length1 = reimport_state->alterations_length1;
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = g_strdup ("image:baseline");
#line 1346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add236 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp27_);
#line 10745 "Photo.c"
		}
	}
#line 1349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = reimport_state->alterations;
#line 1349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28__length1 = reimport_state->alterations_length1;
#line 1349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp28__length1 > 0) {
#line 10754 "Photo.c"
		gchar** _tmp29_;
		gint _tmp29__length1;
		Alteration* _tmp30_;
		Alteration* _tmp31_;
#line 1350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp29_ = reimport_state->alterations;
#line 1350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp29__length1 = reimport_state->alterations_length1;
#line 1350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = alteration_new_from_array (_tmp29_, _tmp29__length1);
#line 1350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = _tmp30_;
#line 1350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp31_);
#line 1350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp31_);
#line 10771 "Photo.c"
	}
#line 1352 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = reimport_state->metadata;
#line 1352 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp32_);
#line 1354 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = photo_is_master_baseline (self);
#line 1354 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp33_) {
#line 10781 "Photo.c"
		PhotoMetadata* _tmp34_;
#line 1355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp34_ = reimport_state->metadata;
#line 1355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp34_);
#line 10787 "Photo.c"
	}
#line 1357 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = photo_is_master_source (self);
#line 1357 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp35_) {
#line 10793 "Photo.c"
		PhotoMetadata* _tmp36_;
#line 1358 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp36_ = reimport_state->metadata;
#line 1358 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp36_);
#line 10799 "Photo.c"
	}
#line 1325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 10803 "Photo.c"
}


static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error) {
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_ = NULL;
	BackingPhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	DetectedPhotoInformation* _tmp7_;
	GdkColorspace _tmp8_;
	gboolean _tmp11_;
	gboolean _tmp14_;
	GError * _inner_error_ = NULL;
#line 1362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, _tmp0_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error_);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 10843 "Photo.c"
	}
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_backing = _tmp3_;
#line 1366 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _vala_backing;
#line 1366 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (backing) {
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*backing = _vala_backing;
#line 10859 "Photo.c"
		} else {
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 10863 "Photo.c"
		}
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (detected) {
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*detected = _vala_detected;
#line 10869 "Photo.c"
		} else {
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10873 "Photo.c"
		}
#line 1367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 10877 "Photo.c"
	}
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _vala_detected;
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_->colorspace;
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp8_ != GDK_COLORSPACE_RGB) {
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = TRUE;
#line 10887 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp9_;
		gint _tmp10_;
#line 1372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = _vala_detected;
#line 1372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp9_->channels;
#line 1372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp10_ < 3;
#line 10897 "Photo.c"
	}
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp6_;
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = TRUE;
#line 10905 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp12_;
		gint _tmp13_;
#line 1373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _vala_detected;
#line 1373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = _tmp12_->bits_per_channel;
#line 1373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp13_ != 8;
#line 10915 "Photo.c"
	}
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp5_;
#line 1371 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_) {
#line 10921 "Photo.c"
		GFile* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 1374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = file;
#line 1374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 1374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:1374: Not re-importing %s: Unsupported color format", _tmp17_);
#line 1374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (backing) {
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*backing = _vala_backing;
#line 10941 "Photo.c"
		} else {
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 10945 "Photo.c"
		}
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (detected) {
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*detected = _vala_detected;
#line 10951 "Photo.c"
		} else {
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10955 "Photo.c"
		}
#line 1376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 10959 "Photo.c"
	}
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (backing) {
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*backing = _vala_backing;
#line 10967 "Photo.c"
	} else {
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 10971 "Photo.c"
	}
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (detected) {
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*detected = _vala_detected;
#line 10977 "Photo.c"
	} else {
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 10981 "Photo.c"
	}
#line 1379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 10985 "Photo.c"
}


gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp2_;
	BackingPhotoRow* _tmp3_ = NULL;
	DetectedPhotoInformation* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp7_;
	DetectedPhotoInformation* _tmp8_;
	PhotoMetadata* _tmp9_;
	PhotoReimportEditableStateImpl* _tmp10_;
	GError * _inner_error_ = NULL;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = NULL;
#line 1386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp0_;
#line 1387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 1387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 1388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 11029 "Photo.c"
		} else {
#line 1388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11033 "Photo.c"
		}
#line 1388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 11037 "Photo.c"
	}
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = file;
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo_verify_file_for_reimport (self, _tmp2_, &_tmp3_, &_tmp4_, &_inner_error_);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing = _tmp3_;
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	detected = _tmp4_;
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 11065 "Photo.c"
	}
#line 1392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp6_) {
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 11081 "Photo.c"
		} else {
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11085 "Photo.c"
		}
#line 1393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 11089 "Photo.c"
	}
#line 1395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = backing;
#line 1395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = detected;
#line 1395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_->metadata;
#line 1395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = photo_reimport_editable_state_impl_new (_tmp7_, _tmp9_);
#line 1395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = PHOTO_REIMPORT_EDITABLE_STATE (_tmp10_);
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (state) {
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*state = _vala_state;
#line 11115 "Photo.c"
	} else {
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 11119 "Photo.c"
	}
#line 1397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 11123 "Photo.c"
}


static gpointer _photo_reimport_editable_state_ref0 (gpointer self) {
#line 1406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 11130 "Photo.c"
}


void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error) {
	BackingPhotoID _tmp0_ = {0};
	BackingPhotoID editable_id;
	gboolean _tmp1_ = FALSE;
	PhotoReimportEditableState* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp3_;
	PhotoReimportEditableStateImpl* reimport_state;
	PhotoReimportEditableStateImpl* _tmp4_;
	gboolean _tmp5_;
	PhotoReimportEditableStateImpl* _tmp21_;
	PhotoMetadata* _tmp22_;
	gchar* _tmp32_;
	gchar* list;
	PhotoReimportEditableStateImpl* _tmp33_;
	gboolean _tmp34_;
	const gchar* _tmp37_;
	Alteration* _tmp38_;
	Alteration* _tmp39_;
	PhotoReimportEditableStateImpl* _tmp40_;
	PhotoMetadata* _tmp41_;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp45_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1402 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1402 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	editable_id = _tmp0_;
#line 1403 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = backing_photo_id_is_invalid (&editable_id);
#line 1403 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 1404 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 11171 "Photo.c"
	}
#line 1406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = state;
#line 1406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _photo_reimport_editable_state_ref0 (PHOTO_REIMPORT_EDITABLE_STATE_IMPL (_tmp2_));
#line 1406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reimport_state = _tmp3_;
#line 1408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = reimport_state;
#line 1408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp4_->metadata_only;
#line 1408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp5_) {
#line 11185 "Photo.c"
		BackingPhotoTable* _tmp6_ = NULL;
		BackingPhotoTable* _tmp7_;
		PhotoReimportEditableStateImpl* _tmp8_;
		BackingPhotoRow* _tmp9_;
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = backing_photo_table_get_instance ();
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = reimport_state;
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = _tmp8_->backing_state;
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		backing_photo_table_update (_tmp7_, _tmp9_, &_inner_error_);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_database_table_unref0 (_tmp7_);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 11212 "Photo.c"
			} else {
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1409 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 11222 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp10_;
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = self->row;
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11231 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp11_;
				BackingPhotoRow* _tmp12_;
				BackingPhotoRow* _tmp13_;
				PhotoReimportEditableStateImpl* _tmp14_;
				BackingPhotoRow* _tmp15_;
				Orientation _tmp16_;
#line 1412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->editable = _tmp13_;
#line 1413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = reimport_state;
#line 1413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = _tmp14_->backing_state;
#line 1413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 1413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_set_orientation (self, _tmp16_);
#line 1414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11259 "Photo.c"
			}
			__finally256:
			{
				PhotoRow* _tmp17_;
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = self->row;
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11268 "Photo.c"
			}
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 11280 "Photo.c"
				} else {
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 11290 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp18_;
		BackingPhotoRow* _tmp19_;
		Orientation _tmp20_;
#line 1417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = _tmp18_->backing_state;
#line 1417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = _tmp19_->original_orientation;
#line 1417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_set_orientation (self, _tmp20_);
#line 11306 "Photo.c"
	}
#line 1420 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = reimport_state;
#line 1420 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = _tmp21_->metadata;
#line 1420 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 11314 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp23_;
		PhotoMetadata* _tmp24_;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_;
		PhotoReimportEditableStateImpl* _tmp27_;
		PhotoMetadata* _tmp28_;
		Rating _tmp29_ = 0;
		PhotoReimportEditableStateImpl* _tmp30_;
		PhotoMetadata* _tmp31_;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = reimport_state;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = _tmp23_->metadata;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = media_metadata_get_title (MEDIA_METADATA (_tmp24_));
#line 1421 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_set_title (MEDIA_SOURCE (self), _tmp26_);
#line 1421 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp26_);
#line 1422 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27_ = reimport_state;
#line 1422 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp28_ = _tmp27_->metadata;
#line 1422 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp29_ = photo_metadata_get_rating (_tmp28_);
#line 1422 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_set_rating (MEDIA_SOURCE (self), _tmp29_);
#line 1423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = reimport_state;
#line 1423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = _tmp30_->metadata;
#line 1423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp31_);
#line 11350 "Photo.c"
	}
#line 1426 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1426 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	list = _tmp32_;
#line 1427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = reimport_state;
#line 1427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_->metadata_only;
#line 1427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp34_) {
#line 11362 "Photo.c"
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 1428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = list;
#line 1428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (list);
#line 1428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		list = _tmp36_;
#line 11373 "Photo.c"
	}
#line 1430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = list;
#line 1430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	data_object_notify_altered (DATA_OBJECT (self), _tmp39_);
#line 1430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = reimport_state;
#line 1432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = _tmp40_->metadata;
#line 1432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp41_);
#line 1434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = photo_is_editable_baseline (self);
#line 1434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp42_) {
#line 11395 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp43_;
		PhotoMetadata* _tmp44_;
#line 1435 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = reimport_state;
#line 1435 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_ = _tmp43_->metadata;
#line 1435 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp44_);
#line 11404 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = photo_is_editable_source (self);
#line 1437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp45_) {
#line 11410 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 1438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = reimport_state;
#line 1438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp47_ = _tmp46_->metadata;
#line 1438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp47_);
#line 11419 "Photo.c"
	}
#line 1401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (list);
#line 1401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 11425 "Photo.c"
}


static gpointer _photo_reimport_raw_development_state_ref0 (gpointer self) {
#line 1460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 11432 "Photo.c"
}


gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error) {
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* files;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	gint _tmp21_ = 0;
	GError * _inner_error_ = NULL;
#line 1442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = NULL;
#line 1445 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1445 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	files = _tmp0_;
#line 1446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = files;
#line 1446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (files);
#line 1447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 1447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 11471 "Photo.c"
		} else {
#line 1447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 11475 "Photo.c"
		}
#line 1447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 11479 "Photo.c"
	}
#line 1449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reimport_state = _tmp2_;
#line 11485 "Photo.c"
	{
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _file_it;
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = files;
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_file_it = _tmp4_;
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 11498 "Photo.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			GFile* file;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _file_it;
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp6_) {
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 11523 "Photo.c"
			}
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _file_it;
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			file = (GFile*) _tmp8_;
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = file;
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error_);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing = _tmp10_;
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			detected = _tmp11_;
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (files);
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return FALSE;
#line 11563 "Photo.c"
			}
#line 1454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp13_) {
#line 1455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 1455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				continue;
#line 11575 "Photo.c"
			}
#line 1457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = backing;
#line 1457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = detected;
#line 1457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 11593 "Photo.c"
		}
#line 1451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 11597 "Photo.c"
	}
#line 1460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE (_tmp18_));
#line 1460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = _tmp19_;
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = photo_reimport_raw_development_state_impl_get_size (_tmp20_);
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp21_ > 0;
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (files);
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (state) {
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*state = _vala_state;
#line 11621 "Photo.c"
	} else {
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 11625 "Photo.c"
	}
#line 1461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 11629 "Photo.c"
}


void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error) {
	PhotoFileFormat _tmp0_ = 0;
	PhotoReimportRawDevelopmentState* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state;
	gchar* _tmp32_;
	gchar* list;
	PhotoReimportRawDevelopmentStateImpl* _tmp33_;
	gboolean _tmp34_;
	const gchar* _tmp37_;
	Alteration* _tmp38_;
	Alteration* _tmp39_;
	GError * _inner_error_ = NULL;
#line 1465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE (state));
#line 1466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 11656 "Photo.c"
	}
#line 1469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = state;
#line 1469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _photo_reimport_raw_development_state_ref0 (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (_tmp1_));
#line 1469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reimport_state = _tmp2_;
#line 11664 "Photo.c"
	{
		PhotoReimportRawDevelopmentStateImpl* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _dev_it;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = reimport_state;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp3_->list;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_dev_it = _tmp5_;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 11680 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev;
			PhotoReimportRawDevelopmentStateImpl* _tmp10_;
			gboolean _tmp11_;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _dev_it;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp7_) {
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 11696 "Photo.c"
			}
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _dev_it;
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp9_;
#line 1472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = reimport_state;
#line 1472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = _tmp10_->metadata_only;
#line 1472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp11_) {
#line 11710 "Photo.c"
				BackingPhotoTable* _tmp12_ = NULL;
				BackingPhotoTable* _tmp13_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp14_;
				BackingPhotoRow* _tmp15_;
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = backing_photo_table_get_instance ();
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = dev;
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = _tmp14_->backing;
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				backing_photo_table_update (_tmp13_, _tmp15_, &_inner_error_);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp13_);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						return;
#line 11741 "Photo.c"
					} else {
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 1473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						return;
#line 11755 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp16_;
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp16_ = self->row;
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11764 "Photo.c"
					{
						gint _tmp17_ = 0;
						RawDeveloper* _tmp18_ = NULL;
#line 1477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp18_ = raw_developer_as_array (&_tmp17_);
#line 11770 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							d_collection = _tmp18_;
#line 1477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							d_collection_length1 = _tmp17_;
#line 1477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							for (d_it = 0; d_it < _tmp17_; d_it = d_it + 1) {
#line 11782 "Photo.c"
								RawDeveloper d = 0;
#line 1477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								d = d_collection[d_it];
#line 11786 "Photo.c"
								{
									PhotoRow* _tmp19_;
									BackingPhotoID* _tmp20_;
									gint _tmp20__length1;
									RawDeveloper _tmp21_;
									BackingPhotoID _tmp22_;
									BackingPhotoID id;
									BackingPhotoID _tmp23_;
									gint64 _tmp24_;
#line 1478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp19_ = self->row;
#line 1478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp20_ = _tmp19_->development_ids;
#line 1478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp20__length1 = _tmp19_->development_ids_length1;
#line 1478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp21_ = d;
#line 1478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp22_ = _tmp20_[_tmp21_];
#line 1478 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									id = _tmp22_;
#line 1479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp23_ = id;
#line 1479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									_tmp24_ = _tmp23_.id;
#line 1479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
									if (_tmp24_ != BACKING_PHOTO_ID_INVALID) {
#line 11814 "Photo.c"
										BackingPhotoID _tmp25_;
										BackingPhotoRow* _tmp26_ = NULL;
										BackingPhotoRow* bpr;
										BackingPhotoRow* _tmp27_;
#line 1480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
										_tmp25_ = id;
#line 1480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
										_tmp26_ = photo_get_backing_row (self, &_tmp25_);
#line 1480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
										bpr = _tmp26_;
#line 1481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
										_tmp27_ = bpr;
#line 1481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
										if (_tmp27_ != NULL) {
#line 11829 "Photo.c"
											GeeHashMap* _tmp28_;
											RawDeveloper _tmp29_;
											BackingPhotoRow* _tmp30_;
#line 1482 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
											_tmp28_ = self->priv->developments;
#line 1482 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
											_tmp29_ = d;
#line 1482 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
											_tmp30_ = bpr;
#line 1482 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
											gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp28_), GINT_TO_POINTER (_tmp29_), _tmp30_);
#line 11841 "Photo.c"
										}
#line 1479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 11845 "Photo.c"
									}
								}
							}
#line 1477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 11851 "Photo.c"
						}
					}
					__finally257:
					{
						PhotoRow* _tmp31_;
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp31_ = self->row;
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11861 "Photo.c"
					}
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							g_propagate_error (error, _inner_error_);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							return;
#line 11877 "Photo.c"
						} else {
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							g_clear_error (&_inner_error_);
#line 1475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							return;
#line 11891 "Photo.c"
						}
					}
				}
			}
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 11898 "Photo.c"
		}
#line 1471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 11902 "Photo.c"
	}
#line 1489 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1489 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	list = _tmp32_;
#line 1490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = reimport_state;
#line 1490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_->metadata_only;
#line 1490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp34_) {
#line 11914 "Photo.c"
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 1491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = list;
#line 1491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (list);
#line 1491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		list = _tmp36_;
#line 11925 "Photo.c"
	}
#line 1493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = list;
#line 1493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	data_object_notify_altered (DATA_OBJECT (self), _tmp39_);
#line 1493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (list);
#line 1465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 11943 "Photo.c"
}


static gchar* photo_real_get_typename (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 1499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 11959 "Photo.c"
}


static gint64 photo_real_get_instance_id (DataSource* base) {
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1502 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 1503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 11978 "Photo.c"
}


static gchar* photo_real_get_source_id (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 1506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = data_source_get_typename (DATA_SOURCE (self));
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = data_source_get_instance_id (DATA_SOURCE (self));
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 1510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12008 "Photo.c"
}


void photo_set_master_timestamp (Photo* self, GFileInfo* info) {
	GFileInfo* _tmp0_;
	GTimeVal _tmp1_ = {0};
	GTimeVal modification;
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = info;
#line 1515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	modification = _tmp1_;
#line 12028 "Photo.c"
	{
		{
			PhotoRow* _tmp2_;
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->row;
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12036 "Photo.c"
			{
				PhotoRow* _tmp3_;
				BackingPhotoRow* _tmp4_;
				time_t _tmp5_;
				GTimeVal _tmp6_;
				glong _tmp7_;
				PhotoTable* _tmp9_ = NULL;
				PhotoTable* _tmp10_;
				PhotoRow* _tmp11_;
				PhotoID _tmp12_;
				GTimeVal _tmp13_;
				glong _tmp14_;
				PhotoRow* _tmp15_;
				BackingPhotoRow* _tmp16_;
				GTimeVal _tmp17_;
				glong _tmp18_;
#line 1519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->master;
#line 1519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = modification;
#line 1519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp5_ == ((time_t) _tmp7_)) {
#line 12065 "Photo.c"
					{
						PhotoRow* _tmp8_;
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp8_ = self->row;
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12072 "Photo.c"
					}
#line 1520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 12076 "Photo.c"
				}
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = photo_table_get_instance ();
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = self->row;
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_->photo_id;
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = modification;
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = _tmp13_.tv_sec;
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_update_timestamp (_tmp10_, &_tmp12_, (time_t) _tmp14_, &_inner_error_);
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1522 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 12096 "Photo.c"
					goto __finally259;
				}
#line 1523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = self->row;
#line 1523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp15_->master;
#line 1523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = modification;
#line 1523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = _tmp17_.tv_sec;
#line 1523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_->timestamp = (time_t) _tmp18_;
#line 12109 "Photo.c"
			}
			__finally259:
			{
				PhotoRow* _tmp19_;
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = self->row;
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12118 "Photo.c"
			}
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 12124 "Photo.c"
					goto __catch258_database_error;
				}
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 12133 "Photo.c"
			}
		}
	}
	goto __finally258;
	__catch258_database_error:
	{
		GError* err = NULL;
		GError* _tmp20_;
#line 1517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 1517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = err;
#line 1526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app_window_database_error (_tmp20_);
#line 1528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 1528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 12154 "Photo.c"
	}
	__finally258:
#line 1517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 12165 "Photo.c"
	}
#line 1531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = photo_is_master_baseline (self);
#line 1531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp21_) {
#line 12171 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1532 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1532 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1532 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp23_);
#line 1532 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 12182 "Photo.c"
	} else {
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 1534 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = alteration_new ("metadata", "master-timestamp");
#line 1534 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1534 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp25_);
#line 1534 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 12194 "Photo.c"
	}
}


void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error) {
	GFileInfo* _tmp0_;
	GTimeVal _tmp1_ = {0};
	GTimeVal modification;
	gboolean altered;
	gboolean _tmp21_;
	GError * _inner_error_ = NULL;
#line 1538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = info;
#line 1539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	modification = _tmp1_;
#line 1541 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	altered = FALSE;
#line 12218 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = self->row;
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12225 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
			PhotoRow* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp10_;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = backing_photo_id_is_valid (&_tmp4_->editable_id);
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp5_) {
#line 12237 "Photo.c"
				BackingPhotoRow* _tmp6_;
				time_t _tmp7_;
				GTimeVal _tmp8_;
				glong _tmp9_;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->priv->editable;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = _tmp6_->timestamp;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = modification;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_.tv_sec;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = _tmp7_ != ((time_t) _tmp9_);
#line 12252 "Photo.c"
			} else {
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = FALSE;
#line 12256 "Photo.c"
			}
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _tmp3_;
#line 1543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp10_) {
#line 12262 "Photo.c"
				BackingPhotoTable* _tmp11_ = NULL;
				BackingPhotoTable* _tmp12_;
				PhotoRow* _tmp13_;
				BackingPhotoID _tmp14_;
				GTimeVal _tmp15_;
				glong _tmp16_;
				BackingPhotoRow* _tmp17_;
				GTimeVal _tmp18_;
				glong _tmp19_;
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = backing_photo_table_get_instance ();
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = self->row;
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = _tmp13_->editable_id;
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = modification;
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp15_.tv_sec;
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp12_, &_tmp14_, (time_t) _tmp16_, &_inner_error_);
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp12_);
#line 1544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 12290 "Photo.c"
					goto __finally260;
				}
#line 1546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = self->priv->editable;
#line 1546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = modification;
#line 1546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = _tmp18_.tv_sec;
#line 1546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_->timestamp = (time_t) _tmp19_;
#line 1547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				altered = TRUE;
#line 12303 "Photo.c"
			}
		}
		__finally260:
		{
			PhotoRow* _tmp20_;
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = self->row;
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12313 "Photo.c"
		}
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 12323 "Photo.c"
			} else {
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 12331 "Photo.c"
			}
		}
	}
#line 1551 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = altered;
#line 1551 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp21_) {
#line 12339 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp23_);
#line 1552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 12350 "Photo.c"
	}
}


void photo_update_many_editable_timestamps (GeeMap* map, GError** error) {
	GError * _inner_error_ = NULL;
#line 1556 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1558 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	database_table_begin_transaction ();
#line 12361 "Photo.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _photo_it;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = map;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_it = _tmp5_;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 12388 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			Photo* photo;
			Photo* _tmp10_;
			GeeMap* _tmp11_;
			Photo* _tmp12_;
			gpointer _tmp13_ = NULL;
			GFileInfo* _tmp14_;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp7_) {
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 12407 "Photo.c"
			}
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo = (Photo*) _tmp9_;
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = photo;
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = map;
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo;
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = gee_map_get (_tmp11_, _tmp12_);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = (GFileInfo*) _tmp13_;
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_update_editable_modification_time (_tmp10_, _tmp14_, &_inner_error_);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp14_);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 12441 "Photo.c"
				} else {
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 12453 "Photo.c"
				}
			}
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (photo);
#line 12458 "Photo.c"
		}
#line 1559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 12462 "Photo.c"
	}
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 12474 "Photo.c"
		} else {
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 12482 "Photo.c"
		}
	}
}


static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base) {
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_file_format (self);
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write_image (_tmp1_);
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_) {
#line 12502 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_get_file_format (self);
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 12508 "Photo.c"
	} else {
		PhotoFileFormat _tmp4_ = 0;
#line 1566 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = photo_file_format_get_system_default_format ();
#line 1566 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 12515 "Photo.c"
	}
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 1565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12521 "Photo.c"
}


static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 1569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = scale;
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	scaling_for_best_fit (_tmp0_, TRUE, &_tmp1_);
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (PHOTO_SOURCE (self), &_tmp1_, &_inner_error_);
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 12549 "Photo.c"
	}
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 1570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12555 "Photo.c"
}


gboolean photo_is_file_image (GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1573 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 1577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_format_is_file_supported (_tmp1_);
#line 1577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_) {
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = TRUE;
#line 12574 "Photo.c"
	} else {
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = file;
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = photo_is_extension_found (_tmp5_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 1578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 12592 "Photo.c"
	}
#line 1577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 1577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12598 "Photo.c"
}


static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1) {
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 1581 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = basename;
#line 1583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	disassemble_filename (_tmp0_, &_tmp1_, &_tmp2_);
#line 1583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (name);
#line 1583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	name = _tmp1_;
#line 1583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (ext);
#line 1583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ext = _tmp2_;
#line 1584 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = ext;
#line 1584 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 1585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 1585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (ext);
#line 1585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (name);
#line 1585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 12640 "Photo.c"
	}
#line 1588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = ext;
#line 1588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) (-1));
#line 1588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (ext);
#line 1588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ext = _tmp5_;
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = extensions;
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6__length1 = extensions_length1;
#line 12654 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		extension_collection = _tmp6_;
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		extension_collection_length1 = _tmp6__length1;
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		for (extension_it = 0; extension_it < _tmp6__length1; extension_it = extension_it + 1) {
#line 12666 "Photo.c"
			gchar* _tmp7_;
			gchar* extension = NULL;
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = g_strdup (extension_collection[extension_it]);
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			extension = _tmp7_;
#line 12673 "Photo.c"
			{
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 1592 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = ext;
#line 1592 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = extension;
#line 1592 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 1593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					result = TRUE;
#line 1593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (extension);
#line 1593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (ext);
#line 1593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (name);
#line 1593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return result;
#line 12693 "Photo.c"
				}
#line 1591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (extension);
#line 12697 "Photo.c"
			}
		}
	}
#line 1596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = FALSE;
#line 1596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (ext);
#line 1596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (name);
#line 1596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12709 "Photo.c"
}


gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	PhotoFileFormat _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
#line 1602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = file;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = file_format;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = photo_table_has_duplicate (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp7_;
#line 1605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12747 "Photo.c"
}


PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1) {
	PhotoID* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	PhotoFileFormat _tmp5_;
	gint _tmp6_ = 0;
	PhotoID* _tmp7_ = NULL;
	PhotoID* _tmp8_;
	gint _tmp8__length1;
	PhotoID* _tmp9_;
	gint _tmp9__length1;
#line 1611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = file;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = file_format;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = photo_table_get_duplicate_ids (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, &_tmp6_);
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8__length1 = _tmp6_;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9__length1 = _tmp8__length1;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (result_length1) {
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*result_length1 = _tmp9__length1;
#line 12795 "Photo.c"
	}
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp9_;
#line 1614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12801 "Photo.c"
}


gint64 photo_get_photo_key (DataSource* source) {
	gint64 result = 0LL;
	DataSource* _tmp0_;
	PhotoID _tmp1_ = {0};
	gint64 _tmp2_;
#line 1621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = source;
#line 1622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_photo_id (PHOTO (LIBRARY_PHOTO (_tmp0_)), &_tmp1_);
#line 1622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 1622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12822 "Photo.c"
}


static GFile* photo_real_get_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 1641 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 12849 "Photo.c"
}


static void _vala_array_add237 (gchar*** array, int* length, int* size, gchar* value) {
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12860 "Photo.c"
	}
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 12866 "Photo.c"
}


static void _vala_array_add238 (gchar*** array, int* length, int* size, gchar* value) {
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12877 "Photo.c"
	}
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 12883 "Photo.c"
}


static void _vala_array_add239 (gchar*** array, int* length, int* size, gchar* value) {
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12894 "Photo.c"
	}
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 12900 "Photo.c"
}


static void _vala_array_add240 (gchar*** array, int* length, int* size, gchar* value) {
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12911 "Photo.c"
	}
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 12917 "Photo.c"
}


void photo_set_master_file (Photo* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	gboolean name_changed;
	GFile* old_file;
	gboolean _tmp42_;
	GError * _inner_error_ = NULL;
#line 1646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1647 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 1647 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1647 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	filepath = _tmp1_;
#line 1649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	altered = FALSE;
#line 1650 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_baseline = FALSE;
#line 1651 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_source = FALSE;
#line 1652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	name_changed = FALSE;
#line 1653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old_file = NULL;
#line 12952 "Photo.c"
	{
		{
			PhotoRow* _tmp2_;
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->row;
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12960 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_;
#line 1656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 12968 "Photo.c"
					{
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp6_ = NULL;
						GFile* _tmp7_;
						GFile* _tmp8_;
						gboolean _tmp9_ = FALSE;
#line 1657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp5_ = _tmp4_->master;
#line 1657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp6_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp5_));
#line 1657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						old_file = _tmp6_;
#line 1658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp7_ = file;
#line 1658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp8_ = old_file;
#line 1658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp9_ = g_file_equal (_tmp7_, _tmp8_);
#line 1658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (!_tmp9_) {
#line 12994 "Photo.c"
							PhotoTable* _tmp10_ = NULL;
							PhotoTable* _tmp11_;
							PhotoID _tmp12_ = {0};
							const gchar* _tmp13_;
							PhotoRow* _tmp14_;
							BackingPhotoRow* _tmp15_;
							const gchar* _tmp16_;
							gchar* _tmp17_;
							GFile* _tmp18_;
							gchar* _tmp19_ = NULL;
							PhotoBackingReaders* _tmp20_;
							PhotoRow* _tmp21_;
							BackingPhotoRow* _tmp22_;
							PhotoFileFormat _tmp23_;
							const gchar* _tmp24_;
							PhotoFileReader* _tmp25_ = NULL;
							gboolean _tmp26_ = FALSE;
							gboolean _tmp27_ = FALSE;
							gboolean _tmp28_ = FALSE;
							PhotoRow* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_ = FALSE;
							gboolean _tmp38_;
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp10_ = photo_table_get_instance ();
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp11_ = _tmp10_;
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							photo_get_photo_id (self, &_tmp12_);
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp13_ = filepath;
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							photo_table_set_filepath (_tmp11_, &_tmp12_, _tmp13_, &_inner_error_);
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_database_table_unref0 (_tmp11_);
#line 1659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 13032 "Photo.c"
								goto __finally263;
							}
#line 1661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp14_ = self->row;
#line 1661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp15_ = _tmp14_->master;
#line 1661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp16_ = filepath;
#line 1661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp17_ = g_strdup (_tmp16_);
#line 1661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (_tmp15_->filepath);
#line 1661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp15_->filepath = _tmp17_;
#line 1662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp18_ = file;
#line 1662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp19_ = g_file_get_basename (_tmp18_);
#line 1662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							self->priv->file_title = _tmp19_;
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp20_ = self->priv->readers;
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp21_ = self->row;
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp22_ = _tmp21_->master;
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp24_ = filepath;
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp20_->master);
#line 1663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp20_->master = _tmp25_;
#line 1665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							altered = TRUE;
#line 1666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp26_ = photo_is_master_baseline (self);
#line 1666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							is_baseline = _tmp26_;
#line 1667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp27_ = photo_is_master_source (self);
#line 1667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							is_source = _tmp27_;
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp29_ = self->row;
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp30_ = _tmp29_->title;
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp31_ = is_string_empty (_tmp30_);
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (_tmp31_) {
#line 13089 "Photo.c"
								GFile* _tmp32_;
								gchar* _tmp33_ = NULL;
								gchar* _tmp34_;
								GFile* _tmp35_;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_;
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp32_ = old_file;
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp33_ = g_file_get_basename (_tmp32_);
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp34_ = _tmp33_;
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp35_ = file;
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp36_ = g_file_get_basename (_tmp35_);
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp37_ = _tmp36_;
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp28_ = g_strcmp0 (_tmp34_, _tmp37_) != 0;
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_g_free0 (_tmp37_);
#line 1669 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_g_free0 (_tmp34_);
#line 13114 "Photo.c"
							} else {
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp28_ = FALSE;
#line 13118 "Photo.c"
							}
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp38_ = _tmp28_;
#line 1668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							name_changed = _tmp38_;
#line 13124 "Photo.c"
						}
					}
					__finally263:
					{
						PhotoBackingReaders* _tmp39_;
#line 1656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp39_ = self->priv->readers;
#line 1656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 13134 "Photo.c"
					}
#line 1656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 13138 "Photo.c"
						goto __finally262;
					}
				}
			}
			__finally262:
			{
				PhotoRow* _tmp40_;
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp40_ = self->row;
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13150 "Photo.c"
			}
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 13156 "Photo.c"
					goto __catch261_database_error;
				}
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (filepath);
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 13169 "Photo.c"
			}
		}
	}
	goto __finally261;
	__catch261_database_error:
	{
		GError* err = NULL;
		GError* _tmp41_;
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41_ = err;
#line 1674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app_window_database_error (_tmp41_);
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 13188 "Photo.c"
	}
	__finally261:
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (filepath);
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 13203 "Photo.c"
	}
#line 1677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = altered;
#line 1677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp42_) {
#line 13209 "Photo.c"
		GFile* _tmp43_;
		GFile* _tmp44_;
		gboolean _tmp45_;
		gchar** _tmp46_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		gchar* _tmp48_;
		gboolean _tmp49_;
		gboolean _tmp52_;
		gboolean _tmp55_;
		gchar** _tmp58_;
		gint _tmp58__length1;
		Alteration* _tmp59_;
		Alteration* _tmp60_;
#line 1678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = old_file;
#line 1678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_ = file;
#line 1678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_notify_master_replaced (MEDIA_SOURCE (self), _tmp43_, _tmp44_);
#line 1680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45_ = is_baseline;
#line 1680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp45_) {
#line 1681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 13239 "Photo.c"
		}
#line 1683 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = g_new0 (gchar*, 0 + 1);
#line 1683 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration_list = _tmp46_;
#line 1683 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1683 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp47_ = alteration_list;
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp47__length1 = alteration_list_length1;
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp48_ = g_strdup ("backing:master");
#line 1684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add237 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp48_);
#line 1688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49_ = name_changed;
#line 1688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp49_) {
#line 13261 "Photo.c"
			gchar** _tmp50_;
			gint _tmp50__length1;
			gchar* _tmp51_;
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp50_ = alteration_list;
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp50__length1 = alteration_list_length1;
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp51_ = g_strdup ("metadata:name");
#line 1689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add238 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp51_);
#line 13273 "Photo.c"
		}
#line 1691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp52_ = is_source;
#line 1691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp52_) {
#line 13279 "Photo.c"
			gchar** _tmp53_;
			gint _tmp53__length1;
			gchar* _tmp54_;
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp53_ = alteration_list;
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp53__length1 = alteration_list_length1;
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp54_ = g_strdup ("backing:source");
#line 1692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add239 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp54_);
#line 13291 "Photo.c"
		}
#line 1694 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = is_baseline;
#line 1694 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp55_) {
#line 13297 "Photo.c"
			gchar** _tmp56_;
			gint _tmp56__length1;
			gchar* _tmp57_;
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp56_ = alteration_list;
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp56__length1 = alteration_list_length1;
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp57_ = g_strdup ("backing:baseline");
#line 1695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add240 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp57_);
#line 13309 "Photo.c"
		}
#line 1697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp58_ = alteration_list;
#line 1697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp58__length1 = alteration_list_length1;
#line 1697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp59_ = alteration_new_from_array (_tmp58_, _tmp58__length1);
#line 1697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp60_ = _tmp59_;
#line 1697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp60_);
#line 1697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp60_);
#line 1677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 13325 "Photo.c"
	}
#line 1646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (filepath);
#line 13331 "Photo.c"
}


static void _vala_array_add241 (gchar*** array, int* length, int* size, gchar* value) {
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13342 "Photo.c"
	}
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13348 "Photo.c"
}


static void _vala_array_add242 (gchar*** array, int* length, int* size, gchar* value) {
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13359 "Photo.c"
	}
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13365 "Photo.c"
}


static void _vala_array_add243 (gchar*** array, int* length, int* size, gchar* value) {
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13376 "Photo.c"
	}
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13382 "Photo.c"
}


void photo_set_editable_file (Photo* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	GFile* old_file;
	gboolean _tmp36_;
	GError * _inner_error_ = NULL;
#line 1703 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1703 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 1704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	filepath = _tmp1_;
#line 1706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	altered = FALSE;
#line 1707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_baseline = FALSE;
#line 1708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_source = FALSE;
#line 1709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old_file = NULL;
#line 13414 "Photo.c"
	{
		{
			PhotoRow* _tmp2_;
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->row;
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13422 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_;
#line 1712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 13430 "Photo.c"
					{
						GFile* _tmp4_ = NULL;
						PhotoBackingReaders* _tmp5_;
						PhotoFileReader* _tmp6_;
						GFile* _tmp10_;
						GFile* _tmp11_;
						gboolean _tmp12_ = FALSE;
						GFile* _tmp13_;
						gboolean _tmp17_;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp5_ = self->priv->readers;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp6_ = _tmp5_->editable;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp6_ != NULL) {
#line 13446 "Photo.c"
							PhotoBackingReaders* _tmp7_;
							PhotoFileReader* _tmp8_;
							GFile* _tmp9_ = NULL;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp7_ = self->priv->readers;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp8_ = _tmp7_->editable;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp9_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp8_));
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp4_ = _tmp9_;
#line 13460 "Photo.c"
						} else {
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp4_ = NULL;
#line 13466 "Photo.c"
						}
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp10_ = _tmp4_;
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						old_file = _tmp11_;
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp13_ = old_file;
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp13_ != NULL) {
#line 13480 "Photo.c"
							GFile* _tmp14_;
							GFile* _tmp15_;
							gboolean _tmp16_ = FALSE;
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp14_ = old_file;
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp15_ = file;
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp16_ = g_file_equal (_tmp14_, _tmp15_);
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp12_ = !_tmp16_;
#line 13492 "Photo.c"
						} else {
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp12_ = FALSE;
#line 13496 "Photo.c"
						}
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp17_ = _tmp12_;
#line 1714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp17_) {
#line 13502 "Photo.c"
							BackingPhotoTable* _tmp18_ = NULL;
							BackingPhotoTable* _tmp19_;
							PhotoRow* _tmp20_;
							BackingPhotoID _tmp21_;
							const gchar* _tmp22_;
							BackingPhotoRow* _tmp23_;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							PhotoBackingReaders* _tmp26_;
							BackingPhotoRow* _tmp27_;
							PhotoFileFormat _tmp28_;
							const gchar* _tmp29_;
							PhotoFileReader* _tmp30_ = NULL;
							gboolean _tmp31_ = FALSE;
							gboolean _tmp32_ = FALSE;
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp18_ = backing_photo_table_get_instance ();
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp19_ = _tmp18_;
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp20_ = self->row;
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp21_ = _tmp20_->editable_id;
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp22_ = filepath;
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp19_, &_tmp21_, _tmp22_, &_inner_error_);
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_database_table_unref0 (_tmp19_);
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 1715 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_g_object_unref0 (_tmp4_);
#line 13536 "Photo.c"
								goto __finally266;
							}
#line 1717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp23_ = self->priv->editable;
#line 1717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp24_ = filepath;
#line 1717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp25_ = g_strdup (_tmp24_);
#line 1717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (_tmp23_->filepath);
#line 1717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp23_->filepath = _tmp25_;
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp26_ = self->priv->readers;
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp27_ = self->priv->editable;
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp28_ = _tmp27_->file_format;
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp29_ = filepath;
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp30_ = photo_file_format_create_reader (_tmp28_, _tmp29_);
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp26_->editable);
#line 1718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp26_->editable = _tmp30_;
#line 1720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							altered = TRUE;
#line 1721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp31_ = photo_is_editable_baseline (self);
#line 1721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							is_baseline = _tmp31_;
#line 1722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp32_ = photo_is_editable_source (self);
#line 1722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							is_source = _tmp32_;
#line 13573 "Photo.c"
						}
#line 1712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_tmp4_);
#line 13577 "Photo.c"
					}
					__finally266:
					{
						PhotoBackingReaders* _tmp33_;
#line 1712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp33_ = self->priv->readers;
#line 1712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 13586 "Photo.c"
					}
#line 1712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 13590 "Photo.c"
						goto __finally265;
					}
				}
			}
			__finally265:
			{
				PhotoRow* _tmp34_;
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp34_ = self->row;
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13602 "Photo.c"
			}
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 13608 "Photo.c"
					goto __catch264_database_error;
				}
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (filepath);
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 13621 "Photo.c"
			}
		}
	}
	goto __finally264;
	__catch264_database_error:
	{
		GError* err = NULL;
		GError* _tmp35_;
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 1727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = err;
#line 1727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app_window_database_error (_tmp35_);
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 13640 "Photo.c"
	}
	__finally264:
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (filepath);
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 13655 "Photo.c"
	}
#line 1730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = altered;
#line 1730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp36_) {
#line 13661 "Photo.c"
		GFile* _tmp37_;
		GFile* _tmp38_;
		gboolean _tmp39_;
		gchar** _tmp40_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp46_;
		gchar** _tmp49_;
		gint _tmp49__length1;
		Alteration* _tmp50_;
		Alteration* _tmp51_;
#line 1731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp37_ = old_file;
#line 1731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp38_ = file;
#line 1731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp37_, _tmp38_);
#line 1733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp39_ = is_baseline;
#line 1733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp39_) {
#line 1734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 13690 "Photo.c"
		}
#line 1736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp40_ = g_new0 (gchar*, 0 + 1);
#line 1736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration_list = _tmp40_;
#line 1736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41_ = alteration_list;
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41__length1 = alteration_list_length1;
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp42_ = g_strdup ("backing:editable");
#line 1737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add241 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp42_);
#line 1739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = is_baseline;
#line 1739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp43_) {
#line 13712 "Photo.c"
			gchar** _tmp44_;
			gint _tmp44__length1;
			gchar* _tmp45_;
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp44_ = alteration_list;
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp44__length1 = alteration_list_length1;
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp45_ = g_strdup ("backing:baseline");
#line 1740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add242 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp45_);
#line 13724 "Photo.c"
		}
#line 1742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = is_source;
#line 1742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp46_) {
#line 13730 "Photo.c"
			gchar** _tmp47_;
			gint _tmp47__length1;
			gchar* _tmp48_;
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp47_ = alteration_list;
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp47__length1 = alteration_list_length1;
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp48_ = g_strdup ("backing:source");
#line 1743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add243 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp48_);
#line 13742 "Photo.c"
		}
#line 1745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49_ = alteration_list;
#line 1745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49__length1 = alteration_list_length1;
#line 1745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = alteration_new_from_array (_tmp49_, _tmp49__length1);
#line 1745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = _tmp50_;
#line 1745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp51_);
#line 1745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp51_);
#line 1730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 13758 "Photo.c"
	}
#line 1703 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1703 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (filepath);
#line 13764 "Photo.c"
}


void photo_set_many_editable_file (GeeMap* map, GError** error) {
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GeeMap* _tmp2_;
	GeeMapIterator* _tmp3_ = NULL;
	GeeMapIterator* map_iter;
	PhotoTable* _tmp12_ = NULL;
	PhotoTable* _tmp13_;
	GError * _inner_error_ = NULL;
#line 1750 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	database_table_begin_transaction ();
#line 1751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1753 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = map;
#line 1753 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = gee_map_map_iterator (_tmp2_);
#line 1753 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map_iter = _tmp3_;
#line 1754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	while (TRUE) {
#line 13795 "Photo.c"
		GeeMapIterator* _tmp4_;
		gboolean _tmp5_ = FALSE;
		GeeMapIterator* _tmp6_;
		gpointer _tmp7_ = NULL;
		Photo* _tmp8_;
		GeeMapIterator* _tmp9_;
		gpointer _tmp10_ = NULL;
		GFile* _tmp11_;
#line 1754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = map_iter;
#line 1754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = gee_map_iterator_next (_tmp4_);
#line 1754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (!_tmp5_) {
#line 1754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 13812 "Photo.c"
		}
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = map_iter;
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = gee_map_iterator_get_key (_tmp6_);
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = (Photo*) _tmp7_;
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = map_iter;
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = gee_map_iterator_get_value (_tmp9_);
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = (GFile*) _tmp10_;
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_set_editable_file (_tmp8_, _tmp11_);
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 1755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp8_);
#line 13832 "Photo.c"
	}
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = photo_table_get_instance ();
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp13_);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 13852 "Photo.c"
		} else {
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 13862 "Photo.c"
		}
	}
#line 1750 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 13867 "Photo.c"
}


GFile* photo_get_actual_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1762 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 1763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 13893 "Photo.c"
}


static GFile* photo_real_get_master_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 1767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 13920 "Photo.c"
}


GFile* photo_get_editable_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1770 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reader = _tmp0_;
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = reader;
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 13940 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_ = NULL;
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = reader;
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp3_));
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 13951 "Photo.c"
	} else {
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = NULL;
#line 13957 "Photo.c"
	}
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 13965 "Photo.c"
}


GeeCollection* photo_get_raw_developer_files (Photo* self) {
	GeeCollection* result = NULL;
	PhotoFileFormat _tmp0_ = 0;
	GeeArrayList* _tmp1_;
	GeeArrayList* ret;
	GError * _inner_error_ = NULL;
#line 1776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 1778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 13985 "Photo.c"
	}
#line 1780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ret = _tmp1_;
#line 13991 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = self->row;
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13998 "Photo.c"
		{
			{
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeIterator* _tmp7_ = NULL;
				GeeIterator* _tmp8_;
				GeeIterator* _row_it;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (GEE_MAP (_tmp3_));
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = _tmp5_;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = gee_iterable_iterator (GEE_ITERABLE (_tmp6_));
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp6_);
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_row_it = _tmp8_;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				while (TRUE) {
#line 14026 "Photo.c"
					GeeIterator* _tmp9_;
					gboolean _tmp10_ = FALSE;
					GeeIterator* _tmp11_;
					gpointer _tmp12_ = NULL;
					BackingPhotoRow* row;
					GeeArrayList* _tmp13_;
					BackingPhotoRow* _tmp14_;
					const gchar* _tmp15_;
					GFile* _tmp16_ = NULL;
					GFile* _tmp17_;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp9_ = _row_it;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp10_ = gee_iterator_next (_tmp9_);
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (!_tmp10_) {
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						break;
#line 14045 "Photo.c"
					}
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_ = _row_it;
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					row = (BackingPhotoRow*) _tmp12_;
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp13_ = ret;
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = row;
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = _tmp14_->filepath;
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp16_ = g_file_new_for_path (_tmp15_);
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp17_ = _tmp16_;
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp13_), _tmp17_);
#line 1783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp17_);
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 14069 "Photo.c"
				}
#line 1782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 14073 "Photo.c"
			}
		}
		__finally267:
		{
			PhotoRow* _tmp18_;
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = self->row;
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14083 "Photo.c"
		}
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (ret);
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1781 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 14095 "Photo.c"
		}
	}
#line 1786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = GEE_COLLECTION (ret);
#line 1786 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 14102 "Photo.c"
}


GFile* photo_get_source_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1789 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 1790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 14128 "Photo.c"
}


PhotoFileFormat photo_get_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1793 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 14137 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14144 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 14154 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14161 "Photo.c"
			}
#line 1795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 14165 "Photo.c"
		}
		__finally268:
		{
			PhotoRow* _tmp4_;
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14174 "Photo.c"
		}
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1794 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 14182 "Photo.c"
	}
}


PhotoFileFormat photo_get_best_export_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat file_format;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1799 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_file_format (self);
#line 1800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file_format = _tmp0_;
#line 1801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file_format;
#line 1801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write (_tmp1_);
#line 1801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp2_) {
#line 14205 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1802 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_file_format_get_system_default_format ();
#line 1802 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		file_format = _tmp3_;
#line 14211 "Photo.c"
	}
#line 1804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = file_format;
#line 1804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 14217 "Photo.c"
}


PhotoFileFormat photo_get_master_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1807 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 14226 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14233 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileFormat _tmp3_ = 0;
#line 1809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 1809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 14246 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14253 "Photo.c"
			}
#line 1809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 14257 "Photo.c"
		}
		__finally269:
		{
			PhotoRow* _tmp5_;
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14266 "Photo.c"
		}
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 14274 "Photo.c"
	}
}


static time_t photo_real_get_timestamp (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1813 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 14285 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14292 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			time_t _tmp2_;
#line 1815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 1815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 14302 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14309 "Photo.c"
			}
#line 1815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 14313 "Photo.c"
		}
		__finally270:
		{
			PhotoRow* _tmp4_;
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14322 "Photo.c"
		}
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 14330 "Photo.c"
	}
}


void photo_get_photo_id (Photo* self, PhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 14339 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14346 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 1821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*result = _tmp2_;
#line 14356 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14363 "Photo.c"
			}
#line 1821 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 14367 "Photo.c"
		}
		__finally271:
		{
			PhotoRow* _tmp4_;
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14376 "Photo.c"
		}
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 14384 "Photo.c"
	}
}


static inline void photo_real_get_event_id (MediaSource* base, EventID* result) {
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 1826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 1827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->row;
#line 1827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = _tmp1_;
#line 1827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 14403 "Photo.c"
}


inline gint64 photo_get_raw_event_id (Photo* self) {
	gint64 result = 0LL;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 _tmp2_;
#line 1831 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 1832 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->row;
#line 1832 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1832 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1832 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 1832 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 14424 "Photo.c"
}


static void photo_real_get_import_id (MediaSource* base, ImportID* result) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 14433 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14440 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 1837 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1837 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1837 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*result = _tmp2_;
#line 14450 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14457 "Photo.c"
			}
#line 1837 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 14461 "Photo.c"
		}
		__finally272:
		{
			PhotoRow* _tmp4_;
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14470 "Photo.c"
		}
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 14478 "Photo.c"
	}
}


void photo_get_editable_id (Photo* self, BackingPhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 14487 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14494 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 1843 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1843 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1843 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*result = _tmp2_;
#line 14504 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14511 "Photo.c"
			}
#line 1843 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 14515 "Photo.c"
		}
		__finally273:
		{
			PhotoRow* _tmp4_;
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14524 "Photo.c"
		}
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 14532 "Photo.c"
	}
}


static gchar* photo_real_get_master_md5 (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 14543 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14550 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 14563 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14570 "Photo.c"
			}
#line 1849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 14574 "Photo.c"
		}
		__finally274:
		{
			PhotoRow* _tmp5_;
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14583 "Photo.c"
		}
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 14591 "Photo.c"
	}
}


guint64 photo_get_flags (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1855 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 14601 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14608 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 1857 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1857 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1857 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 14618 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14625 "Photo.c"
			}
#line 1857 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 14629 "Photo.c"
		}
		__finally275:
		{
			PhotoRow* _tmp4_;
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14638 "Photo.c"
		}
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0ULL;
#line 14646 "Photo.c"
	}
}


static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration) {
	Alteration* _tmp0_;
	Alteration* alteration;
	Alteration* _tmp1_;
	Alteration* _tmp5_;
#line 1861 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1861 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 1862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 1862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	alteration = _tmp0_;
#line 1863 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = additional_alteration;
#line 1863 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 14668 "Photo.c"
		Alteration* _tmp2_;
		Alteration* _tmp3_;
		Alteration* _tmp4_ = NULL;
#line 1864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = alteration;
#line 1864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = additional_alteration;
#line 1864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = alteration_compress (_tmp2_, _tmp3_);
#line 1864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 1864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		alteration = _tmp4_;
#line 14682 "Photo.c"
	}
#line 1866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = alteration;
#line 1866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	data_object_notify_altered (DATA_OBJECT (self), _tmp5_);
#line 1861 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 14690 "Photo.c"
}


guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp10_;
	guint64 _tmp12_;
	GError * _inner_error_ = NULL;
#line 1869 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1869 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 14704 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14711 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			guint64 _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = flags;
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp3_, _tmp4_);
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			committed = _tmp5_;
#line 1872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = committed;
#line 1873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_) {
#line 14737 "Photo.c"
				PhotoRow* _tmp7_;
				guint64 _tmp8_;
#line 1874 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = self->row;
#line 1874 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = flags;
#line 1874 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_->flags = _tmp8_;
#line 14746 "Photo.c"
			}
		}
		__finally276:
		{
			PhotoRow* _tmp9_;
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->row;
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14756 "Photo.c"
		}
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return 0ULL;
#line 14766 "Photo.c"
		}
	}
#line 1877 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = committed;
#line 1877 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp10_) {
#line 14773 "Photo.c"
		Alteration* _tmp11_;
#line 1878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = additional_alteration;
#line 1878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp11_);
#line 14779 "Photo.c"
	}
#line 1880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = flags;
#line 1880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp12_;
#line 1880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 14787 "Photo.c"
}


gboolean photo_is_flag_set (Photo* self, guint64 mask) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1883 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 14796 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14803 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 1885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = mask;
#line 1885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = media_source_internal_is_flag_set (_tmp2_, _tmp3_);
#line 1885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp4_;
#line 14819 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = self->row;
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14826 "Photo.c"
			}
#line 1885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 14830 "Photo.c"
		}
		__finally277:
		{
			PhotoRow* _tmp6_;
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->row;
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14839 "Photo.c"
		}
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 14847 "Photo.c"
	}
}


guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 1889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1890 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	flags = (guint64) 0;
#line 1892 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 14866 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14873 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 1894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = mask;
#line 1894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = media_source_internal_add_flags (_tmp2_, _tmp3_);
#line 1894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			flags = _tmp4_;
#line 1895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 1895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = flags;
#line 1895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 14900 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = flags;
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = _tmp12_;
#line 1896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = committed;
#line 1897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp13_) {
#line 14925 "Photo.c"
					PhotoRow* _tmp14_;
					guint64 _tmp15_;
#line 1898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = self->row;
#line 1898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = flags;
#line 1898 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 14934 "Photo.c"
				}
			}
		}
		__finally278:
		{
			PhotoRow* _tmp16_;
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = self->row;
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14945 "Photo.c"
		}
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return 0ULL;
#line 14955 "Photo.c"
		}
	}
#line 1902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = committed;
#line 1902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 14962 "Photo.c"
		Alteration* _tmp18_;
#line 1903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 1903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 14968 "Photo.c"
	}
#line 1905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = flags;
#line 1905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 14974 "Photo.c"
}


guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 1908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1909 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	flags = (guint64) 0;
#line 1911 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 14992 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14999 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 1913 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1913 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1913 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = mask;
#line 1913 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = media_source_internal_remove_flags (_tmp2_, _tmp3_);
#line 1913 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			flags = _tmp4_;
#line 1914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 1914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = flags;
#line 1914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15026 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = flags;
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = _tmp12_;
#line 1915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1916 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = committed;
#line 1916 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp13_) {
#line 15051 "Photo.c"
					PhotoRow* _tmp14_;
					guint64 _tmp15_;
#line 1917 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = self->row;
#line 1917 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = flags;
#line 1917 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15060 "Photo.c"
				}
			}
		}
		__finally279:
		{
			PhotoRow* _tmp16_;
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = self->row;
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15071 "Photo.c"
		}
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return 0ULL;
#line 15081 "Photo.c"
		}
	}
#line 1921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = committed;
#line 1921 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 15088 "Photo.c"
		Alteration* _tmp18_;
#line 1922 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 1922 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 15094 "Photo.c"
	}
#line 1924 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = flags;
#line 1924 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 15100 "Photo.c"
}


guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 1927 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1927 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1928 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	flags = (guint64) 0;
#line 1930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 15118 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15125 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_;
			PhotoRow* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 1932 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1932 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1932 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = add;
#line 1932 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = remove;
#line 1932 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			flags = (_tmp2_ | _tmp3_) & (~_tmp4_);
#line 1933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 1933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = flags;
#line 1933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15152 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = flags;
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = _tmp12_;
#line 1934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = committed;
#line 1935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp13_) {
#line 15177 "Photo.c"
					PhotoRow* _tmp14_;
					guint64 _tmp15_;
#line 1936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = self->row;
#line 1936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = flags;
#line 1936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15186 "Photo.c"
				}
			}
		}
		__finally280:
		{
			PhotoRow* _tmp16_;
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = self->row;
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15197 "Photo.c"
		}
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return 0ULL;
#line 15207 "Photo.c"
		}
	}
#line 1940 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = committed;
#line 1940 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 15214 "Photo.c"
		Alteration* _tmp18_;
#line 1941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 1941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 15220 "Photo.c"
	}
#line 1943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = flags;
#line 1943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 15226 "Photo.c"
}


void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp10_;
	GError * _inner_error_ = NULL;
#line 1946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((add == NULL) || GEE_IS_COLLECTION (add));
#line 1946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 1946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((remove == NULL) || GEE_IS_COLLECTION (remove));
#line 1946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 1949 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	database_table_begin_transaction ();
#line 1951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = add;
#line 1951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 15248 "Photo.c"
		{
			GeeCollection* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _photo_it;
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = add;
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_it = _tmp2_;
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 15261 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				Photo* photo;
				Photo* _tmp7_;
				guint64 _tmp8_;
				Alteration* _tmp9_;
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = _photo_it;
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp4_) {
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 15278 "Photo.c"
				}
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _photo_it;
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = (Photo*) _tmp6_;
#line 1953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = photo;
#line 1953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = add_mask;
#line 1953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = additional_add_alteration;
#line 1953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_add_flags (_tmp7_, _tmp8_, _tmp9_);
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 15296 "Photo.c"
			}
#line 1952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 15300 "Photo.c"
		}
	}
#line 1956 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = remove;
#line 1956 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 15307 "Photo.c"
		{
			GeeCollection* _tmp11_;
			GeeIterator* _tmp12_ = NULL;
			GeeIterator* _photo_it;
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = remove;
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = gee_iterable_iterator (GEE_ITERABLE (_tmp11_));
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_it = _tmp12_;
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 15320 "Photo.c"
				GeeIterator* _tmp13_;
				gboolean _tmp14_ = FALSE;
				GeeIterator* _tmp15_;
				gpointer _tmp16_ = NULL;
				Photo* photo;
				Photo* _tmp17_;
				guint64 _tmp18_;
				Alteration* _tmp19_;
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = _photo_it;
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = gee_iterator_next (_tmp13_);
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp14_) {
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 15337 "Photo.c"
				}
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = _photo_it;
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = gee_iterator_get (_tmp15_);
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = (Photo*) _tmp16_;
#line 1958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = photo;
#line 1958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = remove_mask;
#line 1958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = additional_remove_alteration;
#line 1958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_remove_flags (_tmp17_, _tmp18_, _tmp19_);
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 15355 "Photo.c"
			}
#line 1957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 15359 "Photo.c"
		}
	}
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 15372 "Photo.c"
		} else {
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 15380 "Photo.c"
		}
	}
}


guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 1964 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1964 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1965 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	flags = (guint64) 0;
#line 1967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 15400 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15407 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			PhotoRow* _tmp4_;
			guint64 _tmp5_;
			guint64 _tmp6_;
#line 1969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = mask;
#line 1969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			flags = _tmp2_ ^ _tmp3_;
#line 1970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _tmp4_->flags;
#line 1970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = flags;
#line 1970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp5_ != _tmp6_) {
#line 15431 "Photo.c"
				PhotoTable* _tmp7_ = NULL;
				PhotoTable* _tmp8_;
				PhotoID _tmp9_ = {0};
				guint64 _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_;
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = photo_table_get_instance ();
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_get_photo_id (self, &_tmp9_);
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = flags;
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = photo_table_replace_flags (_tmp8_, &_tmp9_, _tmp10_);
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = _tmp11_;
#line 1971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 1972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = committed;
#line 1972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp12_) {
#line 15456 "Photo.c"
					PhotoRow* _tmp13_;
					guint64 _tmp14_;
#line 1973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp13_ = self->row;
#line 1973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = flags;
#line 1973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp13_->flags = _tmp14_;
#line 15465 "Photo.c"
				}
			}
		}
		__finally281:
		{
			PhotoRow* _tmp15_;
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = self->row;
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15476 "Photo.c"
		}
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return 0ULL;
#line 15486 "Photo.c"
		}
	}
#line 1977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = committed;
#line 1977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp16_) {
#line 15493 "Photo.c"
		Alteration* _tmp17_;
#line 1978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = additional_alteration;
#line 1978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp17_);
#line 15499 "Photo.c"
	}
#line 1980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = flags;
#line 1980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 15505 "Photo.c"
}


gboolean photo_is_master_metadata_dirty (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1983 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 15514 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15521 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 1985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 1985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 15531 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15538 "Photo.c"
			}
#line 1985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 15542 "Photo.c"
		}
		__finally282:
		{
			PhotoRow* _tmp4_;
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15551 "Photo.c"
		}
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 15559 "Photo.c"
	}
}


void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error) {
	gboolean committed;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
#line 1989 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 15572 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15579 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 1992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 1992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 1992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = dirty;
#line 1992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 15592 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_;
				PhotoRow* _tmp8_;
				gboolean _tmp9_;
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = dirty;
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp5_, &_tmp6_, _tmp7_, &_inner_error_);
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 1993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 15613 "Photo.c"
					goto __finally283;
				}
#line 1994 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = self->row;
#line 1994 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = dirty;
#line 1994 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_->metadata_dirty = _tmp9_;
#line 1995 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = TRUE;
#line 15624 "Photo.c"
			}
		}
		__finally283:
		{
			PhotoRow* _tmp10_;
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = self->row;
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15634 "Photo.c"
		}
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 15644 "Photo.c"
			} else {
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 15652 "Photo.c"
			}
		}
	}
#line 1999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = committed;
#line 1999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 15660 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = alteration_new ("metadata", "master-dirty");
#line 2000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp13_);
#line 2000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 15671 "Photo.c"
	}
}


static Rating photo_real_get_rating (MediaSource* base) {
	Photo * self;
	Rating result = 0;
	GError * _inner_error_ = NULL;
#line 2003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 15682 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15689 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 15699 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15706 "Photo.c"
			}
#line 2005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 15710 "Photo.c"
		}
		__finally284:
		{
			PhotoRow* _tmp4_;
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15719 "Photo.c"
		}
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 15727 "Photo.c"
	}
}


static void photo_real_set_rating (MediaSource* base, Rating rating) {
	Photo * self;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 2009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2010 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 15741 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15748 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			Rating _tmp2_;
			PhotoRow* _tmp3_;
			Rating _tmp4_;
			gboolean _tmp7_;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = rating;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = _tmp3_->rating;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != _tmp4_) {
#line 15763 "Photo.c"
				Rating _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = rating;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = rating_is_valid (_tmp5_);
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 15772 "Photo.c"
			} else {
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = FALSE;
#line 15776 "Photo.c"
			}
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _tmp1_;
#line 2013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp7_) {
#line 15782 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				Rating _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = rating;
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = photo_table_set_rating (_tmp9_, &_tmp10_, _tmp11_);
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = _tmp12_;
#line 2014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = committed;
#line 2015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp13_) {
#line 15807 "Photo.c"
					PhotoRow* _tmp14_;
					Rating _tmp15_;
#line 2016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = self->row;
#line 2016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = rating;
#line 2016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_->rating = _tmp15_;
#line 15816 "Photo.c"
				}
			}
		}
		__finally285:
		{
			PhotoRow* _tmp16_;
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = self->row;
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15827 "Photo.c"
		}
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 15837 "Photo.c"
		}
	}
#line 2020 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = committed;
#line 2020 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 15844 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 2021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "rating");
#line 2021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp19_);
#line 2021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 15855 "Photo.c"
	}
}


static void photo_real_increase_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2024 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 15865 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15872 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
			Rating _tmp3_ = 0;
#line 2026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = rating_increase (_tmp2_);
#line 2026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media_source_set_rating (MEDIA_SOURCE (self), _tmp3_);
#line 15885 "Photo.c"
		}
		__finally286:
		{
			PhotoRow* _tmp4_;
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15894 "Photo.c"
		}
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 15904 "Photo.c"
		}
	}
}


static void photo_real_decrease_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 15915 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15922 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
			Rating _tmp3_ = 0;
#line 2032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = rating_decrease (_tmp2_);
#line 2032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media_source_set_rating (MEDIA_SOURCE (self), _tmp3_);
#line 15935 "Photo.c"
		}
		__finally287:
		{
			PhotoRow* _tmp4_;
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15944 "Photo.c"
		}
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2031 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 15954 "Photo.c"
		}
	}
}


static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 15967 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
		const gchar* _tmp3_;
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = backlinks;
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, _tmp3_, &_inner_error_);
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 15989 "Photo.c"
				goto __catch288_database_error;
			}
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 15998 "Photo.c"
		}
		{
			PhotoRow* _tmp4_;
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16006 "Photo.c"
			{
				PhotoRow* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
#line 2043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = self->row;
#line 2043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = backlinks;
#line 2043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 2043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp5_->backlinks);
#line 2043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_->backlinks = _tmp7_;
#line 16021 "Photo.c"
			}
			__finally289:
			{
				PhotoRow* _tmp8_;
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = self->row;
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16030 "Photo.c"
			}
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 16036 "Photo.c"
					goto __catch288_database_error;
				}
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 16045 "Photo.c"
			}
		}
	}
	goto __finally288;
	__catch288_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 2046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = data_object_to_string (DATA_OBJECT (self));
#line 2046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = err;
#line 2046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 2046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:2046: Unable to update link state for %s: %s", _tmp10_, _tmp12_);
#line 2046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 16075 "Photo.c"
	}
	__finally288:
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 16086 "Photo.c"
	}
}


static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id) {
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 16099 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16106 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean committed;
			gboolean _tmp8_;
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = *event_id;
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			committed = _tmp7_;
#line 2058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = committed;
#line 2058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_) {
#line 16139 "Photo.c"
				PhotoRow* _tmp9_;
				EventID _tmp10_;
#line 2059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->row;
#line 2059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = *event_id;
#line 2059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_->event_id = _tmp10_;
#line 16148 "Photo.c"
			}
#line 2061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = committed;
#line 16152 "Photo.c"
			{
				PhotoRow* _tmp11_;
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = self->row;
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16159 "Photo.c"
			}
#line 2061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16163 "Photo.c"
		}
		__finally290:
		{
			PhotoRow* _tmp12_;
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = self->row;
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16172 "Photo.c"
		}
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 16180 "Photo.c"
	}
}


static gchar* photo_real_to_string (DataObject* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	PhotoID _tmp10_ = {0};
	gint64 _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileReader* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
#line 2065 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_is_master_baseline (self);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp1_) {
#line 16207 "Photo.c"
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = photo_get_actual_file (self);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 16239 "Photo.c"
	} else {
		gchar* _tmp9_;
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = g_strdup ("");
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp9_;
#line 16248 "Photo.c"
	}
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_photo_id (self, &_tmp10_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_.id;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = photo_get_master_reader (self);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp15_));
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = _tmp0_;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = g_strdup_printf ("[%s] %s%s", _tmp13_, _tmp17_, _tmp18_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp17_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp15_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp13_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp20_;
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 16284 "Photo.c"
}


static gboolean photo_real_equals (DataSource* base, DataSource* source) {
	Photo * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
	Photo* _tmp1_;
	Photo* photo;
	Photo* _tmp2_;
	DataSource* _tmp15_;
	gboolean _tmp16_ = FALSE;
#line 2070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2072 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = source;
#line 2072 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (IS_PHOTO (_tmp0_) ? ((Photo*) _tmp0_) : NULL);
#line 2072 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp1_;
#line 2073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo;
#line 2073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16311 "Photo.c"
		PhotoID _tmp3_ = {0};
		PhotoID photo_id;
		Photo* _tmp4_;
		PhotoID _tmp5_ = {0};
		PhotoID other_photo_id;
		gboolean _tmp6_ = FALSE;
		Photo* _tmp7_;
		gboolean _tmp10_;
#line 2074 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_get_photo_id (self, &_tmp3_);
#line 2074 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_id = _tmp3_;
#line 2075 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = photo;
#line 2075 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_get_photo_id (_tmp4_, &_tmp5_);
#line 2075 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		other_photo_id = _tmp5_;
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = photo;
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (self != _tmp7_) {
#line 16334 "Photo.c"
			PhotoID _tmp8_;
			gint64 _tmp9_;
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = photo_id;
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _tmp8_.id;
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tmp9_ != PHOTO_ID_INVALID;
#line 16343 "Photo.c"
		} else {
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = FALSE;
#line 16347 "Photo.c"
		}
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp6_;
#line 2077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp10_) {
#line 16353 "Photo.c"
			PhotoID _tmp11_;
			gint64 _tmp12_;
			PhotoID _tmp13_;
			gint64 _tmp14_;
#line 2078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = photo_id;
#line 2078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = _tmp11_.id;
#line 2078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = other_photo_id;
#line 2078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_.id;
#line 2078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_assert (_tmp12_ != _tmp14_);
#line 16368 "Photo.c"
		}
	}
#line 2082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = source;
#line 2082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = DATA_SOURCE_CLASS (photo_parent_class)->equals (DATA_SOURCE (PHOTO_SOURCE (self)), _tmp15_);
#line 2082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp16_;
#line 2082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 2082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 16381 "Photo.c"
}


static void photo_file_exif_updated (Photo* self) {
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp6_;
	GTimeVal _tmp7_ = {0};
	GTimeVal timestamp;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* interrogator;
	DetectedPhotoInformation* _tmp13_ = NULL;
	DetectedPhotoInformation* detected;
	DetectedPhotoInformation* _tmp14_;
	gboolean success = FALSE;
	gboolean _tmp34_;
	GError * _inner_error_ = NULL;
#line 2086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_get_file (MEDIA_SOURCE (self));
#line 2087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp0_;
#line 2089 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	info = NULL;
#line 16408 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
#line 2091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 2091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 16418 "Photo.c"
			goto __catch291_g_error;
		}
#line 2091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 2091 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		info = _tmp2_;
#line 16425 "Photo.c"
	}
	goto __finally291;
	__catch291_g_error:
	{
		GError* err = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 2094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = data_object_to_string (DATA_OBJECT (self));
#line 2094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = err->message;
#line 2094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_error ("Photo.vala:2094: Unable to read file information for %s: %s", _tmp4_, _tmp5_);
#line 2094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 16450 "Photo.c"
	}
	__finally291:
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 16465 "Photo.c"
	}
#line 2097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = info;
#line 2097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_info_get_modification_time (_tmp6_, &_tmp7_);
#line 2097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	timestamp = _tmp7_;
#line 2100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	interrogator = _tmp8_;
#line 16477 "Photo.c"
	{
#line 2102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 2102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 16483 "Photo.c"
			goto __catch292_g_error;
		}
	}
	goto __finally292;
	__catch292_g_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 2104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = g_file_get_path (file);
#line 2104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = err;
#line 2104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 2104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:2104: Unable to interrogate photo file %s: %s", _tmp10_, _tmp12_);
#line 2104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 16513 "Photo.c"
	}
	__finally292:
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 16530 "Photo.c"
	}
#line 2107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	detected = _tmp13_;
#line 2108 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = detected;
#line 2108 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_ == NULL) {
#line 16540 "Photo.c"
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
#line 2109 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = data_object_to_string (DATA_OBJECT (self));
#line 2109 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2109 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("Photo.vala:2109: file_exif_updated: %s no longer an image", _tmp16_);
#line 2109 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 2111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 2111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 2111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 16561 "Photo.c"
	}
	{
		PhotoRow* _tmp17_;
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = self->row;
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16569 "Photo.c"
		{
			PhotoTable* _tmp18_ = NULL;
			PhotoTable* _tmp19_;
			PhotoID _tmp20_ = {0};
			GFileInfo* _tmp21_;
			gint64 _tmp22_ = 0LL;
			GTimeVal _tmp23_;
			glong _tmp24_;
			DetectedPhotoInformation* _tmp25_;
			const gchar* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			PhotoRow* _tmp31_;
			gboolean _tmp32_ = FALSE;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = photo_table_get_instance ();
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_get_photo_id (self, &_tmp20_);
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = info;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = g_file_info_get_size (_tmp21_);
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp23_ = timestamp;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = _tmp23_.tv_sec;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp25_ = detected;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = _tmp25_->md5;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = detected;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp28_ = _tmp27_->exif_md5;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp29_ = detected;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp30_ = _tmp29_->thumbnail_md5;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp31_ = self->row;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp32_ = photo_table_master_exif_updated (_tmp19_, &_tmp20_, _tmp22_, _tmp24_, _tmp26_, _tmp28_, _tmp30_, _tmp31_);
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			success = _tmp32_;
#line 2116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp19_);
#line 16620 "Photo.c"
		}
		__finally293:
		{
			PhotoRow* _tmp33_;
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp33_ = self->row;
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16629 "Photo.c"
		}
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2115 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 16647 "Photo.c"
		}
	}
#line 2120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = success;
#line 2120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp34_) {
#line 16654 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 2121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 2121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp36_);
#line 2121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 16665 "Photo.c"
	}
#line 2086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (info);
#line 2086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 16675 "Photo.c"
}


static guint64 photo_real_get_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 16685 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16692 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 16702 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16709 "Photo.c"
			}
#line 2128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16713 "Photo.c"
		}
		__finally294:
		{
			PhotoRow* _tmp4_;
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16722 "Photo.c"
		}
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0ULL;
#line 16730 "Photo.c"
	}
}


static guint64 photo_real_get_master_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 16741 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16748 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			gint64 _tmp3_;
#line 2134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 16761 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16768 "Photo.c"
			}
#line 2134 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16772 "Photo.c"
		}
		__finally295:
		{
			PhotoRow* _tmp5_;
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16781 "Photo.c"
		}
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0ULL;
#line 16789 "Photo.c"
	}
}


guint64 photo_get_editable_filesize (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 16799 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16806 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 16816 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16823 "Photo.c"
			}
#line 2140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16827 "Photo.c"
		}
		__finally296:
		{
			PhotoRow* _tmp4_;
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16836 "Photo.c"
		}
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2139 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0ULL;
#line 16844 "Photo.c"
	}
}


static time_t photo_real_get_exposure_time (Dateable* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 2144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 16855 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16862 "Photo.c"
		{
			PhotoRow* _tmp1_;
			time_t _tmp2_;
#line 2146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->exposure_time;
#line 2146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 16872 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16879 "Photo.c"
			}
#line 2146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16883 "Photo.c"
		}
		__finally297:
		{
			PhotoRow* _tmp4_;
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16892 "Photo.c"
		}
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 16900 "Photo.c"
	}
}


static gchar* photo_real_get_basename (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 16911 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16918 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 16928 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16935 "Photo.c"
			}
#line 2152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16939 "Photo.c"
		}
		__finally298:
		{
			PhotoRow* _tmp4_;
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16948 "Photo.c"
		}
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 16956 "Photo.c"
	}
}


static gchar* photo_real_get_title (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 16967 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16974 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 16987 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16994 "Photo.c"
			}
#line 2158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 16998 "Photo.c"
		}
		__finally299:
		{
			PhotoRow* _tmp5_;
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17007 "Photo.c"
		}
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 17015 "Photo.c"
	}
}


static void photo_real_set_title (MediaSource* base, const gchar* title) {
	Photo * self;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* new_title;
	gboolean committed;
	gboolean _tmp18_;
	GError * _inner_error_ = NULL;
#line 2162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2163 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = title;
#line 2163 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = media_source_prep_title (_tmp0_);
#line 2163 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	new_title = _tmp1_;
#line 2165 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 17038 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = self->row;
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17045 "Photo.c"
		{
			const gchar* _tmp3_;
			PhotoRow* _tmp4_;
			const gchar* _tmp5_;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoID _tmp10_;
			const gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
#line 2167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = new_title;
#line 2167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _tmp4_->title;
#line 2167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 17065 "Photo.c"
				{
					PhotoRow* _tmp6_;
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp6_ = self->row;
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17072 "Photo.c"
				}
#line 2168 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (new_title);
#line 2168 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 17078 "Photo.c"
			}
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->row;
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = new_title;
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo_table_set_title (_tmp8_, &_tmp10_, _tmp11_);
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			committed = _tmp12_;
#line 2170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2171 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = committed;
#line 2171 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp13_) {
#line 17100 "Photo.c"
				PhotoRow* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 2172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = self->row;
#line 2172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = new_title;
#line 2172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp14_->title);
#line 2172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_->title = _tmp16_;
#line 17114 "Photo.c"
			}
		}
		__finally300:
		{
			PhotoRow* _tmp17_;
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = self->row;
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17124 "Photo.c"
		}
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (new_title);
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 17136 "Photo.c"
		}
	}
#line 2175 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = committed;
#line 2175 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp18_) {
#line 17143 "Photo.c"
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 2176 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = alteration_new ("metadata", "name");
#line 2176 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2176 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp20_);
#line 2176 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 17154 "Photo.c"
	}
#line 2162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (new_title);
#line 17158 "Photo.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 2186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 17165 "Photo.c"
}


void photo_set_import_id (Photo* self, ImportID* import_id) {
	GError* dberr;
	GError* _tmp13_;
	GError * _inner_error_ = NULL;
#line 2179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2180 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dberr = NULL;
#line 17179 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17186 "Photo.c"
		{
			{
				PhotoTable* _tmp1_ = NULL;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = *import_id;
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 17214 "Photo.c"
						goto __catch302_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp6_ = self->row;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17223 "Photo.c"
					}
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 2183 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 17233 "Photo.c"
				}
#line 2184 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = self->row;
#line 2184 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = *import_id;
#line 2184 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 17241 "Photo.c"
			}
			goto __finally302;
			__catch302_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				err = _inner_error_;
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 2186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = err;
#line 2186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				dberr = _tmp10_;
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (err);
#line 17263 "Photo.c"
			}
			__finally302:
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 17268 "Photo.c"
				{
					PhotoRow* _tmp11_;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_ = self->row;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17275 "Photo.c"
				}
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 17285 "Photo.c"
			}
		}
		__finally301:
		{
			PhotoRow* _tmp12_;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = self->row;
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17295 "Photo.c"
		}
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 17307 "Photo.c"
		}
	}
#line 2190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = dberr;
#line 2190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 17314 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp15_);
#line 2191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 17325 "Photo.c"
	} else {
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 2193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = data_object_to_string (DATA_OBJECT (self));
#line 2193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = dberr;
#line 2193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:2193: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 17343 "Photo.c"
	}
#line 2179 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_error_free0 (dberr);
#line 17347 "Photo.c"
}


void photo_set_title_persistent (Photo* self, const gchar* title, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	const gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp14_;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_;
	const gchar* _tmp22_;
	GError * _inner_error_ = NULL;
#line 2196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	source = _tmp0_;
#line 2200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = source;
#line 2200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp1_));
#line 2200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp3_) {
#line 17384 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 2201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = source;
#line 2201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp4_));
#line 2201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:2201: No photo file writer available for %s", _tmp6_);
#line 2201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2203 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = title;
#line 2203 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_set_title (MEDIA_SOURCE (self), _tmp7_);
#line 2205 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2205 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17407 "Photo.c"
	}
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = source;
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp9_;
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17423 "Photo.c"
	}
#line 2209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = metadata;
#line 2209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = title;
#line 2209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_metadata_set_title (_tmp10_, _tmp11_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = source;
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	writer = _tmp13_;
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2211 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17447 "Photo.c"
	}
#line 2212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = source;
#line 2212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp14_));
#line 2212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_title");
#line 2212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 17459 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_;
		PhotoMetadata* _tmp18_;
#line 2214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = writer;
#line 2214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = metadata;
#line 2214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 17471 "Photo.c"
			goto __finally303;
		}
	}
	__finally303:
	{
		PhotoFileReader* _tmp19_;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_;
#line 2216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = source;
#line 2216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp19_));
#line 2216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 17490 "Photo.c"
	}
#line 2213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17504 "Photo.c"
	}
#line 2219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = title;
#line 2219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	media_source_set_title (MEDIA_SOURCE (self), _tmp22_);
#line 2221 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 17518 "Photo.c"
}


static void photo_real_set_exposure_time (Dateable* base, time_t time) {
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
#line 2224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 17529 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17536 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			time_t _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = time;
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = photo_table_set_exposure_time (_tmp2_, &_tmp4_, _tmp5_);
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			committed = _tmp6_;
#line 2227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = committed;
#line 2228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp7_) {
#line 17565 "Photo.c"
				PhotoRow* _tmp8_;
				time_t _tmp9_;
#line 2229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = self->row;
#line 2229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = time;
#line 2229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_->exposure_time = _tmp9_;
#line 17574 "Photo.c"
			}
		}
		__finally304:
		{
			PhotoRow* _tmp10_;
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = self->row;
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17584 "Photo.c"
		}
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 17594 "Photo.c"
		}
	}
#line 2232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = committed;
#line 2232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 17601 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = alteration_new ("metadata", "exposure-time");
#line 2233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp13_);
#line 2233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 17612 "Photo.c"
	}
}


void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	time_t _tmp11_;
	MetadataDateTime* _tmp12_;
	MetadataDateTime* _tmp13_;
	PhotoFileReader* _tmp14_;
	PhotoFileMetadataWriter* _tmp15_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp16_;
	GFile* _tmp17_ = NULL;
	GFile* _tmp18_;
	time_t _tmp24_;
	GError * _inner_error_ = NULL;
#line 2236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2237 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2237 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	source = _tmp0_;
#line 2240 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = source;
#line 2240 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp1_));
#line 2240 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2240 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp3_) {
#line 17652 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		time_t _tmp7_;
#line 2241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = source;
#line 2241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp4_));
#line 2241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:2241: No photo file writer available for %s", _tmp6_);
#line 2241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = time;
#line 2243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dateable_set_exposure_time (DATEABLE (self), _tmp7_);
#line 2245 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2245 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17675 "Photo.c"
	}
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = source;
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp9_;
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17691 "Photo.c"
	}
#line 2249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = metadata;
#line 2249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = time;
#line 2249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = metadata_date_time_new (_tmp11_);
#line 2249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp10_, _tmp13_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2249 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp13_);
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = source;
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = photo_file_reader_create_metadata_writer (_tmp14_, &_inner_error_);
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	writer = _tmp15_;
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17721 "Photo.c"
	}
#line 2252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = source;
#line 2252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp16_));
#line 2252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_monitor_blacklist_file (_tmp18_, "Photo.set_exposure_time_persistent");
#line 2252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 17733 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp19_;
		PhotoMetadata* _tmp20_;
#line 2254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = writer;
#line 2254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = metadata;
#line 2254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp19_, _tmp20_, &_inner_error_);
#line 2254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 17745 "Photo.c"
			goto __finally305;
		}
	}
	__finally305:
	{
		PhotoFileReader* _tmp21_;
		GFile* _tmp22_ = NULL;
		GFile* _tmp23_;
#line 2256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = source;
#line 2256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp21_));
#line 2256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp23_);
#line 2256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp23_);
#line 17764 "Photo.c"
	}
#line 2253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 17778 "Photo.c"
	}
#line 2259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = time;
#line 2259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dateable_set_exposure_time (DATEABLE (self), _tmp24_);
#line 2261 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 17792 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result) {
	Photo * self;
	Dimensions _tmp0_ = {0};
	Dimensions returned_dims;
	PhotoException _tmp1_;
	gboolean _tmp2_ = FALSE;
	PhotoException _tmp10_;
	gboolean _tmp11_ = FALSE;
	PhotoException _tmp22_;
	gboolean _tmp23_ = FALSE;
#line 2277 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 2279 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2279 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	returned_dims = _tmp0_;
#line 2282 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = disallowed_steps;
#line 2282 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_exception_allows (_tmp1_, PHOTO_EXCEPTION_ORIENTATION);
#line 2282 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_) {
#line 17831 "Photo.c"
		Orientation _tmp3_ = 0;
		Orientation ori_tmp;
		Orientation _tmp4_;
#line 2283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_get_orientation (self);
#line 2283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		ori_tmp = _tmp3_;
#line 2286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = ori_tmp;
#line 2286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		switch (_tmp4_) {
#line 2286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 17851 "Photo.c"
			{
				Dimensions _tmp5_;
				gint _tmp6_;
				gint width_tmp;
				Dimensions _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 2292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = returned_dims;
#line 2292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = _tmp5_.width;
#line 2292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				width_tmp = _tmp6_;
#line 2294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = returned_dims;
#line 2294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _tmp7_.height;
#line 2294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				returned_dims.width = _tmp8_;
#line 2295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = width_tmp;
#line 2295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				returned_dims.height = _tmp9_;
#line 2296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 17877 "Photo.c"
			}
			default:
			{
#line 2300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 17883 "Photo.c"
			}
		}
	}
#line 2305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = disallowed_steps;
#line 2305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 2305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 17893 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle;
		gdouble _tmp12_ = 0.0;
		Dimensions _tmp13_;
		gint _tmp14_;
		Dimensions _tmp15_;
		gint _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_;
		gdouble _tmp21_;
#line 2307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		angle = 0.0;
#line 2309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_get_straighten (self, &_tmp12_);
#line 2309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		angle = _tmp12_;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = returned_dims;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = _tmp13_.width;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = returned_dims;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = _tmp15_.height;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = angle;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp14_, (gdouble) _tmp16_, _tmp17_, &_tmp18_, &_tmp19_);
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		x_size = _tmp18_;
#line 2311 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		y_size = _tmp19_;
#line 2313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = x_size;
#line 2313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		returned_dims.width = (gint) _tmp20_;
#line 2314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = y_size;
#line 2314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		returned_dims.height = (gint) _tmp21_;
#line 17937 "Photo.c"
	}
#line 2318 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = disallowed_steps;
#line 2318 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = photo_exception_allows (_tmp22_, PHOTO_EXCEPTION_CROP);
#line 2318 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp23_) {
#line 17945 "Photo.c"
		Box crop = {0};
		Box _tmp24_ = {0};
		gboolean _tmp25_ = FALSE;
#line 2320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = photo_get_crop (self, &_tmp24_);
#line 2320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		crop = _tmp24_;
#line 2320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp25_) {
#line 17955 "Photo.c"
			Dimensions _tmp26_ = {0};
#line 2321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp26_);
#line 2321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			returned_dims = _tmp26_;
#line 17961 "Photo.c"
		}
	}
#line 2324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = returned_dims;
#line 2324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 17968 "Photo.c"
}


static void photo_locked_create_adjustments_from_data (Photo* self) {
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_ = NULL;
#line 2328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp1_;
#line 2332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = map;
#line 2332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 17995 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 18001 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = map;
#line 2335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 18011 "Photo.c"
	}
#line 2337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 18023 "Photo.c"
}


PixelTransformationBundle* photo_get_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
#line 2341 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 18032 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18039 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_ = NULL;
#line 2343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 18050 "Photo.c"
			}
#line 2346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 18058 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18065 "Photo.c"
			}
#line 2346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 18069 "Photo.c"
		}
		__finally306:
		{
			PhotoRow* _tmp5_;
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18078 "Photo.c"
		}
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 18086 "Photo.c"
	}
}


PixelTransformer* photo_get_pixel_transformer (Photo* self) {
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
#line 2350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 18096 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18103 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_ = NULL;
#line 2352 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2352 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2353 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 18114 "Photo.c"
			}
#line 2355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp3_;
#line 18122 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18129 "Photo.c"
			}
#line 2355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 18133 "Photo.c"
		}
		__finally307:
		{
			PhotoRow* _tmp5_;
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18142 "Photo.c"
		}
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2351 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 18150 "Photo.c"
	}
}


gboolean photo_has_color_adjustments (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2359 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2360 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "adjustments");
#line 2360 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 2360 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 18166 "Photo.c"
}


PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type) {
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationType _tmp2_;
	PixelTransformation* _tmp3_ = NULL;
	PixelTransformation* _tmp4_;
#line 2363 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = type;
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = pixel_transformation_bundle_get_transformation (_tmp1_, _tmp2_);
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 2364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 18195 "Photo.c"
}


void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments) {
	PixelTransformationBundle* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PixelTransformationBundle* _tmp8_;
	KeyValueMap* _tmp9_ = NULL;
	KeyValueMap* map;
	gboolean committed = FALSE;
	gboolean _tmp40_;
	GError * _inner_error_ = NULL;
#line 2367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PIXEL_TRANSFORMATION_BUNDLE (new_adjustments));
#line 2370 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = new_adjustments;
#line 2370 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = pixel_transformation_bundle_is_identity (_tmp0_);
#line 2370 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 18218 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp5_;
		{
			PhotoRow* _tmp2_;
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->row;
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18227 "Photo.c"
			{
				gboolean _tmp3_ = FALSE;
#line 2373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = photo_remove_transformation (self, "adjustments");
#line 2373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_result_ = _tmp3_;
#line 2374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->transformer = NULL;
#line 18242 "Photo.c"
			}
			__finally308:
			{
				PhotoRow* _tmp4_;
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18251 "Photo.c"
			}
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2372 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 18261 "Photo.c"
			}
		}
#line 2378 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _result_;
#line 2378 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp5_) {
#line 18268 "Photo.c"
			Alteration* _tmp6_;
			Alteration* _tmp7_;
#line 2379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = alteration_new ("image", "color-adjustments");
#line 2379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			data_object_notify_altered (DATA_OBJECT (self), _tmp7_);
#line 2379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_alteration_unref0 (_tmp7_);
#line 18279 "Photo.c"
		}
#line 2381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 18283 "Photo.c"
	}
#line 2385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = new_adjustments;
#line 2385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = pixel_transformation_bundle_save (_tmp8_, "adjustments");
#line 2385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp9_;
#line 18291 "Photo.c"
	{
		PhotoRow* _tmp10_;
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = self->row;
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18298 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			PixelTransformer* _tmp12_;
			gboolean _tmp14_;
			KeyValueMap* _tmp37_;
			gboolean _tmp38_ = FALSE;
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = self->priv->transformer;
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = TRUE;
#line 18311 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp13_;
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = self->priv->adjustments;
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tmp13_ == NULL;
#line 18318 "Photo.c"
			}
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp11_;
#line 2389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp14_) {
#line 18324 "Photo.c"
				PixelTransformationBundle* _tmp15_;
				PixelTransformationBundle* _tmp16_ = NULL;
				PixelTransformationBundle* _tmp17_;
				PixelTransformer* _tmp18_ = NULL;
#line 2391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = new_adjustments;
#line 2391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = pixel_transformation_bundle_copy (_tmp15_);
#line 2391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2391 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->adjustments = _tmp16_;
#line 2392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = new_adjustments;
#line 2392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = pixel_transformation_bundle_generate_transformer (_tmp17_);
#line 2392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->transformer = _tmp18_;
#line 18345 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp35_;
				PixelTransformationBundle* _tmp36_ = NULL;
				{
					PixelTransformationBundle* _tmp19_;
					GeeIterable* _tmp20_ = NULL;
					GeeIterable* _tmp21_;
					GeeIterator* _tmp22_ = NULL;
					GeeIterator* _tmp23_;
					GeeIterator* _transformation_it;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp19_ = new_adjustments;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp20_ = pixel_transformation_bundle_get_transformations (_tmp19_);
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp21_ = _tmp20_;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp22_ = gee_iterable_iterator (_tmp21_);
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp21_);
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_transformation_it = _tmp23_;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					while (TRUE) {
#line 18372 "Photo.c"
						GeeIterator* _tmp24_;
						gboolean _tmp25_ = FALSE;
						GeeIterator* _tmp26_;
						gpointer _tmp27_ = NULL;
						PixelTransformation* transformation;
						PixelTransformer* _tmp28_;
						PixelTransformationBundle* _tmp29_;
						PixelTransformation* _tmp30_;
						PixelTransformationType _tmp31_ = 0;
						PixelTransformation* _tmp32_ = NULL;
						PixelTransformation* _tmp33_;
						PixelTransformation* _tmp34_;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp24_ = _transformation_it;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp25_ = gee_iterator_next (_tmp24_);
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (!_tmp25_) {
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							break;
#line 18393 "Photo.c"
						}
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp26_ = _transformation_it;
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp27_ = gee_iterator_get (_tmp26_);
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp27_;
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp28_ = self->priv->transformer;
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp29_ = self->priv->adjustments;
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp30_ = transformation;
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp31_ = pixel_transformation_get_transformation_type (_tmp30_);
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp32_ = pixel_transformation_bundle_get_transformation (_tmp29_, _tmp31_);
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp33_ = _tmp32_;
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp34_ = transformation;
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp28_, _tmp33_, _tmp34_);
#line 2396 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp33_);
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 18421 "Photo.c"
					}
#line 2395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 18425 "Photo.c"
				}
#line 2401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = new_adjustments;
#line 2401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = pixel_transformation_bundle_copy (_tmp35_);
#line 2401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->adjustments = _tmp36_;
#line 18435 "Photo.c"
			}
#line 2404 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp37_ = map;
#line 2404 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = photo_set_transformation (self, _tmp37_);
#line 2404 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			committed = _tmp38_;
#line 18443 "Photo.c"
		}
		__finally309:
		{
			PhotoRow* _tmp39_;
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp39_ = self->row;
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18452 "Photo.c"
		}
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 18464 "Photo.c"
		}
	}
#line 2407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = committed;
#line 2407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp40_) {
#line 18471 "Photo.c"
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 2408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41_ = alteration_new ("image", "color-adjustments");
#line 2408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 2408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp42_);
#line 2408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 18482 "Photo.c"
	}
#line 2367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 18486 "Photo.c"
}


static PhotoMetadata* photo_real_get_metadata (PhotoSource* base) {
	Photo * self;
	PhotoMetadata* result = NULL;
	GError * _inner_error_ = NULL;
#line 2412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 18496 "Photo.c"
	{
		PhotoFileReader* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoMetadata* _tmp2_ = NULL;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = photo_get_source_reader (self);
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp1_);
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 18517 "Photo.c"
			goto __catch310_g_error;
		}
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp4_;
#line 2414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18524 "Photo.c"
	}
	goto __finally310;
	__catch310_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 2413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 2413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 2416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = err;
#line 2416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_->message;
#line 2416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:2416: Unable to load metadata: %s", _tmp6_);
#line 2418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 2418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 2418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18548 "Photo.c"
	}
	__finally310:
#line 2413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_clear_error (&_inner_error_);
#line 2413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 18557 "Photo.c"
}


PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	GError * _inner_error_ = NULL;
#line 2422 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 18589 "Photo.c"
	}
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 2423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 18595 "Photo.c"
}


PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError * _inner_error_ = NULL;
#line 2426 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reader = _tmp0_;
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = reader;
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 18616 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_ = NULL;
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = reader;
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error_);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 18637 "Photo.c"
		}
	} else {
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = NULL;
#line 18644 "Photo.c"
	}
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 18652 "Photo.c"
}


gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error) {
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* master_reader;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_ = NULL;
	PhotoFileMetadataWriter* _tmp6_;
	PhotoFileMetadataWriter* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoReimportMasterState* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	PhotoReimportMasterState* _tmp12_;
	GError * _inner_error_ = NULL;
#line 2435 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2435 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = NULL;
#line 2439 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2439 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	master_reader = _tmp0_;
#line 2441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = master_reader;
#line 2441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp1_));
#line 2441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp3_) {
#line 2442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 2442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 18702 "Photo.c"
		} else {
#line 2442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 18706 "Photo.c"
		}
#line 2442 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18710 "Photo.c"
	}
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = master_reader;
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error_);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 18726 "Photo.c"
	}
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = metadata;
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp7_, _tmp8_, &_inner_error_);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp7_);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 18744 "Photo.c"
	}
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_master (self, &_tmp9_, &_inner_error_);
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = _tmp9_;
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 18762 "Photo.c"
	}
#line 2446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp11_) {
#line 2447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 2447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 18774 "Photo.c"
		} else {
#line 2447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 18778 "Photo.c"
		}
#line 2447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18782 "Photo.c"
	}
#line 2449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_IMPL (_tmp12_)->metadata_only = TRUE;
#line 2451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 2451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (state) {
#line 2451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*state = _vala_state;
#line 18796 "Photo.c"
	} else {
#line 2451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 18800 "Photo.c"
	}
#line 2451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 18804 "Photo.c"
}


void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_;
	GError * _inner_error_ = NULL;
#line 2454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = state;
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_finish_reimport_master (self, _tmp0_, &_inner_error_);
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 18827 "Photo.c"
		} else {
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2455 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 18835 "Photo.c"
		}
	}
}


gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* editable_reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	PhotoFileReader* _tmp5_;
	PhotoFileMetadataWriter* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp7_;
	PhotoFileMetadataWriter* _tmp8_;
	PhotoMetadata* _tmp9_;
	PhotoReimportEditableState* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_;
	PhotoReimportEditableState* _tmp13_;
	GError * _inner_error_ = NULL;
#line 2458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = NULL;
#line 2462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	editable_reader = _tmp0_;
#line 2463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 2464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 18884 "Photo.c"
		} else {
#line 2464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 18888 "Photo.c"
		}
#line 2464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18892 "Photo.c"
	}
#line 2466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 2466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_file_format_can_write_metadata (_tmp3_);
#line 2466 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp4_) {
#line 2467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 2467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 18910 "Photo.c"
		} else {
#line 2467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 18914 "Photo.c"
		}
#line 2467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18918 "Photo.c"
	}
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = editable_reader;
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = photo_file_reader_create_metadata_writer (_tmp5_, &_inner_error_);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 18934 "Photo.c"
	}
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = metadata;
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp8_, _tmp9_, &_inner_error_);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp8_);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 18952 "Photo.c"
	}
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = photo_prepare_for_reimport_editable (self, &_tmp10_, &_inner_error_);
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = _tmp10_;
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 18970 "Photo.c"
	}
#line 2471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp12_) {
#line 2472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 2472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 18982 "Photo.c"
		} else {
#line 2472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 18986 "Photo.c"
		}
#line 2472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 18990 "Photo.c"
	}
#line 2474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _vala_state;
#line 2474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL (_tmp13_)->metadata_only = TRUE;
#line 2476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 2476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (state) {
#line 2476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*state = _vala_state;
#line 19004 "Photo.c"
	} else {
#line 2476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 19008 "Photo.c"
	}
#line 2476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 19012 "Photo.c"
}


void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error) {
	PhotoReimportEditableState* _tmp0_;
	GError * _inner_error_ = NULL;
#line 2479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = state;
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_finish_reimport_editable (self, _tmp0_, &_inner_error_);
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 19035 "Photo.c"
		} else {
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 19043 "Photo.c"
		}
	}
}


void photo_get_raw_dimensions (Photo* self, Dimensions* result) {
	GError * _inner_error_ = NULL;
#line 2485 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 19053 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19060 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*result = _tmp2_;
#line 19070 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19077 "Photo.c"
			}
#line 2487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 19081 "Photo.c"
		}
		__finally311:
		{
			PhotoRow* _tmp4_;
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19090 "Photo.c"
		}
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2486 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 19098 "Photo.c"
	}
}


gboolean photo_has_transformations (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 19108 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19115 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Orientation _tmp3_;
			BackingPhotoRow* _tmp4_;
			Orientation _tmp5_;
			gboolean _tmp8_;
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->row;
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = TRUE;
#line 19135 "Photo.c"
			} else {
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
#line 2495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->row;
#line 2495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 19145 "Photo.c"
			}
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp1_;
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp8_;
#line 19151 "Photo.c"
			{
				PhotoRow* _tmp9_;
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->row;
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19158 "Photo.c"
			}
#line 2493 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 19162 "Photo.c"
		}
		__finally312:
		{
			PhotoRow* _tmp10_;
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = self->row;
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19171 "Photo.c"
		}
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 19179 "Photo.c"
	}
}


gboolean photo_only_metadata_changed (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp1_;
	GError * _inner_error_ = NULL;
#line 2499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	date_time = NULL;
#line 2502 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 2502 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp0_;
#line 2503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = metadata;
#line 2503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 19203 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_ = NULL;
#line 2504 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = metadata;
#line 2504 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2504 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2504 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		date_time = _tmp3_;
#line 19214 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = self->row;
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19222 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
			gboolean _tmp21_;
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->row;
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 19234 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				Orientation _tmp10_;
				BackingPhotoRow* _tmp11_;
				Orientation _tmp12_;
				gboolean _tmp20_;
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->row;
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp8_ = TRUE;
#line 19253 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
					gboolean _tmp19_;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = date_time;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 19262 "Photo.c"
						PhotoRow* _tmp15_;
						time_t _tmp16_;
						MetadataDateTime* _tmp17_;
						time_t _tmp18_ = 0;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp15_ = self->row;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp17_ = date_time;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp18_ = metadata_date_time_get_timestamp (_tmp17_);
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp13_ = _tmp16_ != _tmp18_;
#line 19277 "Photo.c"
					} else {
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp13_ = FALSE;
#line 19281 "Photo.c"
					}
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp19_ = _tmp13_;
#line 2509 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp8_ = _tmp19_;
#line 19287 "Photo.c"
				}
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = _tmp8_;
#line 2508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp20_;
#line 19293 "Photo.c"
			} else {
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = FALSE;
#line 19297 "Photo.c"
			}
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = _tmp5_;
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp21_;
#line 19303 "Photo.c"
			{
				PhotoRow* _tmp22_;
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = self->row;
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19310 "Photo.c"
			}
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2507 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 19318 "Photo.c"
		}
		__finally313:
		{
			PhotoRow* _tmp23_;
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp23_ = self->row;
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19327 "Photo.c"
		}
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2506 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 19339 "Photo.c"
	}
#line 2499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 19345 "Photo.c"
}


gboolean photo_has_alterations (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	gchar* title;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp6_;
	GError * _inner_error_ = NULL;
#line 2513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	date_time = NULL;
#line 2515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	title = NULL;
#line 2517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 2517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp0_;
#line 2518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = metadata;
#line 2518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 19372 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_ = NULL;
#line 2519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = metadata;
#line 2519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		date_time = _tmp3_;
#line 2520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = metadata;
#line 2520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = media_metadata_get_title (MEDIA_METADATA (_tmp4_));
#line 2520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (title);
#line 2520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		title = _tmp5_;
#line 19393 "Photo.c"
	}
#line 2524 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = date_time;
#line 2524 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 19399 "Photo.c"
		{
			PhotoRow* _tmp7_;
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->row;
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19406 "Photo.c"
			{
				BackingPhotoRow* _tmp8_;
				time_t _tmp9_;
				PhotoRow* _tmp10_;
				time_t _tmp11_;
#line 2528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = self->backing_photo_row;
#line 2528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_->timestamp;
#line 2528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = self->row;
#line 2528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tmp10_->exposure_time;
#line 2528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp9_ != _tmp11_) {
#line 2530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					result = TRUE;
#line 19424 "Photo.c"
					{
						PhotoRow* _tmp12_;
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp12_ = self->row;
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19431 "Photo.c"
					}
#line 2530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (title);
#line 2530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2530 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return result;
#line 19441 "Photo.c"
				}
			}
			__finally314:
			{
				PhotoRow* _tmp13_;
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = self->row;
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19451 "Photo.c"
			}
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (title);
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return FALSE;
#line 19467 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp14_;
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = self->row;
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19477 "Photo.c"
		{
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			PhotoRow* _tmp18_;
			GeeHashMap* _tmp19_;
			gboolean _tmp24_;
			gboolean _tmp32_;
			gboolean _tmp36_;
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = self->row;
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = _tmp18_->transformations;
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp19_ != NULL) {
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = TRUE;
#line 19495 "Photo.c"
			} else {
				PhotoRow* _tmp20_;
				Orientation _tmp21_;
				BackingPhotoRow* _tmp22_;
				Orientation _tmp23_;
#line 2537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = self->row;
#line 2537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = _tmp20_->orientation;
#line 2537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = self->backing_photo_row;
#line 2537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = _tmp22_->original_orientation;
#line 2537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = _tmp21_ != _tmp23_;
#line 19511 "Photo.c"
			}
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = _tmp17_;
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp24_) {
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = TRUE;
#line 19519 "Photo.c"
			} else {
				gboolean _tmp25_ = FALSE;
				MetadataDateTime* _tmp26_;
				gboolean _tmp31_;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = date_time;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp26_ != NULL) {
#line 19528 "Photo.c"
					PhotoRow* _tmp27_;
					time_t _tmp28_;
					MetadataDateTime* _tmp29_;
					time_t _tmp30_ = 0;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp27_ = self->row;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp28_ = _tmp27_->exposure_time;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp29_ = date_time;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp30_ = metadata_date_time_get_timestamp (_tmp29_);
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp25_ = _tmp28_ != _tmp30_;
#line 19543 "Photo.c"
				} else {
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp25_ = FALSE;
#line 19547 "Photo.c"
				}
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = _tmp25_;
#line 2538 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp31_;
#line 19553 "Photo.c"
			}
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp32_ = _tmp16_;
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp32_) {
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = TRUE;
#line 19561 "Photo.c"
			} else {
				gchar* _tmp33_ = NULL;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 2539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = media_source_get_title (MEDIA_SOURCE (self));
#line 2539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = title;
#line 2539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp34_);
#line 19576 "Photo.c"
			}
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_ = _tmp15_;
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp36_;
#line 19582 "Photo.c"
			{
				PhotoRow* _tmp37_;
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = self->row;
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19589 "Photo.c"
			}
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (title);
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 19599 "Photo.c"
		}
		__finally315:
		{
			PhotoRow* _tmp38_;
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = self->row;
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19608 "Photo.c"
		}
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (title);
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 19622 "Photo.c"
	}
#line 2513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (title);
#line 2513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 19630 "Photo.c"
}


PhotoTransformationState* photo_save_transformation_state (Photo* self) {
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
#line 2543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 19639 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19646 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			Orientation _tmp10_;
			PhotoRow* _tmp11_;
			GeeHashMap* _tmp12_;
			PixelTransformer* _tmp13_;
			PixelTransformationBundle* _tmp14_;
			PhotoPhotoTransformationStateImpl* _tmp15_;
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 19663 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_ = NULL;
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 19674 "Photo.c"
			} else {
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2547 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = NULL;
#line 19680 "Photo.c"
			}
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 19686 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_ = NULL;
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 19697 "Photo.c"
			} else {
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = NULL;
#line 19703 "Photo.c"
			}
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->row;
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = self->row;
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = _tmp1_;
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp5_;
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp13_, _tmp14_);
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = PHOTO_TRANSFORMATION_STATE (_tmp15_);
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 19725 "Photo.c"
			{
				PhotoRow* _tmp16_;
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = self->row;
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19732 "Photo.c"
			}
#line 2545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 19736 "Photo.c"
		}
		__finally316:
		{
			PhotoRow* _tmp17_;
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = self->row;
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19745 "Photo.c"
		}
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 19753 "Photo.c"
	}
}


static gpointer _pixel_transformer_ref0 (gpointer self) {
#line 2569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 19761 "Photo.c"
}


static gpointer _pixel_transformation_bundle_ref0 (gpointer self) {
#line 2570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 19768 "Photo.c"
}


gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state) {
	gboolean result = FALSE;
	PhotoTransformationState* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	PhotoPhotoTransformationStateImpl* state_impl;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	Orientation _tmp4_ = 0;
	Orientation saved_orientation;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	GeeHashMap* _tmp6_ = NULL;
	GeeHashMap* saved_transformations;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformer* _tmp8_ = NULL;
	PixelTransformer* saved_transformer;
	PhotoPhotoTransformationStateImpl* _tmp9_;
	PixelTransformationBundle* _tmp10_ = NULL;
	PixelTransformationBundle* saved_adjustments;
	gboolean committed = FALSE;
	gboolean _tmp30_;
	GError * _inner_error_ = NULL;
#line 2552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = state;
#line 2553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (_tmp0_) ? ((PhotoPhotoTransformationStateImpl*) _tmp0_) : NULL);
#line 2553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	state_impl = _tmp1_;
#line 2554 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2554 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 2555 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2555 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2555 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 19813 "Photo.c"
	}
#line 2557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_orientation (_tmp3_);
#line 2557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	saved_orientation = _tmp4_;
#line 2558 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = state_impl;
#line 2558 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformations (_tmp5_);
#line 2558 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	saved_transformations = _tmp6_;
#line 2559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = state_impl;
#line 2559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_transformer (_tmp7_);
#line 2559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	saved_transformer = _tmp8_;
#line 2560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = state_impl;
#line 2560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp9_);
#line 2560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	saved_adjustments = _tmp10_;
#line 19839 "Photo.c"
	{
		PhotoRow* _tmp11_;
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = self->row;
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19846 "Photo.c"
		{
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_;
			PhotoRow* _tmp14_;
			PhotoID _tmp15_;
			Orientation _tmp16_;
			GeeHashMap* _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = self->row;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = _tmp14_->photo_id;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = saved_orientation;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = saved_transformations;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = photo_table_set_transformation_state (_tmp13_, &_tmp15_, _tmp16_, _tmp17_);
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			committed = _tmp18_;
#line 2564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 2566 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = committed;
#line 2566 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp19_) {
#line 19878 "Photo.c"
				PhotoRow* _tmp20_;
				Orientation _tmp21_;
				PhotoRow* _tmp22_;
				GeeHashMap* _tmp23_;
				GeeHashMap* _tmp24_;
				PixelTransformer* _tmp25_;
				PixelTransformer* _tmp26_;
				PixelTransformationBundle* _tmp27_;
				PixelTransformationBundle* _tmp28_;
#line 2567 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = self->row;
#line 2567 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = saved_orientation;
#line 2567 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_->orientation = _tmp21_;
#line 2568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = self->row;
#line 2568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = saved_transformations;
#line 2568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 2568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp22_->transformations);
#line 2568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_->transformations = _tmp24_;
#line 2569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = saved_transformer;
#line 2569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = _pixel_transformer_ref0 (_tmp25_);
#line 2569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->transformer = _tmp26_;
#line 2570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = saved_adjustments;
#line 2570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = _pixel_transformation_bundle_ref0 (_tmp27_);
#line 2570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->adjustments = _tmp28_;
#line 19920 "Photo.c"
			}
		}
		__finally317:
		{
			PhotoRow* _tmp29_;
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp29_ = self->row;
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19930 "Photo.c"
		}
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 19948 "Photo.c"
		}
	}
#line 2574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = committed;
#line 2574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp30_) {
#line 19955 "Photo.c"
		Alteration* _tmp31_;
		Alteration* _tmp32_;
#line 2575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = alteration_new ("image", "transformation-state");
#line 2575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = _tmp31_;
#line 2575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp32_);
#line 2575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp32_);
#line 19966 "Photo.c"
	}
#line 2577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = committed;
#line 2577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 19980 "Photo.c"
}


void photo_remove_all_transformations (Photo* self) {
#line 2580 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2581 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 19989 "Photo.c"
}


static void photo_internal_remove_all_transformations (Photo* self, gboolean notify) {
	gboolean is_altered;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_;
	gboolean _tmp24_;
	GError * _inner_error_ = NULL;
#line 2584 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_altered = FALSE;
#line 20003 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20010 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			PhotoRow* _tmp7_;
			Orientation _tmp8_;
			BackingPhotoRow* _tmp9_;
			Orientation _tmp10_;
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			is_altered = _tmp5_;
#line 2587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->row;
#line 2588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp6_->transformations);
#line 2588 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_->transformations = NULL;
#line 2590 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2590 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->row;
#line 2593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp7_->orientation;
#line 2593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->backing_photo_row;
#line 2593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _tmp9_->original_orientation;
#line 2593 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_ != _tmp10_) {
#line 20060 "Photo.c"
				PhotoTable* _tmp11_ = NULL;
				PhotoTable* _tmp12_;
				PhotoRow* _tmp13_;
				PhotoID _tmp14_;
				BackingPhotoRow* _tmp15_;
				Orientation _tmp16_;
				PhotoRow* _tmp17_;
				BackingPhotoRow* _tmp18_;
				Orientation _tmp19_;
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = photo_table_get_instance ();
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = self->row;
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = _tmp13_->photo_id;
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = self->backing_photo_row;
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo_table_set_orientation (_tmp12_, &_tmp14_, _tmp16_);
#line 2594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp12_);
#line 2596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = self->row;
#line 2596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = self->backing_photo_row;
#line 2596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = _tmp18_->original_orientation;
#line 2596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_->orientation = _tmp19_;
#line 2597 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				is_altered = TRUE;
#line 20096 "Photo.c"
			}
		}
		__finally318:
		{
			PhotoRow* _tmp20_;
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = self->row;
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20106 "Photo.c"
		}
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 20116 "Photo.c"
		}
	}
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = is_altered;
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp22_) {
#line 20123 "Photo.c"
		gboolean _tmp23_;
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = notify;
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 20129 "Photo.c"
	} else {
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = FALSE;
#line 20133 "Photo.c"
	}
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = _tmp21_;
#line 2601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp24_) {
#line 20139 "Photo.c"
		Alteration* _tmp25_;
		Alteration* _tmp26_;
#line 2602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = alteration_new ("image", "revert");
#line 2602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 2602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp26_);
#line 2602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp26_);
#line 20150 "Photo.c"
	}
}


Orientation photo_get_original_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 20160 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20167 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 20177 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20184 "Photo.c"
			}
#line 2607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 20188 "Photo.c"
		}
		__finally319:
		{
			PhotoRow* _tmp4_;
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20197 "Photo.c"
		}
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 20205 "Photo.c"
	}
}


Orientation photo_get_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 20215 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20222 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2613 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2613 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2613 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp2_;
#line 20232 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20239 "Photo.c"
			}
#line 2613 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 20243 "Photo.c"
		}
		__finally320:
		{
			PhotoRow* _tmp4_;
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20252 "Photo.c"
		}
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return 0;
#line 20260 "Photo.c"
	}
}


gboolean photo_set_orientation (Photo* self, Orientation orientation) {
	gboolean result = FALSE;
	gboolean committed;
	gboolean _tmp14_;
	GError * _inner_error_ = NULL;
#line 2617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2618 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	committed = FALSE;
#line 20274 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20281 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
			Orientation _tmp3_;
#line 2620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = orientation;
#line 2620 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 20294 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_;
				PhotoRow* _tmp6_;
				PhotoID _tmp7_;
				Orientation _tmp8_;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_;
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->row;
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = _tmp6_->photo_id;
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = orientation;
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = photo_table_set_orientation (_tmp5_, &_tmp7_, _tmp8_);
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				committed = _tmp9_;
#line 2621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = committed;
#line 2622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp10_) {
#line 20322 "Photo.c"
					PhotoRow* _tmp11_;
					Orientation _tmp12_;
#line 2623 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_ = self->row;
#line 2623 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = orientation;
#line 2623 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_->orientation = _tmp12_;
#line 20331 "Photo.c"
				}
			}
		}
		__finally321:
		{
			PhotoRow* _tmp13_;
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = self->row;
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20342 "Photo.c"
		}
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2619 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 20352 "Photo.c"
		}
	}
#line 2627 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = committed;
#line 2627 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_) {
#line 20359 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2628 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "orientation");
#line 2628 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2628 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp16_);
#line 2628 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 20370 "Photo.c"
	}
#line 2630 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = committed;
#line 2630 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 20376 "Photo.c"
}


gboolean photo_check_can_rotate (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 2633 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 2634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 20391 "Photo.c"
}


static void photo_real_rotate (Photo* self, Rotation rotation) {
	GError * _inner_error_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20403 "Photo.c"
		{
			Orientation _tmp1_ = 0;
			Rotation _tmp2_;
			Orientation _tmp3_ = 0;
#line 2639 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_get_orientation (self);
#line 2639 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = rotation;
#line 2639 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = orientation_perform (_tmp1_, _tmp2_);
#line 2639 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_set_orientation (self, _tmp3_);
#line 20416 "Photo.c"
		}
		__finally322:
		{
			PhotoRow* _tmp4_;
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20425 "Photo.c"
		}
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 20435 "Photo.c"
		}
	}
}


void photo_rotate (Photo* self, Rotation rotation) {
#line 2637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 20446 "Photo.c"
}


static gboolean photo_has_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 20457 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20464 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->row;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 20475 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
				const gchar* _tmp6_;
				gboolean _tmp7_ = FALSE;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->row;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = name;
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp5_), _tmp6_);
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 20490 "Photo.c"
			} else {
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = FALSE;
#line 20494 "Photo.c"
			}
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp1_;
#line 20498 "Photo.c"
			{
				PhotoRow* _tmp8_;
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = self->row;
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20505 "Photo.c"
			}
#line 2645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 20509 "Photo.c"
		}
		__finally323:
		{
			PhotoRow* _tmp9_;
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->row;
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20518 "Photo.c"
		}
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 20526 "Photo.c"
	}
}


static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name) {
	KeyValueMap* result = NULL;
	KeyValueMap* map;
	GError * _inner_error_ = NULL;
#line 2652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = NULL;
#line 20541 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20548 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 20558 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				const gchar* _tmp5_;
				gpointer _tmp6_ = NULL;
				KeyValueMap* _tmp7_;
#line 2656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = name;
#line 2656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp4_), _tmp5_);
#line 2656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				map = (KeyValueMap*) _tmp6_;
#line 2657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = map;
#line 2657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp7_ != NULL) {
#line 20580 "Photo.c"
					KeyValueMap* _tmp8_;
					KeyValueMap* _tmp9_ = NULL;
#line 2658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp8_ = map;
#line 2658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp9_ = key_value_map_copy (_tmp8_);
#line 2658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					map = _tmp9_;
#line 20591 "Photo.c"
				}
			}
		}
		__finally324:
		{
			PhotoRow* _tmp10_;
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = self->row;
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20602 "Photo.c"
		}
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 20614 "Photo.c"
		}
	}
#line 2662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = map;
#line 2662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 20621 "Photo.c"
}


static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_KEY_VALUE_MAP (trans), FALSE);
#line 20632 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20639 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp8_;
			GeeHashMap* _tmp9_;
			KeyValueMap* _tmp10_;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_;
			KeyValueMap* _tmp13_;
			PhotoTable* _tmp14_ = NULL;
			PhotoTable* _tmp15_;
			PhotoRow* _tmp16_;
			PhotoID _tmp17_;
			KeyValueMap* _tmp18_;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_;
#line 2667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 20662 "Photo.c"
				PhotoRow* _tmp3_;
				GHashFunc _tmp4_;
				GEqualFunc _tmp5_;
				GEqualFunc _tmp6_;
				GeeHashMap* _tmp7_;
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = g_str_hash;
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = g_str_equal;
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = g_direct_equal;
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, _tmp4_, _tmp5_, _tmp6_);
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2668 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_->transformations = _tmp7_;
#line 20682 "Photo.c"
			}
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = self->row;
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _tmp8_->transformations;
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = trans;
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = key_value_map_get_group (_tmp10_);
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = trans;
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp9_), _tmp12_, _tmp13_);
#line 2670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp12_);
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = photo_table_get_instance ();
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = self->row;
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = _tmp16_->photo_id;
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = trans;
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = photo_table_set_transformation (_tmp15_, &_tmp17_, _tmp18_);
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp20_;
#line 20718 "Photo.c"
			{
				PhotoRow* _tmp21_;
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = self->row;
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20725 "Photo.c"
			}
#line 2672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 20729 "Photo.c"
		}
		__finally325:
		{
			PhotoRow* _tmp22_;
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = self->row;
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20738 "Photo.c"
		}
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 20746 "Photo.c"
	}
}


static gboolean photo_remove_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	GError * _inner_error_ = NULL;
#line 2676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 20763 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20770 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_;
			PhotoRow* _tmp14_;
			PhotoID _tmp15_;
			const gchar* _tmp16_;
			gboolean _tmp17_ = FALSE;
#line 2679 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->row;
#line 2679 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2679 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 20786 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
				PhotoRow* _tmp7_;
				GeeHashMap* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 2680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->row;
#line 2680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = name;
#line 2680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp4_), _tmp5_, NULL);
#line 2680 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				altered_cache = _tmp6_;
#line 2681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = self->row;
#line 2681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _tmp7_->transformations;
#line 2681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = gee_abstract_map_get_size (GEE_MAP (_tmp8_));
#line 2681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 2681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp10_ == 0) {
#line 20815 "Photo.c"
					PhotoRow* _tmp11_;
#line 2682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_ = self->row;
#line 2682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp11_->transformations);
#line 2682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_->transformations = NULL;
#line 20823 "Photo.c"
				}
			} else {
#line 2684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				altered_cache = FALSE;
#line 20828 "Photo.c"
			}
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = self->row;
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = _tmp14_->photo_id;
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = name;
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = photo_table_remove_transformation (_tmp13_, &_tmp15_, _tmp16_);
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			altered_persistent = _tmp17_;
#line 2687 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 20846 "Photo.c"
		}
		__finally326:
		{
			PhotoRow* _tmp18_;
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = self->row;
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20855 "Photo.c"
		}
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 20865 "Photo.c"
		}
	}
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = altered_cache;
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp20_) {
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = TRUE;
#line 20874 "Photo.c"
	} else {
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = altered_persistent;
#line 20878 "Photo.c"
	}
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = _tmp19_;
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp21_;
#line 2691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 20886 "Photo.c"
}


gboolean photo_has_crop (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2694 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "crop");
#line 2695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 2695 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 20901 "Photo.c"
}


gboolean photo_get_raw_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gint _tmp3_ = 0;
	gint left;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint top;
	KeyValueMap* _tmp6_;
	gint _tmp7_ = 0;
	gint right;
	KeyValueMap* _tmp8_;
	gint _tmp9_ = 0;
	gint bottom;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	gboolean _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 2699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2700 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 2703 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = map;
#line 2703 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (crop) {
#line 2704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*crop = _vala_crop;
#line 20954 "Photo.c"
		}
#line 2704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 20958 "Photo.c"
	}
#line 2706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = map;
#line 2706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = key_value_map_get_int (_tmp2_, "left", -1);
#line 2706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	left = _tmp3_;
#line 2707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = map;
#line 2707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "top", -1);
#line 2707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	top = _tmp5_;
#line 2708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = map;
#line 2708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = key_value_map_get_int (_tmp6_, "right", -1);
#line 2708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	right = _tmp7_;
#line 2709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = map;
#line 2709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = key_value_map_get_int (_tmp8_, "bottom", -1);
#line 2709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	bottom = _tmp9_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = left;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp13_ == (-1)) {
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = TRUE;
#line 20990 "Photo.c"
	} else {
		gint _tmp14_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = top;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp14_ == (-1);
#line 20997 "Photo.c"
	}
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp12_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp15_) {
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = TRUE;
#line 21005 "Photo.c"
	} else {
		gint _tmp16_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = right;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = _tmp16_ == (-1);
#line 21012 "Photo.c"
	}
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp11_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = TRUE;
#line 21020 "Photo.c"
	} else {
		gint _tmp18_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = bottom;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp18_ == (-1);
#line 21027 "Photo.c"
	}
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = _tmp10_;
#line 2711 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp19_) {
#line 2712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (crop) {
#line 2712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*crop = _vala_crop;
#line 21041 "Photo.c"
		}
#line 2712 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 21045 "Photo.c"
	}
#line 2714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = left;
#line 2714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = top;
#line 2714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = right;
#line 2714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = bottom;
#line 2714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	box_init (&_vala_crop, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 2716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 2716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (crop) {
#line 2716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*crop = _vala_crop;
#line 21065 "Photo.c"
	}
#line 2716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 21069 "Photo.c"
}


static void photo_set_raw_crop (Photo* self, Box* crop) {
	KeyValueMap* _tmp0_;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	KeyValueMap* _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	KeyValueMap* _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	KeyValueMap* _tmp13_;
	gboolean _tmp14_ = FALSE;
#line 2720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 2722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = map;
#line 2722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = *crop;
#line 2722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = map;
#line 2723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = *crop;
#line 2723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = map;
#line 2724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = *crop;
#line 2724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = map;
#line 2725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = *crop;
#line 2725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = map;
#line 2727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = photo_set_transformation (self, _tmp13_);
#line 2727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_) {
#line 21136 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "crop");
#line 2728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp16_);
#line 2728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 21147 "Photo.c"
	}
#line 2720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 21151 "Photo.c"
}


static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle) {
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gdouble _tmp3_ = 0.0;
#line 2731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 2732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 2733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = map;
#line 2733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_angle = 0.0;
#line 2736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (angle) {
#line 2736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*angle = _vala_angle;
#line 21183 "Photo.c"
		}
#line 2736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 21187 "Photo.c"
	}
#line 2739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = map;
#line 2739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 2739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_angle = _tmp3_;
#line 2741 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 2741 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2741 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (angle) {
#line 2741 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*angle = _vala_angle;
#line 21203 "Photo.c"
	}
#line 2741 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 21207 "Photo.c"
}


static void photo_set_raw_straighten (Photo* self, gdouble theta) {
	KeyValueMap* _tmp0_;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	gdouble _tmp2_;
	KeyValueMap* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 2744 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 2745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 2746 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = map;
#line 2746 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = theta;
#line 2746 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", _tmp2_);
#line 2748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = map;
#line 2748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_set_transformation (self, _tmp3_);
#line 2748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp4_) {
#line 21236 "Photo.c"
		Alteration* _tmp5_;
		Alteration* _tmp6_;
#line 2749 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = alteration_new ("image", "straighen");
#line 2749 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2749 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp6_);
#line 2749 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp6_);
#line 21247 "Photo.c"
	}
#line 2744 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 21251 "Photo.c"
}


static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1) {
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint num_points;
	gint _tmp6_;
	gint _tmp7_;
	EditingToolsRedeyeInstance* _tmp8_ = NULL;
	EditingToolsRedeyeInstance* res;
	gint res_length1;
	gint _res_size_;
	GdkPoint _tmp9_ = {0};
	GdkPoint default_point;
	EditingToolsRedeyeInstance* _tmp48_;
	gint _tmp48__length1;
#line 2754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 2756 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = map;
#line 2756 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 21283 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_ = NULL;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3__length1 = 0;
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (result_length1) {
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 21297 "Photo.c"
		}
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp3_;
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2757 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 21305 "Photo.c"
	}
#line 2759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = map;
#line 2759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	num_points = _tmp5_;
#line 2760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = num_points;
#line 2760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp6_ > 0);
#line 2762 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = num_points;
#line 2762 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = g_new0 (EditingToolsRedeyeInstance, _tmp7_);
#line 2762 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	res = _tmp8_;
#line 2762 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	res_length1 = _tmp7_;
#line 2762 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_res_size_ = res_length1;
#line 2764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_.x = 0;
#line 2764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	default_point = _tmp9_;
#line 2765 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	default_point.x = -1;
#line 2766 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	default_point.y = -1;
#line 21335 "Photo.c"
	{
		gint i;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		i = 0;
#line 21340 "Photo.c"
		{
			gboolean _tmp10_;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = TRUE;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 21347 "Photo.c"
				gboolean _tmp11_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gchar* _tmp16_ = NULL;
				gchar* center_key;
				gint _tmp17_;
				gchar* _tmp18_ = NULL;
				gchar* radius_key;
				EditingToolsRedeyeInstance* _tmp19_;
				gint _tmp19__length1;
				gint _tmp20_;
				KeyValueMap* _tmp21_;
				const gchar* _tmp22_;
				GdkPoint _tmp23_;
				GdkPoint _tmp24_ = {0};
				EditingToolsRedeyeInstance* _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				EditingToolsRedeyeInstance _tmp27_;
				GdkPoint _tmp28_;
				gint _tmp29_;
				GdkPoint _tmp30_;
				gint _tmp31_;
				EditingToolsRedeyeInstance* _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_;
				EditingToolsRedeyeInstance _tmp34_;
				GdkPoint _tmp35_;
				gint _tmp36_;
				GdkPoint _tmp37_;
				gint _tmp38_;
				EditingToolsRedeyeInstance* _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				KeyValueMap* _tmp41_;
				const gchar* _tmp42_;
				gint _tmp43_ = 0;
				EditingToolsRedeyeInstance* _tmp44_;
				gint _tmp44__length1;
				gint _tmp45_;
				EditingToolsRedeyeInstance _tmp46_;
				gint _tmp47_;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp11_) {
#line 21395 "Photo.c"
					gint _tmp12_;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = i;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					i = _tmp12_ + 1;
#line 21401 "Photo.c"
				}
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = FALSE;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = i;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = num_points;
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 21413 "Photo.c"
				}
#line 2769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = i;
#line 2769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = g_strdup_printf ("center%d", _tmp15_);
#line 2769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				center_key = _tmp16_;
#line 2770 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = i;
#line 2770 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = g_strdup_printf ("radius%d", _tmp17_);
#line 2770 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				radius_key = _tmp18_;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = res;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19__length1 = res_length1;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = i;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = map;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = center_key;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = default_point;
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				key_value_map_get_point (_tmp21_, _tmp22_, &_tmp23_, &_tmp24_);
#line 2772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_[_tmp20_].center = _tmp24_;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = res;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25__length1 = res_length1;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = i;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = _tmp25_[_tmp26_];
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = _tmp27_.center;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = _tmp28_.x;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp30_ = default_point;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = _tmp30_.x;
#line 2773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_assert (_tmp29_ != _tmp31_);
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = res;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32__length1 = res_length1;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = i;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp34_ = _tmp32_[_tmp33_];
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = _tmp34_.center;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = _tmp35_.y;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = default_point;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = _tmp37_.y;
#line 2774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_assert (_tmp36_ != _tmp38_);
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_ = res;
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39__length1 = res_length1;
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp40_ = i;
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp41_ = map;
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp42_ = radius_key;
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = key_value_map_get_int (_tmp41_, _tmp42_, -1);
#line 2776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_[_tmp40_].radius = _tmp43_;
#line 2777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = res;
#line 2777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44__length1 = res_length1;
#line 2777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp45_ = i;
#line 2777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp46_ = _tmp44_[_tmp45_];
#line 2777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp47_ = _tmp46_.radius;
#line 2777 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_assert (_tmp47_ != (-1));
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (radius_key);
#line 2768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (center_key);
#line 21509 "Photo.c"
			}
		}
	}
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = res;
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48__length1 = res_length1;
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (result_length1) {
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*result_length1 = _tmp48__length1;
#line 21521 "Photo.c"
	}
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp48_;
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 21529 "Photo.c"
}


gboolean photo_has_redeye_transformations (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "redeye");
#line 2784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 2784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 21544 "Photo.c"
}


void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye) {
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint num_points;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* radius_key;
	gint _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* center_key;
	KeyValueMap* _tmp12_;
	const gchar* _tmp13_;
	EditingToolsRedeyeInstance _tmp14_;
	gint _tmp15_;
	KeyValueMap* _tmp16_;
	const gchar* _tmp17_;
	EditingToolsRedeyeInstance _tmp18_;
	GdkPoint _tmp19_;
	KeyValueMap* _tmp20_;
	gint _tmp21_;
	KeyValueMap* _tmp22_;
	gboolean _tmp23_ = FALSE;
#line 2788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 2789 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2789 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 2790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = map;
#line 2790 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 21587 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 2791 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 2791 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2791 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		map = _tmp2_;
#line 2792 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = map;
#line 2792 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 21600 "Photo.c"
	}
#line 2795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = map;
#line 2795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2795 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	num_points = _tmp5_;
#line 2796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = num_points;
#line 2796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp6_ >= 0);
#line 2798 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = num_points;
#line 2798 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	num_points = _tmp7_ + 1;
#line 2800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = num_points;
#line 2800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = g_strdup_printf ("radius%d", _tmp8_ - 1);
#line 2800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	radius_key = _tmp9_;
#line 2801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = num_points;
#line 2801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("center%d", _tmp10_ - 1);
#line 2801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	center_key = _tmp11_;
#line 2803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = map;
#line 2803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = radius_key;
#line 2803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = *redeye;
#line 2803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp14_.radius;
#line 2803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_int (_tmp12_, _tmp13_, _tmp15_);
#line 2804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = map;
#line 2804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = center_key;
#line 2804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = *redeye;
#line 2804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = _tmp18_.center;
#line 2804 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_point (_tmp16_, _tmp17_, &_tmp19_);
#line 2806 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = map;
#line 2806 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = num_points;
#line 2806 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	key_value_map_set_int (_tmp20_, "num_points", _tmp21_);
#line 2808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = map;
#line 2808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = photo_set_transformation (self, _tmp22_);
#line 2808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp23_) {
#line 21660 "Photo.c"
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 2809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = alteration_new ("image", "redeye");
#line 2809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 2809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp25_);
#line 2809 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 21671 "Photo.c"
	}
#line 2788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (center_key);
#line 2788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (radius_key);
#line 2788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 21679 "Photo.c"
}


static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 21692 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21699 "Photo.c"
		{
			Scaling _tmp1_;
			PhotoException _tmp2_;
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = *scaling;
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = exceptions;
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_scaled_image = _tmp3_;
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp4_;
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp5_;
#line 21718 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->row;
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21725 "Photo.c"
			}
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (scaled_image) {
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 21731 "Photo.c"
			}
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (scaled_to_viewport) {
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 21737 "Photo.c"
			}
#line 2827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 21741 "Photo.c"
		}
		__finally327:
		{
			PhotoRow* _tmp7_;
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->row;
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21750 "Photo.c"
		}
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 21758 "Photo.c"
	}
#line 2823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (scaled_image) {
#line 2823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 21764 "Photo.c"
	}
#line 2823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (scaled_to_viewport) {
#line 2823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 21770 "Photo.c"
	}
}


static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
	Dimensions raw;
	gboolean _tmp1_ = FALSE;
	Orientation _tmp4_ = 0;
	Orientation orientation;
	PhotoException _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp54_ = FALSE;
	Dimensions _tmp55_;
	gint _tmp56_;
	Dimensions _tmp57_;
	gint _tmp58_;
	gboolean _tmp63_;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
#line 2833 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2833 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 2835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw = _tmp0_;
#line 2837 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = scaling_is_unscaled (scaling);
#line 2837 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 21807 "Photo.c"
		Dimensions _tmp2_;
		Dimensions _tmp3_;
#line 2838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = raw;
#line 2838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_scaled_image = _tmp2_;
#line 2839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = raw;
#line 2839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp3_;
#line 2841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (scaled_image) {
#line 2841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 21824 "Photo.c"
		}
#line 2841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (scaled_to_viewport) {
#line 2841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 21830 "Photo.c"
		}
#line 2841 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 21834 "Photo.c"
	}
#line 2844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_get_orientation (self);
#line 2844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation = _tmp4_;
#line 2849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 2850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 2852 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = exceptions;
#line 2852 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = photo_exception_allows (_tmp5_, PHOTO_EXCEPTION_CROP);
#line 2852 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp6_) {
#line 21850 "Photo.c"
		Box crop = {0};
		Box _tmp7_ = {0};
		gboolean _tmp8_ = FALSE;
#line 2854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = photo_get_raw_crop (self, &_tmp7_);
#line 2854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		crop = _tmp7_;
#line 2854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp8_) {
#line 21860 "Photo.c"
			Dimensions _tmp9_;
			Dimensions rotated_raw;
			PhotoException _tmp10_;
			gboolean _tmp11_ = FALSE;
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
			Box _tmp21_ = {0};
			Box scaled_crop;
			Dimensions _tmp22_ = {0};
			gboolean _tmp23_ = FALSE;
			gint _tmp24_ = 0;
			gint _tmp25_ = 0;
			gboolean _tmp28_;
			Dimensions _tmp31_ = {0};
			Dimensions _tmp32_ = {0};
			Dimensions _tmp33_ = {0};
			PhotoException _tmp34_;
			gboolean _tmp35_ = FALSE;
#line 2857 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = raw;
#line 2857 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			rotated_raw = _tmp9_;
#line 2858 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = exceptions;
#line 2858 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_ORIENTATION);
#line 2858 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp11_) {
#line 21889 "Photo.c"
				Orientation _tmp12_;
				Dimensions _tmp13_;
				Box _tmp14_;
				Box _tmp15_ = {0};
				Orientation _tmp16_;
				Dimensions _tmp17_;
				Dimensions _tmp18_ = {0};
#line 2859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = orientation;
#line 2859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = raw;
#line 2859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = crop;
#line 2859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				orientation_rotate_box (_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 2859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				crop = _tmp15_;
#line 2860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = orientation;
#line 2860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = raw;
#line 2860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				orientation_rotate_dimensions (_tmp16_, &_tmp17_, &_tmp18_);
#line 2860 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				rotated_raw = _tmp18_;
#line 21915 "Photo.c"
			}
#line 2864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 2864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp19_, &_tmp20_);
#line 2864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			box_get_scaled (&crop, &_tmp20_, &_tmp21_);
#line 2864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaled_crop = _tmp21_;
#line 2867 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp22_);
#line 2867 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp22_;
#line 2870 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = box_get_width (&crop);
#line 2870 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp25_ = box_get_width (&scaled_crop);
#line 2870 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp24_ <= _tmp25_) {
#line 21935 "Photo.c"
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
#line 2871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = box_get_height (&crop);
#line 2871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = box_get_height (&scaled_crop);
#line 2871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = _tmp26_ <= _tmp27_;
#line 21944 "Photo.c"
			} else {
#line 2870 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = FALSE;
#line 21948 "Photo.c"
			}
#line 2870 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp28_ = _tmp23_;
#line 2870 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp28_) {
#line 21954 "Photo.c"
				Dimensions _tmp29_;
				Dimensions _tmp30_ = {0};
#line 2872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = raw;
#line 2872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_vala_scaled_image = _tmp29_;
#line 2873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp30_);
#line 2873 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp30_;
#line 2875 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = FALSE;
#line 2875 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (scaled_image) {
#line 2875 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 21971 "Photo.c"
				}
#line 2875 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (scaled_to_viewport) {
#line 2875 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 21977 "Photo.c"
				}
#line 2875 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 21981 "Photo.c"
			}
#line 2880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp31_);
#line 2880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp32_);
#line 2880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp31_, &_tmp32_, &_tmp33_);
#line 2880 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_scaled_image = _tmp33_;
#line 2884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp34_ = exceptions;
#line 2884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp35_ = photo_exception_allows (_tmp34_, PHOTO_EXCEPTION_ORIENTATION);
#line 2884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp35_) {
#line 21997 "Photo.c"
				Orientation _tmp36_;
				Dimensions _tmp37_;
				Dimensions _tmp38_ = {0};
#line 2885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = orientation;
#line 2885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = _vala_scaled_image;
#line 2885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				orientation_derotate_dimensions (_tmp36_, &_tmp37_, &_tmp38_);
#line 2885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_vala_scaled_image = _tmp38_;
#line 22009 "Photo.c"
			}
		}
	}
#line 2890 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = dimensions_has_area (&_vala_scaled_image);
#line 2890 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp39_) {
#line 22017 "Photo.c"
		Dimensions _tmp40_;
		Dimensions rotated_raw;
		PhotoException _tmp41_;
		gboolean _tmp42_ = FALSE;
		Dimensions _tmp46_;
		Dimensions _tmp47_ = {0};
		Dimensions _tmp48_;
		PhotoException _tmp49_;
		gboolean _tmp50_ = FALSE;
#line 2892 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp40_ = raw;
#line 2892 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		rotated_raw = _tmp40_;
#line 2893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp41_ = exceptions;
#line 2893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp42_ = photo_exception_allows (_tmp41_, PHOTO_EXCEPTION_ORIENTATION);
#line 2893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp42_) {
#line 22037 "Photo.c"
			Orientation _tmp43_;
			Dimensions _tmp44_;
			Dimensions _tmp45_ = {0};
#line 2894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp43_ = orientation;
#line 2894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp44_ = raw;
#line 2894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			orientation_rotate_dimensions (_tmp43_, &_tmp44_, &_tmp45_);
#line 2894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			rotated_raw = _tmp45_;
#line 22049 "Photo.c"
		}
#line 2896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = rotated_raw;
#line 2896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp46_, &_tmp47_);
#line 2896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_scaled_image = _tmp47_;
#line 2897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp48_ = _vala_scaled_image;
#line 2897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp48_;
#line 2900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49_ = exceptions;
#line 2900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = photo_exception_allows (_tmp49_, PHOTO_EXCEPTION_ORIENTATION);
#line 2900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp50_) {
#line 22067 "Photo.c"
			Orientation _tmp51_;
			Dimensions _tmp52_;
			Dimensions _tmp53_ = {0};
#line 2901 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp51_ = orientation;
#line 2901 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp52_ = _vala_scaled_image;
#line 2901 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			orientation_derotate_dimensions (_tmp51_, &_tmp52_, &_tmp53_);
#line 2901 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_scaled_image = _tmp53_;
#line 22079 "Photo.c"
		}
	}
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp55_ = _vala_scaled_image;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp56_ = _tmp55_.width;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp57_ = raw;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp58_ = _tmp57_.width;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp56_ >= _tmp58_) {
#line 22092 "Photo.c"
		Dimensions _tmp59_;
		gint _tmp60_;
		Dimensions _tmp61_;
		gint _tmp62_;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp59_ = _vala_scaled_image;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp60_ = _tmp59_.height;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp61_ = raw;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp62_ = _tmp61_.height;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = _tmp60_ >= _tmp62_;
#line 22107 "Photo.c"
	} else {
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = FALSE;
#line 22111 "Photo.c"
	}
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp63_ = _tmp54_;
#line 2905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp63_) {
#line 22117 "Photo.c"
		Dimensions _tmp64_;
#line 2906 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp64_ = raw;
#line 2906 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_scaled_image = _tmp64_;
#line 2908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 2908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (scaled_image) {
#line 2908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 22129 "Photo.c"
		}
#line 2908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (scaled_to_viewport) {
#line 2908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22135 "Photo.c"
		}
#line 2908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 22139 "Photo.c"
	}
#line 2911 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp65_ = dimensions_has_area (&_vala_scaled_image);
#line 2911 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp65_);
#line 2912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp66_ = dimensions_has_area (&_vala_scaled_to_viewport);
#line 2912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp66_);
#line 2914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 2914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (scaled_image) {
#line 2914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 22155 "Photo.c"
	}
#line 2914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (scaled_to_viewport) {
#line 2914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22161 "Photo.c"
	}
#line 2914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 22165 "Photo.c"
}


static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	BackingFetchMode _tmp0_;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* loader;
	gboolean _tmp2_ = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Scaling _tmp6_;
	PhotoException _tmp7_;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	gboolean is_scaled;
	gboolean _tmp11_;
	PhotoFileReader* _tmp15_;
	Dimensions _tmp16_ = {0};
	Dimensions _tmp17_;
	GdkPixbuf* _tmp18_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp19_;
	Dimensions _tmp20_ = {0};
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2920 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2923 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = fetch_mode;
#line 2923 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_backing_reader (self, _tmp0_);
#line 2923 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	loader = _tmp1_;
#line 2926 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = scaling_is_unscaled (scaling);
#line 2926 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_) {
#line 22207 "Photo.c"
		PhotoFileReader* _tmp3_;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_;
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = loader;
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = photo_file_reader_unscaled_read (_tmp3_, &_inner_error_);
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 22225 "Photo.c"
		}
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp5_;
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 2931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 22233 "Photo.c"
	}
#line 2936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = *scaling;
#line 2936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = exceptions;
#line 2936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = photo_calculate_pixbuf_dimensions (self, &_tmp6_, _tmp7_, &_tmp8_, &_tmp9_);
#line 2936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	scaled_image = _tmp8_;
#line 2936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	scaled_to_viewport = _tmp9_;
#line 2936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_scaled = _tmp10_;
#line 2938 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = is_scaled;
#line 2938 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp11_) {
#line 22251 "Photo.c"
		PhotoFileReader* _tmp12_;
		GdkPixbuf* _tmp13_ = NULL;
		GdkPixbuf* _tmp14_;
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = loader;
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = photo_file_reader_unscaled_read (_tmp12_, &_inner_error_);
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 22269 "Photo.c"
		}
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp14_;
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 2943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 22277 "Photo.c"
	}
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = loader;
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp16_);
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = scaled_image;
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = photo_file_reader_scaled_read (_tmp15_, &_tmp16_, &_tmp17_, &_inner_error_);
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	pixbuf = _tmp18_;
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 2946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 22297 "Photo.c"
	}
#line 2954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = pixbuf;
#line 2954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dimensions_for_pixbuf (_tmp19_, &_tmp20_);
#line 2954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = dimensions_approx_equals (&scaled_image, &_tmp20_, PHOTO_SCALING_FUDGE);
#line 2954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp21_);
#line 2956 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = pixbuf;
#line 2956 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 2956 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 22313 "Photo.c"
}


GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	gboolean _tmp1_;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 2961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *scaling;
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = rotate;
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp0_, _tmp1_, BACKING_FETCH_MODE_MASTER, &_inner_error_);
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 22342 "Photo.c"
	}
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 2962 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 22348 "Photo.c"
}


GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	gboolean _tmp1_;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 2966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *scaling;
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = rotate;
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp0_, _tmp1_, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error_);
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 22377 "Photo.c"
	}
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 2967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 22383 "Photo.c"
}


static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	Scaling _tmp6_;
	BackingFetchMode _tmp7_;
	GdkPixbuf* _tmp8_ = NULL;
	GdkPixbuf* pixbuf;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
#line 2971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 22402 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 22409 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			Orientation _tmp4_ = 0;
#line 2986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = *scaling;
#line 2986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 2986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaled_image = _tmp2_;
#line 2986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 2988 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = photo_get_original_orientation (self);
#line 2988 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			original_orientation = _tmp4_;
#line 22427 "Photo.c"
		}
		__finally328:
		{
			PhotoRow* _tmp5_;
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = self->row;
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 22436 "Photo.c"
		}
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 22444 "Photo.c"
		}
	}
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = *scaling;
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = fetch_mode;
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo_load_raw_pixbuf (self, &_tmp6_, PHOTO_EXCEPTION_NONE, _tmp7_, &_inner_error_);
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	pixbuf = _tmp8_;
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 22461 "Photo.c"
	}
#line 2998 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = rotate;
#line 2998 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp9_) {
#line 22467 "Photo.c"
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_ = NULL;
#line 2999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = pixbuf;
#line 2999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = orientation_rotate_pixbuf (original_orientation, _tmp10_);
#line 2999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 2999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixbuf = _tmp11_;
#line 22478 "Photo.c"
	}
#line 3008 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = pixbuf;
#line 3008 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 22484 "Photo.c"
}


static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 3011 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (base);
#line 3011 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *scaling;
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_pixbuf_with_options (self, &_tmp0_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 22511 "Photo.c"
	}
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 3012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 22517 "Photo.c"
}


/**
     * @brief Populates the cached version of the unmodified image.
     */
void photo_populate_prefetched (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3018 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 22528 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 22535 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
#line 3021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 22542 "Photo.c"
				Scaling _tmp2_ = {0};
				GdkPixbuf* _tmp3_ = NULL;
				GdkPixbuf* _tmp4_;
				GTimer* _tmp5_;
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
#line 3022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				scaling_for_original (&_tmp2_);
#line 3022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = photo_load_raw_pixbuf (self, &_tmp2_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 3022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 22557 "Photo.c"
					goto __finally329;
				}
#line 3022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3022 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->unmodified_precached = _tmp4_;
#line 3023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = g_timer_new ();
#line 3023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->secs_since_access = _tmp5_;
#line 3024 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), g_object_unref);
#line 3025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = data_object_to_string (DATA_OBJECT (self));
#line 3025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 3025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_debug ("Photo.vala:3025: spawning new precache timeout for %s", _tmp7_);
#line 3025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp7_);
#line 22580 "Photo.c"
			}
		}
		__finally329:
		{
			GdkPixbuf* _tmp8_;
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = self->priv->unmodified_precached;
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22590 "Photo.c"
		}
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 22598 "Photo.c"
		}
	}
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf* photo_get_prefetched_copy (Photo* self) {
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 3035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 22614 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 22621 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_ = NULL;
#line 3037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 22630 "Photo.c"
				{
#line 3039 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 3039 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 22636 "Photo.c"
						goto __catch331_g_error;
					}
				}
				goto __finally331;
				__catch331_g_error:
				{
					GError* e = NULL;
					gchar* _tmp2_ = NULL;
					gchar* _tmp3_;
#line 3038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					e = _inner_error_;
#line 3038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_inner_error_ = NULL;
#line 3041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp2_ = data_object_to_string (DATA_OBJECT (self));
#line 3041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_warning ("Photo.vala:3041: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					result = NULL;
#line 3042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_error_free0 (e);
#line 22662 "Photo.c"
					{
						GdkPixbuf* _tmp4_;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22669 "Photo.c"
					}
#line 3042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return result;
#line 22673 "Photo.c"
				}
				__finally331:
#line 3038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 22678 "Photo.c"
					{
						GdkPixbuf* _tmp5_;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp5_ = self->priv->unmodified_precached;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22685 "Photo.c"
					}
#line 3038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return NULL;
#line 22693 "Photo.c"
				}
			}
#line 3046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->priv->unmodified_precached;
#line 3046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gdk_pixbuf_copy (_tmp6_);
#line 3046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp7_;
#line 22702 "Photo.c"
			{
				GdkPixbuf* _tmp8_;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = self->priv->unmodified_precached;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22709 "Photo.c"
			}
#line 3046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 22713 "Photo.c"
		}
		__finally330:
		{
			GdkPixbuf* _tmp9_;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22722 "Photo.c"
		}
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 22730 "Photo.c"
	}
}


/**
     * @brief Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean photo_discard_prefetched (Photo* self, gboolean immed) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 22745 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 22752 "Photo.c"
		{
			GTimer* _tmp1_;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_ = 0.0;
			gboolean _tmp8_;
#line 3057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = FALSE;
#line 22767 "Photo.c"
				{
					GdkPixbuf* _tmp2_;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22774 "Photo.c"
				}
#line 3058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 22778 "Photo.c"
			}
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = TRUE;
#line 22790 "Photo.c"
			} else {
				gboolean _tmp7_;
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = immed;
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = _tmp7_;
#line 22797 "Photo.c"
			}
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp3_;
#line 3061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_) {
#line 22803 "Photo.c"
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_;
#line 3062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = data_object_to_string (DATA_OBJECT (self));
#line 3062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 3062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp10_);
#line 3062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp10_);
#line 3065 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3065 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = FALSE;
#line 22824 "Photo.c"
				{
					GdkPixbuf* _tmp11_;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_ = self->priv->unmodified_precached;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22831 "Photo.c"
				}
#line 3067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 22835 "Photo.c"
			}
#line 3070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = TRUE;
#line 22839 "Photo.c"
			{
				GdkPixbuf* _tmp12_;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = self->priv->unmodified_precached;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22846 "Photo.c"
			}
#line 3070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 22850 "Photo.c"
		}
		__finally332:
		{
			GdkPixbuf* _tmp13_;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = self->priv->unmodified_precached;
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 22859 "Photo.c"
		}
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 22867 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp6_;
	gboolean _tmp14_;
	gboolean _tmp17_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer;
	Orientation orientation = 0;
	GdkPixbuf* _tmp38_ = NULL;
	GdkPixbuf* pixbuf;
	GTimer* _tmp39_;
	gchar* _tmp40_ = NULL;
	gchar* _tmp41_;
	GdkPixbuf* _tmp42_;
	PhotoException _tmp43_;
	gboolean _tmp44_ = FALSE;
	PhotoException _tmp49_;
	gboolean _tmp50_ = FALSE;
	PhotoException _tmp55_;
	gboolean _tmp56_ = FALSE;
	PhotoException _tmp94_;
	gboolean _tmp95_ = FALSE;
	gboolean _tmp98_;
	PhotoException _tmp105_;
	gboolean _tmp106_ = FALSE;
	gboolean _tmp110_ = FALSE;
	gboolean _tmp111_;
	gboolean _tmp113_;
	GError * _inner_error_ = NULL;
#line 3085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp4_) {
#line 22937 "Photo.c"
		PhotoFileFormat _tmp5_ = 0;
#line 3099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = photo_get_master_file_format (self);
#line 3099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp5_ == PHOTO_FILE_FORMAT_RAW;
#line 22943 "Photo.c"
	} else {
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = FALSE;
#line 22947 "Photo.c"
	}
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp2_;
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp6_) {
#line 22953 "Photo.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		BackingFetchMode _tmp9_;
		gboolean _tmp11_;
		gboolean _tmp13_;
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = fetch_mode;
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp9_ == BACKING_FETCH_MODE_BASELINE) {
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = TRUE;
#line 22965 "Photo.c"
		} else {
			BackingFetchMode _tmp10_;
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = fetch_mode;
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp10_ == BACKING_FETCH_MODE_UNMODIFIED;
#line 22972 "Photo.c"
		}
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = _tmp8_;
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp11_) {
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = TRUE;
#line 22980 "Photo.c"
		} else {
			BackingFetchMode _tmp12_;
#line 3101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = fetch_mode;
#line 3101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _tmp12_ == BACKING_FETCH_MODE_SOURCE;
#line 22987 "Photo.c"
		}
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = _tmp7_;
#line 3100 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp13_;
#line 22993 "Photo.c"
	} else {
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = FALSE;
#line 22997 "Photo.c"
	}
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp1_;
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_) {
#line 23003 "Photo.c"
		RawDeveloper _tmp15_ = 0;
		gboolean _tmp16_ = FALSE;
#line 3102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = photo_get_raw_developer (self);
#line 3102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = photo_is_raw_developer_complete (self, _tmp15_);
#line 3102 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = !_tmp16_;
#line 23012 "Photo.c"
	} else {
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = FALSE;
#line 23016 "Photo.c"
	}
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp0_;
#line 3098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 23022 "Photo.c"
		RawDeveloper _tmp18_ = 0;
#line 3103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = photo_get_raw_developer (self);
#line 3103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_set_raw_developer (self, _tmp18_);
#line 23028 "Photo.c"
	}
#line 3108 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3109 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	redeye_instances = NULL;
#line 3110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3110 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	transformer = NULL;
#line 23042 "Photo.c"
	{
		PhotoRow* _tmp19_;
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = self->row;
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 23049 "Photo.c"
		{
			Dimensions _tmp20_ = {0};
			PhotoException _tmp21_;
			Dimensions _tmp22_ = {0};
			Dimensions _tmp23_ = {0};
			Dimensions _tmp24_;
			Dimensions _tmp25_ = {0};
			Dimensions _tmp26_;
			gboolean _tmp27_ = FALSE;
			gint _tmp28_ = 0;
			EditingToolsRedeyeInstance* _tmp29_ = NULL;
			Box _tmp30_ = {0};
			gboolean _tmp31_ = FALSE;
			gdouble _tmp32_ = 0.0;
			gboolean _tmp33_ = FALSE;
			gboolean _tmp34_ = FALSE;
			Orientation _tmp36_ = 0;
#line 3117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media_source_get_dimensions (MEDIA_SOURCE (self), PHOTO_EXCEPTION_ALL, &_tmp20_);
#line 3117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			original = _tmp20_;
#line 3118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = exceptions;
#line 3118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media_source_get_dimensions (MEDIA_SOURCE (self), _tmp21_, &_tmp22_);
#line 3118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp22_, &_tmp23_);
#line 3118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaled = _tmp23_;
#line 3119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = scaled;
#line 3119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaled_to_viewport = _tmp24_;
#line 3121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media_source_get_dimensions (MEDIA_SOURCE (self), PHOTO_EXCEPTION_NONE, &_tmp25_);
#line 3121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = scaled;
#line 3121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = dimensions_equals (&_tmp25_, &_tmp26_);
#line 3121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			is_scaled = !_tmp27_;
#line 3123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp29_ = photo_get_raw_redeye_instances (self, &_tmp28_);
#line 3123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			redeye_instances = _tmp29_;
#line 3123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			redeye_instances_length1 = _tmp28_;
#line 3123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp31_ = photo_get_raw_crop (self, &_tmp30_);
#line 3125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			crop = _tmp30_;
#line 3125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			is_cropped = _tmp31_;
#line 3127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp33_ = photo_get_raw_straighten (self, &_tmp32_);
#line 3127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			straightening_angle = _tmp32_;
#line 3127 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			is_straightened = _tmp33_;
#line 3129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp34_ = photo_has_color_adjustments (self);
#line 3129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp34_) {
#line 23117 "Photo.c"
				PixelTransformer* _tmp35_ = NULL;
#line 3130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = photo_get_pixel_transformer (self);
#line 3130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3130 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				transformer = _tmp35_;
#line 23125 "Photo.c"
			}
#line 3132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_ = photo_get_orientation (self);
#line 3132 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			orientation = _tmp36_;
#line 23131 "Photo.c"
		}
		__finally333:
		{
			PhotoRow* _tmp37_;
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp37_ = self->row;
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 23140 "Photo.c"
		}
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 23152 "Photo.c"
		}
	}
#line 3138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error_);
#line 3138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 23167 "Photo.c"
	}
#line 3140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = photo_get_prefetched_copy (self);
#line 3140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	pixbuf = _tmp38_;
#line 3143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = self->priv->secs_since_access;
#line 3143 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_timer_start (_tmp39_);
#line 3144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = data_object_to_string (DATA_OBJECT (self));
#line 3144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = _tmp40_;
#line 3144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3144: pipeline being run against %s, timer restarted.", _tmp41_);
#line 3144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp41_);
#line 3146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = pixbuf;
#line 3146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp42_ != NULL);
#line 3153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = exceptions;
#line 3153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = photo_exception_allows (_tmp43_, PHOTO_EXCEPTION_REDEYE);
#line 3153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp44_) {
#line 23195 "Photo.c"
		EditingToolsRedeyeInstance* _tmp45_;
		gint _tmp45__length1;
#line 3158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45_ = redeye_instances;
#line 3158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45__length1 = redeye_instances_length1;
#line 23202 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			instance_collection = _tmp45_;
#line 3158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			instance_collection_length1 = _tmp45__length1;
#line 3158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp45__length1; instance_it = instance_it + 1) {
#line 23214 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 23218 "Photo.c"
				{
					GdkPixbuf* _tmp46_;
					EditingToolsRedeyeInstance _tmp47_;
					GdkPixbuf* _tmp48_ = NULL;
#line 3159 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp46_ = pixbuf;
#line 3159 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp47_ = instance;
#line 3159 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp48_ = photo_do_redeye (self, _tmp46_, &_tmp47_);
#line 3159 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3159 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					pixbuf = _tmp48_;
#line 23233 "Photo.c"
				}
			}
		}
	}
#line 3167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_ = exceptions;
#line 3167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp50_ = photo_exception_allows (_tmp49_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 3167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp50_) {
#line 23244 "Photo.c"
		gboolean _tmp51_;
#line 3171 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = is_straightened;
#line 3171 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp51_) {
#line 23250 "Photo.c"
			GdkPixbuf* _tmp52_;
			gdouble _tmp53_;
			GdkPixbuf* _tmp54_ = NULL;
#line 3172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp52_ = pixbuf;
#line 3172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp53_ = straightening_angle;
#line 3172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp54_ = rotate_arb (_tmp52_, _tmp53_);
#line 3172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3172 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			pixbuf = _tmp54_;
#line 23264 "Photo.c"
		}
	}
#line 3181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp55_ = exceptions;
#line 3181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp56_ = photo_exception_allows (_tmp55_, PHOTO_EXCEPTION_CROP);
#line 3181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp56_) {
#line 23273 "Photo.c"
		gboolean _tmp57_;
#line 3185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp57_ = is_cropped;
#line 3185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp57_) {
#line 23279 "Photo.c"
			Box _tmp58_;
			gint _tmp59_;
			GdkPixbuf* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			gint _tmp63_ = 0;
			Box _tmp64_;
			gint _tmp65_;
			GdkPixbuf* _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
			gint _tmp69_ = 0;
			Box _tmp70_;
			gint _tmp71_;
			Box _tmp72_;
			gint _tmp73_;
			GdkPixbuf* _tmp74_;
			gint _tmp75_;
			gint _tmp76_;
			gint _tmp77_ = 0;
			Box _tmp78_;
			gint _tmp79_;
			Box _tmp80_;
			gint _tmp81_;
			GdkPixbuf* _tmp82_;
			gint _tmp83_;
			gint _tmp84_;
			gint _tmp85_ = 0;
			GdkPixbuf* _tmp86_;
			Box _tmp87_;
			gint _tmp88_;
			Box _tmp89_;
			gint _tmp90_;
			gint _tmp91_ = 0;
			gint _tmp92_ = 0;
			GdkPixbuf* _tmp93_;
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp58_ = crop;
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp59_ = _tmp58_.left;
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp60_ = pixbuf;
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp61_ = gdk_pixbuf_get_width (_tmp60_);
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp62_ = _tmp61_;
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp63_ = CLAMP (_tmp59_, 0, _tmp62_ - 2);
#line 3190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			crop.left = _tmp63_;
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp64_ = crop;
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp65_ = _tmp64_.top;
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp66_ = pixbuf;
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp67_ = gdk_pixbuf_get_height (_tmp66_);
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp68_ = _tmp67_;
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp69_ = CLAMP (_tmp65_, 0, _tmp68_ - 2);
#line 3191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			crop.top = _tmp69_;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp70_ = crop;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp71_ = _tmp70_.right;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp72_ = crop;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp73_ = _tmp72_.left;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp74_ = pixbuf;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp75_ = gdk_pixbuf_get_width (_tmp74_);
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp76_ = _tmp75_;
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp77_ = CLAMP (_tmp71_, _tmp73_ + 1, _tmp76_ - 1);
#line 3193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			crop.right = _tmp77_;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp78_ = crop;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp79_ = _tmp78_.bottom;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp80_ = crop;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp81_ = _tmp80_.top;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp82_ = pixbuf;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp83_ = gdk_pixbuf_get_height (_tmp82_);
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp84_ = _tmp83_;
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp85_ = CLAMP (_tmp79_, _tmp81_ + 1, _tmp84_ - 1);
#line 3194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			crop.bottom = _tmp85_;
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp86_ = pixbuf;
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp87_ = crop;
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp88_ = _tmp87_.left;
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp89_ = crop;
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp90_ = _tmp89_.top;
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp91_ = box_get_width (&crop);
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp92_ = box_get_height (&crop);
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp93_ = gdk_pixbuf_new_subpixbuf (_tmp86_, _tmp88_, _tmp90_, _tmp91_, _tmp92_);
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3196 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			pixbuf = _tmp93_;
#line 23400 "Photo.c"
		}
	}
#line 3206 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp94_ = exceptions;
#line 3206 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp95_ = photo_exception_allows (_tmp94_, PHOTO_EXCEPTION_ORIENTATION);
#line 3206 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp95_) {
#line 23409 "Photo.c"
		GdkPixbuf* _tmp96_;
		GdkPixbuf* _tmp97_ = NULL;
#line 3210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp96_ = pixbuf;
#line 3210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp97_ = orientation_rotate_pixbuf (orientation, _tmp96_);
#line 3210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixbuf = _tmp97_;
#line 23420 "Photo.c"
	}
#line 3223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp98_ = is_scaled;
#line 3223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp98_) {
#line 23426 "Photo.c"
		GdkPixbuf* _tmp99_;
		Dimensions _tmp100_;
		gint _tmp101_;
		Dimensions _tmp102_;
		gint _tmp103_;
		GdkPixbuf* _tmp104_ = NULL;
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp99_ = pixbuf;
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp100_ = scaled_to_viewport;
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp101_ = _tmp100_.width;
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp102_ = scaled_to_viewport;
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp103_ = _tmp102_.height;
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp104_ = gdk_pixbuf_scale_simple (_tmp99_, _tmp101_, _tmp103_, GDK_INTERP_BILINEAR);
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixbuf = _tmp104_;
#line 23449 "Photo.c"
	}
#line 3229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp105_ = exceptions;
#line 3229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp106_ = photo_exception_allows (_tmp105_, PHOTO_EXCEPTION_ADJUST);
#line 3229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp106_) {
#line 23457 "Photo.c"
		PixelTransformer* _tmp107_;
#line 3233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp107_ = transformer;
#line 3233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp107_ != NULL) {
#line 23463 "Photo.c"
			PixelTransformer* _tmp108_;
			GdkPixbuf* _tmp109_;
#line 3234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp108_ = transformer;
#line 3234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp109_ = pixbuf;
#line 3234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp108_, _tmp109_, NULL);
#line 23472 "Photo.c"
		}
	}
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp111_ = is_scaled;
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp111_) {
#line 23479 "Photo.c"
		gboolean _tmp112_;
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp112_ = is_straightened;
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp110_ = !_tmp112_;
#line 23485 "Photo.c"
	} else {
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp110_ = FALSE;
#line 23489 "Photo.c"
	}
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp113_ = _tmp110_;
#line 3243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp113_) {
#line 23495 "Photo.c"
		GdkPixbuf* _tmp114_;
		Dimensions _tmp115_ = {0};
		gboolean _tmp116_ = FALSE;
#line 3244 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp114_ = pixbuf;
#line 3244 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dimensions_for_pixbuf (_tmp114_, &_tmp115_);
#line 3244 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp116_ = dimensions_approx_equals (&scaled_to_viewport, &_tmp115_, PHOTO_SCALING_FUDGE);
#line 3244 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_assert (_tmp116_);
#line 23507 "Photo.c"
	}
#line 3246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = pixbuf;
#line 3246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 23517 "Photo.c"
}


static gboolean photo_real_has_user_generated_metadata (Photo* self) {
#line 3254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return FALSE;
#line 23526 "Photo.c"
}


gboolean photo_has_user_generated_metadata (Photo* self) {
#line 3254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 23535 "Photo.c"
}


static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 23544 "Photo.c"
}


void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 23553 "Photo.c"
}


gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format) {
	gchar* result = NULL;
	PhotoFileFormat* _tmp0_;
#line 3265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file_format;
#line 3266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 23566 "Photo.c"
		PhotoFileFormat* _tmp1_;
		PhotoFileFormatProperties* _tmp2_ = NULL;
		PhotoFileFormatProperties* _tmp3_;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = file_format;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = photo_file_format_get_properties (*_tmp1_);
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = photo_file_format_properties_convert_file_extension (_tmp3_, _tmp5_);
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = g_file_get_basename (_tmp7_);
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp3_);
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp9_;
#line 3267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 23604 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
#line 3269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = photo_get_file_format (self);
#line 3269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = photo_file_format_can_write (_tmp10_);
#line 3269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp11_) {
#line 23614 "Photo.c"
			PhotoFileFormat _tmp12_ = 0;
			PhotoFileFormatProperties* _tmp13_ = NULL;
			PhotoFileFormatProperties* _tmp14_;
			GFile* _tmp15_ = NULL;
			GFile* _tmp16_;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_;
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = photo_get_file_format (self);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = photo_file_format_get_properties (_tmp12_);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = photo_file_format_properties_convert_file_extension (_tmp14_, _tmp16_);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = g_file_get_basename (_tmp18_);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp18_);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp16_);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp14_);
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp20_;
#line 3270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 23652 "Photo.c"
		} else {
			PhotoFileFormat _tmp21_ = 0;
			PhotoFileFormatProperties* _tmp22_ = NULL;
			PhotoFileFormatProperties* _tmp23_;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_;
			GFile* _tmp26_ = NULL;
			GFile* _tmp27_;
			gchar* _tmp28_ = NULL;
			gchar* _tmp29_;
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = photo_file_format_get_system_default_format ();
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = photo_file_format_get_properties (_tmp21_);
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp25_ = _tmp24_;
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = photo_file_format_properties_convert_file_extension (_tmp23_, _tmp25_);
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = _tmp26_;
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp28_ = g_file_get_basename (_tmp27_);
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp29_ = _tmp28_;
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp27_);
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp25_);
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp23_);
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			result = _tmp29_;
#line 3273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return result;
#line 23691 "Photo.c"
		}
	}
}


static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error) {
	gboolean result = FALSE;
	PhotoFileReader* export_reader;
	gboolean is_master;
	PhotoFileReader* _tmp31_;
	PhotoFileReader* _tmp32_;
	PhotoFileFormat _tmp33_ = 0;
	PhotoFileFormatProperties* _tmp34_ = NULL;
	PhotoFileFormatProperties* format_properties;
	PhotoFileFormatProperties* _tmp35_;
	GFile* _tmp36_;
	GFile* _tmp37_ = NULL;
	GFile* dest_file;
	PhotoFileReader* _tmp38_;
	PhotoFileFormat _tmp39_ = 0;
	GFile* _tmp40_;
	gchar* _tmp41_ = NULL;
	gchar* _tmp42_;
	PhotoFileMetadataWriter* _tmp43_ = NULL;
	PhotoFileMetadataWriter* _tmp44_;
	PhotoFileMetadataWriter* writer;
	gchar* _tmp45_ = NULL;
	gchar* _tmp46_;
	PhotoFileMetadataWriter* _tmp47_;
	gchar* _tmp48_ = NULL;
	gchar* _tmp49_;
	PhotoFileReader* _tmp50_;
	GFile* _tmp51_ = NULL;
	GFile* _tmp52_;
	GFile* _tmp53_;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp60_;
	gboolean _tmp62_;
	gboolean _tmp65_;
	gboolean _tmp67_;
	PhotoFileReader* _tmp68_;
	PhotoMetadata* _tmp69_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp70_;
	PhotoFileMetadataWriter* _tmp74_;
	gchar* _tmp75_ = NULL;
	gchar* _tmp76_;
	time_t _tmp77_ = 0;
	gboolean _tmp83_;
	PhotoFileMetadataWriter* _tmp97_;
	PhotoMetadata* _tmp98_;
	GError * _inner_error_ = NULL;
#line 3279 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3279 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3282 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	export_reader = NULL;
#line 3283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_master = TRUE;
#line 23756 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 23763 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp8_;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 23775 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				PhotoFileFormat _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp5_));
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = photo_file_format_can_write_metadata (_tmp6_);
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 23790 "Photo.c"
			} else {
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = FALSE;
#line 23794 "Photo.c"
			}
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp1_;
#line 3285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp8_) {
#line 23800 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 3286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tmp9_->editable;
#line 3286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 3286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				export_reader = _tmp11_;
#line 3287 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				is_master = FALSE;
#line 23816 "Photo.c"
			} else {
				gboolean _tmp12_ = FALSE;
				PhotoBackingReaders* _tmp13_;
				PhotoFileReader* _tmp14_;
				gboolean _tmp19_;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = self->priv->readers;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = _tmp13_->developer;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp14_ != NULL) {
#line 23828 "Photo.c"
					PhotoBackingReaders* _tmp15_;
					PhotoFileReader* _tmp16_;
					PhotoFileFormat _tmp17_ = 0;
					gboolean _tmp18_ = FALSE;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = self->priv->readers;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp16_ = _tmp15_->developer;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp17_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp16_));
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp18_ = photo_file_format_can_write_metadata (_tmp17_);
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = _tmp18_;
#line 23843 "Photo.c"
				} else {
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = FALSE;
#line 23847 "Photo.c"
				}
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = _tmp12_;
#line 3288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp19_) {
#line 23853 "Photo.c"
					PhotoBackingReaders* _tmp20_;
					PhotoFileReader* _tmp21_;
					PhotoFileReader* _tmp22_;
#line 3289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp20_ = self->priv->readers;
#line 3289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp21_ = _tmp20_->developer;
#line 3289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp22_ = _photo_file_adapter_ref0 (_tmp21_);
#line 3289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					export_reader = _tmp22_;
#line 3290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					is_master = FALSE;
#line 23869 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp23_;
					PhotoFileReader* _tmp24_;
					PhotoFileFormat _tmp25_ = 0;
					gboolean _tmp26_ = FALSE;
#line 3291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp23_ = self->priv->readers;
#line 3291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp24_ = _tmp23_->master;
#line 3291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp25_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp24_));
#line 3291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp26_ = photo_file_format_can_write_metadata (_tmp25_);
#line 3291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_tmp26_) {
#line 23885 "Photo.c"
						PhotoBackingReaders* _tmp27_;
						PhotoFileReader* _tmp28_;
						PhotoFileReader* _tmp29_;
#line 3292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp27_ = self->priv->readers;
#line 3292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp28_ = _tmp27_->master;
#line 3292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp29_ = _photo_file_adapter_ref0 (_tmp28_);
#line 3292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						export_reader = _tmp29_;
#line 23899 "Photo.c"
					}
				}
			}
		}
		__finally334:
		{
			PhotoBackingReaders* _tmp30_;
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp30_ = self->priv->readers;
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 23911 "Photo.c"
		}
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 23921 "Photo.c"
		}
	}
#line 3296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = export_reader;
#line 3296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp31_ == NULL) {
#line 3297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 3297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 23934 "Photo.c"
	}
#line 3299 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = export_reader;
#line 3299 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp32_));
#line 3299 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = photo_file_format_get_properties (_tmp33_);
#line 3299 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	format_properties = _tmp34_;
#line 3302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = format_properties;
#line 3302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = file;
#line 3302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = photo_file_format_properties_convert_file_extension (_tmp35_, _tmp36_);
#line 3302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dest_file = _tmp37_;
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = export_reader;
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp38_));
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = dest_file;
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = g_file_get_path (_tmp40_);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = _tmp41_;
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = photo_file_format_create_metadata_writer (_tmp39_, _tmp42_, &_inner_error_);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp42_);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	writer = _tmp44_;
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3305 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 23982 "Photo.c"
	}
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = data_object_to_string (DATA_OBJECT (self));
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = _tmp45_;
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = writer;
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp47_));
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3308: Exporting full-sized copy of %s to %s", _tmp46_, _tmp49_);
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp49_);
#line 3308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp46_);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp50_ = export_reader;
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp51_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp50_));
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp52_ = _tmp51_;
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp53_ = dest_file;
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_copy (_tmp52_, _tmp53_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp52_);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 24026 "Photo.c"
	}
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp58_ = photo_has_alterations (self);
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp58_) {
#line 24032 "Photo.c"
		gboolean _tmp59_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp59_ = is_master;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp57_ = _tmp59_;
#line 24038 "Photo.c"
	} else {
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp57_ = FALSE;
#line 24042 "Photo.c"
	}
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp60_ = _tmp57_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp60_) {
#line 24048 "Photo.c"
		gboolean _tmp61_ = FALSE;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp61_ = photo_has_user_generated_metadata (self);
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp56_ = !_tmp61_;
#line 24054 "Photo.c"
	} else {
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp56_ = FALSE;
#line 24058 "Photo.c"
	}
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp62_ = _tmp56_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp62_) {
#line 24064 "Photo.c"
		gchar* _tmp63_ = NULL;
		gchar* _tmp64_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp63_ = media_source_get_title (MEDIA_SOURCE (self));
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp64_ = _tmp63_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = _tmp64_ == NULL;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp64_);
#line 24075 "Photo.c"
	} else {
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = FALSE;
#line 24079 "Photo.c"
	}
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp65_ = _tmp55_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp65_) {
#line 24085 "Photo.c"
		gboolean _tmp66_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp66_ = export_metadata;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = _tmp66_;
#line 24091 "Photo.c"
	} else {
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = FALSE;
#line 24095 "Photo.c"
	}
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp67_ = _tmp54_;
#line 3315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp67_) {
#line 3316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = TRUE;
#line 3316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 24113 "Photo.c"
	}
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp68_ = export_reader;
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp69_ = photo_file_reader_read_metadata (_tmp68_, &_inner_error_);
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp69_;
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3319 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 24135 "Photo.c"
	}
#line 3320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp70_ = metadata;
#line 3320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp70_ == NULL) {
#line 24141 "Photo.c"
		PhotoFileReader* _tmp71_;
		PhotoFileFormat _tmp72_ = 0;
		PhotoMetadata* _tmp73_ = NULL;
#line 3321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp71_ = export_reader;
#line 3321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp72_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp71_));
#line 3321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp73_ = photo_file_format_create_metadata (_tmp72_);
#line 3321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3321 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		metadata = _tmp73_;
#line 24155 "Photo.c"
	}
#line 3323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp74_ = writer;
#line 3323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp75_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp74_));
#line 3323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp76_ = _tmp75_;
#line 3323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3323: Updating metadata of %s", _tmp76_);
#line 3323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp76_);
#line 3325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp77_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 3325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp77_ != ((time_t) 0)) {
#line 24171 "Photo.c"
		PhotoMetadata* _tmp78_;
		time_t _tmp79_ = 0;
		MetadataDateTime* _tmp80_;
		MetadataDateTime* _tmp81_;
#line 3326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp78_ = metadata;
#line 3326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp79_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 3326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp80_ = metadata_date_time_new (_tmp79_);
#line 3326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 3326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp78_, _tmp81_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3326 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp81_);
#line 24188 "Photo.c"
	} else {
		PhotoMetadata* _tmp82_;
#line 3328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp82_ = metadata;
#line 3328 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp82_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 24195 "Photo.c"
	}
#line 3330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp83_ = export_metadata;
#line 3330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp83_) {
#line 24201 "Photo.c"
		PhotoMetadata* _tmp84_;
		gchar* _tmp85_ = NULL;
		gchar* _tmp86_;
		PhotoMetadata* _tmp87_;
		Dimensions _tmp88_ = {0};
		PhotoMetadata* _tmp89_;
		Orientation _tmp90_ = 0;
		PhotoMetadata* _tmp91_;
		Orientation _tmp92_ = 0;
		Orientation _tmp93_ = 0;
		PhotoMetadata* _tmp95_;
#line 3332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp84_ = metadata;
#line 3332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp85_ = media_source_get_title (MEDIA_SOURCE (self));
#line 3332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp86_ = _tmp85_;
#line 3332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_title (_tmp84_, _tmp86_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp86_);
#line 3333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp87_ = metadata;
#line 3333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_get_dimensions (MEDIA_SOURCE (self), PHOTO_EXCEPTION_NONE, &_tmp88_);
#line 3333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp87_, &_tmp88_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp89_ = metadata;
#line 3334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp90_ = photo_get_orientation (self);
#line 3334 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_orientation (_tmp89_, _tmp90_);
#line 3335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp91_ = metadata;
#line 3335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_software (_tmp91_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp92_ = photo_get_orientation (self);
#line 3337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp93_ = photo_get_original_orientation (self);
#line 3337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp92_ != _tmp93_) {
#line 24245 "Photo.c"
			PhotoMetadata* _tmp94_;
#line 3338 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp94_ = metadata;
#line 3338 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp94_);
#line 24251 "Photo.c"
		}
#line 3340 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp95_ = metadata;
#line 3340 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp95_);
#line 24257 "Photo.c"
	} else {
		PhotoMetadata* _tmp96_;
#line 3344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp96_ = metadata;
#line 3344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_clear (_tmp96_);
#line 24264 "Photo.c"
	}
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp97_ = writer;
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp98_ = metadata;
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp97_, _tmp98_, &_inner_error_);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 24288 "Photo.c"
	}
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 24304 "Photo.c"
}


gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp10_;
#line 3354 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3354 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = scaling_is_unscaled (scaling);
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp3_) {
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = TRUE;
#line 24327 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = photo_has_alterations (self);
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 24334 "Photo.c"
	}
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp2_;
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_) {
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = TRUE;
#line 24342 "Photo.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = photo_has_user_generated_metadata (self);
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 24349 "Photo.c"
	}
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp1_;
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp7_) {
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = TRUE;
#line 24357 "Photo.c"
	} else {
		PhotoFileFormat _tmp8_;
		PhotoFileFormat _tmp9_ = 0;
#line 3356 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = export_format;
#line 3356 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = photo_get_file_format (self);
#line 3356 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp8_ != _tmp9_;
#line 24367 "Photo.c"
	}
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = _tmp0_;
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp10_;
#line 3355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 24375 "Photo.c"
}


void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error) {
	gboolean _tmp0_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	PhotoMetadata* _tmp22_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp23_;
	PhotoFileFormat _tmp26_;
	gboolean _tmp27_ = FALSE;
	PhotoFileFormat _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_;
	PhotoFileWriter* _tmp33_ = NULL;
	PhotoFileWriter* _tmp34_;
	PhotoFileWriter* writer;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_;
	PhotoFileWriter* _tmp37_;
	gchar* _tmp38_ = NULL;
	gchar* _tmp39_;
	PhotoFileFormat _tmp40_;
	GEnumValue* _tmp41_;
	Scaling _tmp42_;
	GdkPixbuf* _tmp43_ = NULL;
	GdkPixbuf* pixbuf;
	PhotoFileWriter* _tmp44_;
	GdkPixbuf* _tmp45_;
	JpegQuality _tmp46_;
	PhotoFileWriter* _tmp47_;
	gchar* _tmp48_ = NULL;
	gchar* _tmp49_;
	gboolean _tmp50_;
	PhotoFileFormat _tmp71_;
	GFile* _tmp72_;
	gchar* _tmp73_ = NULL;
	gchar* _tmp74_;
	PhotoFileMetadataWriter* _tmp75_ = NULL;
	PhotoFileMetadataWriter* _tmp76_;
	PhotoFileMetadataWriter* _tmp77_;
	PhotoFileMetadataWriter* _tmp78_;
	PhotoMetadata* _tmp79_;
	GError * _inner_error_ = NULL;
#line 3362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (dest_file));
#line 3362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = direct_copy_unmodified;
#line 3364 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_) {
#line 24437 "Photo.c"
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = dest_file;
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_file_copy (_tmp2_, _tmp3_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3365 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 24457 "Photo.c"
		}
#line 3367 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 24461 "Photo.c"
	}
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = scaling_is_unscaled (scaling);
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp7_) {
#line 24467 "Photo.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp11_;
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = photo_has_alterations (self);
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (!_tmp9_) {
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = TRUE;
#line 24477 "Photo.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = photo_only_metadata_changed (self);
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp10_;
#line 24484 "Photo.c"
		}
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = _tmp8_;
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp11_;
#line 24490 "Photo.c"
	} else {
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = FALSE;
#line 24494 "Photo.c"
	}
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = _tmp6_;
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp12_) {
#line 24500 "Photo.c"
		PhotoFileFormat _tmp13_;
		PhotoFileFormat _tmp14_ = 0;
#line 3375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = export_format;
#line 3375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = photo_get_file_format (self);
#line 3375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp13_ == _tmp14_;
#line 24509 "Photo.c"
	} else {
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = FALSE;
#line 24513 "Photo.c"
	}
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp5_;
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp15_) {
#line 24519 "Photo.c"
		PhotoFileFormat _tmp16_ = 0;
#line 3375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = photo_get_file_format (self);
#line 3375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp16_ == PHOTO_FILE_FORMAT_JFIF;
#line 24525 "Photo.c"
	} else {
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = FALSE;
#line 24529 "Photo.c"
	}
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp4_;
#line 3374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_) {
#line 24535 "Photo.c"
		GFile* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_;
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = dest_file;
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = export_metadata;
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = photo_export_fullsized_backing (self, _tmp18_, _tmp19_, &_inner_error_);
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 24554 "Photo.c"
		}
#line 3376 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp21_) {
#line 3377 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 24560 "Photo.c"
		}
	}
#line 3383 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 3383 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp22_;
#line 3384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = metadata;
#line 3384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp23_ == NULL) {
#line 24571 "Photo.c"
		PhotoFileFormat _tmp24_;
		PhotoMetadata* _tmp25_ = NULL;
#line 3385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = export_format;
#line 3385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = photo_file_format_create_metadata (_tmp24_);
#line 3385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3385 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		metadata = _tmp25_;
#line 24582 "Photo.c"
	}
#line 3387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = export_format;
#line 3387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = photo_file_format_can_write (_tmp26_);
#line 3387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp27_) {
#line 24590 "Photo.c"
		PhotoFileFormat _tmp28_ = 0;
#line 3388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp28_ = photo_file_format_get_system_default_format ();
#line 3388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		export_format = _tmp28_;
#line 24596 "Photo.c"
	}
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = export_format;
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = dest_file;
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = photo_file_format_create_writer (_tmp29_, _tmp32_, &_inner_error_);
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	writer = _tmp34_;
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3390 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 24622 "Photo.c"
	}
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = data_object_to_string (DATA_OBJECT (self));
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = writer;
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp37_));
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = export_format;
#line 3393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), _tmp40_);
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3392: Saving transformed version of %s to %s in file format" \
" %s", _tmp36_, _tmp39_, (_tmp41_ != NULL) ? _tmp41_->value_name : NULL);
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp39_);
#line 3392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp36_);
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = *scaling;
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = photo_get_pixbuf_with_options (self, &_tmp42_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	pixbuf = _tmp43_;
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3395 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 24660 "Photo.c"
	}
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = writer;
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = pixbuf;
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = quality;
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_writer_write (_tmp44_, _tmp45_, _tmp46_, &_inner_error_);
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 24682 "Photo.c"
	}
#line 3400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = writer;
#line 3400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp47_));
#line 3400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3400: Setting EXIF for %s", _tmp49_);
#line 3400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp49_);
#line 3403 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp50_ = export_metadata;
#line 3403 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp50_) {
#line 24698 "Photo.c"
		PhotoMetadata* _tmp51_;
		gchar* _tmp52_ = NULL;
		gchar* _tmp53_;
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
		PhotoMetadata* _tmp58_;
		time_t _tmp59_ = 0;
		PhotoMetadata* _tmp65_;
		PhotoMetadata* _tmp66_;
		PhotoMetadata* _tmp67_;
		gboolean _tmp68_ = FALSE;
#line 3405 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = metadata;
#line 3405 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp52_ = media_source_get_title (MEDIA_SOURCE (self));
#line 3405 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp53_ = _tmp52_;
#line 3405 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_title (_tmp51_, _tmp53_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3405 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp53_);
#line 3406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = metadata;
#line 3406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp57_ = metadata;
#line 3407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 3408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp58_ = metadata;
#line 3408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_software (_tmp58_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3410 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp59_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 3410 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp59_ != ((time_t) 0)) {
#line 24742 "Photo.c"
			PhotoMetadata* _tmp60_;
			time_t _tmp61_ = 0;
			MetadataDateTime* _tmp62_;
			MetadataDateTime* _tmp63_;
#line 3411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp60_ = metadata;
#line 3411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp61_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 3411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp62_ = metadata_date_time_new (_tmp61_);
#line 3411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp63_ = _tmp62_;
#line 3411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp60_, _tmp63_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_metadata_date_time_unref0 (_tmp63_);
#line 24759 "Photo.c"
		} else {
			PhotoMetadata* _tmp64_;
#line 3413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp64_ = metadata;
#line 3413 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp64_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 24766 "Photo.c"
		}
#line 3415 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp65_ = metadata;
#line 3415 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_remove_tag (_tmp65_, "Exif.Iop.RelatedImageWidth");
#line 3416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp66_ = metadata;
#line 3416 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_remove_tag (_tmp66_, "Exif.Iop.RelatedImageHeight");
#line 3417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp67_ = metadata;
#line 3417 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp67_);
#line 3419 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp68_ = photo_has_user_generated_metadata (self);
#line 3419 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp68_) {
#line 24784 "Photo.c"
			PhotoMetadata* _tmp69_;
#line 3420 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp69_ = metadata;
#line 3420 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp69_);
#line 24790 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp70_;
#line 3424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp70_ = metadata;
#line 3424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_clear (_tmp70_);
#line 24798 "Photo.c"
	}
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp71_ = export_format;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp72_ = dest_file;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp73_ = g_file_get_path (_tmp72_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp74_ = _tmp73_;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp75_ = photo_file_format_create_metadata_writer (_tmp71_, _tmp74_, &_inner_error_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp76_ = _tmp75_;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp74_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp77_ = _tmp76_;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 24828 "Photo.c"
	}
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp78_ = _tmp77_;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp79_ = metadata;
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp78_, _tmp79_, &_inner_error_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp78_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3427 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 24850 "Photo.c"
	}
#line 3362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 24858 "Photo.c"
}


static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error) {
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	gboolean _tmp18_;
	const gchar* _tmp23_;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_ = NULL;
	gchar* editable_basename;
	gboolean collision = FALSE;
	GFile* _tmp27_ = NULL;
	GFile* _tmp28_;
	gboolean _tmp29_ = FALSE;
	GFile* _tmp30_ = NULL;
	GFile* _tmp31_;
	GFile* _tmp32_;
	GError * _inner_error_ = NULL;
#line 3430 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 24892 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->row;
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 24899 "Photo.c"
		{
			PhotoFileFormat _tmp1_ = 0;
			GFile* _tmp2_ = NULL;
#line 3433 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = photo_get_file_format (self);
#line 3433 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_file_format = _tmp1_;
#line 3434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = media_source_get_file (MEDIA_SOURCE (self));
#line 3434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing = _tmp2_;
#line 24913 "Photo.c"
		}
		__finally335:
		{
			PhotoRow* _tmp3_;
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = self->row;
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 24922 "Photo.c"
		}
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3432 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return NULL;
#line 24932 "Photo.c"
		}
	}
#line 3437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _vala_file_format;
#line 3437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo_file_format_can_write (_tmp4_);
#line 3437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp5_) {
#line 24941 "Photo.c"
		PhotoFileFormat _tmp6_ = 0;
#line 3438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = photo_file_format_get_system_default_format ();
#line 3438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_file_format = _tmp6_;
#line 24947 "Photo.c"
	}
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = g_file_get_basename (backing);
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	disassemble_filename (_tmp8_, &_tmp9_, &_tmp10_);
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (name);
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	name = _tmp9_;
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (ext);
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ext = _tmp10_;
#line 3441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = ext;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = TRUE;
#line 24971 "Photo.c"
	} else {
		PhotoFileFormat _tmp13_;
		PhotoFileFormatProperties* _tmp14_ = NULL;
		PhotoFileFormatProperties* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp17_ = FALSE;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = _vala_file_format;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = photo_file_format_get_properties (_tmp13_);
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = ext;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_is_recognized_extension (_tmp15_, _tmp16_);
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = !_tmp17_;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp15_);
#line 24992 "Photo.c"
	}
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = _tmp11_;
#line 3443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp18_) {
#line 24998 "Photo.c"
		PhotoFileFormat _tmp19_;
		PhotoFileFormatProperties* _tmp20_ = NULL;
		PhotoFileFormatProperties* _tmp21_;
		gchar* _tmp22_ = NULL;
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = _vala_file_format;
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = photo_file_format_get_properties (_tmp19_);
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = photo_file_format_properties_get_default_extension (_tmp21_);
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (ext);
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		ext = _tmp22_;
#line 3444 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp21_);
#line 25017 "Photo.c"
	}
#line 3446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = name;
#line 3446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = _ ("modified");
#line 3446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = ext;
#line 3446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = g_strdup_printf ("%s_%s.%s", _tmp23_, _tmp24_, _tmp25_);
#line 3446 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	editable_basename = _tmp26_;
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = g_file_get_parent (backing);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = generate_unique_file (_tmp28_, editable_basename, &_tmp29_, &_inner_error_);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	collision = _tmp29_;
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp28_);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (editable_basename);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (ext);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (name);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (backing);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 25057 "Photo.c"
	}
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp32_;
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (editable_basename);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (ext);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (name);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (backing);
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (file_format) {
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*file_format = _vala_file_format;
#line 25073 "Photo.c"
	}
#line 3449 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 25077 "Photo.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 25084 "Photo.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_list_free (self);
#line 25093 "Photo.c"
}


static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	PhotoFileFormat _tmp1_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* commandline;
	const gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GAppInfo* app = NULL;
	GList* files;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GAppInfo* _tmp17_;
	gchar** _tmp22_ = NULL;
	gchar** argv;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	GFile* _tmp28_;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_;
	GPid child_pid = 0;
	gchar** _tmp31_;
	gint _tmp31__length1;
	GPid _tmp32_ = 0;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_;
	GError * _inner_error_ = NULL;
#line 3452 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file_format;
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == PHOTO_FILE_FORMAT_RAW) {
#line 25138 "Photo.c"
		ConfigFacade* _tmp2_ = NULL;
		ConfigFacade* _tmp3_;
		gchar* _tmp4_ = NULL;
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = config_facade_get_instance ();
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = configuration_facade_get_external_raw_app (CONFIGURATION_FACADE (_tmp3_));
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 25154 "Photo.c"
	} else {
		ConfigFacade* _tmp5_ = NULL;
		ConfigFacade* _tmp6_;
		gchar* _tmp7_ = NULL;
#line 3454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = config_facade_get_instance ();
#line 3454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 3454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = configuration_facade_get_external_photo_app (CONFIGURATION_FACADE (_tmp6_));
#line 3454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 3454 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 25171 "Photo.c"
	}
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp0_;
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 3453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	commandline = _tmp9_;
#line 3456 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = commandline;
#line 3456 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = is_string_empty (_tmp10_);
#line 3456 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 3457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 3457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (commandline);
#line 3457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 25193 "Photo.c"
	}
	{
		const gchar* _tmp12_;
		GAppInfo* _tmp13_ = NULL;
		GAppInfo* _tmp14_;
#line 3461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = commandline;
#line 3461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = g_app_info_create_from_commandline (_tmp12_, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 3461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 3461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 25207 "Photo.c"
			goto __catch336_g_error;
		}
#line 3461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (app);
#line 3461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app = _tmp14_;
#line 25214 "Photo.c"
	}
	goto __finally336;
	__catch336_g_error:
	{
		GError* er = NULL;
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		er = _inner_error_;
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 3464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (app);
#line 3464 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app = NULL;
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (er);
#line 25230 "Photo.c"
	}
	__finally336:
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (app);
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (commandline);
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3460 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 25245 "Photo.c"
	}
#line 3467 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	files = NULL;
#line 3468 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = file;
#line 3468 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 3468 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	files = g_list_insert (files, _tmp16_, -1);
#line 3470 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = app;
#line 3470 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 25259 "Photo.c"
		GAppInfo* _tmp18_;
		GList* _tmp19_;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_;
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = app;
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = files;
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = g_app_info_launch (_tmp18_, _tmp19_, NULL, &_inner_error_);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			__g_list_free__g_object_unref0_0 (files);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (app);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (commandline);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp0_);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 25286 "Photo.c"
		}
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp21_;
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (app);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (commandline);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3471 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 25300 "Photo.c"
	}
#line 3473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = g_new0 (gchar*, 2 + 1);
#line 3473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	argv = _tmp22_;
#line 3473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	argv_length1 = 2;
#line 3473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = argv;
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23__length1 = argv_length1;
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = commandline;
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = g_strdup (_tmp24_);
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp23_[0]);
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_[0] = _tmp25_;
#line 3474 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = _tmp23_[0];
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = argv;
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27__length1 = argv_length1;
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = file;
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = g_file_get_path (_tmp28_);
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp27_[1]);
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_[1] = _tmp29_;
#line 3475 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = _tmp27_[1];
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = argv;
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31__length1 = argv_length1;
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = g_spawn_async ("/", _tmp31_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp32_, &_inner_error_);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	child_pid = _tmp32_;
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (app);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (commandline);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 25364 "Photo.c"
	}
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp34_;
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	__g_list_free__g_object_unref0_0 (files);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (app);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (commandline);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 3479 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 25380 "Photo.c"
}


void photo_open_with_raw_external_editor (Photo* self, GError** error) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	GError * _inner_error_ = NULL;
#line 3489 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_get_master_file_format (self);
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_launch_editor (_tmp1_, _tmp2_, &_inner_error_);
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 25407 "Photo.c"
	}
}


void photo_open_with_external_editor (Photo* self, GError** error) {
	GFile* current_editable_file;
	GFile* create_editable_file;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp18_;
	gboolean _tmp24_;
	gboolean _tmp27_ = FALSE;
	GFile* _tmp28_;
	gboolean _tmp31_;
	GFile* _tmp47_;
	GFileMonitor* _tmp48_;
	GFile* _tmp50_;
	PhotoFileFormat _tmp51_ = 0;
	GError * _inner_error_ = NULL;
#line 3494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	current_editable_file = NULL;
#line 3496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	create_editable_file = NULL;
#line 25435 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 25442 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3499 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 25453 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 3500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp4_));
#line 3500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 25467 "Photo.c"
			}
#line 3502 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3502 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 25473 "Photo.c"
				PhotoFileFormat _tmp7_ = 0;
				GFile* _tmp8_ = NULL;
				GFile* _tmp9_;
#line 3503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = photo_generate_new_editable_file (self, &_tmp7_, &_inner_error_);
#line 3503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable_file_format = _tmp7_;
#line 3503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 3503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 25485 "Photo.c"
					goto __finally337;
				}
#line 3503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3503 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				create_editable_file = _tmp9_;
#line 25492 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
				PhotoFileFormat _tmp12_ = 0;
#line 3505 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3505 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tmp10_->editable;
#line 3505 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp11_));
#line 3505 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable_file_format = _tmp12_;
#line 25505 "Photo.c"
			}
		}
		__finally337:
		{
			PhotoBackingReaders* _tmp13_;
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25515 "Photo.c"
		}
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 25527 "Photo.c"
		}
	}
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 25534 "Photo.c"
		GFile* _tmp17_;
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 25540 "Photo.c"
	} else {
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = FALSE;
#line 25544 "Photo.c"
	}
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = _tmp15_;
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp18_) {
#line 25550 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp23_;
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (!_tmp21_) {
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = TRUE;
#line 25563 "Photo.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = photo_has_transformations (self);
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = _tmp22_;
#line 25570 "Photo.c"
		}
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = _tmp19_;
#line 3511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = _tmp23_;
#line 25576 "Photo.c"
	} else {
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = FALSE;
#line 25580 "Photo.c"
	}
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = _tmp14_;
#line 3510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp24_) {
#line 25586 "Photo.c"
		GFile* _tmp25_;
		GFile* _tmp26_;
#line 3512 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = current_editable_file;
#line 3512 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 3512 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3512 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		create_editable_file = _tmp26_;
#line 25597 "Photo.c"
	}
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = create_editable_file;
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp28_ != NULL) {
#line 25603 "Photo.c"
		PhotoFileFormat _tmp29_;
		gboolean _tmp30_ = FALSE;
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp29_ = editable_file_format;
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = photo_file_format_can_write (_tmp29_);
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27_ = _tmp30_;
#line 25612 "Photo.c"
	} else {
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27_ = FALSE;
#line 25616 "Photo.c"
	}
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = _tmp27_;
#line 3515 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp31_) {
#line 25622 "Photo.c"
		PhotoFileFormat _tmp43_;
		GFile* _tmp44_;
		GFile* _tmp45_;
		GFile* _tmp46_;
#line 3516 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 25629 "Photo.c"
		{
			GFile* _tmp32_;
			Scaling _tmp33_ = {0};
			PhotoFileFormat _tmp34_;
#line 3519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp32_ = create_editable_file;
#line 3519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			scaling_for_original (&_tmp33_);
#line 3519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp34_ = editable_file_format;
#line 3519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_export (self, _tmp32_, &_tmp33_, JPEG_QUALITY_MAXIMUM, _tmp34_, FALSE, TRUE, &_inner_error_);
#line 3519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 25644 "Photo.c"
				goto __catch338_g_error;
			}
		}
		goto __finally338;
		__catch338_g_error:
		{
			GError* err = NULL;
			GError* _tmp41_;
			GError* _tmp42_;
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 25658 "Photo.c"
			{
				GFile* _tmp35_;
#line 3524 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = create_editable_file;
#line 3524 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_file_delete (_tmp35_, NULL, &_inner_error_);
#line 3524 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 25667 "Photo.c"
					goto __catch339_g_error;
				}
			}
			goto __finally339;
			__catch339_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp36_;
				gchar* _tmp37_ = NULL;
				gchar* _tmp38_;
				GError* _tmp39_;
				const gchar* _tmp40_;
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				delete_err = _inner_error_;
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_inner_error_ = NULL;
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = create_editable_file;
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = g_file_get_path (_tmp36_);
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_ = delete_err;
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp40_ = _tmp39_->message;
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_warning ("Photo.vala:3527: Unable to delete editable file %s after export error:" \
" %s", _tmp38_, _tmp40_);
#line 3527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp38_);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 25700 "Photo.c"
			}
			__finally339:
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (err);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_error_free0 (err);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 3523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 25719 "Photo.c"
			}
#line 3531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp41_ = err;
#line 3531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp42_ = _g_error_copy0 (_tmp41_);
#line 3531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = _tmp42_;
#line 3531 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 25729 "Photo.c"
			goto __finally338;
		}
		__finally338:
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 25743 "Photo.c"
		}
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = editable_file_format;
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_ = create_editable_file;
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_attach_editable (self, _tmp43_, _tmp44_, &_inner_error_);
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 25761 "Photo.c"
		}
#line 3537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45_ = create_editable_file;
#line 3537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = _g_object_ref0 (_tmp45_);
#line 3537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3537 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		current_editable_file = _tmp46_;
#line 25771 "Photo.c"
	}
#line 3540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = current_editable_file;
#line 3540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp47_ != NULL);
#line 3543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = self->priv->editable_monitor;
#line 3543 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp48_ == NULL) {
#line 25781 "Photo.c"
		GFile* _tmp49_;
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp49_ = current_editable_file;
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp49_, &_inner_error_);
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3544 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 25797 "Photo.c"
		}
	}
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp50_ = current_editable_file;
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp51_ = photo_get_file_format (self);
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_launch_editor (_tmp50_, _tmp51_, &_inner_error_);
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3546 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 25816 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 25822 "Photo.c"
}


void photo_revert_to_master (Photo* self, gboolean notify) {
	gboolean _tmp0_;
#line 3549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = notify;
#line 3550 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, _tmp0_);
#line 25834 "Photo.c"
}


static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 3560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_on_editable_file_changed (self, file, other_file, event_type);
#line 25841 "Photo.c"
}


static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileMonitor* _tmp2_ = NULL;
	GFileMonitor* _tmp3_;
	GFileMonitor* _tmp4_;
	GError * _inner_error_ = NULL;
#line 3553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3554 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 3557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_monitor_blacklist_file (_tmp0_, "Photo.start_monitoring_editable");
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = g_file_monitor (_tmp1_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 25874 "Photo.c"
	}
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->editable_monitor = _tmp3_;
#line 3560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3560 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_connect_object (_tmp4_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 25884 "Photo.c"
}


static void photo_halt_monitoring_editable (Photo* self) {
	GFileMonitor* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* file;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_ = 0U;
	GFileMonitor* _tmp6_;
#line 3563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 25904 "Photo.c"
	}
#line 3568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp1_;
#line 3569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = file;
#line 3569 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 25914 "Photo.c"
		GFile* _tmp3_;
#line 3570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = file;
#line 3570 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 25920 "Photo.c"
	}
#line 3572 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3572 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3572 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3573 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3573 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3574 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3563 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 25938 "Photo.c"
}


static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error) {
	PhotoFileFormat _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_;
	GError * _inner_error_ = NULL;
#line 3577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3577 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3582 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file_format;
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_file_format_create_reader (_tmp0_, _tmp3_);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp5_, &_inner_error_);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp3_);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3583 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 25980 "Photo.c"
	}
}


static void photo_update_editable_attributes (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
#line 3587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 25997 "Photo.c"
	}
}


void photo_reimport_editable (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3590 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
#line 3591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3591 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 26014 "Photo.c"
	}
}


static void _vala_array_add244 (gchar*** array, int* length, int* size, gchar* value) {
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26026 "Photo.c"
	}
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 26032 "Photo.c"
}


static void _vala_array_add245 (gchar*** array, int* length, int* size, gchar* value) {
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26043 "Photo.c"
	}
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 26049 "Photo.c"
}


static void _vala_array_add246 (gchar*** array, int* length, int* size, gchar* value) {
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26060 "Photo.c"
	}
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 26066 "Photo.c"
}


static void _vala_array_add247 (gchar*** array, int* length, int* size, gchar* value) {
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26077 "Photo.c"
	}
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 26083 "Photo.c"
}


static void _vala_array_add248 (gchar*** array, int* length, int* size, gchar* value) {
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26094 "Photo.c"
	}
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 26100 "Photo.c"
}


static void _vala_array_add249 (gchar*** array, int* length, int* size, gchar* value) {
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26111 "Photo.c"
	}
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	(*array)[*length] = NULL;
#line 26117 "Photo.c"
}


static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp4_;
	gboolean _tmp6_;
	PhotoFileReader* _tmp7_ = NULL;
	PhotoFileReader* old_reader;
	PhotoFileReader* _tmp8_;
	PhotoFileReader* _tmp9_;
	PhotoFileReader* _tmp10_;
	PhotoFileReader* _tmp11_;
	PhotoFileReader* _tmp14_;
	PhotoFileReader* _tmp15_;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp16_;
	gboolean timestamp_changed;
	gboolean filesize_changed;
	gboolean is_new_editable;
	BackingPhotoID _tmp17_ = {0};
	BackingPhotoID editable_id;
	PhotoFileReader* _tmp18_;
	GFile* _tmp19_ = NULL;
	GFile* file;
	DetectedPhotoInformation* detected = NULL;
	GFile* _tmp20_;
	DetectedPhotoInformation* _tmp21_ = NULL;
	BackingPhotoRow* _tmp22_ = NULL;
	BackingPhotoRow* backing;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp41_;
	PhotoFileReader* _tmp100_;
	gboolean _tmp106_ = FALSE;
	gboolean _tmp107_;
	gboolean _tmp110_;
	gchar** _tmp121_ = NULL;
	gchar** alteration_list;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp122_;
	gboolean _tmp130_ = FALSE;
	gboolean _tmp131_;
	gboolean _tmp133_;
	gchar** _tmp141_;
	gint _tmp141__length1;
	GError * _inner_error_ = NULL;
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = only_attributes;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_) {
#line 26175 "Photo.c"
		PhotoFileReader* _tmp3_;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = new_reader;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 26181 "Photo.c"
	} else {
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = FALSE;
#line 26185 "Photo.c"
	}
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp1_;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp4_) {
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = TRUE;
#line 26193 "Photo.c"
	} else {
		gboolean _tmp5_;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = only_attributes;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = !_tmp5_;
#line 26200 "Photo.c"
	}
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp0_;
#line 3598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp6_);
#line 3600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = photo_get_editable_reader (self);
#line 3600 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old_reader = _tmp7_;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = new_reader;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _photo_file_adapter_ref0 (_tmp8_);
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_ == NULL) {
#line 26220 "Photo.c"
		PhotoFileReader* _tmp12_;
		PhotoFileReader* _tmp13_;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = old_reader;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = _photo_file_adapter_ref0 (_tmp12_);
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp13_;
#line 26231 "Photo.c"
	}
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp10_;
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 3602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reader = _tmp15_;
#line 3603 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = reader;
#line 3603 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 3604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 3606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3606 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 26253 "Photo.c"
	}
#line 3609 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	timestamp_changed = FALSE;
#line 3610 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	filesize_changed = FALSE;
#line 3611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	is_new_editable = FALSE;
#line 3613 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_editable_id (self, &_tmp17_);
#line 3613 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	editable_id = _tmp17_;
#line 3614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = reader;
#line 3614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp18_));
#line 3614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp19_;
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = file;
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = photo_query_backing_photo_row (self, _tmp20_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp21_, &_inner_error_);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	detected = _tmp21_;
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing = _tmp22_;
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3617 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 26297 "Photo.c"
	}
#line 3621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = backing_photo_id_is_invalid (&editable_id);
#line 3621 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp23_) {
#line 26303 "Photo.c"
		BackingPhotoRow* _tmp24_;
#line 3623 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = backing;
#line 3623 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp24_ != NULL) {
#line 26309 "Photo.c"
			BackingPhotoTable* _tmp25_ = NULL;
			BackingPhotoTable* _tmp26_;
			BackingPhotoRow* _tmp27_;
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp25_ = backing_photo_table_get_instance ();
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = _tmp25_;
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = backing;
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing_photo_table_add (_tmp26_, _tmp27_, &_inner_error_);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp26_);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3624 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 26341 "Photo.c"
			}
			{
				PhotoRow* _tmp28_;
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = self->row;
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 26349 "Photo.c"
				{
					PhotoTable* _tmp29_ = NULL;
					PhotoTable* _tmp30_;
					PhotoRow* _tmp31_;
					BackingPhotoRow* _tmp32_;
					BackingPhotoID _tmp33_;
					BackingPhotoRow* _tmp34_;
					BackingPhotoRow* _tmp35_;
					BackingPhotoRow* _tmp36_;
					BackingPhotoRow* _tmp37_;
					BackingPhotoRow* _tmp38_;
					Orientation _tmp39_;
#line 3626 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					timestamp_changed = TRUE;
#line 3627 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					filesize_changed = TRUE;
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp29_ = photo_table_get_instance ();
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp30_ = _tmp29_;
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp31_ = self->row;
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp32_ = backing;
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp33_ = _tmp32_->id;
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					photo_table_attach_editable (_tmp30_, _tmp31_, &_tmp33_, &_inner_error_);
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_database_table_unref0 (_tmp30_);
#line 3629 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 26382 "Photo.c"
						goto __finally340;
					}
#line 3630 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = backing;
#line 3630 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp35_ = _backing_photo_row_ref0 (_tmp34_);
#line 3630 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3630 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					self->priv->editable = _tmp35_;
#line 3631 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp36_ = self->priv->editable;
#line 3631 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp37_ = _backing_photo_row_ref0 (_tmp36_);
#line 3631 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3631 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					self->backing_photo_row = _tmp37_;
#line 3632 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp38_ = self->backing_photo_row;
#line 3632 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp39_ = _tmp38_->original_orientation;
#line 3632 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					photo_set_orientation (self, _tmp39_);
#line 26407 "Photo.c"
				}
				__finally340:
				{
					PhotoRow* _tmp40_;
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp40_ = self->row;
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 26416 "Photo.c"
				}
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (file);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (_tmp10_);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3625 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 26436 "Photo.c"
				}
			}
		}
#line 3635 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		is_new_editable = TRUE;
#line 26442 "Photo.c"
	}
#line 3638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = only_attributes;
#line 3638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp41_) {
#line 26448 "Photo.c"
		gboolean _tmp42_ = FALSE;
		GFileInfo* info = NULL;
		GFileInfo* _tmp50_;
		GTimeVal _tmp51_ = {0};
		GTimeVal timestamp;
		BackingPhotoTable* _tmp52_ = NULL;
		BackingPhotoTable* _tmp53_;
		BackingPhotoID _tmp54_;
		GTimeVal _tmp55_;
		glong _tmp56_;
		GFileInfo* _tmp57_;
		gint64 _tmp58_ = 0LL;
#line 3640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp42_ = backing_photo_id_is_valid (&editable_id);
#line 3640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_assert (_tmp42_);
#line 26465 "Photo.c"
		{
			GFile* _tmp43_;
			GFileInfo* _tmp44_ = NULL;
			GFileInfo* _tmp45_;
#line 3644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp43_ = file;
#line 3644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp44_ = g_file_query_filesystem_info (_tmp43_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
#line 3644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 3644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 26478 "Photo.c"
				goto __catch341_g_error;
			}
#line 3644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 3644 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			info = _tmp45_;
#line 26485 "Photo.c"
		}
		goto __finally341;
		__catch341_g_error:
		{
			GError* err = NULL;
			gchar* _tmp46_ = NULL;
			gchar* _tmp47_;
			GError* _tmp48_;
			const gchar* _tmp49_;
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 3646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp46_ = data_object_to_string (DATA_OBJECT (self));
#line 3646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp47_ = _tmp46_;
#line 3646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp48_ = err;
#line 3646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp49_ = _tmp48_->message;
#line 3646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_warning ("Photo.vala:3646: Unable to read editable filesystem info for %s: %s", _tmp47_, _tmp49_);
#line 3646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp47_);
#line 3647 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 26531 "Photo.c"
		}
		__finally341:
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3643 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 26554 "Photo.c"
		}
#line 3652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = info;
#line 3652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_file_info_get_modification_time (_tmp50_, &_tmp51_);
#line 3652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		timestamp = _tmp51_;
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp52_ = backing_photo_table_get_instance ();
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp53_ = _tmp52_;
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp54_ = editable_id;
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = timestamp;
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp56_ = _tmp55_.tv_sec;
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp57_ = info;
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp58_ = g_file_info_get_size (_tmp57_);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp53_, &_tmp54_, (time_t) _tmp56_, _tmp58_, &_inner_error_);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_database_table_unref0 (_tmp53_);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (info);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3654 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 26600 "Photo.c"
		}
		{
			PhotoRow* _tmp59_;
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp59_ = self->row;
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 26608 "Photo.c"
			{
				BackingPhotoRow* _tmp60_;
				time_t _tmp61_;
				GTimeVal _tmp62_;
				glong _tmp63_;
				BackingPhotoRow* _tmp64_;
				gint64 _tmp65_;
				GFileInfo* _tmp66_;
				gint64 _tmp67_ = 0LL;
				BackingPhotoRow* _tmp68_;
				GTimeVal _tmp69_;
				glong _tmp70_;
				BackingPhotoRow* _tmp71_;
				GFileInfo* _tmp72_;
				gint64 _tmp73_ = 0LL;
#line 3657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp60_ = self->priv->editable;
#line 3657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp61_ = _tmp60_->timestamp;
#line 3657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp62_ = timestamp;
#line 3657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp63_ = _tmp62_.tv_sec;
#line 3657 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				timestamp_changed = _tmp61_ != ((time_t) _tmp63_);
#line 3658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp64_ = self->priv->editable;
#line 3658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp65_ = _tmp64_->filesize;
#line 3658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp66_ = info;
#line 3658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp67_ = g_file_info_get_size (_tmp66_);
#line 3658 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				filesize_changed = _tmp65_ != _tmp67_;
#line 3660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp68_ = self->priv->editable;
#line 3660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp69_ = timestamp;
#line 3660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp70_ = _tmp69_.tv_sec;
#line 3660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp68_->timestamp = (time_t) _tmp70_;
#line 3661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp71_ = self->priv->editable;
#line 3661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp72_ = info;
#line 3661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp73_ = g_file_info_get_size (_tmp72_);
#line 3661 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp71_->filesize = _tmp73_;
#line 26660 "Photo.c"
			}
			__finally342:
			{
				PhotoRow* _tmp74_;
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp74_ = self->row;
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 26669 "Photo.c"
			}
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (info);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 26691 "Photo.c"
			}
		}
#line 3638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (info);
#line 26696 "Photo.c"
	} else {
		gboolean _tmp75_ = FALSE;
		gboolean _tmp76_ = FALSE;
		gboolean _tmp78_;
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp76_ = backing_photo_id_is_valid (&editable_id);
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp76_) {
#line 26705 "Photo.c"
			gboolean _tmp77_;
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp77_ = is_new_editable;
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp75_ = !_tmp77_;
#line 26711 "Photo.c"
		} else {
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp75_ = FALSE;
#line 26715 "Photo.c"
		}
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp78_ = _tmp75_;
#line 3665 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp78_) {
#line 26721 "Photo.c"
			BackingPhotoRow* _tmp79_;
			BackingPhotoID _tmp80_;
			BackingPhotoTable* _tmp81_ = NULL;
			BackingPhotoTable* _tmp82_;
			BackingPhotoRow* _tmp83_;
#line 3670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp79_ = backing;
#line 3670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp80_ = editable_id;
#line 3670 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp79_->id = _tmp80_;
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp81_ = backing_photo_table_get_instance ();
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp82_ = _tmp81_;
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp83_ = backing;
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing_photo_table_update (_tmp82_, _tmp83_, &_inner_error_);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp82_);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 26761 "Photo.c"
			}
			{
				PhotoRow* _tmp84_;
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp84_ = self->row;
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 26769 "Photo.c"
				{
					BackingPhotoRow* _tmp85_;
					time_t _tmp86_;
					BackingPhotoRow* _tmp87_;
					time_t _tmp88_;
					BackingPhotoRow* _tmp89_;
					gint64 _tmp90_;
					BackingPhotoRow* _tmp91_;
					gint64 _tmp92_;
					BackingPhotoRow* _tmp93_;
					BackingPhotoRow* _tmp94_;
					BackingPhotoRow* _tmp95_;
					BackingPhotoRow* _tmp96_;
					BackingPhotoRow* _tmp97_;
					Orientation _tmp98_;
#line 3673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp85_ = self->priv->editable;
#line 3673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp86_ = _tmp85_->timestamp;
#line 3673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp87_ = backing;
#line 3673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp88_ = _tmp87_->timestamp;
#line 3673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					timestamp_changed = _tmp86_ != _tmp88_;
#line 3674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp89_ = self->priv->editable;
#line 3674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp90_ = _tmp89_->filesize;
#line 3674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp91_ = backing;
#line 3674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp92_ = _tmp91_->filesize;
#line 3674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					filesize_changed = _tmp90_ != _tmp92_;
#line 3676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp93_ = backing;
#line 3676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp94_ = _backing_photo_row_ref0 (_tmp93_);
#line 3676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					self->priv->editable = _tmp94_;
#line 3677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp95_ = self->priv->editable;
#line 3677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp96_ = _backing_photo_row_ref0 (_tmp95_);
#line 3677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					self->backing_photo_row = _tmp96_;
#line 3678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp97_ = self->backing_photo_row;
#line 3678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp98_ = _tmp97_->original_orientation;
#line 3678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					photo_set_orientation (self, _tmp98_);
#line 26827 "Photo.c"
				}
				__finally343:
				{
					PhotoRow* _tmp99_;
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp99_ = self->row;
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 26836 "Photo.c"
				}
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (file);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (_tmp10_);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 26856 "Photo.c"
				}
			}
		}
	}
#line 3684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp100_ = new_reader;
#line 3684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp100_ != NULL) {
#line 26865 "Photo.c"
		{
			PhotoBackingReaders* _tmp101_;
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp101_ = self->priv->readers;
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 26872 "Photo.c"
			{
				PhotoBackingReaders* _tmp102_;
				PhotoFileReader* _tmp103_;
				PhotoFileReader* _tmp104_;
#line 3686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp102_ = self->priv->readers;
#line 3686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp103_ = new_reader;
#line 3686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp104_ = _photo_file_adapter_ref0 (_tmp103_);
#line 3686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp102_->editable);
#line 3686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp102_->editable = _tmp104_;
#line 26887 "Photo.c"
			}
			__finally344:
			{
				PhotoBackingReaders* _tmp105_;
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp105_ = self->priv->readers;
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 26896 "Photo.c"
			}
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3685 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 26916 "Photo.c"
			}
		}
	}
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp107_ = only_attributes;
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp107_) {
#line 26924 "Photo.c"
		PhotoFileReader* _tmp108_;
		PhotoFileReader* _tmp109_;
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp108_ = reader;
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp109_ = old_reader;
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp106_ = _tmp108_ != _tmp109_;
#line 26933 "Photo.c"
	} else {
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp106_ = FALSE;
#line 26937 "Photo.c"
	}
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp110_ = _tmp106_;
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp110_) {
#line 26943 "Photo.c"
		GFile* _tmp111_ = NULL;
		PhotoFileReader* _tmp112_;
		GFile* _tmp115_ = NULL;
		PhotoFileReader* _tmp116_;
		GFile* _tmp119_;
		GFile* _tmp120_;
#line 3691 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp112_ = old_reader;
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp112_ != NULL) {
#line 26956 "Photo.c"
			PhotoFileReader* _tmp113_;
			GFile* _tmp114_ = NULL;
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp113_ = old_reader;
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp114_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp113_));
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp111_);
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp111_ = _tmp114_;
#line 26967 "Photo.c"
		} else {
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp111_);
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp111_ = NULL;
#line 26973 "Photo.c"
		}
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp116_ = new_reader;
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp116_ != NULL) {
#line 26979 "Photo.c"
			PhotoFileReader* _tmp117_;
			GFile* _tmp118_ = NULL;
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp117_ = new_reader;
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp118_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp117_));
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp115_);
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp115_ = _tmp118_;
#line 26990 "Photo.c"
		} else {
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp115_);
#line 3693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp115_ = NULL;
#line 26996 "Photo.c"
		}
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp119_ = _tmp111_;
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp120_ = _tmp115_;
#line 3692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp119_, _tmp120_);
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp115_);
#line 3690 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp111_);
#line 27008 "Photo.c"
	}
#line 3696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp121_ = g_new0 (gchar*, 0 + 1);
#line 3696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	alteration_list = _tmp121_;
#line 3696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	alteration_list_length1 = 0;
#line 3696 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 3697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp122_ = timestamp_changed;
#line 3697 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp122_) {
#line 27022 "Photo.c"
		gchar** _tmp123_;
		gint _tmp123__length1;
		gchar* _tmp124_;
		gchar** _tmp125_;
		gint _tmp125__length1;
		gchar* _tmp126_;
		gboolean _tmp127_ = FALSE;
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp123_ = alteration_list;
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp123__length1 = alteration_list_length1;
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp124_ = g_strdup ("metadata:editable-timestamp");
#line 3698 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add244 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp124_);
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp125_ = alteration_list;
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp125__length1 = alteration_list_length1;
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp126_ = g_strdup ("metadata:baseline-timestamp");
#line 3699 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add245 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp126_);
#line 3701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp127_ = photo_is_editable_source (self);
#line 3701 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp127_) {
#line 27050 "Photo.c"
			gchar** _tmp128_;
			gint _tmp128__length1;
			gchar* _tmp129_;
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp128_ = alteration_list;
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp128__length1 = alteration_list_length1;
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp129_ = g_strdup ("metadata:source-timestamp");
#line 3702 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add246 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp129_);
#line 27062 "Photo.c"
		}
	}
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp131_ = filesize_changed;
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp131_) {
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp130_ = TRUE;
#line 27071 "Photo.c"
	} else {
		PhotoFileReader* _tmp132_;
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp132_ = new_reader;
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp130_ = _tmp132_ != NULL;
#line 27078 "Photo.c"
	}
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp133_ = _tmp130_;
#line 3705 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp133_) {
#line 27084 "Photo.c"
		gchar** _tmp134_;
		gint _tmp134__length1;
		gchar* _tmp135_;
		gchar** _tmp136_;
		gint _tmp136__length1;
		gchar* _tmp137_;
		gboolean _tmp138_ = FALSE;
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp134_ = alteration_list;
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp134__length1 = alteration_list_length1;
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp135_ = g_strdup ("image:editable");
#line 3706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add247 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp135_);
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp136_ = alteration_list;
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp136__length1 = alteration_list_length1;
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp137_ = g_strdup ("image:baseline");
#line 3707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_array_add248 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp137_);
#line 3709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp138_ = photo_is_editable_source (self);
#line 3709 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp138_) {
#line 27112 "Photo.c"
			gchar** _tmp139_;
			gint _tmp139__length1;
			gchar* _tmp140_;
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp139_ = alteration_list;
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp139__length1 = alteration_list_length1;
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp140_ = g_strdup ("image:source");
#line 3710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_vala_array_add249 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp140_);
#line 27124 "Photo.c"
		}
	}
#line 3713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp141_ = alteration_list;
#line 3713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp141__length1 = alteration_list_length1;
#line 3713 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp141__length1 > 0) {
#line 27133 "Photo.c"
		gchar** _tmp142_;
		gint _tmp142__length1;
		Alteration* _tmp143_;
		Alteration* _tmp144_;
#line 3714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp142_ = alteration_list;
#line 3714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp142__length1 = alteration_list_length1;
#line 3714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp143_ = alteration_new_from_array (_tmp142_, _tmp142__length1);
#line 3714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp144_ = _tmp143_;
#line 3714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp144_);
#line 3714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp144_);
#line 27150 "Photo.c"
	}
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_);
#line 3596 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 27166 "Photo.c"
}


static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify) {
	gboolean has_editable;
	GFile* editable_file;
	gboolean _tmp8_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
	gboolean _tmp34_;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_;
	gboolean _tmp47_;
	gboolean _tmp49_;
	GError * _inner_error_ = NULL;
#line 3717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3718 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	has_editable = FALSE;
#line 3721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	editable_file = NULL;
#line 27193 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 27200 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 3723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27210 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
				PhotoBackingReaders* _tmp6_;
#line 3724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp4_));
#line 3724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3724 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable_file = _tmp5_;
#line 3725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 3725 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_->editable = NULL;
#line 3726 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				has_editable = TRUE;
#line 27233 "Photo.c"
			}
		}
		__finally345:
		{
			PhotoBackingReaders* _tmp7_;
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27243 "Photo.c"
		}
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3722 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 27255 "Photo.c"
		}
	}
#line 3730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = has_editable;
#line 3730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp8_) {
#line 27262 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 3731 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 27266 "Photo.c"
		{
			{
				PhotoRow* _tmp9_;
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = self->row;
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 27274 "Photo.c"
				{
					PhotoRow* _tmp10_;
					BackingPhotoID _tmp11_;
					gboolean _tmp12_ = FALSE;
					PhotoRow* _tmp16_;
					BackingPhotoRow* _tmp17_;
					BackingPhotoRow* _tmp18_;
#line 3734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp10_ = self->row;
#line 3734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 3734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					editable_id = _tmp11_;
#line 3735 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = backing_photo_id_is_valid (&editable_id);
#line 3735 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_tmp12_) {
#line 27292 "Photo.c"
						PhotoTable* _tmp13_ = NULL;
						PhotoTable* _tmp14_;
						PhotoRow* _tmp15_;
#line 3736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp13_ = photo_table_get_instance ();
#line 3736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp14_ = _tmp13_;
#line 3736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp15_ = self->row;
#line 3736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						photo_table_detach_editable (_tmp14_, _tmp15_, &_inner_error_);
#line 3736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_database_table_unref0 (_tmp14_);
#line 3736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 27308 "Photo.c"
							goto __finally347;
						}
					}
#line 3737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp16_ = self->row;
#line 3737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp17_ = _tmp16_->master;
#line 3737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp18_ = _backing_photo_row_ref0 (_tmp17_);
#line 3737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3737 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					self->backing_photo_row = _tmp18_;
#line 27322 "Photo.c"
				}
				__finally347:
				{
					PhotoRow* _tmp19_;
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp19_ = self->row;
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 27331 "Photo.c"
				}
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 27337 "Photo.c"
						goto __catch346_database_error;
					}
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 27348 "Photo.c"
				}
			}
		}
		goto __finally346;
		__catch346_database_error:
		{
			GError* err = NULL;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 3740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = err;
#line 3740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = _tmp20_->message;
#line 3740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_warning ("Photo.vala:3740: Unable to remove editable from PhotoTable: %s", _tmp21_);
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 27370 "Photo.c"
		}
		__finally346:
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3732 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 27383 "Photo.c"
		}
		{
			gboolean _tmp22_ = FALSE;
#line 3744 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = backing_photo_id_is_valid (&editable_id);
#line 3744 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp22_) {
#line 27391 "Photo.c"
				BackingPhotoTable* _tmp23_ = NULL;
				BackingPhotoTable* _tmp24_;
				BackingPhotoID _tmp25_;
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = backing_photo_table_get_instance ();
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = _tmp23_;
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = editable_id;
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				backing_photo_table_remove (_tmp24_, &_tmp25_, &_inner_error_);
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_database_table_unref0 (_tmp24_);
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 27409 "Photo.c"
						goto __catch348_database_error;
					}
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return;
#line 27420 "Photo.c"
				}
			}
		}
		goto __finally348;
		__catch348_database_error:
		{
			GError* err = NULL;
			GError* _tmp26_;
			const gchar* _tmp27_;
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 3747 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = err;
#line 3747 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = _tmp26_->message;
#line 3747 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_warning ("Photo.vala:3747: Unable to remove editable from BackingPhotoTable: %s", _tmp27_);
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 27442 "Photo.c"
		}
		__finally348:
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3743 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 27455 "Photo.c"
		}
	}
#line 3751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = remove_transformations;
#line 3751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp28_) {
#line 3752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 27464 "Photo.c"
	}
#line 3754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = has_editable;
#line 3754 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp29_) {
#line 27470 "Photo.c"
		GFile* _tmp30_;
#line 3755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3756 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = editable_file;
#line 3756 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, NULL);
#line 27478 "Photo.c"
	}
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = delete_editable;
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp32_) {
#line 27484 "Photo.c"
		GFile* _tmp33_;
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp33_ = editable_file;
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = _tmp33_ != NULL;
#line 27490 "Photo.c"
	} else {
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = FALSE;
#line 27494 "Photo.c"
	}
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp31_;
#line 3759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp34_) {
#line 27500 "Photo.c"
		{
			GFile* _tmp35_;
#line 3761 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp35_ = editable_file;
#line 3761 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_file_trash (_tmp35_, NULL, &_inner_error_);
#line 3761 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 27509 "Photo.c"
				goto __catch349_g_error;
			}
		}
		goto __finally349;
		__catch349_g_error:
		{
			GError* err = NULL;
			GFile* _tmp36_;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_;
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			err = _inner_error_;
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_inner_error_ = NULL;
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_ = editable_file;
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp37_ = g_file_get_path (_tmp36_);
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = _tmp37_;
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp39_ = data_object_to_string (DATA_OBJECT (self));
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp41_ = err;
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp42_ = _tmp41_->message;
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_warning ("Photo.vala:3763: Unable to trash editable %s for %s: %s", _tmp38_, _tmp40_, _tmp42_);
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp40_);
#line 3763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (_tmp38_);
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_error_free0 (err);
#line 27550 "Photo.c"
		}
		__finally349:
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3760 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 27563 "Photo.c"
		}
	}
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = has_editable;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp45_) {
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_ = TRUE;
#line 27572 "Photo.c"
	} else {
		gboolean _tmp46_;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp46_ = remove_transformations;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp44_ = _tmp46_;
#line 27579 "Photo.c"
	}
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = _tmp44_;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp47_) {
#line 27585 "Photo.c"
		gboolean _tmp48_;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp48_ = notify;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = _tmp48_;
#line 27591 "Photo.c"
	} else {
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp43_ = FALSE;
#line 27595 "Photo.c"
	}
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_ = _tmp43_;
#line 3768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp49_) {
#line 27601 "Photo.c"
		Alteration* _tmp50_;
		Alteration* _tmp51_;
#line 3769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = alteration_new ("image", "revert");
#line 3769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = _tmp50_;
#line 3769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp51_);
#line 3769 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_alteration_unref0 (_tmp51_);
#line 27612 "Photo.c"
	}
#line 3717 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 27616 "Photo.c"
}


static void _photo_on_reimport_editable_one_shot_callback (gpointer self) {
#line 3784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_on_reimport_editable (self);
#line 27623 "Photo.c"
}


static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self) {
#line 3793 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_on_update_editable_attributes (self);
#line 27630 "Photo.c"
}


static void _photo_on_remove_editable_one_shot_callback (gpointer self) {
#line 3802 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_on_remove_editable (self);
#line 27637 "Photo.c"
}


static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GFileMonitorEvent _tmp12_;
	GEnumValue* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	GFileMonitorEvent _tmp17_;
	GError * _inner_error_ = NULL;
#line 3772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3772 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 27655 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 27662 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp10_;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 27674 "Photo.c"
				GFile* _tmp4_;
				PhotoBackingReaders* _tmp5_;
				PhotoFileReader* _tmp6_;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = file;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = self->priv->readers;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = _tmp5_->editable;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp6_));
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = g_file_equal (_tmp4_, _tmp8_);
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = _tmp9_;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 27697 "Photo.c"
			} else {
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp1_ = FALSE;
#line 27701 "Photo.c"
			}
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _tmp1_;
#line 3775 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_assert (_tmp10_);
#line 27707 "Photo.c"
		}
		__finally350:
		{
			PhotoBackingReaders* _tmp11_;
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = self->priv->readers;
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27716 "Photo.c"
		}
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 27726 "Photo.c"
		}
	}
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = event;
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp12_);
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = file;
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = g_file_get_path (_tmp14_);
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3778: EDITABLE %s: %s", (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, _tmp16_);
#line 3778 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp16_);
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = event;
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (_tmp17_) {
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 27751 "Photo.c"
		{
			OneShotScheduler* _tmp18_;
			OneShotScheduler* _tmp20_;
#line 3783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = self->priv->reimport_editable_scheduler;
#line 3783 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp18_ == NULL) {
#line 27759 "Photo.c"
				OneShotScheduler* _tmp19_;
#line 3784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 3784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 3784 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp19_;
#line 27767 "Photo.c"
			}
#line 3788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = self->priv->reimport_editable_scheduler;
#line 3788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp20_, (guint) 1000, TRUE);
#line 3789 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 27775 "Photo.c"
		}
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 27779 "Photo.c"
		{
			OneShotScheduler* _tmp21_;
			OneShotScheduler* _tmp23_;
#line 3792 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = self->priv->update_editable_attributes_scheduler;
#line 3792 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp21_ == NULL) {
#line 27787 "Photo.c"
				OneShotScheduler* _tmp22_;
#line 3793 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 3793 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 3793 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp22_;
#line 27795 "Photo.c"
			}
#line 3797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp23_ = self->priv->update_editable_attributes_scheduler;
#line 3797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp23_, (guint) 1000, TRUE);
#line 3798 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 27803 "Photo.c"
		}
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 27807 "Photo.c"
		{
			OneShotScheduler* _tmp24_;
			OneShotScheduler* _tmp26_;
#line 3801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = self->priv->remove_editable_scheduler;
#line 3801 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp24_ == NULL) {
#line 27815 "Photo.c"
				OneShotScheduler* _tmp25_;
#line 3802 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 3802 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 3802 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp25_;
#line 27823 "Photo.c"
			}
#line 3806 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = self->priv->remove_editable_scheduler;
#line 3806 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp26_, (guint) 3000, TRUE);
#line 3807 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 27831 "Photo.c"
		}
		default:
#line 3780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 27836 "Photo.c"
		{
#line 3812 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			break;
#line 27840 "Photo.c"
		}
	}
#line 3817 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 27845 "Photo.c"
}


static void photo_on_reimport_editable (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 3820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3822 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 3824 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = data_object_to_string (DATA_OBJECT (self));
#line 3824 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3824 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3824: Reimporting editable for %s", _tmp1_);
#line 3824 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 27865 "Photo.c"
	{
#line 3826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error_);
#line 3826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 27871 "Photo.c"
			goto __catch351_g_error;
		}
	}
	goto __finally351;
	__catch351_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 3828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = data_object_to_string (DATA_OBJECT (self));
#line 3828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = err;
#line 3828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 3828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:3828: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 3828 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 27901 "Photo.c"
	}
	__finally351:
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 27912 "Photo.c"
	}
}


static void photo_on_update_editable_attributes (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 3833 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = data_object_to_string (DATA_OBJECT (self));
#line 3834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3834: Updating editable attributes for %s", _tmp1_);
#line 3834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 27931 "Photo.c"
	{
#line 3836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error_);
#line 3836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 27937 "Photo.c"
			goto __catch352_g_error;
		}
	}
	goto __finally352;
	__catch352_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 3838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = err;
#line 3838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 3838 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:3838: Unable to update editable attributes: %s", _tmp3_);
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 27959 "Photo.c"
	}
	__finally352:
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3835 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 27970 "Photo.c"
	}
}


static void photo_on_remove_editable (Photo* self) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* file;
	GFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
#line 3842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3843 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 3843 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	reader = _tmp0_;
#line 3844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = reader;
#line 3844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3845 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3845 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 28000 "Photo.c"
	}
#line 3847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = reader;
#line 3847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp2_));
#line 3847 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp3_;
#line 3848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = file;
#line 3848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 3848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_) {
#line 28014 "Photo.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
#line 3849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = data_object_to_string (DATA_OBJECT (self));
#line 3849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_debug ("Photo.vala:3849: Not removing editable for %s: file exists", _tmp7_);
#line 3849 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 3851 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (file);
#line 3851 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3851 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 28031 "Photo.c"
	}
#line 3854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = data_object_to_string (DATA_OBJECT (self));
#line 3854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 3854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_debug ("Photo.vala:3854: Removing editable for %s: file no longer exists", _tmp9_);
#line 3854 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp9_);
#line 3855 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 3842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 28047 "Photo.c"
}


void photo_get_original_dimensions (Photo* self, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions dim;
	Orientation _tmp1_ = 0;
	Orientation orientation;
	Dimensions _tmp2_;
	Dimensions _tmp3_ = {0};
#line 3863 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dim = _tmp0_;
#line 3865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 3865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation = _tmp1_;
#line 3867 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = dim;
#line 3867 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp2_, &_tmp3_);
#line 3867 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = _tmp3_;
#line 3867 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 28076 "Photo.c"
}


void photo_get_master_dimensions (Photo* self, Dimensions* result) {
	Orientation _tmp0_ = 0;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 3871 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_original_orientation (self);
#line 3872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp1_);
#line 3872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 3872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = _tmp2_;
#line 3872 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 28096 "Photo.c"
}


gboolean photo_get_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_ = {0};
	Dimensions dim;
	Orientation _tmp3_ = 0;
	Orientation orientation;
	Orientation _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_ = {0};
#line 3876 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 3878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw = _tmp0_;
#line 3878 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp1_) {
#line 3879 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 3881 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 3881 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (crop) {
#line 3881 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*crop = _vala_crop;
#line 28130 "Photo.c"
		}
#line 3881 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 28134 "Photo.c"
	}
#line 3884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	media_source_get_dimensions (MEDIA_SOURCE (self), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 3884 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dim = _tmp2_;
#line 3885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_get_orientation (self);
#line 3885 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation = _tmp3_;
#line 3887 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = orientation;
#line 3887 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = dim;
#line 3887 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = raw;
#line 3887 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation_rotate_box (_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 3887 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_crop = _tmp7_;
#line 3889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 3889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (crop) {
#line 3889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*crop = _vala_crop;
#line 28160 "Photo.c"
	}
#line 3889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 28164 "Photo.c"
}


void photo_set_crop (Photo* self, Box* crop) {
	Dimensions _tmp0_ = {0};
	Dimensions dim;
	Orientation _tmp1_ = 0;
	Orientation orientation;
	Dimensions _tmp2_;
	Box _tmp3_;
	Box _tmp4_ = {0};
	Box derotated;
	Box _tmp5_;
	gint _tmp6_;
	Dimensions _tmp7_;
	gint _tmp8_;
	gint _tmp9_ = 0;
	Box _tmp10_;
	gint _tmp11_;
	Box _tmp12_;
	gint _tmp13_;
	Dimensions _tmp14_;
	gint _tmp15_;
	gint _tmp16_ = 0;
	Box _tmp17_;
	gint _tmp18_;
	Dimensions _tmp19_;
	gint _tmp20_;
	gint _tmp21_ = 0;
	Box _tmp22_;
	gint _tmp23_;
	Box _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
	gint _tmp28_ = 0;
	Box _tmp29_;
#line 3893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 3894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	media_source_get_dimensions (MEDIA_SOURCE (self), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 3894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dim = _tmp0_;
#line 3895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 3895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation = _tmp1_;
#line 3897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = dim;
#line 3897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = *crop;
#line 3897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp2_, &_tmp3_, &_tmp4_);
#line 3897 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated = _tmp4_;
#line 3899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = derotated;
#line 3899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_.left;
#line 3899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = dim;
#line 3899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_.width;
#line 3899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = CLAMP (_tmp6_, 0, _tmp8_ - 2);
#line 3899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated.left = _tmp9_;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = derotated;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_.right;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = derotated;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_.left;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = dim;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp14_.width;
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = CLAMP (_tmp11_, _tmp13_, _tmp15_ - 1);
#line 3900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated.right = _tmp16_;
#line 3902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = derotated;
#line 3902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = _tmp17_.top;
#line 3902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = dim;
#line 3902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = _tmp19_.height;
#line 3902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = CLAMP (_tmp18_, 0, _tmp20_ - 2);
#line 3902 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated.top = _tmp21_;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = derotated;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = _tmp22_.bottom;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = derotated;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = _tmp24_.top;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = dim;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = _tmp26_.height;
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = CLAMP (_tmp23_, _tmp25_, _tmp27_ - 1);
#line 3903 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated.bottom = _tmp28_;
#line 3905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = derotated;
#line 3905 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp29_);
#line 28282 "Photo.c"
}


gboolean photo_get_straighten (Photo* self, gdouble* theta) {
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_ = FALSE;
#line 3908 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3909 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 3909 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_theta = _tmp0_;
#line 3909 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp1_) {
#line 3910 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 3910 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (theta) {
#line 3910 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*theta = _vala_theta;
#line 28305 "Photo.c"
		}
#line 3910 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 28309 "Photo.c"
	}
#line 3912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 3912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (theta) {
#line 3912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*theta = _vala_theta;
#line 28317 "Photo.c"
	}
#line 3912 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 28321 "Photo.c"
}


void photo_set_straighten (Photo* self, gdouble theta) {
	gdouble _tmp0_;
#line 3915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3916 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = theta;
#line 3916 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_set_raw_straighten (self, _tmp0_);
#line 28333 "Photo.c"
}


static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst) {
	GdkPixbuf* result = NULL;
	EditingToolsRedeyeInstance _tmp0_;
	gint _tmp1_;
	gdouble r;
	EditingToolsRedeyeInstance _tmp2_;
	gint _tmp3_;
	gint* _tmp4_ = NULL;
	gint* x_insets_first_quadrant;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i;
	EditingToolsRedeyeInstance _tmp23_;
	GdkPoint _tmp24_;
	gint _tmp25_;
	EditingToolsRedeyeInstance _tmp26_;
	gint _tmp27_;
	gint x_bounds_min;
	EditingToolsRedeyeInstance _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	EditingToolsRedeyeInstance _tmp31_;
	gint _tmp32_;
	gint x_bounds_max;
	EditingToolsRedeyeInstance _tmp33_;
	GdkPoint _tmp34_;
	gint _tmp35_;
	EditingToolsRedeyeInstance _tmp36_;
	gint _tmp37_;
	gint ymin;
	gint _tmp38_ = 0;
	gint _tmp39_;
	gint _tmp41_;
	EditingToolsRedeyeInstance _tmp42_;
	GdkPoint _tmp43_;
	gint _tmp44_;
	gint ymax;
	gint _tmp45_ = 0;
	gint _tmp46_;
	GdkPixbuf* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint _tmp54_;
	gint inset_index;
	EditingToolsRedeyeInstance _tmp95_;
	GdkPoint _tmp96_;
	gint _tmp97_;
	EditingToolsRedeyeInstance _tmp98_;
	GdkPoint _tmp99_;
	gint _tmp100_;
	EditingToolsRedeyeInstance _tmp101_;
	gint _tmp102_;
	gint* _tmp103_;
	gint _tmp103__length1;
	GdkPixbuf* _tmp144_;
	GdkPixbuf* _tmp145_;
#line 3919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 3919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 3929 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *inst;
#line 3929 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 3929 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 3930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = *inst;
#line 3930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 3930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 3930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 3930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 3930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 3932 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	i = 0;
#line 28419 "Photo.c"
	{
		gdouble _tmp5_;
		gdouble y;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = r;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		y = _tmp5_;
#line 28427 "Photo.c"
		{
			gboolean _tmp6_;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = TRUE;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 28434 "Photo.c"
				gboolean _tmp7_;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_ = 0.0;
				gdouble theta;
				gdouble _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_ = 0.0;
				gint x;
				gint* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				EditingToolsRedeyeInstance _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp7_) {
#line 28457 "Photo.c"
					gdouble _tmp8_;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp8_ = y;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					y = _tmp8_ - 1.0;
#line 28463 "Photo.c"
				}
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = FALSE;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = y;
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp9_ >= 0.0)) {
#line 3933 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 28473 "Photo.c"
				}
#line 3934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = y;
#line 3934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = r;
#line 3934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = asin (_tmp10_ / _tmp11_);
#line 3934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				theta = _tmp12_;
#line 3935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = r;
#line 3935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = theta;
#line 3935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = cos (_tmp14_);
#line 3935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				x = (gint) ((_tmp13_ * _tmp15_) + 0.5);
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = x_insets_first_quadrant;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16__length1 = x_insets_first_quadrant_length1;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = i;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = *inst;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = _tmp18_.radius;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = x;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_[_tmp17_] = _tmp19_ - _tmp20_;
#line 3936 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = _tmp16_[_tmp17_];
#line 3938 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = i;
#line 3938 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				i = _tmp22_ + 1;
#line 28511 "Photo.c"
			}
		}
	}
#line 3941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = *inst;
#line 3941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = _tmp23_.center;
#line 3941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = _tmp24_.x;
#line 3941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = *inst;
#line 3941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = _tmp26_.radius;
#line 3941 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	x_bounds_min = _tmp25_ - _tmp27_;
#line 3942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = *inst;
#line 3942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = _tmp28_.center;
#line 3942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = _tmp29_.x;
#line 3942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = *inst;
#line 3942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = _tmp31_.radius;
#line 3942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	x_bounds_max = _tmp30_ + _tmp32_;
#line 3943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = *inst;
#line 3943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = _tmp33_.center;
#line 3943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = _tmp34_.y;
#line 3943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = *inst;
#line 3943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = _tmp36_.radius;
#line 3943 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ymin = _tmp35_ - _tmp37_;
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = ymin;
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp39_ < 0) {
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp38_ = 0;
#line 28557 "Photo.c"
	} else {
		gint _tmp40_;
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp40_ = ymin;
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp38_ = _tmp40_;
#line 28564 "Photo.c"
	}
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = _tmp38_;
#line 3944 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ymin = _tmp41_;
#line 3945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = *inst;
#line 3945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = _tmp42_.center;
#line 3945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = _tmp43_.y;
#line 3945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ymax = _tmp44_;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = ymax;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = pixbuf;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = gdk_pixbuf_get_height (_tmp47_);
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp46_ > (_tmp49_ - 1)) {
#line 28588 "Photo.c"
		GdkPixbuf* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp50_ = pixbuf;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp51_ = gdk_pixbuf_get_height (_tmp50_);
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45_ = _tmp52_ - 1;
#line 28600 "Photo.c"
	} else {
		gint _tmp53_;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp53_ = ymax;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp45_ = _tmp53_;
#line 28607 "Photo.c"
	}
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp54_ = _tmp45_;
#line 3946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ymax = _tmp54_;
#line 3950 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	inset_index = 0;
#line 28615 "Photo.c"
	{
		gint _tmp55_;
		gint y_it;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp55_ = ymin;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		y_it = _tmp55_;
#line 28623 "Photo.c"
		{
			gboolean _tmp56_;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp56_ = TRUE;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 28630 "Photo.c"
				gboolean _tmp57_;
				gint _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
				gint* _tmp62_;
				gint _tmp62__length1;
				gint _tmp63_;
				gint _tmp64_;
				gint xmin;
				gint _tmp65_ = 0;
				gint _tmp66_;
				gint _tmp68_;
				gint _tmp69_;
				gint* _tmp70_;
				gint _tmp70__length1;
				gint _tmp71_;
				gint _tmp72_;
				gint xmax;
				gint _tmp73_ = 0;
				gint _tmp74_;
				GdkPixbuf* _tmp75_;
				gint _tmp76_;
				gint _tmp77_;
				gint _tmp82_;
				gint _tmp94_;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp57_ = _tmp56_;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp57_) {
#line 28660 "Photo.c"
					gint _tmp58_;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp58_ = y_it;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					y_it = _tmp58_ + 1;
#line 28666 "Photo.c"
				}
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp56_ = FALSE;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp59_ = y_it;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp60_ = ymax;
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp59_ <= _tmp60_)) {
#line 3951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 28678 "Photo.c"
				}
#line 3952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp61_ = x_bounds_min;
#line 3952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp62_ = x_insets_first_quadrant;
#line 3952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp62__length1 = x_insets_first_quadrant_length1;
#line 3952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp63_ = inset_index;
#line 3952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp64_ = _tmp62_[_tmp63_];
#line 3952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmin = _tmp61_ + _tmp64_;
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp66_ = xmin;
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp66_ < 0) {
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp65_ = 0;
#line 28698 "Photo.c"
				} else {
					gint _tmp67_;
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp67_ = xmin;
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp65_ = _tmp67_;
#line 28705 "Photo.c"
				}
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp68_ = _tmp65_;
#line 3953 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmin = _tmp68_;
#line 3954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp69_ = x_bounds_max;
#line 3954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp70_ = x_insets_first_quadrant;
#line 3954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp70__length1 = x_insets_first_quadrant_length1;
#line 3954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp71_ = inset_index;
#line 3954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp72_ = _tmp70_[_tmp71_];
#line 3954 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmax = _tmp69_ - _tmp72_;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp74_ = xmax;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp75_ = pixbuf;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp76_ = gdk_pixbuf_get_width (_tmp75_);
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp77_ = _tmp76_;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp74_ > (_tmp77_ - 1)) {
#line 28733 "Photo.c"
					GdkPixbuf* _tmp78_;
					gint _tmp79_;
					gint _tmp80_;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp78_ = pixbuf;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp79_ = gdk_pixbuf_get_width (_tmp78_);
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp80_ = _tmp79_;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp73_ = _tmp80_ - 1;
#line 28745 "Photo.c"
				} else {
					gint _tmp81_;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp81_ = xmax;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp73_ = _tmp81_;
#line 28752 "Photo.c"
				}
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp82_ = _tmp73_;
#line 3955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmax = _tmp82_;
#line 28758 "Photo.c"
				{
					gint _tmp83_;
					gint x_it;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp83_ = xmin;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					x_it = _tmp83_;
#line 28766 "Photo.c"
					{
						gboolean _tmp84_;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp84_ = TRUE;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 28773 "Photo.c"
							gboolean _tmp85_;
							gint _tmp87_;
							gint _tmp88_;
							GdkPixbuf* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
							GdkPixbuf* _tmp92_ = NULL;
							GdkPixbuf* _tmp93_;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp85_ = _tmp84_;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp85_) {
#line 28786 "Photo.c"
								gint _tmp86_;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp86_ = x_it;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								x_it = _tmp86_ + 1;
#line 28792 "Photo.c"
							}
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp84_ = FALSE;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp87_ = x_it;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp88_ = xmax;
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!(_tmp87_ <= _tmp88_)) {
#line 3957 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 28804 "Photo.c"
							}
#line 3958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp89_ = pixbuf;
#line 3958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp90_ = x_it;
#line 3958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp91_ = y_it;
#line 3958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp92_ = photo_red_reduce_pixel (self, _tmp89_, _tmp90_, _tmp91_);
#line 3958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp93_ = _tmp92_;
#line 3958 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp93_);
#line 28818 "Photo.c"
						}
					}
				}
#line 3960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp94_ = inset_index;
#line 3960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				inset_index = _tmp94_ + 1;
#line 28826 "Photo.c"
			}
		}
	}
#line 3965 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp95_ = *inst;
#line 3965 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp96_ = _tmp95_.center;
#line 3965 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp97_ = _tmp96_.y;
#line 3965 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ymin = _tmp97_;
#line 3966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp98_ = *inst;
#line 3966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp99_ = _tmp98_.center;
#line 3966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp100_ = _tmp99_.y;
#line 3966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp101_ = *inst;
#line 3966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp102_ = _tmp101_.radius;
#line 3966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ymax = _tmp100_ + _tmp102_;
#line 3967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp103_ = x_insets_first_quadrant;
#line 3967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp103__length1 = x_insets_first_quadrant_length1;
#line 3967 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	inset_index = _tmp103__length1 - 1;
#line 28856 "Photo.c"
	{
		gint _tmp104_;
		gint y_it;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp104_ = ymin;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		y_it = _tmp104_;
#line 28864 "Photo.c"
		{
			gboolean _tmp105_;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp105_ = TRUE;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 28871 "Photo.c"
				gboolean _tmp106_;
				gint _tmp108_;
				gint _tmp109_;
				gint _tmp110_;
				gint* _tmp111_;
				gint _tmp111__length1;
				gint _tmp112_;
				gint _tmp113_;
				gint xmin;
				gint _tmp114_ = 0;
				gint _tmp115_;
				gint _tmp117_;
				gint _tmp118_;
				gint* _tmp119_;
				gint _tmp119__length1;
				gint _tmp120_;
				gint _tmp121_;
				gint xmax;
				gint _tmp122_ = 0;
				gint _tmp123_;
				GdkPixbuf* _tmp124_;
				gint _tmp125_;
				gint _tmp126_;
				gint _tmp131_;
				gint _tmp143_;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp106_ = _tmp105_;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp106_) {
#line 28901 "Photo.c"
					gint _tmp107_;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp107_ = y_it;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					y_it = _tmp107_ + 1;
#line 28907 "Photo.c"
				}
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp105_ = FALSE;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp108_ = y_it;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp109_ = ymax;
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp108_ <= _tmp109_)) {
#line 3968 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 28919 "Photo.c"
				}
#line 3969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp110_ = x_bounds_min;
#line 3969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp111_ = x_insets_first_quadrant;
#line 3969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp111__length1 = x_insets_first_quadrant_length1;
#line 3969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp112_ = inset_index;
#line 3969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp113_ = _tmp111_[_tmp112_];
#line 3969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmin = _tmp110_ + _tmp113_;
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp115_ = xmin;
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp115_ < 0) {
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp114_ = 0;
#line 28939 "Photo.c"
				} else {
					gint _tmp116_;
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp116_ = xmin;
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp114_ = _tmp116_;
#line 28946 "Photo.c"
				}
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp117_ = _tmp114_;
#line 3970 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmin = _tmp117_;
#line 3971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp118_ = x_bounds_max;
#line 3971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp119_ = x_insets_first_quadrant;
#line 3971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp119__length1 = x_insets_first_quadrant_length1;
#line 3971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp120_ = inset_index;
#line 3971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp121_ = _tmp119_[_tmp120_];
#line 3971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmax = _tmp118_ - _tmp121_;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp123_ = xmax;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp124_ = pixbuf;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp125_ = gdk_pixbuf_get_width (_tmp124_);
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp126_ = _tmp125_;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp123_ > (_tmp126_ - 1)) {
#line 28974 "Photo.c"
					GdkPixbuf* _tmp127_;
					gint _tmp128_;
					gint _tmp129_;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp127_ = pixbuf;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp128_ = gdk_pixbuf_get_width (_tmp127_);
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp129_ = _tmp128_;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp122_ = _tmp129_ - 1;
#line 28986 "Photo.c"
				} else {
					gint _tmp130_;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp130_ = xmax;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp122_ = _tmp130_;
#line 28993 "Photo.c"
				}
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp131_ = _tmp122_;
#line 3972 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				xmax = _tmp131_;
#line 28999 "Photo.c"
				{
					gint _tmp132_;
					gint x_it;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp132_ = xmin;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					x_it = _tmp132_;
#line 29007 "Photo.c"
					{
						gboolean _tmp133_;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp133_ = TRUE;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 29014 "Photo.c"
							gboolean _tmp134_;
							gint _tmp136_;
							gint _tmp137_;
							GdkPixbuf* _tmp138_;
							gint _tmp139_;
							gint _tmp140_;
							GdkPixbuf* _tmp141_ = NULL;
							GdkPixbuf* _tmp142_;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp134_ = _tmp133_;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp134_) {
#line 29027 "Photo.c"
								gint _tmp135_;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp135_ = x_it;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								x_it = _tmp135_ + 1;
#line 29033 "Photo.c"
							}
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp133_ = FALSE;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp136_ = x_it;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp137_ = xmax;
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!(_tmp136_ <= _tmp137_)) {
#line 3974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 29045 "Photo.c"
							}
#line 3975 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp138_ = pixbuf;
#line 3975 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp139_ = x_it;
#line 3975 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp140_ = y_it;
#line 3975 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp141_ = photo_red_reduce_pixel (self, _tmp138_, _tmp139_, _tmp140_);
#line 3975 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp142_ = _tmp141_;
#line 3975 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp142_);
#line 29059 "Photo.c"
						}
					}
				}
#line 3977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp143_ = inset_index;
#line 3977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				inset_index = _tmp143_ - 1;
#line 29067 "Photo.c"
			}
		}
	}
#line 3980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp144_ = pixbuf;
#line 3980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp145_ = _g_object_ref0 (_tmp144_);
#line 3980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp145_;
#line 3980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 3980 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29081 "Photo.c"
}


static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
	GdkPixbuf* _tmp4_;
	gint _tmp5_ = 0;
	gint px_start_byte_offset;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gboolean _tmp11_;
	gboolean _tmp16_;
	gboolean _tmp21_;
	GdkPixbuf* _tmp36_;
	GdkPixbuf* _tmp37_;
#line 3983 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3983 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = y;
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = pixbuf;
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = gdk_pixbuf_get_rowstride (_tmp1_);
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = x;
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (_tmp4_);
#line 3984 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	px_start_byte_offset = (_tmp0_ * _tmp2_) + (_tmp3_ * _tmp5_);
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = x;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp9_ >= 0) {
#line 29125 "Photo.c"
		gint _tmp10_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = y;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = _tmp10_ >= 0;
#line 29131 "Photo.c"
	} else {
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = FALSE;
#line 29135 "Photo.c"
	}
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp8_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 29141 "Photo.c"
		gint _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = x;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = pixbuf;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp12_ < _tmp15_;
#line 29156 "Photo.c"
	} else {
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = FALSE;
#line 29160 "Photo.c"
	}
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = _tmp7_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp16_) {
#line 29166 "Photo.c"
		gint _tmp17_;
		GdkPixbuf* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = y;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = pixbuf;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp17_ < _tmp20_;
#line 29181 "Photo.c"
	} else {
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = FALSE;
#line 29185 "Photo.c"
	}
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = _tmp6_;
#line 3991 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp21_) {
#line 29191 "Photo.c"
		GdkPixbuf* _tmp22_;
		guint8* _tmp23_ = NULL;
		guchar* pixel_data;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar* _tmp24_;
		gint _tmp24__length1;
		gint _tmp25_;
		guchar _tmp26_;
		guchar g;
		guchar* _tmp27_;
		gint _tmp27__length1;
		gint _tmp28_;
		guchar _tmp29_;
		guchar b;
		guchar _tmp30_;
		guchar _tmp31_;
		guchar r;
		guchar* _tmp32_;
		gint _tmp32__length1;
		gint _tmp33_;
		guchar _tmp34_;
		guchar _tmp35_;
#line 3992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = pixbuf;
#line 3992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = gdk_pixbuf_get_pixels (_tmp22_);
#line 3992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixel_data = _tmp23_;
#line 3992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixel_data_length1 = -1;
#line 3992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = pixel_data;
#line 4002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24__length1 = pixel_data_length1;
#line 4002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = px_start_byte_offset;
#line 4002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = _tmp24_[_tmp25_ + 1];
#line 4002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g = _tmp26_;
#line 4003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27_ = pixel_data;
#line 4003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27__length1 = pixel_data_length1;
#line 4003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp28_ = px_start_byte_offset;
#line 4003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp29_ = _tmp27_[_tmp28_ + 2];
#line 4003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		b = _tmp29_;
#line 4005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp30_ = g;
#line 4005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = b;
#line 4005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		r = (guchar) ((_tmp30_ + _tmp31_) / 2);
#line 4007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = pixel_data;
#line 4007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32__length1 = pixel_data_length1;
#line 4007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp33_ = px_start_byte_offset;
#line 4007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp34_ = r;
#line 4007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_[_tmp33_] = _tmp34_;
#line 4007 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = _tmp32_[_tmp33_];
#line 29263 "Photo.c"
	}
#line 4010 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = pixbuf;
#line 4010 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = _g_object_ref0 (_tmp36_);
#line 4010 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp37_;
#line 4010 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29273 "Photo.c"
}


void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result) {
	Orientation _tmp0_ = 0;
	Orientation unscaled_orientation;
	Orientation _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions unscaled_dims;
	gint unscaled_x_offset_raw;
	gint unscaled_y_offset_raw;
	Box crop_box = {0};
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	Orientation _tmp10_;
	Dimensions _tmp11_;
	GdkPoint _tmp12_;
	GdkPoint _tmp13_ = {0};
	GdkPoint derotated_point;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
#line 4013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_orientation (self);
#line 4014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	unscaled_orientation = _tmp0_;
#line 4016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = unscaled_orientation;
#line 4016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	media_source_get_dimensions (MEDIA_SOURCE (self), PHOTO_EXCEPTION_NONE, &_tmp2_);
#line 4016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation_rotate_dimensions (_tmp1_, &_tmp2_, &_tmp3_);
#line 4016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	unscaled_dims = _tmp3_;
#line 4019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4020 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo_get_raw_crop (self, &_tmp4_);
#line 4023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	crop_box = _tmp4_;
#line 4023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_) {
#line 29324 "Photo.c"
		Box _tmp6_;
		gint _tmp7_;
		Box _tmp8_;
		gint _tmp9_;
#line 4024 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = crop_box;
#line 4024 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_.left;
#line 4024 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		unscaled_x_offset_raw = _tmp7_;
#line 4025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = crop_box;
#line 4025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = _tmp8_.top;
#line 4025 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		unscaled_y_offset_raw = _tmp9_;
#line 29341 "Photo.c"
	}
#line 4028 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = unscaled_orientation;
#line 4028 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = unscaled_dims;
#line 4028 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = *unscaled_point;
#line 4028 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	orientation_derotate_point (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
#line 4028 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated_point = _tmp13_;
#line 4032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = derotated_point.x;
#line 4032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = unscaled_x_offset_raw;
#line 4032 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated_point.x = _tmp14_ + _tmp15_;
#line 4033 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = derotated_point.y;
#line 4033 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = unscaled_y_offset_raw;
#line 4033 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	derotated_point.y = _tmp16_ + _tmp17_;
#line 4035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = derotated_point;
#line 4035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 29369 "Photo.c"
}


void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint upper_left;
	GdkPoint _tmp1_ = {0};
	GdkPoint lower_right;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp27_;
	gint _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_;
	gint _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	GdkPoint _tmp44_;
	gint _tmp45_;
	GdkPoint _tmp46_;
	gint _tmp47_;
#line 4038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4039 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_.x = 0;
#line 4039 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	upper_left = _tmp0_;
#line 4040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_.x = 0;
#line 4040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	lower_right = _tmp1_;
#line 4041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4042 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = upper_left;
#line 4043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4043 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = upper_left;
#line 4044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = upper_left;
#line 4046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	upper_left = _tmp15_;
#line 4047 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = lower_right;
#line 4047 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4047 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	lower_right = _tmp17_;
#line 4049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = upper_left;
#line 4049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = lower_right;
#line 4049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 29481 "Photo.c"
		GdkPoint _tmp22_;
		gint _tmp23_;
		gint temp;
		GdkPoint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 4050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = upper_left;
#line 4050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		temp = _tmp23_;
#line 4051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = lower_right;
#line 4051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4052 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = temp;
#line 4052 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 29504 "Photo.c"
	}
#line 4054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = upper_left;
#line 4054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = lower_right;
#line 4054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 29516 "Photo.c"
		GdkPoint _tmp31_;
		gint _tmp32_;
		gint temp;
		GdkPoint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 4055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp31_ = upper_left;
#line 4055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4055 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		temp = _tmp32_;
#line 4056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp33_ = lower_right;
#line 4056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4056 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp35_ = temp;
#line 4057 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 29539 "Photo.c"
	}
#line 4060 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = upper_left;
#line 4061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4061 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = upper_left;
#line 4062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4062 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = lower_right;
#line 4063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = upper_left;
#line 4063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4063 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = lower_right;
#line 4064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = upper_left;
#line 4064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4064 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = raw_rect;
#line 4066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 29579 "Photo.c"
}


PixelTransformationBundle* photo_get_enhance_transformations (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp3_;
	PixelTransformationBundle* _tmp4_ = NULL;
	PixelTransformationBundle* transformations;
	GError * _inner_error_ = NULL;
#line 4069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4070 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	pixbuf = NULL;
#line 29594 "Photo.c"
	{
		Scaling _tmp0_ = {0};
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
#line 4077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp0_);
#line 4077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = photo_get_pixbuf_with_options (self, &_tmp0_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 4077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 29607 "Photo.c"
			goto __catch353_g_error;
		}
#line 4077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4077 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		pixbuf = _tmp2_;
#line 29614 "Photo.c"
	}
	goto __finally353;
	__catch353_g_error:
	{
		GError* e = NULL;
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		e = _inner_error_;
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 4084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:4084: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 4086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (e);
#line 4086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4086 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 29634 "Photo.c"
	}
	__finally353:
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 29647 "Photo.c"
	}
#line 4093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = pixbuf;
#line 4093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = auto_enhance_create_auto_enhance_adjustments (_tmp3_);
#line 4093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	transformations = _tmp4_;
#line 4101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = transformations;
#line 4101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4101 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29661 "Photo.c"
}


gboolean photo_enhance (Photo* self) {
	gboolean result = FALSE;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* transformations;
	PixelTransformationBundle* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	transformations = _tmp0_;
#line 4107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = transformations;
#line 4107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4108 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 4108 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4108 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 29687 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = self->row;
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 29695 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 4114 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = transformations;
#line 4114 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 29702 "Photo.c"
		}
		__finally354:
		{
			PhotoRow* _tmp4_;
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = self->row;
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 29711 "Photo.c"
		}
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4113 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return FALSE;
#line 29723 "Photo.c"
		}
	}
#line 4121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = TRUE;
#line 4121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4121 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29732 "Photo.c"
}


gboolean photo_get_develop_raw_photos_to_files (void) {
	gboolean result;
	gboolean _tmp0_;
#line 323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29745 "Photo.c"
}


void photo_set_develop_raw_photos_to_files (gboolean value) {
	gboolean _tmp0_;
#line 323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = value;
#line 323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo__develop_raw_photos_to_files = _tmp0_;
#line 29755 "Photo.c"
}


static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 29764 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data1 = closure->data;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 29783 "Photo.c"
	} else {
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data2 = closure->data;
#line 29789 "Photo.c"
	}
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 29795 "Photo.c"
}


static void photo_real_raw_development_modified (Photo* self) {
}


static void photo_real_baseline_replaced (Photo* self) {
}


static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 29810 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data1 = closure->data;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 29829 "Photo.c"
	} else {
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data2 = closure->data;
#line 29835 "Photo.c"
	}
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 29841 "Photo.c"
}


static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 354 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 29848 "Photo.c"
}


static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 29855 "Photo.c"
}


static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 368 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 29862 "Photo.c"
}


static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self) {
#line 243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced (self);
#line 29869 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
	Orientation _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_ = NULL;
	PixelTransformer* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	Photo* _tmp9_;
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || GEE_IS_HASH_MAP (transformations), NULL);
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || IS_PIXEL_TRANSFORMER (transformer), NULL);
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || IS_PIXEL_TRANSFORMATION_BUNDLE (adjustments), NULL);
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo;
#line 233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->photo = _tmp1_;
#line 234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = orientation;
#line 234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->orientation = _tmp2_;
#line 235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = transformations;
#line 235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_copy_transformations (_tmp3_);
#line 235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->transformations = _tmp4_;
#line 236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = transformer;
#line 236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _pixel_transformer_ref0 (_tmp5_);
#line 236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 236 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->transformer = _tmp6_;
#line 237 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = adjustments;
#line 237 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _pixel_transformation_bundle_ref0 (_tmp7_);
#line 237 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 237 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->adjustments = _tmp8_;
#line 239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = photo;
#line 239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_connect_object (_tmp9_, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 29937 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
#line 230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 29944 "Photo.c"
}


static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self) {
	Orientation result = 0;
	Orientation _tmp0_;
#line 246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29959 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_ = NULL;
#line 250 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 251 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 29977 "Photo.c"
}


static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 29991 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_ = NULL;
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 30002 "Photo.c"
	} else {
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = NULL;
#line 30008 "Photo.c"
	}
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 30014 "Photo.c"
}


static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 30028 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_ = NULL;
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 30039 "Photo.c"
	} else {
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = NULL;
#line 30045 "Photo.c"
	}
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 30051 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* clone;
#line 262 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || GEE_IS_HASH_MAP (original), NULL);
#line 264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = original;
#line 264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = NULL;
#line 265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 30070 "Photo.c"
	}
#line 267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL);
#line 267 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	clone = _tmp1_;
#line 30076 "Photo.c"
	{
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _object_it;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = original;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = gee_abstract_map_get_keys (GEE_MAP (_tmp2_));
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = gee_iterable_iterator (GEE_ITERABLE (_tmp5_));
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_object_it = _tmp7_;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 30103 "Photo.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			gchar* object;
			GeeHashMap* _tmp12_;
			const gchar* _tmp13_;
			GeeHashMap* _tmp14_;
			const gchar* _tmp15_;
			gpointer _tmp16_ = NULL;
			KeyValueMap* _tmp17_;
			KeyValueMap* _tmp18_ = NULL;
			KeyValueMap* _tmp19_;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _object_it;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp9_) {
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 30125 "Photo.c"
			}
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = _object_it;
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			object = (gchar*) _tmp11_;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = clone;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = object;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = original;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = object;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp14_), _tmp15_);
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = (KeyValueMap*) _tmp16_;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = key_value_map_copy (_tmp17_);
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp12_), _tmp13_, _tmp19_);
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_key_value_map_unref0 (_tmp19_);
#line 269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_key_value_map_unref0 (_tmp17_);
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_free0 (object);
#line 30157 "Photo.c"
		}
#line 268 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 30161 "Photo.c"
	}
#line 271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = clone;
#line 271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 30167 "Photo.c"
}


static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self) {
	gboolean _tmp0_ = FALSE;
#line 274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 275 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_transformation_state_is_broken (PHOTO_TRANSFORMATION_STATE (self));
#line 275 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp0_) {
#line 276 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_signal_emit_by_name (PHOTO_TRANSFORMATION_STATE (self), "broken");
#line 30181 "Photo.c"
	}
}


static void photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass) {
#line 223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 30193 "Photo.c"
}


static void photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self) {
#line 223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 30200 "Photo.c"
}


static void photo_photo_transformation_state_impl_finalize (GObject* obj) {
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_ = 0U;
#line 223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL (obj);
#line 243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 30226 "Photo.c"
}


static GType photo_photo_transformation_state_impl_get_type (void) {
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders* photo_backing_readers_construct (GType object_type) {
	PhotoBackingReaders* self = NULL;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 30248 "Photo.c"
}


static PhotoBackingReaders* photo_backing_readers_new (void) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 30255 "Photo.c"
}


static void photo_value_backing_readers_init (GValue* value) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 30262 "Photo.c"
}


static void photo_value_backing_readers_free_value (GValue* value) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 30271 "Photo.c"
	}
}


static void photo_value_backing_readers_copy_value (const GValue* src_value, GValue* dest_value) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 30281 "Photo.c"
	} else {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 30285 "Photo.c"
	}
}


static gpointer photo_value_backing_readers_peek_pointer (const GValue* value) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 30293 "Photo.c"
}


static gchar* photo_value_backing_readers_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 30300 "Photo.c"
		PhotoBackingReaders* object;
		object = collect_values[0].v_pointer;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30307 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30311 "Photo.c"
		}
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 30315 "Photo.c"
	} else {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30319 "Photo.c"
	}
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 30323 "Photo.c"
}


static gchar* photo_value_backing_readers_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoBackingReaders** object_p;
	object_p = collect_values[0].v_pointer;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!object_p) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 30334 "Photo.c"
	}
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = NULL;
#line 30340 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 30344 "Photo.c"
	} else {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 30348 "Photo.c"
	}
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 30352 "Photo.c"
}


static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecBackingReaders* spec;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 30366 "Photo.c"
}


static gpointer photo_value_get_backing_readers (const GValue* value) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 30375 "Photo.c"
}


static void photo_value_set_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 30395 "Photo.c"
	} else {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30399 "Photo.c"
	}
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 30405 "Photo.c"
	}
}


static void photo_value_take_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 30424 "Photo.c"
	} else {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30428 "Photo.c"
	}
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 30434 "Photo.c"
	}
}


static void photo_backing_readers_class_init (PhotoBackingReadersClass * klass) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_BACKING_READERS_CLASS (klass)->finalize = photo_backing_readers_finalize;
#line 30444 "Photo.c"
}


static void photo_backing_readers_instance_init (PhotoBackingReaders * self) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->ref_count = 1;
#line 30451 "Photo.c"
}


static void photo_backing_readers_finalize (PhotoBackingReaders* obj) {
	PhotoBackingReaders * self;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_BACKING_READERS (obj);
#line 281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 282 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 283 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 30465 "Photo.c"
}


static GType photo_backing_readers_get_type (void) {
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer photo_backing_readers_ref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return instance;
#line 30490 "Photo.c"
}


static void photo_backing_readers_unref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 280 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 30503 "Photo.c"
	}
}


PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type) {
	PhotoReimportMasterState* self = NULL;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 30514 "Photo.c"
}


static void photo_value_reimport_master_state_init (GValue* value) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 30521 "Photo.c"
}


static void photo_value_reimport_master_state_free_value (GValue* value) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 30530 "Photo.c"
	}
}


static void photo_value_reimport_master_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 30540 "Photo.c"
	} else {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 30544 "Photo.c"
	}
}


static gpointer photo_value_reimport_master_state_peek_pointer (const GValue* value) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 30552 "Photo.c"
}


static gchar* photo_value_reimport_master_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 30559 "Photo.c"
		PhotoReimportMasterState* object;
		object = collect_values[0].v_pointer;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30566 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30570 "Photo.c"
		}
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 30574 "Photo.c"
	} else {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30578 "Photo.c"
	}
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 30582 "Photo.c"
}


static gchar* photo_value_reimport_master_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportMasterState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!object_p) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 30593 "Photo.c"
	}
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = NULL;
#line 30599 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 30603 "Photo.c"
	} else {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 30607 "Photo.c"
	}
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 30611 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportMasterState* spec;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 30625 "Photo.c"
}


gpointer photo_value_get_reimport_master_state (const GValue* value) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 30634 "Photo.c"
}


void photo_value_set_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 30654 "Photo.c"
	} else {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30658 "Photo.c"
	}
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 30664 "Photo.c"
	}
}


void photo_value_take_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 30683 "Photo.c"
	} else {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30687 "Photo.c"
	}
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 30693 "Photo.c"
	}
}


static void photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_finalize;
#line 30703 "Photo.c"
}


static void photo_reimport_master_state_instance_init (PhotoReimportMasterState * self) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->ref_count = 1;
#line 30710 "Photo.c"
}


static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterState * self;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_MASTER_STATE (obj);
#line 30718 "Photo.c"
}


GType photo_reimport_master_state_get_type (void) {
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer photo_reimport_master_state_ref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return instance;
#line 30743 "Photo.c"
}


void photo_reimport_master_state_unref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 30756 "Photo.c"
	}
}


static gchar** _vala_array_dup31 (gchar** self, int length) {
	gchar** result;
	int i;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 30768 "Photo.c"
		gchar* _tmp0_;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result[i] = _tmp0_;
#line 30774 "Photo.c"
	}
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 30778 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 1197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = row;
#line 1198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 1198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->row = _tmp1_;
#line 1199 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 1199 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1199 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1199 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = alterations;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4__length1 = alterations_length1;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup31 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->alterations = _tmp5_;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->alterations_length1 = _tmp5__length1;
#line 1200 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 30832 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
#line 1197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 30839 "Photo.c"
}


static void photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass) {
#line 1191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 30848 "Photo.c"
}


static void photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self) {
	PhotoRow* _tmp0_;
#line 1192 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1192 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->row = _tmp0_;
#line 1195 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->metadata_only = FALSE;
#line 30860 "Photo.c"
}


static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterStateImpl * self;
#line 1191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_MASTER_STATE_IMPL (obj);
#line 1192 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1191 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 30876 "Photo.c"
}


static GType photo_reimport_master_state_impl_get_type (void) {
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type) {
	PhotoReimportEditableState* self = NULL;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 30898 "Photo.c"
}


static void photo_value_reimport_editable_state_init (GValue* value) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 30905 "Photo.c"
}


static void photo_value_reimport_editable_state_free_value (GValue* value) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 30914 "Photo.c"
	}
}


static void photo_value_reimport_editable_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 30924 "Photo.c"
	} else {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 30928 "Photo.c"
	}
}


static gpointer photo_value_reimport_editable_state_peek_pointer (const GValue* value) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 30936 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 30943 "Photo.c"
		PhotoReimportEditableState* object;
		object = collect_values[0].v_pointer;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30950 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30954 "Photo.c"
		}
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 30958 "Photo.c"
	} else {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30962 "Photo.c"
	}
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 30966 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportEditableState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!object_p) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 30977 "Photo.c"
	}
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = NULL;
#line 30983 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 30987 "Photo.c"
	} else {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 30991 "Photo.c"
	}
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 30995 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportEditableState* spec;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31009 "Photo.c"
}


gpointer photo_value_get_reimport_editable_state (const GValue* value) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31018 "Photo.c"
}


void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 31038 "Photo.c"
	} else {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31042 "Photo.c"
	}
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 31048 "Photo.c"
	}
}


void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31067 "Photo.c"
	} else {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31071 "Photo.c"
	}
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 31077 "Photo.c"
	}
}


static void photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_finalize;
#line 31087 "Photo.c"
}


static void photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->ref_count = 1;
#line 31094 "Photo.c"
}


static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableState * self;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_EDITABLE_STATE (obj);
#line 31102 "Photo.c"
}


GType photo_reimport_editable_state_get_type (void) {
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer photo_reimport_editable_state_ref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return instance;
#line 31127 "Photo.c"
}


void photo_reimport_editable_state_unref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31140 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 1212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing_state), NULL);
#line 1212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backing_state;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->backing_state = _tmp1_;
#line 1214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 1214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 31175 "Photo.c"
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
#line 1212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 31182 "Photo.c"
}


static void photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass) {
#line 1207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 31191 "Photo.c"
}


static void photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self) {
	BackingPhotoRow* _tmp0_;
#line 1208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->metadata_only = FALSE;
#line 31203 "Photo.c"
}


static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableStateImpl * self;
#line 1207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_EDITABLE_STATE_IMPL (obj);
#line 1208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 31217 "Photo.c"
}


static GType photo_reimport_editable_state_impl_get_type (void) {
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type) {
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 31239 "Photo.c"
}


static void photo_value_reimport_raw_development_state_init (GValue* value) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31246 "Photo.c"
}


static void photo_value_reimport_raw_development_state_free_value (GValue* value) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 31255 "Photo.c"
	}
}


static void photo_value_reimport_raw_development_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 31265 "Photo.c"
	} else {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31269 "Photo.c"
	}
}


static gpointer photo_value_reimport_raw_development_state_peek_pointer (const GValue* value) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31277 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31284 "Photo.c"
		PhotoReimportRawDevelopmentState* object;
		object = collect_values[0].v_pointer;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31291 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31295 "Photo.c"
		}
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 31299 "Photo.c"
	} else {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31303 "Photo.c"
	}
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 31307 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!object_p) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31318 "Photo.c"
	}
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = NULL;
#line 31324 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31328 "Photo.c"
	} else {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 31332 "Photo.c"
	}
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 31336 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31350 "Photo.c"
}


gpointer photo_value_get_reimport_raw_development_state (const GValue* value) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31359 "Photo.c"
}


void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 31379 "Photo.c"
	} else {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31383 "Photo.c"
	}
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 31389 "Photo.c"
	}
}


void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31408 "Photo.c"
	} else {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31412 "Photo.c"
	}
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 31418 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 31428 "Photo.c"
}


static void photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->ref_count = 1;
#line 31435 "Photo.c"
}


static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentState * self;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE (obj);
#line 31443 "Photo.c"
}


GType photo_reimport_raw_development_state_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer photo_reimport_raw_development_state_ref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return instance;
#line 31468 "Photo.c"
}


void photo_reimport_raw_development_state_unref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31481 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type) {
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 31492 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void) {
#line 1235 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 31499 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	GeeCollection* _tmp0_;
	BackingPhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp3_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp4_;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (backing));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->list;
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = backing;
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (_tmp1_, _tmp2_);
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp4_);
#line 1239 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp4_);
#line 31529 "Photo.c"
}


static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self) {
	gint result = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self), 0);
#line 1243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->list;
#line 1243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 1243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 31550 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 1226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing), NULL);
#line 1226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backing;
#line 1227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1227 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->backing = _tmp1_;
#line 1228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 1228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1228 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 31584 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata) {
#line 1226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 31591 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31598 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 31607 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 31617 "Photo.c"
	} else {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31621 "Photo.c"
	}
}


static gpointer photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31629 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31636 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport* object;
		object = collect_values[0].v_pointer;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31643 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31647 "Photo.c"
		}
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 31651 "Photo.c"
	} else {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31655 "Photo.c"
	}
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 31659 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentStateImplDevToReimport** object_p;
	object_p = collect_values[0].v_pointer;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!object_p) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31670 "Photo.c"
	}
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = NULL;
#line 31676 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31680 "Photo.c"
	} else {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 31684 "Photo.c"
	}
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return NULL;
#line 31688 "Photo.c"
}


GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31702 "Photo.c"
}


gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31711 "Photo.c"
}


void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 31731 "Photo.c"
	} else {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31735 "Photo.c"
	}
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 31741 "Photo.c"
	}
}


void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (v_object) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31760 "Photo.c"
	} else {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31764 "Photo.c"
	}
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (old) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 31770 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS (klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 31780 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self) {
	BackingPhotoRow* _tmp0_;
#line 1223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->backing = _tmp0_;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->ref_count = 1;
#line 31792 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj) {
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT (obj);
#line 1223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 31804 "Photo.c"
}


GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return instance;
#line 31829 "Photo.c"
}


void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31842 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass) {
#line 1221 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1221 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 31852 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self) {
	GeeArrayList* _tmp0_;
#line 1232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL);
#line 1232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->list = GEE_COLLECTION (_tmp0_);
#line 1233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->metadata_only = FALSE;
#line 31864 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1221 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (obj);
#line 1232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1221 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 31876 "Photo.c"
}


static GType photo_reimport_raw_development_state_impl_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void photo_class_init (PhotoClass * klass) {
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_replaced = photo_real_notify_editable_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_raw_development_modified = photo_real_notify_raw_development_modified;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_replaced = photo_real_notify_baseline_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_master_reimported = photo_real_notify_master_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_reimported = photo_real_notify_editable_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_source_reimported = photo_real_notify_source_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_reimported = photo_real_notify_baseline_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = photo_real_internal_delete_backing;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_backing_files_state = photo_real_get_backing_files_state;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = photo_real_apply_user_metadata_for_reimport;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_typename = photo_real_get_typename;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_instance_id = photo_real_get_instance_id;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_source_id = photo_real_get_source_id;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->get_preferred_thumbnail_format = photo_real_get_preferred_thumbnail_format;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->create_thumbnail = photo_real_create_thumbnail;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_file = photo_real_get_file;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_file = photo_real_get_master_file;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_timestamp = photo_real_get_timestamp;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_event_id = photo_real_get_event_id;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_import_id = photo_real_get_import_id;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_md5 = photo_real_get_master_md5;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_rating = photo_real_get_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_rating = photo_real_set_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->increase_rating = photo_real_increase_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->decrease_rating = photo_real_decrease_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->commit_backlinks = photo_real_commit_backlinks;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_event_id = photo_real_set_event_id;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_OBJECT_CLASS (klass)->to_string = photo_real_to_string;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->equals = photo_real_equals;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_filesize = photo_real_get_filesize;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_filesize = photo_real_get_master_filesize;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_exposure_time = photo_real_get_exposure_time;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_basename = photo_real_get_basename;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_title = photo_real_get_title;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_title = photo_real_set_title;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_dimensions = photo_real_get_dimensions;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_real_get_metadata;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->rotate = photo_real_rotate;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_real_get_pixbuf;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->has_user_generated_metadata = photo_real_has_user_generated_metadata;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->set_user_metadata_for_export = photo_real_set_user_metadata_for_export;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->editable_replaced = photo_real_editable_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->raw_development_modified = photo_real_raw_development_modified;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->baseline_replaced = photo_real_baseline_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->master_reimported = photo_real_master_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->editable_reimported = photo_real_editable_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->baseline_reimported = photo_real_baseline_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->source_reimported = photo_real_source_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("editable_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("raw_development_modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("baseline_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 32013 "Photo.c"
}


static void photo_dateable_interface_init (DateableIface * iface) {
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->get_exposure_time = (time_t (*)(Dateable*)) photo_real_get_exposure_time;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->set_exposure_time = (void (*)(Dateable*, time_t)) photo_real_set_exposure_time;
#line 32024 "Photo.c"
}


static void photo_instance_init (Photo * self) {
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_row);
#line 289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_readers);
#line 290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->transformer = NULL;
#line 292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->file_title = NULL;
#line 295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 298 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_developments);
#line 320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->developments = NULL;
#line 327 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->backing_photo_row = NULL;
#line 32073 "Photo.c"
}


static void photo_finalize (GObject* obj) {
	Photo * self;
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = PHOTO (obj);
#line 288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_row);
#line 288 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 289 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_readers);
#line 290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 292 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 298 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_unmodified_precached);
#line 316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_developments);
#line 320 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 327 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 32119 "Photo.c"
}


GType photo_get_type (void) {
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = PHOTO (object);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (property_id) {
#line 32142 "Photo.c"
		default:
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		break;
#line 32148 "Photo.c"
	}
}


static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = PHOTO (object);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	switch (property_id) {
#line 32158 "Photo.c"
		default:
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		break;
#line 32164 "Photo.c"
	}
}


GType library_photo_source_collection_state_get_type (void) {
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint _file_hash_ghash_func (gconstpointer key) {
	guint result;
	result = file_hash (key);
#line 4145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32186 "Photo.c"
}


static gboolean _file_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = file_equal (a, b);
#line 4145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32195 "Photo.c"
}


static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = int64_compare (a, b);
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32204 "Photo.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return dup;
#line 32216 "Photo.c"
}


static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = int64_equal (a, b);
#line 4151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32225 "Photo.c"
}


static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self) {
	gint64 result;
	result = photo_get_photo_key (source);
#line 4171 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32234 "Photo.c"
}


static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4173 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered (self, added, removed);
#line 32241 "Photo.c"
}


static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4174 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered (self, added, removed);
#line 32248 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type) {
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
#line 4171 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4173 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 4173 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4173 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_connect (SOURCE_HOLDING_TANK (_tmp1_), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4173 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4174 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4174 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4174 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_connect (SOURCE_HOLDING_TANK (_tmp3_), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4174 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 32278 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_new (void) {
#line 4170 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 32285 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo (self, source, alteration);
#line 4178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32294 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4177 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = MEDIA_SOURCE_HOLDING_TANK (_tmp0_);
#line 4178 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32310 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo (self, source, alteration);
#line 4182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32319 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4181 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = MEDIA_SOURCE_HOLDING_TANK (_tmp0_);
#line 4182 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32335 "Photo.c"
}


static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable) {
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	Workers* _tmp0_;
	GCancellable* _tmp1_;
	PhotoMonitor* _tmp2_;
#line 4185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 4185 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 4186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = workers;
#line 4186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = cancellable;
#line 4186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_monitor_new (_tmp0_, _tmp1_);
#line 4186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = MEDIA_MONITOR (_tmp2_);
#line 4186 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32361 "Photo.c"
}


static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
#line 4189 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4189 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = source;
#line 4190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = IS_LIBRARY_PHOTO (_tmp0_);
#line 4190 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32379 "Photo.c"
}


static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 4193 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 4194 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32395 "Photo.c"
}


static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 4197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4197 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 4198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 4198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_file_format_is_file_supported (_tmp0_);
#line 4198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 4198 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 32416 "Photo.c"
}


static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 4210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced (self, _sender, old_file, new_file);
#line 32423 "Photo.c"
}


static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 4216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified (self, _sender);
#line 32430 "Photo.c"
}


static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed) {
	LibraryPhotoSourceCollection * self;
	GeeIterable* _tmp0_;
	GeeIterable* _tmp76_;
	GeeIterable* _tmp155_;
	GeeIterable* _tmp156_;
#line 4201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 4201 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 4203 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = added;
#line 4203 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 32450 "Photo.c"
		{
			GeeIterable* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _object_it;
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = added;
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_object_it = _tmp2_;
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 32463 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataObject* object;
				DataObject* _tmp7_;
				LibraryPhoto* _tmp8_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp9_;
				GFile* _tmp10_ = NULL;
				GFile* editable;
				GFile* _tmp11_;
				LibraryPhoto* _tmp15_;
				LibraryPhoto* _tmp16_;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* raw_list;
				GeeCollection* _tmp18_;
				LibraryPhoto* _tmp28_;
				LibraryPhoto* _tmp29_;
				BackingPhotoRow* _tmp30_ = NULL;
				BackingPhotoRow* _tmp31_;
				gint64 _tmp32_;
				gint64 _tmp33_;
				gint64 master_filesize;
				gint64 _tmp34_ = 0LL;
				LibraryPhoto* _tmp35_;
				BackingPhotoRow* _tmp36_ = NULL;
				BackingPhotoRow* _tmp37_;
				gboolean _tmp38_;
				gint64 _tmp43_;
				gint64 editable_filesize;
				GeeMultiMap* _tmp44_;
				gint64 _tmp45_;
				LibraryPhoto* _tmp46_;
				GeeHashMap* _tmp47_;
				LibraryPhoto* _tmp48_;
				gint64 _tmp49_;
				gint64 _tmp50_;
				LibraryPhoto* _tmp57_;
				GeeCollection* _tmp58_ = NULL;
				GeeCollection* raw_rows;
				GeeCollection* _tmp59_;
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = _object_it;
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp4_) {
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 32514 "Photo.c"
				}
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _object_it;
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				object = (DataObject*) _tmp6_;
#line 4205 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = object;
#line 4205 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp7_));
#line 4205 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = _tmp8_;
#line 4207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = photo;
#line 4207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = photo_get_editable_file (PHOTO (_tmp9_));
#line 4207 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable = _tmp10_;
#line 4208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = editable;
#line 4208 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 32538 "Photo.c"
					GeeHashMap* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
#line 4209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp12_ = self->priv->by_editable_file;
#line 4209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp13_ = editable;
#line 4209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = photo;
#line 4209 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp12_), _tmp13_, _tmp14_);
#line 32550 "Photo.c"
				}
#line 4210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = photo;
#line 4210 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_connect (PHOTO (_tmp15_), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = photo;
#line 4212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = photo_get_raw_developer_files (PHOTO (_tmp16_));
#line 4212 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				raw_list = _tmp17_;
#line 4213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = raw_list;
#line 4213 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp18_ != NULL) {
#line 32566 "Photo.c"
					{
						GeeCollection* _tmp19_;
						GeeIterator* _tmp20_ = NULL;
						GeeIterator* _f_it;
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp19_ = raw_list;
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp20_ = gee_iterable_iterator (GEE_ITERABLE (_tmp19_));
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_f_it = _tmp20_;
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 32579 "Photo.c"
							GeeIterator* _tmp21_;
							gboolean _tmp22_ = FALSE;
							GeeIterator* _tmp23_;
							gpointer _tmp24_ = NULL;
							GFile* f;
							GeeHashMap* _tmp25_;
							GFile* _tmp26_;
							LibraryPhoto* _tmp27_;
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp21_ = _f_it;
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp22_ = gee_iterator_next (_tmp21_);
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp22_) {
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 32596 "Photo.c"
							}
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp23_ = _f_it;
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp24_ = gee_iterator_get (_tmp23_);
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							f = (GFile*) _tmp24_;
#line 4215 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp25_ = self->priv->by_raw_development_file;
#line 4215 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp26_ = f;
#line 4215 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp27_ = photo;
#line 4215 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp25_), _tmp26_, _tmp27_);
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (f);
#line 32614 "Photo.c"
						}
#line 4214 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 32618 "Photo.c"
					}
				}
#line 4216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = photo;
#line 4216 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_connect (PHOTO (_tmp28_), "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = photo;
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp30_ = photo_get_master_photo_row (PHOTO (_tmp29_));
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = _tmp31_->filesize;
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp31_);
#line 4218 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				master_filesize = _tmp33_;
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = photo;
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = photo_get_editable_photo_row (PHOTO (_tmp35_));
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = _tmp37_ != NULL;
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp37_);
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp38_) {
#line 32651 "Photo.c"
					LibraryPhoto* _tmp39_;
					BackingPhotoRow* _tmp40_ = NULL;
					BackingPhotoRow* _tmp41_;
					gint64 _tmp42_;
#line 4220 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp39_ = photo;
#line 4220 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp40_ = photo_get_editable_photo_row (PHOTO (_tmp39_));
#line 4220 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp41_ = _tmp40_;
#line 4220 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp42_ = _tmp41_->filesize;
#line 4220 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = _tmp42_;
#line 4220 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp41_);
#line 32668 "Photo.c"
				} else {
#line 4221 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = (gint64) (-1);
#line 32672 "Photo.c"
				}
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = _tmp34_;
#line 4219 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable_filesize = _tmp43_;
#line 4222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = self->priv->filesize_to_photo;
#line 4222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp45_ = master_filesize;
#line 4222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp46_ = photo;
#line 4222 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_set (_tmp44_, &_tmp45_, _tmp46_);
#line 4223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp47_ = self->priv->photo_to_master_filesize;
#line 4223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp48_ = photo;
#line 4223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp49_ = master_filesize;
#line 4223 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp47_), _tmp48_, &_tmp49_);
#line 4224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp50_ = editable_filesize;
#line 4224 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp50_ >= ((gint64) 0)) {
#line 32698 "Photo.c"
					GeeMultiMap* _tmp51_;
					gint64 _tmp52_;
					LibraryPhoto* _tmp53_;
					GeeHashMap* _tmp54_;
					LibraryPhoto* _tmp55_;
					gint64 _tmp56_;
#line 4225 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp51_ = self->priv->filesize_to_photo;
#line 4225 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52_ = editable_filesize;
#line 4225 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp53_ = photo;
#line 4225 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_set (_tmp51_, &_tmp52_, _tmp53_);
#line 4226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp54_ = self->priv->photo_to_editable_filesize;
#line 4226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp55_ = photo;
#line 4226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp56_ = editable_filesize;
#line 4226 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp54_), _tmp55_, &_tmp56_);
#line 32721 "Photo.c"
				}
#line 4229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp57_ = photo;
#line 4229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp58_ = photo_get_raw_development_photo_rows (PHOTO (_tmp57_));
#line 4229 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				raw_rows = _tmp58_;
#line 4230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp59_ = raw_rows;
#line 4230 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp59_ != NULL) {
#line 32733 "Photo.c"
					{
						GeeCollection* _tmp60_;
						GeeIterator* _tmp61_ = NULL;
						GeeIterator* _row_it;
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp60_ = raw_rows;
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp61_ = gee_iterable_iterator (GEE_ITERABLE (_tmp60_));
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_row_it = _tmp61_;
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 32746 "Photo.c"
							GeeIterator* _tmp62_;
							gboolean _tmp63_ = FALSE;
							GeeIterator* _tmp64_;
							gpointer _tmp65_ = NULL;
							BackingPhotoRow* row;
							BackingPhotoRow* _tmp66_;
							gint64 _tmp67_;
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp62_ = _row_it;
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp63_ = gee_iterator_next (_tmp62_);
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp63_) {
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 32762 "Photo.c"
							}
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp64_ = _row_it;
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp65_ = gee_iterator_get (_tmp64_);
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp65_;
#line 4232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp66_ = row;
#line 4232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp67_ = _tmp66_->filesize;
#line 4232 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (_tmp67_ >= ((gint64) 0)) {
#line 32776 "Photo.c"
								GeeMultiMap* _tmp68_;
								BackingPhotoRow* _tmp69_;
								gint64 _tmp70_;
								LibraryPhoto* _tmp71_;
								GeeMultiMap* _tmp72_;
								LibraryPhoto* _tmp73_;
								BackingPhotoRow* _tmp74_;
								gint64 _tmp75_;
#line 4233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp68_ = self->priv->filesize_to_photo;
#line 4233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp69_ = row;
#line 4233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp70_ = _tmp69_->filesize;
#line 4233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp71_ = photo;
#line 4233 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								gee_multi_map_set (_tmp68_, &_tmp70_, _tmp71_);
#line 4234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp72_ = self->priv->photo_to_raw_development_filesize;
#line 4234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp73_ = photo;
#line 4234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp74_ = row;
#line 4234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp75_ = _tmp74_->filesize;
#line 4234 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								gee_multi_map_set (_tmp72_, _tmp73_, &_tmp75_);
#line 32805 "Photo.c"
							}
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 32809 "Photo.c"
						}
#line 4231 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 32813 "Photo.c"
					}
				}
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (object);
#line 32826 "Photo.c"
			}
#line 4204 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 32830 "Photo.c"
		}
	}
#line 4241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp76_ = removed;
#line 4241 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp76_ != NULL) {
#line 32837 "Photo.c"
		{
			GeeIterable* _tmp77_;
			GeeIterator* _tmp78_ = NULL;
			GeeIterator* _object_it;
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp77_ = removed;
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp78_ = gee_iterable_iterator (_tmp77_);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_object_it = _tmp78_;
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 32850 "Photo.c"
				GeeIterator* _tmp79_;
				gboolean _tmp80_ = FALSE;
				GeeIterator* _tmp81_;
				gpointer _tmp82_ = NULL;
				DataObject* object;
				DataObject* _tmp83_;
				LibraryPhoto* _tmp84_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp85_;
				GFile* _tmp86_ = NULL;
				GFile* editable;
				GFile* _tmp87_;
				LibraryPhoto* _tmp95_;
				guint _tmp96_ = 0U;
				LibraryPhoto* _tmp97_;
				GeeCollection* _tmp98_ = NULL;
				GeeCollection* raw_list;
				GeeCollection* _tmp99_;
				LibraryPhoto* _tmp108_;
				guint _tmp109_ = 0U;
				LibraryPhoto* _tmp110_;
				BackingPhotoRow* _tmp111_ = NULL;
				BackingPhotoRow* _tmp112_;
				gint64 _tmp113_;
				gint64 _tmp114_;
				gint64 master_filesize;
				gint64 _tmp115_ = 0LL;
				LibraryPhoto* _tmp116_;
				BackingPhotoRow* _tmp117_ = NULL;
				BackingPhotoRow* _tmp118_;
				gboolean _tmp119_;
				gint64 _tmp124_;
				gint64 editable_filesize;
				GeeMultiMap* _tmp125_;
				gint64 _tmp126_;
				LibraryPhoto* _tmp127_;
				GeeHashMap* _tmp128_;
				LibraryPhoto* _tmp129_;
				gint64 _tmp130_;
				LibraryPhoto* _tmp136_;
				GeeCollection* _tmp137_ = NULL;
				GeeCollection* raw_rows;
				GeeCollection* _tmp138_;
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp79_ = _object_it;
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp80_ = gee_iterator_next (_tmp79_);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp80_) {
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 32902 "Photo.c"
				}
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp81_ = _object_it;
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp82_ = gee_iterator_get (_tmp81_);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				object = (DataObject*) _tmp82_;
#line 4243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp83_ = object;
#line 4243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp84_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp83_));
#line 4243 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = _tmp84_;
#line 4245 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp85_ = photo;
#line 4245 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp86_ = photo_get_editable_file (PHOTO (_tmp85_));
#line 4245 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable = _tmp86_;
#line 4246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp87_ = editable;
#line 4246 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp87_ != NULL) {
#line 32926 "Photo.c"
					GeeHashMap* _tmp88_;
					LibraryPhoto* _tmp89_;
					GFile* _tmp90_ = NULL;
					GFile* _tmp91_;
					gboolean _tmp92_ = FALSE;
					gboolean _tmp93_;
					gboolean is_removed;
					gboolean _tmp94_;
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp88_ = self->priv->by_editable_file;
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp89_ = photo;
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp90_ = photo_get_editable_file (PHOTO (_tmp89_));
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp91_ = _tmp90_;
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp92_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp88_), _tmp91_, NULL);
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp93_ = _tmp92_;
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp91_);
#line 4247 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					is_removed = _tmp93_;
#line 4248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp94_ = is_removed;
#line 4248 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					g_assert (_tmp94_);
#line 32955 "Photo.c"
				}
#line 4250 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp95_ = photo;
#line 4250 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp96_, NULL, FALSE);
#line 4250 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_handlers_disconnect_matched (PHOTO (_tmp95_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp96_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp97_ = photo;
#line 4252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp98_ = photo_get_raw_developer_files (PHOTO (_tmp97_));
#line 4252 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				raw_list = _tmp98_;
#line 4253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp99_ = raw_list;
#line 4253 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp99_ != NULL) {
#line 32973 "Photo.c"
					{
						GeeCollection* _tmp100_;
						GeeIterator* _tmp101_ = NULL;
						GeeIterator* _f_it;
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp100_ = raw_list;
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp101_ = gee_iterable_iterator (GEE_ITERABLE (_tmp100_));
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_f_it = _tmp101_;
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 32986 "Photo.c"
							GeeIterator* _tmp102_;
							gboolean _tmp103_ = FALSE;
							GeeIterator* _tmp104_;
							gpointer _tmp105_ = NULL;
							GFile* f;
							GeeHashMap* _tmp106_;
							GFile* _tmp107_;
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp102_ = _f_it;
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp103_ = gee_iterator_next (_tmp102_);
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp103_) {
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 33002 "Photo.c"
							}
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp104_ = _f_it;
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp105_ = gee_iterator_get (_tmp104_);
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							f = (GFile*) _tmp105_;
#line 4255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp106_ = self->priv->by_raw_development_file;
#line 4255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp107_ = f;
#line 4255 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp106_), _tmp107_, NULL);
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (f);
#line 33018 "Photo.c"
						}
#line 4254 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 33022 "Photo.c"
					}
				}
#line 4256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp108_ = photo;
#line 4256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp109_, NULL, FALSE);
#line 4256 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_handlers_disconnect_matched (PHOTO (_tmp108_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp109_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp110_ = photo;
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp111_ = photo_get_master_photo_row (PHOTO (_tmp110_));
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp112_ = _tmp111_;
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp113_ = _tmp112_->filesize;
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp114_ = _tmp113_;
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp112_);
#line 4258 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				master_filesize = _tmp114_;
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp116_ = photo;
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp117_ = photo_get_editable_photo_row (PHOTO (_tmp116_));
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp118_ = _tmp117_;
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp119_ = _tmp118_ != NULL;
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp118_);
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp119_) {
#line 33057 "Photo.c"
					LibraryPhoto* _tmp120_;
					BackingPhotoRow* _tmp121_ = NULL;
					BackingPhotoRow* _tmp122_;
					gint64 _tmp123_;
#line 4260 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp120_ = photo;
#line 4260 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp121_ = photo_get_editable_photo_row (PHOTO (_tmp120_));
#line 4260 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp122_ = _tmp121_;
#line 4260 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp123_ = _tmp122_->filesize;
#line 4260 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp115_ = _tmp123_;
#line 4260 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp122_);
#line 33074 "Photo.c"
				} else {
#line 4261 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp115_ = (gint64) (-1);
#line 33078 "Photo.c"
				}
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp124_ = _tmp115_;
#line 4259 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable_filesize = _tmp124_;
#line 4262 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp125_ = self->priv->filesize_to_photo;
#line 4262 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp126_ = master_filesize;
#line 4262 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp127_ = photo;
#line 4262 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_remove (_tmp125_, &_tmp126_, _tmp127_);
#line 4263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp128_ = self->priv->photo_to_master_filesize;
#line 4263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp129_ = photo;
#line 4263 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp128_), _tmp129_, NULL);
#line 4264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp130_ = editable_filesize;
#line 4264 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp130_ >= ((gint64) 0)) {
#line 33102 "Photo.c"
					GeeMultiMap* _tmp131_;
					gint64 _tmp132_;
					LibraryPhoto* _tmp133_;
					GeeHashMap* _tmp134_;
					LibraryPhoto* _tmp135_;
#line 4265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp131_ = self->priv->filesize_to_photo;
#line 4265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp132_ = editable_filesize;
#line 4265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp133_ = photo;
#line 4265 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_remove (_tmp131_, &_tmp132_, _tmp133_);
#line 4266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp134_ = self->priv->photo_to_editable_filesize;
#line 4266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp135_ = photo;
#line 4266 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp134_), _tmp135_, NULL);
#line 33122 "Photo.c"
				}
#line 4269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp136_ = photo;
#line 4269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp137_ = photo_get_raw_development_photo_rows (PHOTO (_tmp136_));
#line 4269 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				raw_rows = _tmp137_;
#line 4270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp138_ = raw_rows;
#line 4270 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp138_ != NULL) {
#line 33134 "Photo.c"
					{
						GeeCollection* _tmp139_;
						GeeIterator* _tmp140_ = NULL;
						GeeIterator* _row_it;
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp139_ = raw_rows;
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp140_ = gee_iterable_iterator (GEE_ITERABLE (_tmp139_));
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_row_it = _tmp140_;
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 33147 "Photo.c"
							GeeIterator* _tmp141_;
							gboolean _tmp142_ = FALSE;
							GeeIterator* _tmp143_;
							gpointer _tmp144_ = NULL;
							BackingPhotoRow* row;
							BackingPhotoRow* _tmp145_;
							gint64 _tmp146_;
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp141_ = _row_it;
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp142_ = gee_iterator_next (_tmp141_);
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp142_) {
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 33163 "Photo.c"
							}
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp143_ = _row_it;
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp144_ = gee_iterator_get (_tmp143_);
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp144_;
#line 4272 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp145_ = row;
#line 4272 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp146_ = _tmp145_->filesize;
#line 4272 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (_tmp146_ >= ((gint64) 0)) {
#line 33177 "Photo.c"
								GeeMultiMap* _tmp147_;
								BackingPhotoRow* _tmp148_;
								gint64 _tmp149_;
								LibraryPhoto* _tmp150_;
								GeeMultiMap* _tmp151_;
								LibraryPhoto* _tmp152_;
								BackingPhotoRow* _tmp153_;
								gint64 _tmp154_;
#line 4273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp147_ = self->priv->filesize_to_photo;
#line 4273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp148_ = row;
#line 4273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp149_ = _tmp148_->filesize;
#line 4273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp150_ = photo;
#line 4273 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								gee_multi_map_remove (_tmp147_, &_tmp149_, _tmp150_);
#line 4274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp151_ = self->priv->photo_to_raw_development_filesize;
#line 4274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp152_ = photo;
#line 4274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp153_ = row;
#line 4274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								_tmp154_ = _tmp153_->filesize;
#line 4274 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								gee_multi_map_remove (_tmp151_, _tmp152_, &_tmp154_);
#line 33206 "Photo.c"
							}
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 33210 "Photo.c"
						}
#line 4271 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 33214 "Photo.c"
					}
				}
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (object);
#line 33227 "Photo.c"
			}
#line 4242 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 33231 "Photo.c"
		}
	}
#line 4281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp155_ = added;
#line 4281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp156_ = removed;
#line 4281 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (DATA_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp155_, _tmp156_);
#line 33240 "Photo.c"
}


static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_;
	GFile* _tmp5_;
#line 4284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 4284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 4284 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 4285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = old_file;
#line 4285 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 33259 "Photo.c"
		GeeHashMap* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean is_removed;
		gboolean _tmp4_;
#line 4286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = old_file;
#line 4286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp1_), _tmp2_, NULL);
#line 4286 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		is_removed = _tmp3_;
#line 4287 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = is_removed;
#line 4287 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_assert (_tmp4_);
#line 33277 "Photo.c"
	}
#line 4290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = new_file;
#line 4290 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 33283 "Photo.c"
		GeeHashMap* _tmp6_;
		GFile* _tmp7_;
		Photo* _tmp8_;
#line 4291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = self->priv->by_editable_file;
#line 4291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = new_file;
#line 4291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = photo;
#line 4291 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_, LIBRARY_PHOTO (_tmp8_));
#line 33295 "Photo.c"
	}
}


static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo) {
	Photo* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GeeMultiMap* _tmp3_;
	LibraryPhoto* _tmp4_;
	gboolean _tmp5_ = FALSE;
	LibraryPhoto* _tmp23_;
	GeeCollection* _tmp24_ = NULL;
	GeeCollection* raw_list;
	GeeCollection* _tmp25_;
	LibraryPhoto* _tmp35_;
	GeeCollection* _tmp36_ = NULL;
	GeeCollection* raw_rows;
	GeeCollection* _tmp37_;
#line 4294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 4295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = _photo;
#line 4295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp0_) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 4295 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp1_;
#line 4296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo;
#line 4296 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 4297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4297 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 33334 "Photo.c"
	}
#line 4300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = self->priv->photo_to_raw_development_filesize;
#line 4300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo;
#line 4300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 4300 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_) {
#line 33344 "Photo.c"
		GeeMultiMap* _tmp21_;
		LibraryPhoto* _tmp22_;
		{
			GeeMultiMap* _tmp6_;
			LibraryPhoto* _tmp7_;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_;
			GeeIterator* _s_it;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->priv->photo_to_raw_development_filesize;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = photo;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_s_it = _tmp11_;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 33373 "Photo.c"
				GeeIterator* _tmp12_;
				gboolean _tmp13_ = FALSE;
				GeeIterator* _tmp14_;
				gpointer _tmp15_ = NULL;
				gint64* _tmp16_;
				gint64 _tmp17_;
				gint64 s;
				GeeMultiMap* _tmp18_;
				gint64 _tmp19_;
				LibraryPhoto* _tmp20_;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _s_it;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp13_) {
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 33392 "Photo.c"
				}
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = _s_it;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = (gint64*) _tmp15_;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = *_tmp16_;
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp16_);
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				s = _tmp17_;
#line 4302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = self->priv->filesize_to_photo;
#line 4302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = s;
#line 4302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = photo;
#line 4302 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_remove (_tmp18_, &_tmp19_, _tmp20_);
#line 33414 "Photo.c"
			}
#line 4301 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 33418 "Photo.c"
		}
#line 4303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = self->priv->photo_to_raw_development_filesize;
#line 4303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = photo;
#line 4303 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_multi_map_remove_all (_tmp21_, _tmp22_);
#line 33426 "Photo.c"
	}
#line 4307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = photo;
#line 4307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = photo_get_raw_developer_files (PHOTO (_tmp23_));
#line 4307 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_list = _tmp24_;
#line 4308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = raw_list;
#line 4308 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 33438 "Photo.c"
		{
			GeeCollection* _tmp26_;
			GeeIterator* _tmp27_ = NULL;
			GeeIterator* _f_it;
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = raw_list;
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = gee_iterable_iterator (GEE_ITERABLE (_tmp26_));
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_f_it = _tmp27_;
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 33451 "Photo.c"
				GeeIterator* _tmp28_;
				gboolean _tmp29_ = FALSE;
				GeeIterator* _tmp30_;
				gpointer _tmp31_ = NULL;
				GFile* f;
				GeeHashMap* _tmp32_;
				GFile* _tmp33_;
				LibraryPhoto* _tmp34_;
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = _f_it;
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = gee_iterator_next (_tmp28_);
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp29_) {
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 33468 "Photo.c"
				}
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp30_ = _f_it;
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = gee_iterator_get (_tmp30_);
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				f = (GFile*) _tmp31_;
#line 4310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = self->priv->by_raw_development_file;
#line 4310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = f;
#line 4310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp34_ = photo;
#line 4310 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp32_), _tmp33_, _tmp34_);
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (f);
#line 33486 "Photo.c"
			}
#line 4309 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 33490 "Photo.c"
		}
	}
#line 4312 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = photo;
#line 4312 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = photo_get_raw_development_photo_rows (PHOTO (_tmp35_));
#line 4312 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_rows = _tmp36_;
#line 4313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = raw_rows;
#line 4313 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp37_ != NULL) {
#line 33503 "Photo.c"
		{
			GeeCollection* _tmp38_;
			GeeIterator* _tmp39_ = NULL;
			GeeIterator* _row_it;
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = raw_rows;
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp39_ = gee_iterable_iterator (GEE_ITERABLE (_tmp38_));
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_row_it = _tmp39_;
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 33516 "Photo.c"
				GeeIterator* _tmp40_;
				gboolean _tmp41_ = FALSE;
				GeeIterator* _tmp42_;
				gpointer _tmp43_ = NULL;
				BackingPhotoRow* row;
				BackingPhotoRow* _tmp44_;
				gint64 _tmp45_;
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp40_ = _row_it;
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp41_ = gee_iterator_next (_tmp40_);
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp41_) {
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 33532 "Photo.c"
				}
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp42_ = _row_it;
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = gee_iterator_get (_tmp42_);
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp43_;
#line 4315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = row;
#line 4315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp45_ = _tmp44_->filesize;
#line 4315 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp45_ > ((gint64) 0)) {
#line 33546 "Photo.c"
					GeeMultiMap* _tmp46_;
					BackingPhotoRow* _tmp47_;
					gint64 _tmp48_;
					LibraryPhoto* _tmp49_;
					GeeMultiMap* _tmp50_;
					LibraryPhoto* _tmp51_;
					BackingPhotoRow* _tmp52_;
					gint64 _tmp53_;
#line 4316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp47_ = row;
#line 4316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp49_ = photo;
#line 4316 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp48_, _tmp49_);
#line 4317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp50_ = self->priv->photo_to_raw_development_filesize;
#line 4317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp51_ = photo;
#line 4317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52_ = row;
#line 4317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp53_ = _tmp52_->filesize;
#line 4317 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_set (_tmp50_, _tmp51_, &_tmp53_);
#line 33575 "Photo.c"
				}
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 33579 "Photo.c"
			}
#line 4314 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 33583 "Photo.c"
		}
	}
#line 4294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4294 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 33592 "Photo.c"
}


static gpointer __int64_dup0 (gpointer self) {
#line 4333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 33599 "Photo.c"
}


static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items) {
	LibraryPhotoSourceCollection * self;
	GeeMap* _tmp75_;
#line 4323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4323 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 33610 "Photo.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = items;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_object_it = _tmp5_;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 33637 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			GeeMap* _tmp10_;
			DataObject* _tmp11_;
			gpointer _tmp12_ = NULL;
			Alteration* alteration;
			DataObject* _tmp13_;
			LibraryPhoto* _tmp14_;
			LibraryPhoto* photo;
			gboolean _tmp15_ = FALSE;
			Alteration* _tmp16_;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp20_;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _object_it;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp7_) {
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 33662 "Photo.c"
			}
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _object_it;
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			object = (DataObject*) _tmp9_;
#line 4325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = items;
#line 4325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = object;
#line 4325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 4325 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			alteration = (Alteration*) _tmp12_;
#line 4327 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = object;
#line 4327 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp13_));
#line 4327 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo = _tmp14_;
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = alteration;
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = alteration_has_detail (_tmp16_, "image", "master");
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp17_) {
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = TRUE;
#line 33692 "Photo.c"
			} else {
				Alteration* _tmp18_;
				gboolean _tmp19_ = FALSE;
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = alteration;
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = alteration_has_detail (_tmp18_, "image", "editable");
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = _tmp19_;
#line 33702 "Photo.c"
			}
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = _tmp15_;
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp20_) {
#line 33708 "Photo.c"
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gpointer _tmp23_ = NULL;
				gint64* _tmp24_;
				gint64 _tmp25_;
				gint64 old_master_filesize;
				gint64* _tmp26_ = NULL;
				GeeHashMap* _tmp27_;
				LibraryPhoto* _tmp28_;
				gboolean _tmp29_ = FALSE;
				gint64* _tmp35_;
				gint64 old_editable_filesize;
				GeeHashMap* _tmp36_;
				LibraryPhoto* _tmp37_;
				GeeMultiMap* _tmp38_;
				gint64 _tmp39_;
				LibraryPhoto* _tmp40_;
				gint64 _tmp41_;
				LibraryPhoto* _tmp47_;
				BackingPhotoRow* _tmp48_ = NULL;
				BackingPhotoRow* _tmp49_;
				gint64 _tmp50_;
				gint64 _tmp51_;
				gint64 master_filesize;
				gint64 _tmp52_ = 0LL;
				LibraryPhoto* _tmp53_;
				BackingPhotoRow* _tmp54_ = NULL;
				BackingPhotoRow* _tmp55_;
				gboolean _tmp56_;
				gint64 _tmp61_;
				gint64 editable_filesize;
				GeeHashMap* _tmp62_;
				LibraryPhoto* _tmp63_;
				gint64 _tmp64_;
				GeeMultiMap* _tmp65_;
				gint64 _tmp66_;
				LibraryPhoto* _tmp67_;
				gint64 _tmp68_;
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = self->priv->photo_to_master_filesize;
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = photo;
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp21_), _tmp22_);
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = (gint64*) _tmp23_;
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = *_tmp24_;
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp24_);
#line 4330 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				old_master_filesize = _tmp25_;
#line 4331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = self->priv->photo_to_editable_filesize;
#line 4331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = photo;
#line 4331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp27_), _tmp28_);
#line 4331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp29_) {
#line 33769 "Photo.c"
					GeeHashMap* _tmp30_;
					LibraryPhoto* _tmp31_;
					gpointer _tmp32_ = NULL;
#line 4332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp30_ = self->priv->photo_to_editable_filesize;
#line 4332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp31_ = photo;
#line 4332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp32_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp30_), _tmp31_);
#line 4332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (_tmp26_);
#line 4332 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp26_ = (gint64*) _tmp32_;
#line 33783 "Photo.c"
				} else {
					gint64 _tmp33_;
					gint64* _tmp34_;
#line 4333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp33_ = (gint64) (-1);
#line 4333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = __int64_dup0 (&_tmp33_);
#line 4333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (_tmp26_);
#line 4333 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp26_ = _tmp34_;
#line 33795 "Photo.c"
				}
#line 4331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp35_ = _tmp26_;
#line 4331 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				old_editable_filesize = *_tmp35_;
#line 4335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp36_ = self->priv->photo_to_master_filesize;
#line 4335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = photo;
#line 4335 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp36_), _tmp37_, NULL);
#line 4336 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = self->priv->filesize_to_photo;
#line 4336 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_ = old_master_filesize;
#line 4336 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp40_ = photo;
#line 4336 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_remove (_tmp38_, &_tmp39_, _tmp40_);
#line 4337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp41_ = old_editable_filesize;
#line 4337 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp41_ >= ((gint64) 0)) {
#line 33819 "Photo.c"
					GeeHashMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeMultiMap* _tmp44_;
					gint64 _tmp45_;
					LibraryPhoto* _tmp46_;
#line 4338 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp42_ = self->priv->photo_to_editable_filesize;
#line 4338 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp43_ = photo;
#line 4338 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp42_), _tmp43_, NULL);
#line 4339 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp44_ = self->priv->filesize_to_photo;
#line 4339 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp45_ = old_editable_filesize;
#line 4339 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp46_ = photo;
#line 4339 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_remove (_tmp44_, &_tmp45_, _tmp46_);
#line 33839 "Photo.c"
				}
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp47_ = photo;
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp48_ = photo_get_master_photo_row (PHOTO (_tmp47_));
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp50_ = _tmp49_->filesize;
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp51_ = _tmp50_;
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp49_);
#line 4342 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				master_filesize = _tmp51_;
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp53_ = photo;
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp54_ = photo_get_editable_photo_row (PHOTO (_tmp53_));
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp55_ = _tmp54_;
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp56_ = _tmp55_ != NULL;
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp55_);
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp56_) {
#line 33867 "Photo.c"
					LibraryPhoto* _tmp57_;
					BackingPhotoRow* _tmp58_ = NULL;
					BackingPhotoRow* _tmp59_;
					gint64 _tmp60_;
#line 4344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp57_ = photo;
#line 4344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp58_ = photo_get_editable_photo_row (PHOTO (_tmp57_));
#line 4344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp59_ = _tmp58_;
#line 4344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp60_ = _tmp59_->filesize;
#line 4344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52_ = _tmp60_;
#line 4344 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp59_);
#line 33884 "Photo.c"
				} else {
#line 4345 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52_ = (gint64) (-1);
#line 33888 "Photo.c"
				}
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp61_ = _tmp52_;
#line 4343 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				editable_filesize = _tmp61_;
#line 4346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp62_ = self->priv->photo_to_master_filesize;
#line 4346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp63_ = photo;
#line 4346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp64_ = master_filesize;
#line 4346 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp62_), _tmp63_, &_tmp64_);
#line 4347 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp65_ = self->priv->filesize_to_photo;
#line 4347 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp66_ = master_filesize;
#line 4347 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp67_ = photo;
#line 4347 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_set (_tmp65_, &_tmp66_, _tmp67_);
#line 4348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp68_ = editable_filesize;
#line 4348 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp68_ >= ((gint64) 0)) {
#line 33914 "Photo.c"
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					gint64 _tmp71_;
					GeeMultiMap* _tmp72_;
					gint64 _tmp73_;
					LibraryPhoto* _tmp74_;
#line 4349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp69_ = self->priv->photo_to_editable_filesize;
#line 4349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp70_ = photo;
#line 4349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp71_ = editable_filesize;
#line 4349 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp69_), _tmp70_, &_tmp71_);
#line 4350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp72_ = self->priv->filesize_to_photo;
#line 4350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp73_ = editable_filesize;
#line 4350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp74_ = photo;
#line 4350 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_set (_tmp72_, &_tmp73_, _tmp74_);
#line 33937 "Photo.c"
				}
#line 4329 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp26_);
#line 33941 "Photo.c"
			}
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (object);
#line 33949 "Photo.c"
		}
#line 4324 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 33953 "Photo.c"
	}
#line 4355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp75_ = items;
#line 4355 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (DATA_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp75_);
#line 33959 "Photo.c"
}


static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources) {
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* _tmp0_;
	GeeHashMultiMap* map;
	GeeCollection* _tmp98_;
#line 4359 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4359 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 4360 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 4360 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	map = _tmp0_;
#line 33976 "Photo.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _media_it;
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = media_sources;
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_it = _tmp2_;
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 33989 "Photo.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			MediaSource* media;
			MediaSource* _tmp7_;
			LibraryPhoto* _tmp8_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp9_;
			PhotoMetadata* _tmp10_ = NULL;
			PhotoMetadata* metadata;
			HierarchicalTagIndex* _tmp11_ = NULL;
			HierarchicalTagIndex* global_index;
			HierarchicalTagIndex* htag_index;
			PhotoMetadata* _tmp12_;
			gboolean _tmp13_ = FALSE;
			LibraryPhoto* _tmp18_;
			GeeCollection* _tmp19_ = NULL;
			GeeCollection* _tmp20_;
			gboolean _tmp21_;
			PhotoMetadata* _tmp56_;
			gboolean _tmp57_ = FALSE;
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp3_ = _media_it;
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp4_) {
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 34020 "Photo.c"
			}
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _media_it;
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media = (MediaSource*) _tmp6_;
#line 4362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = media;
#line 4362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp7_));
#line 4362 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo = _tmp8_;
#line 4363 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = photo;
#line 4363 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = photo_source_get_metadata (PHOTO_SOURCE (_tmp9_));
#line 4363 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			metadata = _tmp10_;
#line 4366 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = hierarchical_tag_index_get_global_index ();
#line 4366 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			global_index = _tmp11_;
#line 4373 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			htag_index = NULL;
#line 4374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = metadata;
#line 4374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 4374 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp13_) {
#line 34052 "Photo.c"
				PhotoMetadata* _tmp14_;
				GeeSet* _tmp15_ = NULL;
				GeeSet* _tmp16_;
				HierarchicalTagIndex* _tmp17_ = NULL;
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = metadata;
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = photo_metadata_get_hierarchical_keywords (_tmp14_);
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = _tmp15_;
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (GEE_COLLECTION (_tmp16_));
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				htag_index = _tmp17_;
#line 4375 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp16_);
#line 34071 "Photo.c"
			}
#line 4379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = photo;
#line 4379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = library_photo_get_import_keywords (_tmp18_);
#line 4379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 4379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = _tmp20_ != NULL;
#line 4379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp20_);
#line 4379 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp21_) {
#line 34085 "Photo.c"
				{
					LibraryPhoto* _tmp22_;
					GeeCollection* _tmp23_ = NULL;
					GeeCollection* _tmp24_;
					GeeIterator* _tmp25_ = NULL;
					GeeIterator* _tmp26_;
					GeeIterator* _keyword_it;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp22_ = photo;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp23_ = library_photo_get_import_keywords (_tmp22_);
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp24_ = _tmp23_;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp25_ = gee_iterable_iterator (GEE_ITERABLE (_tmp24_));
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp26_ = _tmp25_;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp24_);
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_keyword_it = _tmp26_;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					while (TRUE) {
#line 34109 "Photo.c"
						GeeIterator* _tmp27_;
						gboolean _tmp28_ = FALSE;
						GeeIterator* _tmp29_;
						gpointer _tmp30_ = NULL;
						gchar* keyword;
						gboolean _tmp31_ = FALSE;
						HierarchicalTagIndex* _tmp32_;
						gboolean _tmp36_;
						const gchar* _tmp37_;
						gchar* _tmp38_ = NULL;
						gchar* name;
						HierarchicalTagIndex* _tmp39_;
						const gchar* _tmp40_;
						gboolean _tmp41_ = FALSE;
						const gchar* _tmp50_;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp28_ = gee_iterator_next (_tmp27_);
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (!_tmp28_) {
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							break;
#line 34133 "Photo.c"
						}
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp29_ = _keyword_it;
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp30_ = gee_iterator_get (_tmp29_);
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						keyword = (gchar*) _tmp30_;
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp32_ = htag_index;
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp32_ != NULL) {
#line 34145 "Photo.c"
							HierarchicalTagIndex* _tmp33_;
							const gchar* _tmp34_;
							gboolean _tmp35_ = FALSE;
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp33_ = htag_index;
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp34_ = keyword;
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp35_ = hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_);
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp31_ = _tmp35_;
#line 34157 "Photo.c"
						} else {
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp31_ = FALSE;
#line 34161 "Photo.c"
						}
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp36_ = _tmp31_;
#line 4381 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp36_) {
#line 4382 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (keyword);
#line 4382 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							continue;
#line 34171 "Photo.c"
						}
#line 4384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp37_ = keyword;
#line 4384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp38_ = tag_prep_tag_name (_tmp37_);
#line 4384 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						name = _tmp38_;
#line 4386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp39_ = global_index;
#line 4386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp40_ = name;
#line 4386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp41_ = hierarchical_tag_index_is_tag_in_index (_tmp39_, _tmp40_);
#line 4386 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp41_) {
#line 34187 "Photo.c"
							HierarchicalTagIndex* _tmp42_;
							const gchar* _tmp43_;
							gchar* _tmp44_ = NULL;
							gchar* most_derived_path;
							GeeHashMultiMap* _tmp45_;
							const gchar* _tmp46_;
							Tag* _tmp47_ = NULL;
							Tag* _tmp48_;
							LibraryPhoto* _tmp49_;
#line 4387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp42_ = global_index;
#line 4387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp43_ = name;
#line 4387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp44_ = hierarchical_tag_index_get_path_for_name (_tmp42_, _tmp43_);
#line 4387 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							most_derived_path = _tmp44_;
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp45_ = map;
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp46_ = most_derived_path;
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp47_ = tag_for_path (_tmp46_);
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp48_ = _tmp47_;
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp49_ = photo;
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_multi_map_set (GEE_MULTI_MAP (_tmp45_), _tmp48_, _tmp49_);
#line 4388 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp48_);
#line 4389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (name);
#line 4389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_free0 (keyword);
#line 4389 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							continue;
#line 34227 "Photo.c"
						}
#line 4392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp50_ = name;
#line 4392 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp50_ != NULL) {
#line 34233 "Photo.c"
							GeeHashMultiMap* _tmp51_;
							const gchar* _tmp52_;
							Tag* _tmp53_ = NULL;
							Tag* _tmp54_;
							LibraryPhoto* _tmp55_;
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp51_ = map;
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp52_ = name;
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp53_ = tag_for_path (_tmp52_);
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp54_ = _tmp53_;
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp55_ = photo;
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_multi_map_set (GEE_MULTI_MAP (_tmp51_), _tmp54_, _tmp55_);
#line 4393 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp54_);
#line 34253 "Photo.c"
						}
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_free0 (name);
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_free0 (keyword);
#line 34259 "Photo.c"
					}
#line 4380 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 34263 "Photo.c"
				}
			}
#line 4397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp56_ = metadata;
#line 4397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp57_ = photo_metadata_has_hierarchical_keywords (_tmp56_);
#line 4397 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp57_) {
#line 34272 "Photo.c"
				{
					HierarchicalTagIndex* _tmp58_;
					GeeCollection* _tmp59_ = NULL;
					GeeCollection* _tmp60_;
					GeeIterator* _tmp61_ = NULL;
					GeeIterator* _tmp62_;
					GeeIterator* _path_it;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp58_ = htag_index;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp59_ = hierarchical_tag_index_get_all_paths (_tmp58_);
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp60_ = _tmp59_;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp61_ = gee_iterable_iterator (GEE_ITERABLE (_tmp60_));
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp62_ = _tmp61_;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp60_);
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_path_it = _tmp62_;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					while (TRUE) {
#line 34296 "Photo.c"
						GeeIterator* _tmp63_;
						gboolean _tmp64_ = FALSE;
						GeeIterator* _tmp65_;
						gpointer _tmp66_ = NULL;
						gchar* path;
						const gchar* _tmp67_;
						gchar* _tmp68_ = NULL;
						gchar* name;
						const gchar* _tmp69_;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp63_ = _path_it;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp64_ = gee_iterator_next (_tmp63_);
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (!_tmp64_) {
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							break;
#line 34314 "Photo.c"
						}
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp65_ = _path_it;
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp66_ = gee_iterator_get (_tmp65_);
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						path = (gchar*) _tmp66_;
#line 4399 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp67_ = path;
#line 4399 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp68_ = tag_prep_tag_name (_tmp67_);
#line 4399 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						name = _tmp68_;
#line 4400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp69_ = name;
#line 4400 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (_tmp69_ != NULL) {
#line 34332 "Photo.c"
							GeeHashMultiMap* _tmp70_;
							const gchar* _tmp71_;
							Tag* _tmp72_ = NULL;
							Tag* _tmp73_;
							LibraryPhoto* _tmp74_;
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp70_ = map;
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp71_ = name;
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp72_ = tag_for_path (_tmp71_);
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp73_ = _tmp72_;
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp74_ = photo;
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_multi_map_set (GEE_MULTI_MAP (_tmp70_), _tmp73_, _tmp74_);
#line 4401 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (_tmp73_);
#line 34352 "Photo.c"
						}
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_free0 (name);
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_free0 (path);
#line 34358 "Photo.c"
					}
#line 4398 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 34362 "Photo.c"
				}
			}
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (media);
#line 34375 "Photo.c"
		}
#line 4361 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 34379 "Photo.c"
	}
	{
		GeeCollection* _tmp75_;
		GeeIterator* _tmp76_ = NULL;
		GeeIterator* _media_it;
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp75_ = media_sources;
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp76_ = gee_iterable_iterator (GEE_ITERABLE (_tmp75_));
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_it = _tmp76_;
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 34393 "Photo.c"
			GeeIterator* _tmp77_;
			gboolean _tmp78_ = FALSE;
			GeeIterator* _tmp79_;
			gpointer _tmp80_ = NULL;
			MediaSource* media;
			MediaSource* _tmp81_;
			LibraryPhoto* _tmp82_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp83_;
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp77_ = _media_it;
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp78_ = gee_iterator_next (_tmp77_);
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp78_) {
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 34411 "Photo.c"
			}
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp79_ = _media_it;
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp80_ = gee_iterator_get (_tmp79_);
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media = (MediaSource*) _tmp80_;
#line 4407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp81_ = media;
#line 4407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp82_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp81_));
#line 4407 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo = _tmp82_;
#line 4408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp83_ = photo;
#line 4408 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			library_photo_clear_import_keywords (_tmp83_);
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (media);
#line 34433 "Photo.c"
		}
#line 4406 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 34437 "Photo.c"
	}
	{
		GeeHashMultiMap* _tmp84_;
		GeeSet* _tmp85_ = NULL;
		GeeSet* _tmp86_;
		GeeIterator* _tmp87_ = NULL;
		GeeIterator* _tmp88_;
		GeeIterator* _tag_it;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp84_ = map;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp85_ = gee_multi_map_get_keys (GEE_MULTI_MAP (_tmp84_));
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp86_ = _tmp85_;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp87_ = gee_iterable_iterator (GEE_ITERABLE (_tmp86_));
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp88_ = _tmp87_;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp86_);
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tag_it = _tmp88_;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 34462 "Photo.c"
			GeeIterator* _tmp89_;
			gboolean _tmp90_ = FALSE;
			GeeIterator* _tmp91_;
			gpointer _tmp92_ = NULL;
			Tag* tag;
			Tag* _tmp93_;
			GeeHashMultiMap* _tmp94_;
			Tag* _tmp95_;
			GeeCollection* _tmp96_ = NULL;
			GeeCollection* _tmp97_;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp89_ = _tag_it;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp90_ = gee_iterator_next (_tmp89_);
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp90_) {
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 34481 "Photo.c"
			}
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp91_ = _tag_it;
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp92_ = gee_iterator_get (_tmp91_);
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			tag = (Tag*) _tmp92_;
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp93_ = tag;
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp94_ = map;
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp95_ = tag;
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp96_ = gee_multi_map_get (GEE_MULTI_MAP (_tmp94_), _tmp95_);
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp97_ = _tmp96_;
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			tag_attach_many (_tmp93_, _tmp97_);
#line 4412 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp97_);
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (tag);
#line 34505 "Photo.c"
		}
#line 4411 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 34509 "Photo.c"
	}
#line 4414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp98_ = media_sources;
#line 4414 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (MEDIA_SOURCE_COLLECTION (self), _tmp98_);
#line 4359 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (map);
#line 34517 "Photo.c"
}


static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4419 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo;
#line 4419 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = metadata;
#line 4419 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_, _tmp1_);
#line 34534 "Photo.c"
}


void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4418 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 34543 "Photo.c"
}


static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo;
#line 4424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = metadata;
#line 4424 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_, _tmp1_);
#line 34560 "Photo.c"
}


void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4423 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 34569 "Photo.c"
}


static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo;
#line 4429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = metadata;
#line 4429 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_, _tmp1_);
#line 34586 "Photo.c"
}


void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4428 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 34595 "Photo.c"
}


static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4433 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4433 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo;
#line 4434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = metadata;
#line 4434 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_, _tmp1_);
#line 34612 "Photo.c"
}


void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4433 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4433 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 34621 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gint64 _tmp0_;
	PhotoID _tmp1_ = {0};
	LibraryPhoto* _tmp2_ = NULL;
#line 4437 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = numeric_id;
#line 4438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_id_init (&_tmp1_, _tmp0_);
#line 4438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch (self, &_tmp1_);
#line 4438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = MEDIA_SOURCE (_tmp2_);
#line 4438 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 34643 "Photo.c"
}


static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 4441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 4441 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 4443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = added;
#line 4443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = removed;
#line 4443 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (MEDIA_SOURCE_COLLECTION (self), "trashcan-contents-altered", GEE_COLLECTION (_tmp0_), GEE_COLLECTION (_tmp1_));
#line 34662 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 4447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4447 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4448 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = source;
#line 4448 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = media_source_is_trashed (MEDIA_SOURCE (LIBRARY_PHOTO (_tmp0_)));
#line 4448 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 4448 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 34684 "Photo.c"
}


static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 4451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 4451 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 4453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = added;
#line 4453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = removed;
#line 4453 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_emit_by_name (MEDIA_SOURCE_COLLECTION (self), "offline-contents-altered", GEE_COLLECTION (_tmp0_), GEE_COLLECTION (_tmp1_));
#line 34703 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 4457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4457 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = source;
#line 4458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = media_source_is_offline (MEDIA_SOURCE (LIBRARY_PHOTO (_tmp0_)));
#line 4458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 4458 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 34725 "Photo.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1305 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1305 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 34748 "Photo.c"
		glong _tmp4_;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 34756 "Photo.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 34768 "Photo.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1315 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 34793 "Photo.c"
		glong _tmp2_;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 34799 "Photo.c"
	} else {
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 34803 "Photo.c"
	}
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 34809 "Photo.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 34821 "Photo.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 34831 "Photo.c"
	}
#line 1324 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1324 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 34837 "Photo.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1326 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1326 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 34851 "Photo.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 34861 "Photo.c"
	}
#line 1330 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1330 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 34867 "Photo.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 34876 "Photo.c"
	}
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 34896 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* numeric_only;
	gint64 _tmp6_ = 0LL;
	MediaSource* _tmp7_ = NULL;
#line 4461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4461 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = source_id;
#line 4462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, PHOTO_TYPENAME);
#line 4462 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp1_);
#line 4463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = source_id;
#line 4463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = strlen (PHOTO_TYPENAME);
#line 4463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = string_substring (_tmp2_, (glong) _tmp4_, (glong) (-1));
#line 4463 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	numeric_only = _tmp5_;
#line 4465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = parse_int64 (numeric_only, 16);
#line 4465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = media_source_collection_fetch_by_numeric_id (MEDIA_SOURCE_COLLECTION (self), _tmp6_);
#line 4465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp7_;
#line 4465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (numeric_only);
#line 4465 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 34942 "Photo.c"
}


static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id) {
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_ = NULL;
	GeeCollection* _tmp4_;
#line 4468 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4468 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = *event_id;
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = GEE_COLLECTION (_tmp3_);
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 4469 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 34974 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id) {
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_ = NULL;
#line 4472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4472 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key (DATABASE_SOURCE_COLLECTION (self), _tmp1_);
#line 4473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = LIBRARY_PHOTO (_tmp2_);
#line 4473 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 34997 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 4476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4476 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 4477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 4477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4477 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35020 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 4480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4480 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 4481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 4481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4481 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35043 "Photo.c"
}


static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development) {
	LibraryPhoto* _tmp0_;
	BackingPhotoRow* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	GFileInfo* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	LibraryPhoto* _tmp8_;
	BackingPhotoRow* _tmp9_ = NULL;
	BackingPhotoRow* editable;
	gboolean _tmp10_ = FALSE;
	BackingPhotoRow* _tmp11_;
	gboolean _tmp15_;
	LibraryPhoto* _tmp18_;
	GeeCollection* _tmp19_ = NULL;
	GeeCollection* development;
	GeeCollection* _tmp20_;
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_development));
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo;
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_get_master_photo_row (PHOTO (_tmp0_));
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = info;
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = backing_photo_row_matches_file_info (_tmp2_, _tmp3_);
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp2_);
#line 4487 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_) {
#line 35092 "Photo.c"
		GeeCollection* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4488 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = matches_master;
#line 4488 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = photo;
#line 4488 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_collection_add (_tmp6_, _tmp7_);
#line 35101 "Photo.c"
	}
#line 4490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo;
#line 4490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = photo_get_editable_photo_row (PHOTO (_tmp8_));
#line 4490 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	editable = _tmp9_;
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = editable;
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 35113 "Photo.c"
		BackingPhotoRow* _tmp12_;
		GFileInfo* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = editable;
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp13_ = info;
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = backing_photo_row_matches_file_info (_tmp12_, _tmp13_);
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp14_;
#line 35125 "Photo.c"
	} else {
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = FALSE;
#line 35129 "Photo.c"
	}
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp10_;
#line 4491 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp15_) {
#line 35135 "Photo.c"
		GeeCollection* _tmp16_;
		LibraryPhoto* _tmp17_;
#line 4492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = matches_editable;
#line 4492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = photo;
#line 4492 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_collection_add (_tmp16_, _tmp17_);
#line 35144 "Photo.c"
	}
#line 4494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp18_ = photo;
#line 4494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = photo_get_raw_development_photo_rows (PHOTO (_tmp18_));
#line 4494 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	development = _tmp19_;
#line 4495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = development;
#line 4495 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 35156 "Photo.c"
		{
			GeeCollection* _tmp21_;
			GeeIterator* _tmp22_ = NULL;
			GeeIterator* _row_it;
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = development;
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = gee_iterable_iterator (GEE_ITERABLE (_tmp21_));
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_row_it = _tmp22_;
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 35169 "Photo.c"
				GeeIterator* _tmp23_;
				gboolean _tmp24_ = FALSE;
				GeeIterator* _tmp25_;
				gpointer _tmp26_ = NULL;
				BackingPhotoRow* row;
				BackingPhotoRow* _tmp27_;
				GFileInfo* _tmp28_;
				gboolean _tmp29_ = FALSE;
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = _row_it;
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = gee_iterator_next (_tmp23_);
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp24_) {
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 35186 "Photo.c"
				}
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = _row_it;
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp26_;
#line 4497 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = row;
#line 4497 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = info;
#line 4497 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = backing_photo_row_matches_file_info (_tmp27_, _tmp28_);
#line 4497 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp29_) {
#line 35202 "Photo.c"
					GeeCollection* _tmp30_;
					LibraryPhoto* _tmp31_;
#line 4498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp30_ = matches_development;
#line 4498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp31_ = photo;
#line 4498 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_collection_add (_tmp30_, _tmp31_);
#line 4500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4500 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 35215 "Photo.c"
				}
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35219 "Photo.c"
			}
#line 4496 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35223 "Photo.c"
		}
	}
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (development);
#line 4484 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 35230 "Photo.c"
}


void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development) {
#line 4508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 4508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 4508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 4508 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matched_development));
#line 35245 "Photo.c"
	{
		GeeMultiMap* _tmp0_;
		GFileInfo* _tmp1_;
		gint64 _tmp2_ = 0LL;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _photo_it;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = info;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = g_file_info_get_size (_tmp1_);
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = gee_multi_map_get (_tmp0_, &_tmp2_);
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_it = _tmp6_;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 35275 "Photo.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp11_;
			GFileInfo* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
			GeeCollection* _tmp15_;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp8_) {
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 35294 "Photo.c"
			}
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _photo_it;
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp10_;
#line 4511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = photo;
#line 4511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = info;
#line 4511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = matches_master;
#line 4511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = matches_editable;
#line 4511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = matched_development;
#line 4511 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_);
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (photo);
#line 35316 "Photo.c"
		}
#line 4510 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 35320 "Photo.c"
	}
	{
		GeeCollection* _tmp16_ = NULL;
		GeeCollection* _tmp17_;
		GeeIterator* _tmp18_ = NULL;
		GeeIterator* _tmp19_;
		GeeIterator* _media_it;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = media_source_collection_get_offline_bin_contents (MEDIA_SOURCE_COLLECTION (self));
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = gee_iterable_iterator (GEE_ITERABLE (_tmp17_));
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_it = _tmp19_;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 35342 "Photo.c"
			GeeIterator* _tmp20_;
			gboolean _tmp21_ = FALSE;
			GeeIterator* _tmp22_;
			gpointer _tmp23_ = NULL;
			MediaSource* media;
			MediaSource* _tmp24_;
			GFileInfo* _tmp25_;
			GeeCollection* _tmp26_;
			GeeCollection* _tmp27_;
			GeeCollection* _tmp28_;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = _media_it;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp21_ = gee_iterator_next (_tmp20_);
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp21_) {
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 35361 "Photo.c"
			}
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp22_ = _media_it;
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			media = (MediaSource*) _tmp23_;
#line 4514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = media;
#line 4514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp25_ = info;
#line 4514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp26_ = matches_master;
#line 4514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp27_ = matches_editable;
#line 4514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp28_ = matched_development;
#line 4514 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, LIBRARY_PHOTO (_tmp24_), _tmp25_, _tmp26_, _tmp27_, _tmp28_);
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (media);
#line 35383 "Photo.c"
		}
#line 4513 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35387 "Photo.c"
	}
}


gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize) {
	gboolean result = FALSE;
#line 4517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4517 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 35398 "Photo.c"
	{
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _photo_it;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = filesize;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_photo_it = _tmp5_;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		while (TRUE) {
#line 35425 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* _tmp12_;
			gchar* _tmp13_ = NULL;
			const gchar* _tmp14_;
			gint _tmp15_ = 0;
			gboolean _tmp16_;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (!_tmp7_) {
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				break;
#line 35446 "Photo.c"
			}
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp9_;
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = photo;
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = media_source_get_master_file (MEDIA_SOURCE (_tmp10_));
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp13_ = g_file_get_basename (_tmp12_);
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp14_ = basename;
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp15_ = utf8_ci_compare (_tmp13_, _tmp14_);
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = _tmp15_ == 0;
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp12_);
#line 4519 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_tmp16_) {
#line 4520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				result = TRUE;
#line 4520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4520 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return result;
#line 35480 "Photo.c"
			}
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (photo);
#line 35484 "Photo.c"
		}
#line 4518 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 35488 "Photo.c"
	}
#line 4523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = FALSE;
#line 4523 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35494 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	GFile* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp5_;
#line 4526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4526 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = file;
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4527 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp4_;
#line 4528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo;
#line 4528 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 35529 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_;
		GFile* _tmp8_;
		LibraryPhoto* _tmp9_ = NULL;
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = LIBRARY_PHOTO_SOURCE_HOLDING_TANK (_tmp6_);
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = file;
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo = LIBRARY_PHOTO (_tmp9_);
#line 4529 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 35548 "Photo.c"
	}
#line 4532 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = photo;
#line 4532 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35554 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 4535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4535 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = md5;
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 4536 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35585 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	GFile* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp5_;
#line 4539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4539 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = file;
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4540 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp4_;
#line 4541 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo;
#line 4541 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 35620 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_;
		GFile* _tmp8_;
		LibraryPhoto* _tmp9_ = NULL;
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = LIBRARY_PHOTO_SOURCE_HOLDING_TANK (_tmp6_);
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = file;
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo = LIBRARY_PHOTO (_tmp9_);
#line 4542 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 35639 "Photo.c"
	}
#line 4545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = photo;
#line 4545 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35645 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 4548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4548 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = md5;
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp4_;
#line 4549 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35676 "Photo.c"
}


gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self) {
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
#line 4552 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (SOURCE_HOLDING_TANK (_tmp1_));
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp3_;
#line 4553 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35702 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state) {
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	GFile* _tmp0_;
	MediaSource* _tmp1_ = NULL;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GFile* _tmp3_;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_;
	GFile* _tmp6_;
	LibraryPhoto* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_;
	GFile* _tmp9_;
	LibraryPhoto* _tmp10_ = NULL;
	LibraryPhoto* _tmp11_;
	GFile* _tmp12_;
	LibraryPhoto* _tmp13_ = NULL;
	LibraryPhoto* _tmp14_;
#line 4556 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4556 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 4557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = media_source_collection_fetch_by_master_file (MEDIA_SOURCE_COLLECTION (self), _tmp0_);
#line 4557 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = LIBRARY_PHOTO (_tmp1_);
#line 4558 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo;
#line 4558 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 4559 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = photo;
#line 4561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 4561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 35747 "Photo.c"
		}
#line 4561 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35751 "Photo.c"
	}
#line 4564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = file;
#line 4564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_editable_file (self, _tmp3_);
#line 4564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4564 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp4_;
#line 4565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo;
#line 4565 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4566 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = photo;
#line 4568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 4568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 35773 "Photo.c"
		}
#line 4568 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35777 "Photo.c"
	}
#line 4571 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = file;
#line 4571 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = library_photo_source_collection_fetch_by_raw_development_file (self, _tmp6_);
#line 4571 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4571 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp7_;
#line 4572 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo;
#line 4572 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4573 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = photo;
#line 4575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 4575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 35799 "Photo.c"
		}
#line 4575 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35803 "Photo.c"
	}
#line 4578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = file;
#line 4578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = library_photo_source_collection_get_trashed_by_file (self, _tmp9_);
#line 4578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4578 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = IS_LIBRARY_PHOTO (_tmp10_) ? ((LibraryPhoto*) _tmp10_) : NULL;
#line 4579 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = photo;
#line 4579 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4580 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4582 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = photo;
#line 4582 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 4582 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 35825 "Photo.c"
		}
#line 4582 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35829 "Photo.c"
	}
#line 4585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = file;
#line 4585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = library_photo_source_collection_get_offline_by_file (self, _tmp12_);
#line 4585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4585 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = IS_LIBRARY_PHOTO (_tmp13_) ? ((LibraryPhoto*) _tmp13_) : NULL;
#line 4586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = photo;
#line 4586 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp14_ != NULL) {
#line 4587 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = photo;
#line 4589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (state) {
#line 4589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*state = _vala_state;
#line 35851 "Photo.c"
		}
#line 4589 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35855 "Photo.c"
	}
#line 4592 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = NULL;
#line 4594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (state) {
#line 4594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*state = _vala_state;
#line 35867 "Photo.c"
	}
#line 4594 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35871 "Photo.c"
}


static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	SourceBacklink* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
	SourceBacklink* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	MediaSourceHoldingTank* _tmp7_ = NULL;
	MediaSourceHoldingTank* _tmp8_;
	SourceBacklink* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
#line 4597 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4597 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 4598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = backlink;
#line 4598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (SOURCE_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp0_);
#line 4598 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 4599 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = TRUE;
#line 4599 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35904 "Photo.c"
	}
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = backlink;
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (SOURCE_HOLDING_TANK (_tmp3_), _tmp4_);
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4601 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp6_) {
#line 4602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = TRUE;
#line 4602 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35924 "Photo.c"
	}
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = backlink;
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = source_holding_tank_has_backlink (SOURCE_HOLDING_TANK (_tmp8_), _tmp9_);
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp8_);
#line 4604 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp11_) {
#line 4605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = TRUE;
#line 4605 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 35944 "Photo.c"
	}
#line 4607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = FALSE;
#line 4607 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 35950 "Photo.c"
}


static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	SourceBacklink* _tmp2_;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	MediaSourceHoldingTank* _tmp4_;
	SourceBacklink* _tmp5_;
	SourceBacklink* _tmp6_;
#line 4610 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4610 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 4611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 4611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = backlink;
#line 4611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	source_holding_tank_remove_backlink (SOURCE_HOLDING_TANK (_tmp1_), _tmp2_);
#line 4611 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 4612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = backlink;
#line 4612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	source_holding_tank_remove_backlink (SOURCE_HOLDING_TANK (_tmp4_), _tmp5_);
#line 4612 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = backlink;
#line 4614 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (SOURCE_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp6_);
#line 35991 "Photo.c"
}


static TransactionController* library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base) {
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 4137 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4137 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 36006 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (MEDIA_SOURCE_COLLECTION (self));
#line 4138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		self->priv->_transaction_controller = TRANSACTION_CONTROLLER (_tmp1_);
#line 36014 "Photo.c"
	}
#line 4140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 4140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 36022 "Photo.c"
}


static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 36031 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data1 = closure->data;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 36050 "Photo.c"
	} else {
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data2 = closure->data;
#line 36056 "Photo.c"
	}
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 36062 "Photo.c"
}


static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4161 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 36071 "Photo.c"
}


static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 36080 "Photo.c"
}


static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4167 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 36089 "Photo.c"
}


static void library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass) {
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->finalize = library_photo_source_collection_finalize;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_trashcan = library_photo_source_collection_real_create_trashcan;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_offline_bin = library_photo_source_collection_real_create_offline_bin;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_media_monitor = library_photo_source_collection_real_create_media_monitor;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->holds_type_of_source = library_photo_source_collection_real_holds_type_of_source;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_typename = library_photo_source_collection_real_get_typename;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->is_file_recognized = library_photo_source_collection_real_is_file_recognized;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = library_photo_source_collection_real_notify_contents_altered;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->items_altered = library_photo_source_collection_real_items_altered;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->postprocess_imported_media = library_photo_source_collection_real_postprocess_imported_media;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_master_reimported = library_photo_source_collection_real_notify_master_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_editable_reimported = library_photo_source_collection_real_notify_editable_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_source_reimported = library_photo_source_collection_real_notify_source_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_baseline_reimported = library_photo_source_collection_real_notify_baseline_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_numeric_id = library_photo_source_collection_real_fetch_by_numeric_id;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_source_id = library_photo_source_collection_real_fetch_by_source_id;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_event_source_ids = library_photo_source_collection_real_get_event_source_ids;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = library_photo_source_collection_real_has_backlink;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = library_photo_source_collection_real_remove_backlink;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 36154 "Photo.c"
}


static void library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GeeHashMap* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GeeHashMap* _tmp8_;
	GeeTreeMultiMap* _tmp9_;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 4144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 4145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 4147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_compare_gcompare_func, NULL);
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->filesize_to_photo = GEE_MULTI_MAP (_tmp2_);
#line 4151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = g_direct_hash;
#line 4151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = g_direct_equal;
#line 4151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, _tmp3_, _tmp4_, _int64_equal_gequal_func);
#line 4151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp5_;
#line 4153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = g_direct_hash;
#line 4153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = g_direct_equal;
#line 4153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, _tmp6_, _tmp7_, _int64_equal_gequal_func);
#line 4153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp8_;
#line 4155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, NULL, NULL);
#line 4155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = GEE_MULTI_MAP (_tmp9_);
#line 36205 "Photo.c"
}


static void library_photo_source_collection_finalize (DataCollection* obj) {
	LibraryPhotoSourceCollection * self;
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (obj);
#line 4144 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4149 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4153 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 36229 "Photo.c"
}


GType library_photo_source_collection_get_type (void) {
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self) {
#line 4642 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_generate_thumbnails (self);
#line 36248 "Photo.c"
}


static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row) {
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	OneShotScheduler* _tmp1_;
	PhotoRow* _tmp2_;
	guint64 _tmp3_;
	PhotoRow* _tmp7_;
	guint64 _tmp8_;
#line 4637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 4638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = row;
#line 4638 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 4640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4640 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 4642 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4642 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4642 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp1_;
#line 4645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = row;
#line 4645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_->flags;
#line 4645 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp3_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 36282 "Photo.c"
		LibraryPhotoSourceCollection* _tmp4_;
		PhotoRow* _tmp5_;
		const gchar* _tmp6_;
#line 4646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = library_photo_global;
#line 4646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = row;
#line 4646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp5_->backlinks;
#line 4646 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_source_rehydrate_backlinks (DATA_SOURCE (self), SOURCE_COLLECTION (_tmp4_), _tmp6_);
#line 36294 "Photo.c"
	}
#line 4648 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = row;
#line 4648 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_->flags;
#line 4648 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 36302 "Photo.c"
		PhotoRow* _tmp9_;
		guint64 _tmp10_;
#line 4649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = row;
#line 4649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp9_->flags;
#line 4649 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp10_);
#line 36311 "Photo.c"
	}
#line 4637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 36315 "Photo.c"
}


static LibraryPhoto* library_photo_new (PhotoRow* row) {
#line 4637 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 36322 "Photo.c"
}


static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params) {
	LibraryPhoto * self = NULL;
	PhotoImportParams* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoImportParams* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	OneShotScheduler* _tmp5_;
	PhotoImportParams* _tmp6_;
	PhotoRow* _tmp7_;
	guint64 _tmp8_;
	PhotoImportParams* _tmp13_;
	PhotoRow* _tmp14_;
	guint64 _tmp15_;
#line 4652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (import_params), NULL);
#line 4653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = import_params;
#line 4653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_->row;
#line 4653 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp1_);
#line 4655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = import_params;
#line 4655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_->keywords;
#line 4655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 4655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4655 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->import_keywords = _tmp4_;
#line 4656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4656 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp5_;
#line 4659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = import_params;
#line 4659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_->row;
#line 4659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = _tmp7_->flags;
#line 4659 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 36372 "Photo.c"
		LibraryPhotoSourceCollection* _tmp9_;
		PhotoImportParams* _tmp10_;
		PhotoRow* _tmp11_;
		const gchar* _tmp12_;
#line 4660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp9_ = library_photo_global;
#line 4660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = import_params;
#line 4660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = _tmp10_->row;
#line 4660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp11_->backlinks;
#line 4660 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		data_source_rehydrate_backlinks (DATA_SOURCE (self), SOURCE_COLLECTION (_tmp9_), _tmp12_);
#line 36387 "Photo.c"
	}
#line 4662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = import_params;
#line 4662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = _tmp13_->row;
#line 4662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp14_->flags;
#line 4662 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp15_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 36397 "Photo.c"
		PhotoImportParams* _tmp16_;
		PhotoRow* _tmp17_;
		guint64 _tmp18_;
#line 4663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp16_ = import_params;
#line 4663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp17_ = _tmp16_->row;
#line 4663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = _tmp17_->flags;
#line 4663 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp18_);
#line 36409 "Photo.c"
	}
#line 4652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 36413 "Photo.c"
}


static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params) {
#line 4652 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 36420 "Photo.c"
}


void library_photo_init (ProgressMonitor monitor, void* monitor_target) {
	LibraryPhotoSourceCollection* _tmp0_;
	PhotoTable* _tmp1_ = NULL;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* all;
	GeeArrayList* _tmp5_;
	GeeArrayList* all_photos;
	GeeArrayList* _tmp6_;
	GeeArrayList* trashed_photos;
	GeeArrayList* _tmp7_;
	GeeArrayList* offline_photos;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint count;
	LibraryPhotoSourceCollection* _tmp35_;
	GeeArrayList* _tmp36_;
	GeeCollection* _tmp37_ = NULL;
	GeeCollection* _tmp38_;
	LibraryPhotoSourceCollection* _tmp39_;
	GeeArrayList* _tmp40_;
	LibraryPhotoSourceCollection* _tmp41_;
	GeeArrayList* _tmp42_;
#line 4667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 4667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 4667 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 4671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 4671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 4671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 4671 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	all = _tmp4_;
#line 4672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4672 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	all_photos = _tmp5_;
#line 4673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4673 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	trashed_photos = _tmp6_;
#line 4674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4674 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	offline_photos = _tmp7_;
#line 4675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = all;
#line 4675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp8_));
#line 4675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 4675 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	count = _tmp10_;
#line 36487 "Photo.c"
	{
		gint ctr;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		ctr = 0;
#line 36492 "Photo.c"
		{
			gboolean _tmp11_;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = TRUE;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 36499 "Photo.c"
				gboolean _tmp12_;
				gint _tmp14_;
				gint _tmp15_;
				GeeArrayList* _tmp16_;
				gint _tmp17_;
				gpointer _tmp18_ = NULL;
				PhotoRow* row;
				PhotoRow* _tmp19_;
				LibraryPhoto* _tmp20_;
				LibraryPhoto* photo;
				PhotoRow* _tmp21_;
				guint64 _tmp22_;
				guint64 flags;
				guint64 _tmp23_;
				ProgressMonitor _tmp31_;
				void* _tmp31__target;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp12_) {
#line 36520 "Photo.c"
					gint _tmp13_;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp13_ = ctr;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					ctr = _tmp13_ + 1;
#line 36526 "Photo.c"
				}
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = FALSE;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = ctr;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = count;
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 36538 "Photo.c"
				}
#line 4677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = all;
#line 4677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = ctr;
#line 4677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_tmp16_), _tmp17_);
#line 4677 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				row = (PhotoRow*) _tmp18_;
#line 4678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp19_ = row;
#line 4678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = library_photo_new (_tmp19_);
#line 4678 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = _tmp20_;
#line 4679 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = row;
#line 4679 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = _tmp21_->flags;
#line 4679 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				flags = _tmp22_;
#line 4681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = flags;
#line 4681 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if ((_tmp23_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 36564 "Photo.c"
					GeeArrayList* _tmp24_;
					LibraryPhoto* _tmp25_;
#line 4682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp24_ = trashed_photos;
#line 4682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp25_ = photo;
#line 4682 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp24_), _tmp25_);
#line 36573 "Photo.c"
				} else {
					guint64 _tmp26_;
#line 4683 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp26_ = flags;
#line 4683 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					if ((_tmp26_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 36580 "Photo.c"
						GeeArrayList* _tmp27_;
						LibraryPhoto* _tmp28_;
#line 4684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp27_ = offline_photos;
#line 4684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp28_ = photo;
#line 4684 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp27_), _tmp28_);
#line 36589 "Photo.c"
					} else {
						GeeArrayList* _tmp29_;
						LibraryPhoto* _tmp30_;
#line 4686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp29_ = all_photos;
#line 4686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp30_ = photo;
#line 4686 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp29_), _tmp30_);
#line 36599 "Photo.c"
					}
				}
#line 4688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = monitor;
#line 4688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31__target = monitor_target;
#line 4688 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp31_ != NULL) {
#line 36608 "Photo.c"
					ProgressMonitor _tmp32_;
					void* _tmp32__target;
					gint _tmp33_;
					gint _tmp34_;
#line 4689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp32_ = monitor;
#line 4689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp32__target = monitor_target;
#line 4689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp33_ = ctr;
#line 4689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = count;
#line 4689 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp32_ ((guint64) _tmp33_, (guint64) _tmp34_, _tmp32__target);
#line 36623 "Photo.c"
				}
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4676 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_photo_row_unref0 (row);
#line 36629 "Photo.c"
			}
		}
	}
#line 4692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = library_photo_global;
#line 4692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = all_photos;
#line 4692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = data_collection_add_many (DATA_COLLECTION (_tmp35_), GEE_COLLECTION (_tmp36_), NULL, NULL);
#line 4692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = _tmp37_;
#line 4692 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp38_);
#line 4693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = library_photo_global;
#line 4693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = trashed_photos;
#line 4693 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	media_source_collection_add_many_to_trash (MEDIA_SOURCE_COLLECTION (_tmp39_), GEE_COLLECTION (_tmp40_));
#line 4694 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = library_photo_global;
#line 4694 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = offline_photos;
#line 4694 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	media_source_collection_add_many_to_offline (MEDIA_SOURCE_COLLECTION (_tmp41_), GEE_COLLECTION (_tmp42_));
#line 4666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 4666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 4666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 4666 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (all);
#line 36663 "Photo.c"
}


void library_photo_terminate (void) {
}


ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo) {
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	PhotoImportParams* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoID _tmp4_ = {0};
	PhotoID _tmp5_;
	PhotoID photo_id;
	gboolean _tmp6_ = FALSE;
	PhotoImportParams* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 4704 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = params;
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_->row;
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_table_add (_tmp1_, _tmp3_, &_tmp4_);
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4706 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_id = _tmp5_;
#line 4707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = photo_id_is_invalid (&photo_id);
#line 4707 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp6_) {
#line 4708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 4708 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_vala_photo = NULL;
#line 4710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 4710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (photo) {
#line 4710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			*photo = _vala_photo;
#line 36716 "Photo.c"
		} else {
#line 4710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 36720 "Photo.c"
		}
#line 4710 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 36724 "Photo.c"
	}
#line 4714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = params;
#line 4714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = library_photo_new_from_import_params (_tmp7_);
#line 4714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 4714 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_vala_photo = _tmp8_;
#line 4716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 4716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (photo) {
#line 4716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*photo = _vala_photo;
#line 36740 "Photo.c"
	} else {
#line 4716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 36744 "Photo.c"
	}
#line 4716 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 36748 "Photo.c"
}


void library_photo_import_failed (LibraryPhoto* photo) {
	GError * _inner_error_ = NULL;
#line 4719 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 36756 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		LibraryPhoto* _tmp2_;
		PhotoID _tmp3_ = {0};
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = photo;
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_get_photo_id (PHOTO (_tmp2_), &_tmp3_);
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp3_, &_inner_error_);
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 36778 "Photo.c"
				goto __catch355_database_error;
			}
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4721 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 36787 "Photo.c"
		}
	}
	goto __finally355;
	__catch355_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 4723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = err;
#line 4723 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 36805 "Photo.c"
	}
	__finally355:
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4720 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 36816 "Photo.c"
	}
}


static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4727 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 4728 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (PHOTO (self), _tmp0_);
#line 4730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 4730 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp1_, self, _tmp2_);
#line 36840 "Photo.c"
}


static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4733 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 4734 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (PHOTO (self), _tmp0_);
#line 4736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 4736 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp1_, self, _tmp2_);
#line 36863 "Photo.c"
}


static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4739 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 4740 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (PHOTO (self), _tmp0_);
#line 4742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 4742 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp1_, self, _tmp2_);
#line 36886 "Photo.c"
}


static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4745 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4746 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 4746 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (PHOTO (self), _tmp0_);
#line 4748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = metadata;
#line 4748 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp1_, self, _tmp2_);
#line 36909 "Photo.c"
}


static void library_photo_generate_thumbnails (LibraryPhoto* self) {
	GError * _inner_error_ = NULL;
#line 4751 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 36917 "Photo.c"
	{
#line 4753 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		thumbnail_cache_import_from_source (THUMBNAIL_SOURCE (self), TRUE, &_inner_error_);
#line 4753 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 36923 "Photo.c"
			goto __catch356_g_error;
		}
	}
	goto __finally356;
	__catch356_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 4755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = data_object_to_string (DATA_OBJECT (self));
#line 4755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = err;
#line 4755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:4755: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 4755 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 36953 "Photo.c"
	}
	__finally356:
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4752 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 36964 "Photo.c"
	}
#line 4759 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (THUMBNAIL_SOURCE (self));
#line 36968 "Photo.c"
}


GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 4763 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 4764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 4764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 4764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 4764 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 36986 "Photo.c"
}


void library_photo_clear_import_keywords (LibraryPhoto* self) {
#line 4767 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 4768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4768 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 36997 "Photo.c"
}


static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration) {
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp4_;
	Alteration* _tmp6_;
#line 4771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4771 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp1_) {
#line 37015 "Photo.c"
		Alteration* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = alteration;
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = alteration_has_subject (_tmp2_, "image");
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 37024 "Photo.c"
	} else {
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = FALSE;
#line 37028 "Photo.c"
	}
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 4773 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp4_) {
#line 37034 "Photo.c"
		OneShotScheduler* _tmp5_;
#line 4774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = self->priv->thumbnail_scheduler;
#line 4774 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp5_, G_PRIORITY_LOW);
#line 37040 "Photo.c"
	}
#line 4776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = alteration;
#line 4776 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (DATA_OBJECT (PHOTO (self)), _tmp6_);
#line 37046 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4779 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4779 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 4780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (THUMBNAIL_SOURCE (self), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
#line 4780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	pixbuf = _tmp0_;
#line 4780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4780 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37071 "Photo.c"
	}
#line 4782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 4782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp1_;
#line 4782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4782 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37081 "Photo.c"
}


static void library_photo_real_rotate (Photo* base, Rotation rotation) {
	LibraryPhoto * self;
	Rotation _tmp0_;
	GError * _inner_error_ = NULL;
#line 4785 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4787 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 4788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = rotation;
#line 4788 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (PHOTO (self), _tmp0_);
#line 4789 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 37099 "Photo.c"
	{
		Rotation _tmp1_;
#line 4797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = rotation;
#line 4797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		thumbnail_cache_rotate (THUMBNAIL_SOURCE (self), _tmp1_, &_inner_error_);
#line 4797 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 37108 "Photo.c"
			goto __catch357_g_error;
		}
	}
	goto __finally357;
	__catch357_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 4800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = data_object_to_string (DATA_OBJECT (self));
#line 4800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = err;
#line 4800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_warning ("Photo.vala:4800: Unable to update thumbnails for %s: %s", _tmp3_, _tmp5_);
#line 4800 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 37138 "Photo.c"
	}
	__finally357:
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4796 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 37149 "Photo.c"
	}
#line 4803 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (THUMBNAIL_SOURCE (self));
#line 37153 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 4807 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = scale;
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (THUMBNAIL_SOURCE (self), _tmp0_, &_inner_error_);
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37178 "Photo.c"
	}
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 4808 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37184 "Photo.c"
}


static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_on_duplicate_progress (self, current_num_bytes, total_num_bytes);
#line 37191 "Photo.c"
}


static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error) {
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp4_;
	BackingPhotoRow* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_ = NULL;
	GFile* file;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 4813 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 4813 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((backing == NULL) || IS_BACKING_PHOTO_ROW (backing));
#line 4814 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = backing;
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = TRUE;
#line 37219 "Photo.c"
	} else {
		BackingPhotoRow* _tmp2_;
		const gchar* _tmp3_;
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = backing;
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = _tmp2_->filepath;
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 37229 "Photo.c"
	}
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 4815 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp4_) {
#line 4816 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		*result = backing_id;
#line 4816 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 37239 "Photo.c"
	}
#line 4818 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = backing;
#line 4818 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = _tmp5_->filepath;
#line 4818 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 4818 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	file = _tmp7_;
#line 4819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = file;
#line 4819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = g_file_query_exists (_tmp8_, NULL);
#line 4819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp9_) {
#line 37255 "Photo.c"
		GFile* _tmp10_;
		GFile* _tmp11_ = NULL;
		GFile* dupe_file;
		DetectedPhotoInformation* detected = NULL;
		GFile* _tmp12_;
		DetectedPhotoInformation* _tmp13_ = NULL;
		BackingPhotoRow* _tmp14_ = NULL;
		BackingPhotoRow* state;
		BackingPhotoRow* _tmp15_;
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = file;
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = library_files_duplicate (_tmp10_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		dupe_file = _tmp11_;
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 4820 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 37279 "Photo.c"
		}
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = dupe_file;
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp14_ = photo_query_backing_photo_row (PHOTO (self), _tmp12_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp13_, &_inner_error_);
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		detected = _tmp13_;
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		state = _tmp14_;
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (file);
#line 4823 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 37303 "Photo.c"
		}
#line 4825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp15_ = state;
#line 4825 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp15_ != NULL) {
#line 37309 "Photo.c"
			BackingPhotoTable* _tmp16_ = NULL;
			BackingPhotoTable* _tmp17_;
			BackingPhotoRow* _tmp18_;
			BackingPhotoRow* _tmp19_;
			BackingPhotoID _tmp20_;
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp16_ = backing_photo_table_get_instance ();
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp18_ = state;
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing_photo_table_add (_tmp17_, _tmp18_, &_inner_error_);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_database_table_unref0 (_tmp17_);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (file);
#line 4826 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				return;
#line 37339 "Photo.c"
			}
#line 4827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp19_ = state;
#line 4827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp20_ = _tmp19_->id;
#line 4827 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			backing_id = _tmp20_;
#line 37347 "Photo.c"
		}
#line 4819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 4819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 4819 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 37355 "Photo.c"
	}
#line 4831 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	*result = backing_id;
#line 4831 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (file);
#line 4831 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return;
#line 37363 "Photo.c"
}


LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error) {
	LibraryPhoto* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* dupe_file;
	BackingPhotoRow* _tmp4_ = NULL;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_editable_id;
	BackingPhotoRow* _tmp8_ = NULL;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_shotwell_id;
	BackingPhotoRow* _tmp12_ = NULL;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_camera_id;
	BackingPhotoRow* _tmp16_ = NULL;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	BackingPhotoID dupe_raw_embedded_id;
	PhotoTable* _tmp20_ = NULL;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoID dupe_id;
	PhotoTable* _tmp32_ = NULL;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_ = NULL;
	PhotoRow* _tmp36_;
	PhotoRow* dupe_row;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* dupe;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_ = NULL;
	Event* _tmp44_;
	LibraryPhoto* _tmp45_;
	TagSourceCollection* _tmp46_;
	GeeList* _tmp47_ = NULL;
	GeeCollection* tags;
	GeeCollection* _tmp48_;
	GError * _inner_error_ = NULL;
#line 4834 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_file = _tmp3_;
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4836 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37448 "Photo.c"
	}
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row (PHOTO (self));
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error_);
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 4839 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37470 "Photo.c"
	}
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row (PHOTO (self), RAW_DEVELOPER_SHOTWELL);
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error_);
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 4840 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37492 "Photo.c"
	}
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row (PHOTO (self), RAW_DEVELOPER_CAMERA);
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error_);
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 4842 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37514 "Photo.c"
	}
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row (PHOTO (self), RAW_DEVELOPER_EMBEDDED);
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error_);
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 4844 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return NULL;
#line 37536 "Photo.c"
	}
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_photo_id (PHOTO (self), &_tmp22_);
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = dupe_file;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 4848 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_id = _tmp31_;
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp34_ = dupe_id;
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 4850 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe_row = _tmp36_;
#line 4853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp37_ = dupe_row;
#line 4853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 4853 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	dupe = _tmp38_;
#line 4856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp39_ = dupe;
#line 4856 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	thumbnail_cache_duplicate (THUMBNAIL_SOURCE (self), THUMBNAIL_SOURCE (_tmp39_));
#line 4859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 4859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp41_ = dupe;
#line 4859 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	data_collection_add (DATA_COLLECTION (_tmp40_), DATA_OBJECT (_tmp41_));
#line 4862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp42_ = dupe;
#line 4862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp43_ = media_source_get_event (MEDIA_SOURCE (_tmp42_));
#line 4862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 4862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp45_ = dupe;
#line 4862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	event_attach (_tmp44_, MEDIA_SOURCE (_tmp45_));
#line 4862 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 4863 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp46_ = tag_global;
#line 4863 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp47_ = tag_source_collection_fetch_for_source (_tmp46_, MEDIA_SOURCE (self));
#line 4863 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	tags = GEE_COLLECTION (_tmp47_);
#line 4864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp48_ = tags;
#line 4864 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 37620 "Photo.c"
		{
			GeeCollection* _tmp49_;
			GeeIterator* _tmp50_ = NULL;
			GeeIterator* _tag_it;
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp49_ = tags;
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp50_ = gee_iterable_iterator (GEE_ITERABLE (_tmp49_));
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_it = _tmp50_;
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 37633 "Photo.c"
				GeeIterator* _tmp51_;
				gboolean _tmp52_ = FALSE;
				GeeIterator* _tmp53_;
				gpointer _tmp54_ = NULL;
				Tag* tag;
				Tag* _tmp55_;
				LibraryPhoto* _tmp56_;
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp51_ = _tag_it;
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp52_ = gee_iterator_next (_tmp51_);
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp52_) {
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 37649 "Photo.c"
				}
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp53_ = _tag_it;
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp54_ = gee_iterator_get (_tmp53_);
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				tag = (Tag*) _tmp54_;
#line 4866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp55_ = tag;
#line 4866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp56_ = dupe;
#line 4866 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				tag_attach (_tmp55_, MEDIA_SOURCE (_tmp56_));
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (tag);
#line 37665 "Photo.c"
			}
#line 4865 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 37669 "Photo.c"
		}
	}
#line 4886 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = dupe;
#line 4886 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (tags);
#line 4886 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 4886 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 4886 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37682 "Photo.c"
}


static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total) {
#line 4889 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 4890 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	spin_event_loop (-1);
#line 37691 "Photo.c"
}


static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags) {
	guint64 _tmp0_;
	guint64 _tmp1_;
#line 4893 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 4894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = flags;
#line 4894 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp0_ & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 4895 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_set_rating (MEDIA_SOURCE (self), RATING_REJECTED);
#line 4896 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 37708 "Photo.c"
	}
#line 4899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = flags;
#line 4899 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if ((_tmp1_ & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 4900 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		media_source_set_rating (MEDIA_SOURCE (self), RATING_FIVE);
#line 4901 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 37718 "Photo.c"
	}
}


static gboolean library_photo_real_is_trashed (MediaSource* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 4906 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH);
#line 4907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 4907 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37735 "Photo.c"
}


static void library_photo_real_trash (MediaSource* base) {
	LibraryPhoto * self;
#line 4910 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4911 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 37745 "Photo.c"
}


static void library_photo_real_untrash (MediaSource* base) {
	LibraryPhoto * self;
#line 4914 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4915 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 37755 "Photo.c"
}


static gboolean library_photo_real_is_offline (Monitorable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 4918 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 4919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 4919 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37771 "Photo.c"
}


static void library_photo_real_mark_offline (Monitorable* base) {
	LibraryPhoto * self;
#line 4922 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4923 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 37781 "Photo.c"
}


static void library_photo_real_mark_online (Monitorable* base) {
	LibraryPhoto * self;
#line 4926 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4927 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 37791 "Photo.c"
}


static gboolean library_photo_real_is_flagged (Flaggable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 4930 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 4931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp0_;
#line 4931 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37807 "Photo.c"
}


static void library_photo_real_mark_flagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 4934 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 4935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 4935 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 37825 "Photo.c"
}


static void library_photo_real_mark_unflagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 4938 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4939 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 4939 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4939 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 4939 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 37843 "Photo.c"
}


static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 4942 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (DATA_SOURCE (PHOTO (self)), &_inner_error_);
#line 4945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return FALSE;
#line 37866 "Photo.c"
	}
#line 4945 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (!_tmp1_) {
#line 4946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 4946 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 37874 "Photo.c"
	}
#line 4948 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = media_source_delete_original_file (MEDIA_SOURCE (self));
#line 4948 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = _tmp2_;
#line 4948 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 37882 "Photo.c"
}


static void library_photo_real_destroy (DataSource* base) {
	LibraryPhoto * self;
	PhotoID _tmp0_ = {0};
	PhotoID photo_id;
	GError * _inner_error_ = NULL;
#line 4951 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_get_photo_id (PHOTO (self), &_tmp0_);
#line 4952 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_id = _tmp0_;
#line 4955 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	thumbnail_cache_remove (THUMBNAIL_SOURCE (self));
#line 37899 "Photo.c"
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_id;
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error_);
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 37918 "Photo.c"
				goto __catch358_database_error;
			}
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4961 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			return;
#line 37927 "Photo.c"
		}
	}
	goto __finally358;
	__catch358_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		err = _inner_error_;
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_inner_error_ = NULL;
#line 4963 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = err;
#line 4963 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_error_free0 (err);
#line 37945 "Photo.c"
	}
	__finally358:
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4960 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return;
#line 37956 "Photo.c"
	}
#line 4966 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (DATA_SOURCE (PHOTO (self)));
#line 37960 "Photo.c"
}


gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoFileFormat _tmp3_;
	gint _tmp4_ = 0;
	PhotoID* _tmp5_ = NULL;
	PhotoID* ids;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp6_ = FALSE;
	PhotoID* _tmp7_;
	gint _tmp7__length1;
	gboolean _tmp9_;
	PhotoID* _tmp10_;
	gint _tmp10__length1;
#line 4969 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = file;
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = full_md5;
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = file_format;
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = photo_get_duplicate_ids (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ids = _tmp5_;
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ids_length1 = _tmp4_;
#line 4971 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = ids;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7__length1 = ids_length1;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = TRUE;
#line 38007 "Photo.c"
	} else {
		PhotoID* _tmp8_;
		gint _tmp8__length1;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = ids;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8__length1 = ids_length1;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = _tmp8__length1 == 0;
#line 38017 "Photo.c"
	}
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = _tmp6_;
#line 4973 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp9_) {
#line 4974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = FALSE;
#line 4974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 4974 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 38029 "Photo.c"
	}
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10_ = ids;
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp10__length1 = ids_length1;
#line 38035 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		id_collection = _tmp10_;
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		id_collection_length1 = _tmp10__length1;
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		for (id_it = 0; id_it < _tmp10__length1; id_it = id_it + 1) {
#line 38047 "Photo.c"
			PhotoID id = {0};
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			id = id_collection[id_it];
#line 38051 "Photo.c"
			{
				LibraryPhotoSourceCollection* _tmp11_;
				PhotoID _tmp12_;
				LibraryPhoto* _tmp13_ = NULL;
				LibraryPhoto* photo;
				gboolean _tmp14_ = FALSE;
				LibraryPhoto* _tmp15_;
				gboolean _tmp18_;
#line 4977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = library_photo_global;
#line 4977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = id;
#line 4977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = library_photo_source_collection_fetch (_tmp11_, &_tmp12_);
#line 4977 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = _tmp13_;
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = photo;
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 38072 "Photo.c"
					LibraryPhoto* _tmp16_;
					gboolean _tmp17_ = FALSE;
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp16_ = photo;
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp17_ = media_source_is_trashed (MEDIA_SOURCE (_tmp16_));
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = !_tmp17_;
#line 38081 "Photo.c"
				} else {
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = FALSE;
#line 38085 "Photo.c"
				}
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = _tmp14_;
#line 4978 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp18_) {
#line 4979 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					result = TRUE;
#line 4979 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (photo);
#line 4979 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 4979 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return result;
#line 38099 "Photo.c"
				}
#line 4976 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 38103 "Photo.c"
			}
		}
	}
#line 4982 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = FALSE;
#line 4982 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 4982 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 38113 "Photo.c"
}


static gboolean library_photo_real_has_user_generated_metadata (Photo* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_ = NULL;
	GeeList* tags;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp3_;
	Rating _tmp13_ = 0;
	PhotoMetadata* _tmp14_;
	Rating _tmp15_ = 0;
	PhotoMetadata* _tmp16_;
	GeeSet* _tmp17_ = NULL;
	GeeSet* keywords;
	gint _tmp18_ = 0;
	GeeList* _tmp19_;
	gint _tmp23_;
	gint tags_count;
	gint _tmp24_ = 0;
	GeeSet* _tmp25_;
	gint _tmp29_;
	gint keywords_count;
	gint _tmp30_;
	gint _tmp31_;
	gboolean _tmp32_ = FALSE;
	GeeList* _tmp33_;
	gboolean _tmp35_;
#line 4985 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = tag_global;
#line 4986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, MEDIA_SOURCE (self));
#line 4986 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	tags = _tmp1_;
#line 4988 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 4988 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	metadata = _tmp2_;
#line 4989 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = metadata;
#line 4989 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 38161 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		GeeList* _tmp6_;
		gboolean _tmp10_;
		gboolean _tmp12_;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = tags;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = TRUE;
#line 38173 "Photo.c"
		} else {
			GeeList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = tags;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = gee_collection_get_size (GEE_COLLECTION (_tmp7_));
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _tmp9_ > 0;
#line 38186 "Photo.c"
		}
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = _tmp5_;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		if (_tmp10_) {
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = TRUE;
#line 38194 "Photo.c"
		} else {
			Rating _tmp11_ = 0;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = media_source_get_rating (MEDIA_SOURCE (self));
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = _tmp11_ != RATING_UNRATED;
#line 38201 "Photo.c"
		}
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = _tmp4_;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = _tmp12_;
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (tags);
#line 4990 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 38213 "Photo.c"
	}
#line 4992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = media_source_get_rating (MEDIA_SOURCE (self));
#line 4992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = metadata;
#line 4992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = photo_metadata_get_rating (_tmp14_);
#line 4992 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp13_ != _tmp15_) {
#line 4993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = TRUE;
#line 4993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 4993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (tags);
#line 4993 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 38231 "Photo.c"
	}
#line 4995 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp16_ = metadata;
#line 4995 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp17_ = photo_metadata_get_keywords (_tmp16_, NULL);
#line 4995 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	keywords = _tmp17_;
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp19_ = tags;
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 38243 "Photo.c"
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = tags;
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = gee_collection_get_size (GEE_COLLECTION (_tmp20_));
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = _tmp22_;
#line 38255 "Photo.c"
	} else {
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = 0;
#line 38259 "Photo.c"
	}
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = _tmp18_;
#line 4996 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	tags_count = _tmp23_;
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp25_ = keywords;
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 38269 "Photo.c"
		GeeSet* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp26_ = keywords;
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp27_ = gee_collection_get_size (GEE_COLLECTION (_tmp26_));
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = _tmp28_;
#line 38281 "Photo.c"
	} else {
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp24_ = 0;
#line 38285 "Photo.c"
	}
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp29_ = _tmp24_;
#line 4997 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	keywords_count = _tmp29_;
#line 4999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp30_ = tags_count;
#line 4999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp31_ = keywords_count;
#line 4999 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp30_ != _tmp31_) {
#line 5000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = TRUE;
#line 5000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5000 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 38307 "Photo.c"
	}
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp33_ = tags;
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 38313 "Photo.c"
		GeeSet* _tmp34_;
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp34_ = keywords;
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = _tmp34_ != NULL;
#line 38319 "Photo.c"
	} else {
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp32_ = FALSE;
#line 38323 "Photo.c"
	}
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp35_ = _tmp32_;
#line 5002 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp35_) {
#line 38329 "Photo.c"
		{
			GeeList* _tmp36_;
			GeeList* _tmp37_;
			GeeList* _tag_list;
			GeeList* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			gint _tag_size;
			gint _tag_index;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp36_ = tags;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_list = _tmp37_;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp38_ = _tag_list;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp39_ = gee_collection_get_size (GEE_COLLECTION (_tmp38_));
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_size = _tmp40_;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_index = -1;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 38357 "Photo.c"
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				GeeList* _tmp44_;
				gint _tmp45_;
				gpointer _tmp46_ = NULL;
				Tag* tag;
				GeeSet* _tmp47_;
				Tag* _tmp48_;
				gchar* _tmp49_ = NULL;
				gchar* _tmp50_;
				gchar* _tmp51_ = NULL;
				gchar* _tmp52_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp41_ = _tag_index;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tag_index = _tmp41_ + 1;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp42_ = _tag_index;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = _tag_size;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp42_ < _tmp43_)) {
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 38385 "Photo.c"
				}
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = _tag_list;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp45_ = _tag_index;
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp46_ = gee_list_get (_tmp44_, _tmp45_);
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				tag = (Tag*) _tmp46_;
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp47_ = keywords;
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp48_ = tag;
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp49_ = data_object_get_name (DATA_OBJECT (_tmp48_));
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp50_ = _tmp49_;
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp51_ = g_utf8_normalize (_tmp50_, (gssize) (-1), G_NORMALIZE_DEFAULT);
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp52_ = _tmp51_;
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp53_ = gee_collection_contains (GEE_COLLECTION (_tmp47_), _tmp52_);
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp54_ = !_tmp53_;
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp52_);
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp50_);
#line 5004 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp54_) {
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					result = TRUE;
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (tag);
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (tags);
#line 5005 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					return result;
#line 38431 "Photo.c"
				}
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (tag);
#line 38435 "Photo.c"
			}
#line 5003 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 38439 "Photo.c"
		}
	}
#line 5009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = FALSE;
#line 5009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5009 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 38452 "Photo.c"
}


static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_ = NULL;
	GeeList* photo_tags;
	GeeList* _tmp2_;
	PhotoMetadata* _tmp22_;
	Rating _tmp23_ = 0;
#line 5012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 5012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, MEDIA_SOURCE (self));
#line 5013 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_tags = _tmp1_;
#line 5014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 38478 "Photo.c"
		GeeArrayList* _tmp3_;
		GeeCollection* string_tags;
		PhotoMetadata* _tmp19_;
		GeeCollection* _tmp20_;
#line 5015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 5015 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		string_tags = GEE_COLLECTION (_tmp3_);
#line 38487 "Photo.c"
		{
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			GeeList* _tag_list;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_size;
			gint _tag_index;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_list = _tmp5_;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = gee_collection_get_size (GEE_COLLECTION (_tmp6_));
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_size = _tmp8_;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tag_index = -1;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 38515 "Photo.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				GeeList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_ = NULL;
				Tag* tag;
				GeeCollection* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 38539 "Photo.c"
				}
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5017 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = string_tags;
#line 5017 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = tag;
#line 5017 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = data_object_get_name (DATA_OBJECT (_tmp16_));
#line 5017 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5017 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5017 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (tag);
#line 38563 "Photo.c"
			}
#line 5016 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 38567 "Photo.c"
		}
#line 5019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = metadata;
#line 5019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp20_ = string_tags;
#line 5019 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_keywords (_tmp19_, _tmp20_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5014 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 38577 "Photo.c"
	} else {
		PhotoMetadata* _tmp21_;
#line 5021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp21_ = metadata;
#line 5021 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		photo_metadata_set_keywords (_tmp21_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 38584 "Photo.c"
	}
#line 5023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = metadata;
#line 5023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp23_ = media_source_get_rating (MEDIA_SOURCE (self));
#line 5023 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo_metadata_set_rating (_tmp22_, _tmp23_);
#line 5012 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 38594 "Photo.c"
}


static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index;
	PhotoMetadata* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PhotoMetadata* _tmp6_;
	GeeSet* _tmp7_ = NULL;
	GeeCollection* keywords;
	GeeCollection* _tmp8_;
	HierarchicalTagIndex* _tmp40_;
#line 5026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 5026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5027 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	new_htag_index = NULL;
#line 5029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = metadata;
#line 5029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = photo_metadata_has_hierarchical_keywords (_tmp0_);
#line 5029 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp1_) {
#line 38620 "Photo.c"
		PhotoMetadata* _tmp2_;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_;
		HierarchicalTagIndex* _tmp5_ = NULL;
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp2_ = metadata;
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp3_ = photo_metadata_get_hierarchical_keywords (_tmp2_);
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (GEE_COLLECTION (_tmp4_));
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		new_htag_index = _tmp5_;
#line 5030 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 38639 "Photo.c"
	}
#line 5034 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = metadata;
#line 5034 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = photo_metadata_get_keywords (_tmp6_, NULL);
#line 5034 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	keywords = GEE_COLLECTION (_tmp7_);
#line 5035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp8_ = keywords;
#line 5035 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 38651 "Photo.c"
		{
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _keyword_it;
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = keywords;
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_keyword_it = _tmp10_;
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 38664 "Photo.c"
				GeeIterator* _tmp11_;
				gboolean _tmp12_ = FALSE;
				GeeIterator* _tmp13_;
				gpointer _tmp14_ = NULL;
				gchar* keyword;
				gboolean _tmp15_ = FALSE;
				HierarchicalTagIndex* _tmp16_;
				gboolean _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_ = NULL;
				gchar* safe_keyword;
				const gchar* _tmp23_;
				gchar* _tmp24_ = NULL;
				gchar* promoted_keyword;
				TagSourceCollection* _tmp25_;
				const gchar* _tmp26_;
				gboolean _tmp27_ = FALSE;
				TagSourceCollection* _tmp31_;
				const gchar* _tmp32_;
				gboolean _tmp33_ = FALSE;
				const gchar* _tmp37_;
				Tag* _tmp38_ = NULL;
				Tag* _tmp39_;
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _keyword_it;
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = gee_iterator_next (_tmp11_);
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp12_) {
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 38696 "Photo.c"
				}
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = _keyword_it;
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				keyword = (gchar*) _tmp14_;
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = new_htag_index;
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp16_ != NULL) {
#line 38708 "Photo.c"
					HierarchicalTagIndex* _tmp17_;
					const gchar* _tmp18_;
					gboolean _tmp19_ = FALSE;
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp17_ = new_htag_index;
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp18_ = keyword;
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp19_ = hierarchical_tag_index_is_tag_in_index (_tmp17_, _tmp18_);
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = _tmp19_;
#line 38720 "Photo.c"
				} else {
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = FALSE;
#line 38724 "Photo.c"
				}
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp20_ = _tmp15_;
#line 5037 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp20_) {
#line 5038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (keyword);
#line 5038 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					continue;
#line 38734 "Photo.c"
				}
#line 5040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp21_ = keyword;
#line 5040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp22_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp21_);
#line 5040 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				safe_keyword = _tmp22_;
#line 5041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = safe_keyword;
#line 5041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp23_);
#line 5041 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				promoted_keyword = _tmp24_;
#line 5044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = tag_global;
#line 5044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = safe_keyword;
#line 5044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = tag_source_collection_exists (_tmp25_, _tmp26_, FALSE);
#line 5044 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp27_) {
#line 38756 "Photo.c"
					const gchar* _tmp28_;
					Tag* _tmp29_ = NULL;
					Tag* _tmp30_;
#line 5045 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp28_ = safe_keyword;
#line 5045 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp29_ = tag_for_path (_tmp28_);
#line 5045 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp30_ = _tmp29_;
#line 5045 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					tag_attach (_tmp30_, MEDIA_SOURCE (self));
#line 5045 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp30_);
#line 5046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (keyword);
#line 5046 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					continue;
#line 38778 "Photo.c"
				}
#line 5049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = tag_global;
#line 5049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = promoted_keyword;
#line 5049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = tag_source_collection_exists (_tmp31_, _tmp32_, FALSE);
#line 5049 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp33_) {
#line 38788 "Photo.c"
					const gchar* _tmp34_;
					Tag* _tmp35_ = NULL;
					Tag* _tmp36_;
#line 5050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp34_ = promoted_keyword;
#line 5050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp35_ = tag_for_path (_tmp34_);
#line 5050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 5050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					tag_attach (_tmp36_, MEDIA_SOURCE (self));
#line 5050 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp36_);
#line 5051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_free0 (keyword);
#line 5051 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					continue;
#line 38810 "Photo.c"
				}
#line 5054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp37_ = keyword;
#line 5054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = tag_for_path (_tmp37_);
#line 5054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_ = _tmp38_;
#line 5054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				tag_attach (_tmp39_, MEDIA_SOURCE (self));
#line 5054 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp39_);
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (keyword);
#line 38828 "Photo.c"
			}
#line 5036 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 38832 "Photo.c"
		}
	}
#line 5058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = new_htag_index;
#line 5058 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 38839 "Photo.c"
		{
			HierarchicalTagIndex* _tmp41_;
			GeeCollection* _tmp42_ = NULL;
			GeeCollection* _tmp43_;
			GeeIterator* _tmp44_ = NULL;
			GeeIterator* _tmp45_;
			GeeIterator* _path_it;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp41_ = new_htag_index;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp42_ = hierarchical_tag_index_get_all_paths (_tmp41_);
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp44_ = gee_iterable_iterator (GEE_ITERABLE (_tmp43_));
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp43_);
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_path_it = _tmp45_;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 38863 "Photo.c"
				GeeIterator* _tmp46_;
				gboolean _tmp47_ = FALSE;
				GeeIterator* _tmp48_;
				gpointer _tmp49_ = NULL;
				gchar* path;
				const gchar* _tmp50_;
				Tag* _tmp51_ = NULL;
				Tag* _tmp52_;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp46_ = _path_it;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp47_ = gee_iterator_next (_tmp46_);
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp47_) {
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 38880 "Photo.c"
				}
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp48_ = _path_it;
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp49_ = gee_iterator_get (_tmp48_);
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				path = (gchar*) _tmp49_;
#line 5060 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp50_ = path;
#line 5060 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp51_ = tag_for_path (_tmp50_);
#line 5060 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp52_ = _tmp51_;
#line 5060 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				tag_attach (_tmp52_, MEDIA_SOURCE (self));
#line 5060 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp52_);
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_free0 (path);
#line 38900 "Photo.c"
			}
#line 5059 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 38904 "Photo.c"
		}
	}
#line 5026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5026 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 38911 "Photo.c"
}


static void library_photo_class_init (LibraryPhotoClass * klass) {
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_master_reimported = library_photo_real_notify_master_reimported;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_reimported = library_photo_real_notify_editable_reimported;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_source_reimported = library_photo_real_notify_source_reimported;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_reimported = library_photo_real_notify_baseline_reimported;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_OBJECT_CLASS (klass)->notify_altered = library_photo_real_notify_altered;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_preview_pixbuf = library_photo_real_get_preview_pixbuf;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->rotate = library_photo_real_rotate;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = library_photo_real_get_thumbnail;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->is_trashed = library_photo_real_is_trashed;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->trash = library_photo_real_trash;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->untrash = library_photo_real_untrash;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->is_offline = library_photo_real_is_offline;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->mark_offline = library_photo_real_mark_offline;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->mark_online = library_photo_real_mark_online;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = library_photo_real_internal_delete_backing;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->destroy = library_photo_real_destroy;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->has_user_generated_metadata = library_photo_real_has_user_generated_metadata;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->set_user_metadata_for_export = library_photo_real_set_user_metadata_for_export;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = library_photo_real_apply_user_metadata_for_reimport;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 38960 "Photo.c"
}


static void library_photo_flaggable_interface_init (FlaggableIface * iface) {
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->is_flagged = (gboolean (*)(Flaggable*)) library_photo_real_is_flagged;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->mark_flagged = (void (*)(Flaggable*)) library_photo_real_mark_flagged;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->mark_unflagged = (void (*)(Flaggable*)) library_photo_real_mark_unflagged;
#line 38973 "Photo.c"
}


static void library_photo_monitorable_interface_init (MonitorableIface * iface) {
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->is_offline = (gboolean (*)(Monitorable*)) library_photo_real_is_offline;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->mark_offline = (void (*)(Monitorable*)) library_photo_real_mark_offline;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->mark_online = (void (*)(Monitorable*)) library_photo_real_mark_online;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->set_master_file = (void (*)(Monitorable*, GFile*)) photo_set_master_file;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	iface->set_master_timestamp = (void (*)(Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 38990 "Photo.c"
}


static void library_photo_instance_init (LibraryPhoto * self) {
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 4633 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 4634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 39001 "Photo.c"
}


static void library_photo_finalize (GObject* obj) {
	LibraryPhoto * self;
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO (obj);
#line 4634 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4635 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4622 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 39015 "Photo.c"
}


GType library_photo_get_type (void) {
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
	LibraryPhotoSourceHoldingTank* self = NULL;
	LibraryPhotoSourceCollection* _tmp0_;
	SourceHoldingTankCheckToKeep _tmp1_;
	void* _tmp1__target;
	GetSourceDatabaseKey _tmp2_;
	void* _tmp2__target;
#line 5076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (sources), NULL);
#line 5078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = sources;
#line 5078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = check_to_keep;
#line 5078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1__target = check_to_keep_target;
#line 5078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = get_key;
#line 5078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2__target = get_key_target;
#line 5078 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, MEDIA_SOURCE_COLLECTION (_tmp0_), _tmp1_, _tmp1__target, _tmp2_, _tmp2__target);
#line 5076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return self;
#line 39058 "Photo.c"
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 5076 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 39065 "Photo.c"
}


LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
	LibraryPhoto* _tmp3_;
	GeeHashMap* _tmp4_;
	GFile* _tmp5_;
	gpointer _tmp6_ = NULL;
#line 5081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self), NULL);
#line 5081 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 5082 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ret = NULL;
#line 5083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = file;
#line 5083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 5083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5083 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	ret = (LibraryPhoto*) _tmp2_;
#line 5084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = ret;
#line 5084 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 5085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		result = ret;
#line 5085 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		return result;
#line 39103 "Photo.c"
	}
#line 5087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = self->priv->development_file_map;
#line 5087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = file;
#line 5087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp4_), _tmp5_);
#line 5087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	result = (LibraryPhoto*) _tmp6_;
#line 5087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5087 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	return result;
#line 39117 "Photo.c"
}


static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 5111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced (self, _sender, old_file, new_file);
#line 39124 "Photo.c"
}


static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 5112 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified (self, _sender);
#line 39131 "Photo.c"
}


static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed) {
	LibraryPhotoSourceHoldingTank * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp40_;
	GeeCollection* _tmp81_;
	GeeCollection* _tmp82_;
#line 5090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_HOLDING_TANK (base);
#line 5090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 5090 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 5092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = added;
#line 5092 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 39151 "Photo.c"
		{
			GeeCollection* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _source_it;
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp1_ = added;
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_source_it = _tmp2_;
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 39164 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataSource* source;
				DataSource* _tmp7_;
				LibraryPhoto* _tmp8_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp9_;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_;
				gboolean _tmp12_;
				LibraryPhoto* _tmp23_;
				GeeCollection* _tmp24_ = NULL;
				GeeCollection* raw_files;
				GeeCollection* _tmp25_;
				LibraryPhoto* _tmp38_;
				LibraryPhoto* _tmp39_;
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp3_ = _source_it;
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp4_) {
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 39191 "Photo.c"
				}
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp5_ = _source_it;
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				source = (DataSource*) _tmp6_;
#line 5094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp7_ = source;
#line 5094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp7_));
#line 5094 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = _tmp8_;
#line 5097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp9_ = photo;
#line 5097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp10_ = photo_get_editable_file (PHOTO (_tmp9_));
#line 5097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 5097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _tmp11_ != NULL;
#line 5097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (_tmp11_);
#line 5097 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp12_) {
#line 39217 "Photo.c"
					GeeHashMap* _tmp13_;
					LibraryPhoto* _tmp14_;
					GFile* _tmp15_ = NULL;
					GFile* _tmp16_;
					LibraryPhoto* _tmp17_;
					GeeMultiMap* _tmp18_;
					LibraryPhoto* _tmp19_;
					LibraryPhoto* _tmp20_;
					GFile* _tmp21_ = NULL;
					GFile* _tmp22_;
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp13_ = self->priv->editable_file_map;
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp14_ = photo;
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp15_ = photo_get_editable_file (PHOTO (_tmp14_));
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp16_ = _tmp15_;
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp17_ = photo;
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp13_), _tmp16_, _tmp17_);
#line 5098 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp16_);
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp18_ = self->priv->reverse_editable_file_map;
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp19_ = photo;
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp20_ = photo;
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp21_ = photo_get_editable_file (PHOTO (_tmp20_));
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					gee_multi_map_set (_tmp18_, _tmp19_, _tmp22_);
#line 5099 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 39256 "Photo.c"
				}
#line 5103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp23_ = photo;
#line 5103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp24_ = photo_get_raw_developer_files (PHOTO (_tmp23_));
#line 5103 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				raw_files = _tmp24_;
#line 5104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = raw_files;
#line 5104 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 39268 "Photo.c"
					{
						GeeCollection* _tmp26_;
						GeeIterator* _tmp27_ = NULL;
						GeeIterator* _f_it;
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp26_ = raw_files;
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp27_ = gee_iterable_iterator (GEE_ITERABLE (_tmp26_));
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_f_it = _tmp27_;
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						while (TRUE) {
#line 39281 "Photo.c"
							GeeIterator* _tmp28_;
							gboolean _tmp29_ = FALSE;
							GeeIterator* _tmp30_;
							gpointer _tmp31_ = NULL;
							GFile* f;
							GeeHashMap* _tmp32_;
							GFile* _tmp33_;
							LibraryPhoto* _tmp34_;
							GeeMultiMap* _tmp35_;
							LibraryPhoto* _tmp36_;
							GFile* _tmp37_;
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp28_ = _f_it;
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp29_ = gee_iterator_next (_tmp28_);
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							if (!_tmp29_) {
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
								break;
#line 39301 "Photo.c"
							}
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp30_ = _f_it;
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp31_ = gee_iterator_get (_tmp30_);
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							f = (GFile*) _tmp31_;
#line 5106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp32_ = self->priv->development_file_map;
#line 5106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp33_ = f;
#line 5106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp34_ = photo;
#line 5106 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp32_), _tmp33_, _tmp34_);
#line 5107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp35_ = self->priv->reverse_development_file_map;
#line 5107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp36_ = photo;
#line 5107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_tmp37_ = f;
#line 5107 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							gee_multi_map_set (_tmp35_, _tmp36_, _tmp37_);
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							_g_object_unref0 (f);
#line 39327 "Photo.c"
						}
#line 5105 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 39331 "Photo.c"
					}
				}
#line 5111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp38_ = photo;
#line 5111 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_connect (PHOTO (_tmp38_), "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5112 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp39_ = photo;
#line 5112 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_connect (PHOTO (_tmp39_), "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (source);
#line 39348 "Photo.c"
			}
#line 5093 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 39352 "Photo.c"
		}
	}
#line 5116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp40_ = removed;
#line 5116 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 39359 "Photo.c"
		{
			GeeCollection* _tmp41_;
			GeeIterator* _tmp42_ = NULL;
			GeeIterator* _source_it;
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp41_ = removed;
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp42_ = gee_iterable_iterator (GEE_ITERABLE (_tmp41_));
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_source_it = _tmp42_;
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 39372 "Photo.c"
				GeeIterator* _tmp43_;
				gboolean _tmp44_ = FALSE;
				GeeIterator* _tmp45_;
				gpointer _tmp46_ = NULL;
				DataSource* source;
				DataSource* _tmp47_;
				LibraryPhoto* _tmp48_;
				LibraryPhoto* photo;
				GeeMultiMap* _tmp73_;
				LibraryPhoto* _tmp74_;
				GeeMultiMap* _tmp75_;
				LibraryPhoto* _tmp76_;
				LibraryPhoto* _tmp77_;
				guint _tmp78_ = 0U;
				LibraryPhoto* _tmp79_;
				guint _tmp80_ = 0U;
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp43_ = _source_it;
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp44_ = gee_iterator_next (_tmp43_);
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp44_) {
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 39397 "Photo.c"
				}
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp45_ = _source_it;
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp46_ = gee_iterator_get (_tmp45_);
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				source = (DataSource*) _tmp46_;
#line 5118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp47_ = source;
#line 5118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp48_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp47_));
#line 5118 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				photo = _tmp48_;
#line 39411 "Photo.c"
				{
					GeeMultiMap* _tmp49_;
					LibraryPhoto* _tmp50_;
					GeeCollection* _tmp51_ = NULL;
					GeeCollection* _tmp52_;
					GeeIterator* _tmp53_ = NULL;
					GeeIterator* _tmp54_;
					GeeIterator* _f_it;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp49_ = self->priv->reverse_editable_file_map;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp50_ = photo;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp51_ = gee_multi_map_get (_tmp49_, _tmp50_);
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp53_ = gee_iterable_iterator (GEE_ITERABLE (_tmp52_));
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_f_it = _tmp54_;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					while (TRUE) {
#line 39438 "Photo.c"
						GeeIterator* _tmp55_;
						gboolean _tmp56_ = FALSE;
						GeeIterator* _tmp57_;
						gpointer _tmp58_ = NULL;
						GFile* f;
						GeeHashMap* _tmp59_;
						GFile* _tmp60_;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp55_ = _f_it;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp56_ = gee_iterator_next (_tmp55_);
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (!_tmp56_) {
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							break;
#line 39454 "Photo.c"
						}
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp57_ = _f_it;
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp58_ = gee_iterator_get (_tmp57_);
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						f = (GFile*) _tmp58_;
#line 5120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp59_ = self->priv->editable_file_map;
#line 5120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp60_ = f;
#line 5120 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp59_), _tmp60_, NULL);
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (f);
#line 39470 "Photo.c"
					}
#line 5119 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 39474 "Photo.c"
				}
				{
					GeeMultiMap* _tmp61_;
					LibraryPhoto* _tmp62_;
					GeeCollection* _tmp63_ = NULL;
					GeeCollection* _tmp64_;
					GeeIterator* _tmp65_ = NULL;
					GeeIterator* _tmp66_;
					GeeIterator* _f_it;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp61_ = self->priv->reverse_development_file_map;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp62_ = photo;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp63_ = gee_multi_map_get (_tmp61_, _tmp62_);
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp64_ = _tmp63_;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp65_ = gee_iterable_iterator (GEE_ITERABLE (_tmp64_));
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_tmp66_ = _tmp65_;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_tmp64_);
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_f_it = _tmp66_;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					while (TRUE) {
#line 39502 "Photo.c"
						GeeIterator* _tmp67_;
						gboolean _tmp68_ = FALSE;
						GeeIterator* _tmp69_;
						gpointer _tmp70_ = NULL;
						GFile* f;
						GeeHashMap* _tmp71_;
						GFile* _tmp72_;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp67_ = _f_it;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp68_ = gee_iterator_next (_tmp67_);
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						if (!_tmp68_) {
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
							break;
#line 39518 "Photo.c"
						}
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp69_ = _f_it;
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp70_ = gee_iterator_get (_tmp69_);
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						f = (GFile*) _tmp70_;
#line 5123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp71_ = self->priv->development_file_map;
#line 5123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_tmp72_ = f;
#line 5123 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp71_), _tmp72_, NULL);
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
						_g_object_unref0 (f);
#line 39534 "Photo.c"
					}
#line 5122 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 39538 "Photo.c"
				}
#line 5125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp73_ = self->priv->reverse_editable_file_map;
#line 5125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp74_ = photo;
#line 5125 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_remove_all (_tmp73_, _tmp74_);
#line 5126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp75_ = self->priv->reverse_development_file_map;
#line 5126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp76_ = photo;
#line 5126 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_remove_all (_tmp75_, _tmp76_);
#line 5128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp77_ = photo;
#line 5128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp78_, NULL, FALSE);
#line 5128 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_handlers_disconnect_matched (PHOTO (_tmp77_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp78_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp79_ = photo;
#line 5129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp80_, NULL, FALSE);
#line 5129 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				g_signal_handlers_disconnect_matched (PHOTO (_tmp79_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp80_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (source);
#line 39568 "Photo.c"
			}
#line 5117 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 39572 "Photo.c"
		}
	}
#line 5133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp81_ = added;
#line 5133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp82_ = removed;
#line 5133 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered (SOURCE_HOLDING_TANK (MEDIA_SOURCE_HOLDING_TANK (self)), _tmp81_, _tmp82_);
#line 39581 "Photo.c"
}


static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file) {
	Photo* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp9_;
	GeeMultiMap* _tmp13_;
	LibraryPhoto* _tmp14_;
	GFile* _tmp15_;
#line 5136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 5136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 5137 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = _photo;
#line 5137 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp0_) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5137 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp1_;
#line 5138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo;
#line 5138 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp2_ != NULL);
#line 5140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = old_file;
#line 5140 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 39617 "Photo.c"
		GeeHashMap* _tmp4_;
		GFile* _tmp5_;
		GeeMultiMap* _tmp6_;
		LibraryPhoto* _tmp7_;
		GFile* _tmp8_;
#line 5141 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp4_ = self->priv->editable_file_map;
#line 5141 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp5_ = old_file;
#line 5141 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp4_), _tmp5_, NULL);
#line 5142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp6_ = self->priv->reverse_editable_file_map;
#line 5142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp7_ = photo;
#line 5142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp8_ = old_file;
#line 5142 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_multi_map_remove (_tmp6_, _tmp7_, _tmp8_);
#line 39637 "Photo.c"
	}
#line 5145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp9_ = new_file;
#line 5145 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp9_ != NULL) {
#line 39643 "Photo.c"
		GeeHashMap* _tmp10_;
		GFile* _tmp11_;
		LibraryPhoto* _tmp12_;
#line 5146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp10_ = self->priv->editable_file_map;
#line 5146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp11_ = new_file;
#line 5146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp12_ = photo;
#line 5146 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp10_), _tmp11_, _tmp12_);
#line 39655 "Photo.c"
	}
#line 5147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp13_ = self->priv->reverse_editable_file_map;
#line 5147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp14_ = photo;
#line 5147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp15_ = new_file;
#line 5147 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	gee_multi_map_set (_tmp13_, _tmp14_, _tmp15_);
#line 5136 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 39667 "Photo.c"
}


static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo) {
	Photo* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GeeMultiMap* _tmp3_;
	LibraryPhoto* _tmp4_;
	gboolean _tmp5_ = FALSE;
	LibraryPhoto* _tmp20_;
	GeeCollection* _tmp21_ = NULL;
	GeeCollection* raw_list;
	GeeCollection* _tmp22_;
#line 5150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = _photo;
#line 5151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp0_) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5151 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	photo = _tmp1_;
#line 5152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = photo;
#line 5152 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_assert (_tmp2_ != NULL);
#line 5155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = self->priv->reverse_development_file_map;
#line 5155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = photo;
#line 5155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 5155 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp5_) {
#line 39705 "Photo.c"
		GeeMultiMap* _tmp18_;
		LibraryPhoto* _tmp19_;
		{
			GeeMultiMap* _tmp6_;
			LibraryPhoto* _tmp7_;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_;
			GeeIterator* _f_it;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp6_ = self->priv->reverse_development_file_map;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp7_ = photo;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_f_it = _tmp11_;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 39734 "Photo.c"
				GeeIterator* _tmp12_;
				gboolean _tmp13_ = FALSE;
				GeeIterator* _tmp14_;
				gpointer _tmp15_ = NULL;
				GFile* f;
				GeeHashMap* _tmp16_;
				GFile* _tmp17_;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp12_ = _f_it;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp13_) {
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 39750 "Photo.c"
				}
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp14_ = _f_it;
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				f = (GFile*) _tmp15_;
#line 5157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp16_ = self->priv->development_file_map;
#line 5157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp17_ = f;
#line 5157 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp16_), _tmp17_, NULL);
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (f);
#line 39766 "Photo.c"
			}
#line 5156 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 39770 "Photo.c"
		}
#line 5158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp18_ = self->priv->reverse_development_file_map;
#line 5158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		_tmp19_ = photo;
#line 5158 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 39778 "Photo.c"
	}
#line 5162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp20_ = photo;
#line 5162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files (PHOTO (_tmp20_));
#line 5162 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	raw_list = _tmp21_;
#line 5163 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp22_ = raw_list;
#line 5163 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 39790 "Photo.c"
		{
			GeeCollection* _tmp23_;
			GeeIterator* _tmp24_ = NULL;
			GeeIterator* _f_it;
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp23_ = raw_list;
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_tmp24_ = gee_iterable_iterator (GEE_ITERABLE (_tmp23_));
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_f_it = _tmp24_;
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			while (TRUE) {
#line 39803 "Photo.c"
				GeeIterator* _tmp25_;
				gboolean _tmp26_ = FALSE;
				GeeIterator* _tmp27_;
				gpointer _tmp28_ = NULL;
				GFile* f;
				GeeHashMap* _tmp29_;
				GFile* _tmp30_;
				LibraryPhoto* _tmp31_;
				GeeMultiMap* _tmp32_;
				LibraryPhoto* _tmp33_;
				GFile* _tmp34_;
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp25_ = _f_it;
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp26_ = gee_iterator_next (_tmp25_);
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				if (!_tmp26_) {
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
					break;
#line 39823 "Photo.c"
				}
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp27_ = _f_it;
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp28_ = gee_iterator_get (_tmp27_);
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				f = (GFile*) _tmp28_;
#line 5165 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp29_ = self->priv->development_file_map;
#line 5165 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp30_ = f;
#line 5165 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp31_ = photo;
#line 5165 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp29_), _tmp30_, _tmp31_);
#line 5166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp32_ = self->priv->reverse_development_file_map;
#line 5166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp33_ = photo;
#line 5166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_tmp34_ = f;
#line 5166 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				gee_multi_map_set (_tmp32_, _tmp33_, _tmp34_);
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
				_g_object_unref0 (f);
#line 39849 "Photo.c"
			}
#line 5164 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 39853 "Photo.c"
		}
	}
#line 5150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5150 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (photo);
#line 39860 "Photo.c"
}


static void library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass) {
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceHoldingTankPrivate));
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = library_photo_source_holding_tank_real_notify_contents_altered;
#line 39873 "Photo.c"
}


static void library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GeeHashMultiMap* _tmp4_;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GeeHashMultiMap* _tmp7_;
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 5067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 5067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 5069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp2_ = g_direct_hash;
#line 5071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp3_ = g_direct_equal;
#line 5071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp4_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp2_, _tmp3_, _file_hash_ghash_func, _file_equal_gequal_func);
#line 5071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->reverse_editable_file_map = GEE_MULTI_MAP (_tmp4_);
#line 5073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp5_ = g_direct_hash;
#line 5073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp6_ = g_direct_equal;
#line 5073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_tmp7_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp5_, _tmp6_, _file_hash_ghash_func, _file_equal_gequal_func);
#line 5073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self->priv->reverse_development_file_map = GEE_MULTI_MAP (_tmp7_);
#line 39912 "Photo.c"
}


static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj) {
	LibraryPhotoSourceHoldingTank * self;
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_HOLDING_TANK (obj);
#line 5067 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5069 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5071 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5073 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5066 "/builddir/build/BUILD/shotwell-0.12.3/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 39930 "Photo.c"
}


GType library_photo_source_holding_tank_get_type (void) {
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



